﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp.Properties;
using System.IO;


namespace WINDF7CSharp
{
    public partial class TFAnalogfilter : Form
    {
        // In the textboxes Memo1 - to Memo3 the x- Axis contains the frequency, not radian frequ.

        #region Konstruktor

        public Meshform meshform;
        public FormMain meinMain;
        DataGridViewColumn colsort;

        public TFAnalogfilter(FormMain m)
        {
            InitializeComponent();
            meshform = new Meshform(this);
            meinMain = m;
            colsort = StringGrid1.Columns[0];  // defines column to sort
            w_zahl = 1000;
            dek = 4;
            w_start = 0.01;
            FAwritewedit();
            label_points.Text = points + "< " + anzahl.ToString();
        }

        #endregion




        #region Felder (kopiert aus Uanalogfilter.cpp und erweitert)

        
        public double w_start, endw, dek;
        public Int32 w_zahl, FAaktmaxi, FAaktnr, FAaktnc, FAaktpr, FAaktpc;
        public const double pi = Math.PI;
        double ln10 = Math.Log(10);
        int anzahl = 32767;     // max points of bode
        String wrongfileformat = "wrong file format";
        String radianfrequencyw = "Radian Frequency w"; 
        public double FAkaf = 1, FAtzaf, t1af, t2af, FAt0; // DC-Gain, delay time, analog filter af}

        string CRLF = "\r\n";
        //---------------------------------------------------------------------------


        String bottomtitle="";
        String FilterName="new";
        string points = "Points";


        int nr_col_index = 0;
        int nc_col_index = 0;
        int pr_col_index = 0;
        int pc_col_index = 0;

    
        

     
       //---------------------------------------------------------------------------

        #endregion         




        #region RadioButtons lin/log

        private void radioButton_lin_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton_lin.Checked)
            {
                Edek.Visible = false;
                label_decades.Visible = false;
            }
        }

        

        private void radioButton_log_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton_log.Checked)
            {
                Edek.Visible = true;
                label_decades.Visible = true;
            }
        }

        #endregion


        //FAwriteedit
        /// <summary>
        /// 
        /// </summary>
        private void FAwritewedit()
        {
            Ewstart.Text = w_start.ToString("G10");
            endw = w_start * Math.Exp(ln10 * dek);
            Ewend.Text = endw.ToString("G10");
            Efstart.Text = (w_start / 2.0 / Math.PI).ToString("G10");
            Efend.Text = (endw / 2.0 / Math.PI).ToString("G10");
            Edek.Text = dek.ToString("G10");
            Epoints.Text = w_zahl.ToString("G10");
            Elogw.Text = Math.Log10(w_start).ToString("G10");
            ElogwEnd.Text = Math.Log10(endw).ToString("G10");
        }
        //-------------------------------------


        #region onExit Textfelder

        private void EwstartExit(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Ewstart.Text, ref w_start);            
            //if (radioButton_log.Checked) endw = w_start * Math.Exp(ln10 * dek);
            FAwritewedit();
        }

        private void EdekExit(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Edek.Text, ref dek);
            //if (radioButton_log.Checked) endw = w_start * Math.Exp(ln10 * dek);
            FAwritewedit();
        }

        private void EfstartExit(object sender, EventArgs e)
        {
            double help = w_start / 2.0 / Math.PI;
            meinMain.ConvertToDouble(Efstart.Text,ref help);        
            //if (radioButton_log.Checked) endw = w_start * Math.Exp(ln10 * dek);
            w_start =help  * 2.0 * pi; 
            FAwritewedit();
        }

        private void EwendExit(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Ewend.Text, ref endw);
            dek = Math.Log10(endw / w_start);
            FAwritewedit();
        }

        private void EfendExit(object sender, EventArgs e)
        {
            double help = endw / 2.0 / Math.PI;
            meinMain.ConvertToDouble(Efend.Text, ref endw);
            endw=help * 2.0 * Math.PI;
            dek = Math.Log10( endw/w_start );
            FAwritewedit();
        }

        private void EpiontsExit(object sender, EventArgs e)
        {
            if (!int.TryParse(Epoints.Text,out w_zahl ))
            {
                w_zahl = 100;
                Epoints.Text = "100";
            }
            if (w_zahl > anzahl)
            {
                w_zahl = anzahl;
                Epoints.Text = w_zahl.ToString();
            }
        }

        private void EKExit(object sender, EventArgs e)
        {
             meinMain.ConvertToDouble(EK.Text,ref FAkaf);
        }

        private void ETzExit(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(ETz.Text, ref FAtzaf);
        }
        
        private void Edek_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) EdekExit(sender, e);
        }

        private void Elogw_Leave(object sender, EventArgs e)
        {
            double help = Math.Log10( w_start);   // field contains log w
            meinMain.ConvertToDouble(Elogw.Text, ref help);
            w_start = Math.Exp(help * ln10);
            FAwritewedit();
        }

        private void Elogw_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Elogw_Leave(sender, e);
        }
        
        private void ElogwEnd_Leave(object sender, EventArgs e)
        {
            double help = Math.Log10(endw);   // field contains log w
            meinMain.ConvertToDouble(ElogwEnd.Text, ref help);
            endw = Math.Exp(help * ln10);
            dek = Math.Log10(endw / w_start);
            FAwritewedit();
        }

        private void ElogwEnd_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) ElogwEnd_Leave(sender, e);
 
        }

        void readw_values()
        {   // before calcbode all data from textfields are actualized

            if (!int.TryParse(Epoints.Text,out w_zahl ))
            {
                w_zahl= 100;
                Epoints.Text = "100";
            }
            if (w_zahl > anzahl)
            {
                w_zahl = anzahl;
                Epoints.Text = w_zahl.ToString();
            }
            meinMain.ConvertToDouble(Ewstart.Text, ref w_start);
            meinMain.ConvertToDouble(Ewend.Text, ref endw);
            dek = Math.Log10(endw / w_start);
            FAwritewedit();
        }


        #endregion

        


        #region Toolstrip-Methoden

        /// <summary>
        /// PlotButton-Click
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton_mesh_Click(object sender, EventArgs e)
        {
           
                meshform.Show();
               
        }


        /// <summary>
        /// Open File .zk
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton_openZK_Click(object sender, EventArgs ev)
        {
            try
            {
                List<String> pList = new List<String>();

     
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {

                    tabControl1.SelectedTab = tabPage_BodePar;
                    labelFN.Text = openFileDialog1.FileName;
                    FilterName=System.IO.Path.GetFileName(openFileDialog1.FileName);  

                    StreamReader filestream = new StreamReader(openFileDialog1.FileName,Encoding.Default);
                    string line = "";
                    while (line != null)
                    {
                        line = filestream.ReadLine();
                        if (line != null)
                        {
                            pList.Add(line);
                        }
                    }
                    filestream.Close();
                    copyList2AnalogFilterForm(pList);
                    
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        public void copyList2AnalogFilterForm(List<String> pList)
        {
            int len = pList.Count, i = 0;
            string[] outstr = new string[10];
            ecomment.Text = pList[0];
            meinMain.datatools.Str2NString(pList[1], ref outstr, ' ');
            // Change of size of the stringgrid by changing the Num - Up- Downs step by step
            int a = 0;
            int.TryParse(outstr[0],out a);
            while (a > nr.Value) nr.Value++;
            while (a < nr.Value) nr.Value--;
            FAaktnr = (int)nr.Value;

            int.TryParse(outstr[1], out a);
            while (a > nc.Value) nc.Value++;
            while (a < nc.Value) nc.Value--;
            FAaktnc = (int)nc.Value;

            int.TryParse(outstr[2], out a);
            while (a > pr.Value) pr.Value++;
            while (a < pr.Value) pr.Value--;
            FAaktpr = (int)pr.Value;

            int.TryParse(outstr[3], out a);
            while (a > pc.Value) pc.Value++;
            while (a < pc.Value) pc.Value--;
            FAaktpc = (int)pc.Value;

            meinMain.ConvertToDouble(outstr[4], ref FAkaf);
            EK.Text = FAkaf.ToString();
            FAaktmaxi = FAaktnr + FAaktnc + FAaktpr + FAaktpc;
            if ((FAaktmaxi + 2) > len) MessageBox.Show(wrongfileformat);
            else
            {
                for (i = 2; i <= FAaktmaxi + 1; i++)
                {
                    meinMain.datatools.Str2NString(pList[i], ref outstr, ' ');

                    double help = 0;
                    meinMain.ConvertToDouble(outstr[0], ref help);
                    StringGrid1.Rows[i - 2].Cells[1].Value = help.ToString();
                    meinMain.ConvertToDouble(outstr[1], ref help);
                    StringGrid1.Rows[i - 2].Cells[2].Value = help.ToString();


                }
                if (i < len)  /*there are some old Versions */
                {              /* of *.zk without delaytime tz */
                    meinMain.ConvertToDouble(pList[i], ref FAtzaf);

                    ETz.Text = FAtzaf.ToString();
                }  /*if*/
                meinMain.fa2d.labelActFilter.Text = FilterName;
            }
        }



        /// <summary>
        /// Write F Mag and PhiClick
        /// </summary>

        public int drawPhi()
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = radioButton_log.Checked;
            LOa.toptitle = FilterName + "  " + Epoints.Text + "  " + points;
            LOa.bottomtitle = bottomtitle;
            LOa.legend = "AnaFilt Phi";
            meinMain.BringToFront();
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, Memo2, ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            return (a);
        }
       
        public void toolStripButton_writeP_Click(object sender, EventArgs e)
        {
            calcbode();
            int a = drawPhi();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton21MagA.Enabled = true;
                meinMain.ToolButton22PhiA.Enabled = true;
                
            }

        }

        public int drawMag()
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = radioButton_log.Checked;
            LOa.toptitle = FilterName + "  " + Epoints.Text + "  " + points;
            LOa.bottomtitle = bottomtitle;
            LOa.legend = "AnaFilt Mag"; 
            meinMain.BringToFront();
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, Memo1, ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            return (a);
        }
        
        public void toolStripButton_writeF_Click(object sender, EventArgs e)
        {
            calcbode();
            int a = drawMag();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton21MagA.Enabled = true;
                meinMain.ToolButton22PhiA.Enabled = true;
              
            }

        }


        /// <summary>
        /// Safe *zk Click
        /// </summary>

        private void toolStripButton_safeZK_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                pList.Add(ecomment.Text);
                pList.Add(FAaktnr.ToString() + " " + FAaktnc.ToString() + " " +
                            FAaktpr.ToString() + " " + FAaktpc.ToString() + " " + FAkaf.ToString());
                for (int i = 1; i <= FAaktmaxi; i++)
                {
                    pList.Add(StringGrid1.Rows[i-1].Cells[1].Value + " "
                        + StringGrid1.Rows[i-1].Cells[2].Value);
                }
                pList.Add(FAtzaf.ToString());

                System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialog1.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
                
            }
        
        }


        #endregion



        
        #region allg. Methoden


        
           
     

        public void ApplicationEvents1Hint(object sender)
        {
            StatusBar1.Items[1].Text = "ApplicationEvents1Hint";
        }

        



        //Onload Form
        /// <summary>
        /// Event on formloading
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TFAnalogfilter_Load(object sender, EventArgs e)
        {
            
            //executed one time after start
            FAaktnr = (int)nr.Value;
            FAaktnc = (int)nc.Value;
            FAaktpr = (int)pr.Value;
            FAaktpc = (int)pc.Value;
            w_start = 0.01;
            Ewstart.Text = w_start.ToString();
            meinMain.ConvertToDouble(Ewend.Text,ref endw );
            meinMain.ConvertToDouble(Edek.Text,ref dek );
            Int32.TryParse(Epoints.Text,out  w_zahl);
            Efstart.Text = (w_start / 2 / pi).ToString();
            Efend.Text = (endw / 2 / pi).ToString();
            //FAkaf = 1.0; EK.Text = FAkaf.ToString();
       
        }
        //--------------------------------------

    

        //WriteHeadlines
        /// <summary>
        /// 
        /// </summary>
        private void FAwriteheadlines()
        {
            try
            {
                              
                //EventArgs e = new EventArgs();
                //TFAnalogfilter_Load(this, e);
                //int i, j = 0;
                FAaktmaxi = FAaktnr + FAaktnc + FAaktpc + FAaktpr;
                
            }
            catch (Exception err)
            {
                MessageBox.Show(err.ToString());                
            }
            
        }
        //-----------------------------------------

        
        /// <summary>
        /// For calculating the Bode-Plot
        /// </summary>
        public void calcbode()
        {
            double w, deltawlin, deltawlog, phi, betrag, k180d_pi;
            int i, j, wzaehler;
            double pi05, pi15, pi2, a, b, re, im, maxdb=0, maxbetrag, minbetrag;
            
            double[,] Cells = new double[3,FAaktmaxi+1];//count starts with 0, but here not used but start with 1

            String strw, strmag, strph;
            readw_values();
            w = w_start;
            deltawlog = Math.Exp(Math.Log(10)*dek / (w_zahl - 1));
            deltawlin = (endw - w) / (w_zahl - 1);
            k180d_pi = 180.0 / pi;
            pi05 = pi * 0.5; pi2 = pi * 2; pi15 = pi * 1.5;
            Memo1.Clear();
            Memo2.Clear();
            Memo3.Clear();
            Memo1.Visible = false;
            Memo2.Visible = false;
            Memo3.Visible = false;

            for (i = 1; i <= FAaktmaxi; i++)
            {
                
                for (j = 1; j < 3; j++)
                {
                    meinMain.ConvertToDouble(StringGrid1.Rows[i - 1].Cells[j].Value.ToString(), ref Cells[j, i]);
                }
                meinMain.ConvertToDouble(EK.Text, ref FAkaf);
                  
            }
            toolStripProgressBar1.Visible = true;
            toolStripProgressBar1.Maximum = w_zahl;

            for (wzaehler = 0; wzaehler <= (w_zahl - 1); wzaehler++)
            {
                /*Calculation of Betrag=magnitude &&Phase*/
                //Math.Atan2(Imag/Real) !!!
                toolStripProgressBar1.Value = wzaehler;
                Application.DoEvents();
                j = 0; phi = 0; betrag = FAkaf;

                for (i = 1; i <= FAaktnr; i++)
                {
                    a = Cells[1,i + j];
                    b = w * a;
                    betrag = betrag * Math.Sqrt(1 + b * b);
                    phi = phi + Math.Atan2(b,1);
                }
                j = FAaktnr;

                for (i = 1; i <= FAaktnc; i++)
                {
                    a = 2.0 * (Cells[1,i + j]);          /*2d*/
                    b = Cells[2,i + j];            /*wo*/
                    im = a * w / b;
                    re = 1 - w * w / b / b;
                    betrag = betrag * Math.Sqrt(re * re + im * im);
                    phi = phi + Math.Atan2( im,re);
                }
                j = j + FAaktnc;

                for (i = 1; i <= FAaktpr; i++)
                {
                    a = Cells[1,i + j];
                    b = w * a;
                    betrag = betrag / Math.Sqrt(1 + b * b);
                    phi = phi - Math.Atan2(b,1);

                }
                j = j + FAaktpr;

                for (i = 1; i <= FAaktpc; i++)
                {
                    a = 2.0 * (Cells[1,i + j]);          /*2d*/
                    b = Cells[2,i + j];            /*wo*/
                    im = a * w / b;
                    re = 1 - w * w / b / b;
                    betrag = betrag / Math.Sqrt(re * re + im * im);
                    phi = phi - Math.Atan2(im,  re);

                }

                /* delay */
                phi = phi - w * FAtzaf;

                /* correction of negative K */
                if (betrag < 0)
                {
                    betrag = Math.Abs(betrag);
                    phi = phi - pi;
                }
                
                /* correction, that phi between +pi/2  &&-3/2pi */
                if (rb270.Checked)
                {
                    while (phi < -pi15)
                        phi = phi + pi2;
                    while (phi > pi05)
                        phi = phi - pi2;
                }
                if (rb180.Checked)
                {
                    while (phi < -pi) phi = phi + pi2;
                    while (phi > pi) phi = phi - pi2;

                }
                // genauigkeit(w, ffFixed, 16, 16);  /*frequency w lin*/
                strw = (w/2/Math.PI).ToString();  

                if (radioButton_lin.Checked)
                {
                    w = w + deltawlin;
                }
                else
                {
                    w = w * deltawlog;
                }
                meinMain.ConvertToDouble(Edmaxdb.Text,ref maxdb);
                maxbetrag = Math.Exp(ln10 * maxdb / 20.0);
                minbetrag = 1.0 / maxbetrag;
                if (betrag < minbetrag) b = -maxdb; /*-limit */
                else if (betrag > maxbetrag) b = maxdb;   /*+limit */
                else b = 20.0 * Math.Log10(betrag);

                strmag = b.ToString();
                strph = (phi * k180d_pi).ToString();
                if (wzaehler < (w_zahl - 1))
                {  // last row without CRLF
                    Memo1.AppendText(strw + " " + strmag + CRLF);
                    Memo2.AppendText(strw + " " + strph + CRLF);
                    Memo3.AppendText(strw + " " + strmag + " " + strph + CRLF);
                }
                else
                {  // last row without CRLF
                    Memo1.AppendText(strw + " " + strmag);
                    Memo2.AppendText(strw + " " + strph);
                    Memo3.AppendText(strw + " " + strmag + " " + strph);
                }
            }  //end for (wzaehler....
            Memo1.Visible = true;
            Memo2.Visible = true;
            Memo3.Visible = true;
            toolStripProgressBar1.Visible = false;

            //if (radioButton_log.Checked)
            //    bottomtitle = "<-- " + (w_start).ToString("G10") +
            //    "       w=10^x        " + (endw).ToString("G10") + "-->";
            //else bottomtitle = "<-- " + radianfrequencyw + "-->";
            bottomtitle = "<-- " + radianfrequencyw + "-->";

        }

        



        #endregion
        
        
        
        
        #region Sprache

        public void deutsch()
        {
            this.Text = "Modifiziere analoges Filter für Bodediagramm";
            label_realZeroes.Text = "reelle Nullstellen (n_r)";
            label_complexZeroes.Text = "komplexe Nullstellen (nc)";
            label_realPoles.Text = "reelle Polstellen (p_r)";
            label_complexPoles.Text = "komplexe Polstellen (pc)";
            label_dcGain.Text = "DC-Verstärkung";
            label_delay.Text = "Totzeit";
            label1.Text = "Bode-Diagramm-Parameter";
            label_points.Text = "Punkte";
            label_decades.Text = "Dekaden";
            groupBox2.Text = "Start Frequenz";
            groupBox3.Text = "End-Frequenz";
            groupBox4.Text="Kurvenparameter";
            groupBox5.Text="Phasen- Wrapping";

            toolStripButton_openZK.ToolTipText = "Lade analoges Filter als *.zk-file";
            toolStripButton_safeZK.ToolTipText = "Speichere analoges Filter als *.zk-file";
            toolStripButton_help.ToolTipText = " Zeige Info an";
            toolStripButton_mesh.ToolTipText = "Zeige 3D- Betragsgebirge";
            toolStripButton_safeDAT.ToolTipText = "Speichere Bode- Daten als *.bdf, *,gpf und *.gpp- Datei";
            toolStripButton_safeZK.ToolTipText = "Speichere *.zk- Datei";
            toolStripButton_writeF.ToolTipText = "Zeichne Betragskurve in Main Form";
            toolStripButton_writeP.ToolTipText = "Zeichne Phasenkurve in Main Form";
            toolStripButton2.ToolTipText = "Schließe das Fenster";
            toolStripButton1.ToolTipText = "Öffne Frequenz- Rechner";
            bottomtitle="Kreisfrequenz w";
            radianfrequencyw = "Kreisfrequenz w";
            FilterName="neu";
            Rglinlog.Text = "Punkt Abstand";
           
            pictureBox1.Dock = DockStyle.None;
            pictureBox1.Visible = false;
            pictureBox2.Visible = true;
            pictureBox2.Dock = DockStyle.Fill;
        }

        #endregion
        


        
        

        
        #region StringGrid1

        //StringGrid1 Zeilen hinzufügen/entfernen****************************

        private void nr_ValueChanged(object sender, EventArgs e)
        {

            DataGridViewRowCollection row_coll = this.StringGrid1.Rows;
            if (FAaktnr < nr.Value)
            {                
                DataGridViewRow row = new DataGridViewRow();
                string[] val = new string[] { Resources.nr_string + nr_col_index.ToString(), "0", "0" };
                row.CreateCells(this.StringGrid1, val);

                StringGrid1.Rows.Insert(nr_col_index, row);
                nr_col_index++;
            }
            if (FAaktnr > nr.Value && nr.Value >= 0)
            {
                nr_col_index--;
                string search_string = Resources.nr_string + nr_col_index.ToString();
                foreach (DataGridViewRow rows_nr in row_coll)
                {
                    if (rows_nr.Cells[0].Value != null)
                    {
                        if (rows_nr.Cells[0].Value.ToString() == search_string)
                        {
                            StringGrid1.Rows.Remove(rows_nr);
                        }
                    }
                } 
            }
            FAaktnr = nr_col_index;
            FAwriteheadlines();
            this.StringGrid1.Sort(colsort, ListSortDirection.Ascending);
            
        }

        private void nc_ValueChanged(object sender, EventArgs e)
        {
            DataGridViewRowCollection row_coll = this.StringGrid1.Rows;
            if (FAaktnc < nc.Value)
            {

                DataGridViewRow row = new DataGridViewRow();
                string[] val = new string[] { Resources.nc_string + nc_col_index.ToString(), "0", "0" };
                row.CreateCells(this.StringGrid1, val);

                StringGrid1.Rows.Insert(nc_col_index, row);
                nc_col_index++;
            }
            if (FAaktnc > nc.Value && nc.Value >= 0)
            {
                nc_col_index--;
                string search_string = Resources.nc_string + nc_col_index.ToString();
                foreach (DataGridViewRow rows_nc in row_coll)
                {
                    if (rows_nc.Cells[0].Value != null)
                    {
                        if (rows_nc.Cells[0].Value.ToString() == search_string)
                        {
                            StringGrid1.Rows.Remove(rows_nc);
                        }
                    }
                }

            }
            FAaktnc = nc_col_index;
            FAwriteheadlines();
            this.StringGrid1.Sort(colsort, ListSortDirection.Ascending);
        }

        private void pr_ValueChanged(object sender, EventArgs e)
        {
            DataGridViewRowCollection row_coll = this.StringGrid1.Rows;
            if (FAaktpr < pr.Value)
            {

                DataGridViewRow row = new DataGridViewRow();
                string[] val = new string[] { Resources.pr_string + pr_col_index.ToString(), "0", "0" };
                row.CreateCells(this.StringGrid1, val);

                StringGrid1.Rows.Insert(pr_col_index, row);
                pr_col_index++;
            }
            if (FAaktpr > pr.Value && pr.Value >= 0)
            {
                pr_col_index--;
                string search_string = Resources.pr_string + pr_col_index.ToString();
                foreach (DataGridViewRow rows_pr in row_coll)
                {
                    if (rows_pr.Cells[0].Value != null)
                    {
                        if (rows_pr.Cells[0].Value.ToString() == search_string)
                        {
                            StringGrid1.Rows.Remove(rows_pr);
                        }
                    }
                }

            }
            FAaktpr = pr_col_index;
            FAwriteheadlines();
            this.StringGrid1.Sort(colsort, ListSortDirection.Ascending);
        }

        private void pc_ValueChanged(object sender, EventArgs e)
        {
            DataGridViewRowCollection row_coll = this.StringGrid1.Rows;
            if (FAaktpc < pc.Value)
            {

                DataGridViewRow row = new DataGridViewRow();
                string[] val = new string[] { Resources.pc_string + pc_col_index.ToString(), "0", "0" };
                row.CreateCells(this.StringGrid1, val);

                StringGrid1.Rows.Insert(pc_col_index, row);
                pc_col_index++;
            }
            if (FAaktpc > pc.Value && pc.Value >= 0)
            {
                pc_col_index--;
                string search_string = Resources.pc_string + pc_col_index.ToString();
                foreach (DataGridViewRow rows_pc in row_coll)
                {
                    if (rows_pc.Cells[0].Value != null)
                    {
                        if (rows_pc.Cells[0].Value.ToString() == search_string)
                        {
                            StringGrid1.Rows.Remove(rows_pc);
                        }
                    }
                }

            }
            FAaktpc = pc_col_index;
            FAwriteheadlines();
            this.StringGrid1.Sort(colsort, ListSortDirection.Ascending);
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            Hide();
        }

        private void toolStripButton_help_Click(object sender, EventArgs e)
        {
            groupBox5.Visible = toolStripButton_help.Checked;
            pictureBox1.Dock = DockStyle.Fill;
        }

        private void toolStripButton_safeDAT_Click(object sender, EventArgs e)
        {
            saveFileDialog2.FileName = System.IO.Path.GetFileNameWithoutExtension(openFileDialog1.FileName);
            if (saveFileDialog2.ShowDialog() == DialogResult.OK)
            {
                string fn = saveFileDialog2.FileName;
                string fnWoExt=System.IO.Path.ChangeExtension(fn,".gpf");
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fnWoExt);
                sw.Write(Memo1.Text);
                sw.Close();
                fnWoExt = System.IO.Path.ChangeExtension(fn, ".gpp");
                System.IO.StreamWriter sw1 = new System.IO.StreamWriter(fnWoExt);
                sw1.Write(Memo2.Text);
                sw1.Close();
                fnWoExt = System.IO.Path.ChangeExtension(fn, ".bdf");
                System.IO.StreamWriter sw2 = new System.IO.StreamWriter(fnWoExt);
                sw2.Write(Memo3.Text);
                sw2.Close();
            }

        }


        private void TFAnalogfilter_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            meinMain.frmxwcalc.Show();

        }

  
 
        
        
             
        

        //*********************************************************

        #endregion


        

        

        

        

                  

    }
}
