﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics; // Für Zeitmessung mit Stopwatch



namespace WINDF7CSharp

{
    public partial class FDigitalFilter : Form
    {

        /*globale Variablen*/

        // Digital Filter
        double sum = 0;
        public const int maxgrad = 20;
        public double[] Dxein = new double[maxgrad];
        public double[] Dxout = new double[maxgrad];
        public double[] DF1 = new double[maxgrad];
        public double[] DF2 = new double[maxgrad];
        String FilterName;
        // USB
        String radianfrequencyw = "Radian Frequency w";
        String points = "Points";
        double Dw_start, Dendw, Ddek;
        int Dw_zahl; 
        public int Dmgrad=0;
        const double pi = Math.PI;
        double ln10 = Math.Log(10);
        public double t0des = 0.314; 
        double tzint, t0run;

        public String coeff, wrongfileformat, bottomtitle;
        int anzahl = 32767;     // max points of bode

        FormMain meinMain;
        DataGridViewRow row = new DataGridViewRow();
        string CRLF = "\r\n";

        // Digital realtime Filter 
        Stopwatch stopwatch = new Stopwatch();
        double stoptm, timeAvr = 0;

        private readonly MicroLibrary.MicroTimer _microTimer;
        double starttmMM, stoptmMM, timeAvrMM = 0, TimeMin = 0;
        int cntMM = 1;


        public FDigitalFilter(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            Dw_start = 0.01;
            Ddek = 4;
            Dw_zahl = 1000;
            FAwritewedit();
            dataGridView1.Rows.Insert(0, row);  // Zeile Nr. 1
            coeff = "coeff";
            dataGridView1.Rows[0].Cells[0].Value = "coeff 0";
            dataGridView1.Rows[0].Cells[1].Value = "1";
            dataGridView1.Rows[0].Cells[2].Value = "1";
            wrongfileformat = "Wrong file format";
            label_points.Text = points + "< " + anzahl.ToString();
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(EventVomMMTimer);
            //       --> less CPU load
            _microTimer.Interval = 10000;                 // --> 10ms interval
            
            stopwatch.Start();
        }

        public void deutsch()
        {
            this.Text = "Modifiziere digitales Filter für Bodediagramm";
            label9.Text = "Grad m des Filters";
            label11.Text = "Entwurfsabtastzeit";
            label12.Text = "Laufzeit - Abtastzeit";
            labelFN.Text = "Keine Datei";
            labelContDelay.Text = "freie Totzeit";
            label10.Text = "Totzeit n*To";
            label1.Text = "Bode-Diagramm-Parameter";
            points = "Punkte";
            label_points.Text = "Punkte";
            label_decades.Text = "Dekaden";
            groupBox5.Text = "Start Frequenz";
            groupBox3.Text = "End-Frequenz";
            groupBox4.Text = "Kurvenparameter";
            groupBox2.Text = "Phasen- Wrapping";

            open.ToolTipText = "Lade digitales Filter als *.fz-Datei";
            save.ToolTipText = "Speichere digitales Filter als *.fz-Datei";
            toolStripButton1.ToolTipText = "Speichere Bode- Daten als *.bdf, *,gpf und *.gpp- Datei";
            toolStripButtonWriteF.ToolTipText = "Zeichne Betragskurve in Main Form";
            toolStripButtonWritephi.ToolTipText = "Zeichne Phasenkurve in Main Form";
            close.ToolTipText = "Schließe das Fenster";
            toolStripButton2.ToolTipText = "Öffne Frequenz- Rechner";
            FilterName = "neu";
            groupBoxDF.Text = "Digitales Echtzeitfilter";
            buttonDFoff.Text ="Deaktivieren";
            buttonDFon.Text = "Aktivieren";
            labelSelADC.Text = "gewähltes AD- Modul: ";
            labelADCCard.Text = "Nix";
            label1.Text = "Periode To";
            labelDuration.Text = "Rechenzeit: ";
            labelMinDur.Text = "Minimalwert :";
            cBFilteron.Text = "Filter aus, dann Abtast-Halte-Glied";


        }

        private void degreen_ValueChanged(object sender, EventArgs e)
        {
            if (dataGridView1.RowCount < (degreen.Value + 1))
            {
                dataGridView1.Rows.Insert((int)degreen.Value, 1);
                dataGridView1.Rows[dataGridView1.RowCount - 1].Cells[0].Value = coeff + " " + (degreen.Value).ToString();
            }
            else
            {
                dataGridView1.Rows.Remove(dataGridView1.Rows[(int)degreen.Value + 1]);
            }
            Dmgrad = (int)degreen.Value;
        }


 
        void calcbodedig()
        {
            double w, deltawlin, deltawlog, phi, betrag1, k180d_pi, maxdb=0, maxbetrag, minbetrag;
            int i, wzaehler;
            double pi05, pi15, pi2, ai, bi, rez, imz, ren, imn, wt0, sini, cosi;
            double[] teta = new double[2 * maxgrad + 1];  //very old temp Vector for the a and b values
            string strw, strmag, strph;
            double tdelay=0;

            this.tBMagnitude.Clear();
            this.tBPhi.Clear();
            this.textBox3.Clear();
            this.tBMagnitude.Visible = false;
            this.tBPhi.Visible = false;
            this.textBox3.Visible = false;
            meinMain.ConvertToDouble(Et0run.Text,ref t0run);// actualize t0run
            meinMain.ConvertToDouble(Etz.Text,ref tzint);
            meinMain.ConvertToDouble(tBContDelay.Text,ref tdelay);
            readw_values();

            meinMain.ConvertToDouble(Edmaxdb.Text,ref maxdb);
            maxbetrag = Math.Exp(ln10 * maxdb / 20.0);
            minbetrag = 1.0 / maxbetrag;

            meinMain.ConvertToDouble(dataGridView1.Rows[0].Cells[2].Value.ToString(), ref teta[Dmgrad + 1]); /*bo*/
            for (i = 1; i <= Dmgrad; i++)
            {
                meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[1].Value.ToString(), ref teta[i]); /*ai*/
                meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[2].Value.ToString(), ref teta[i + Dmgrad + 1]);/*bi*/
            } /*for*/
            w = Dw_start;
            deltawlog = Math.Exp(Math.Log(10) * Ddek / (Dw_zahl - 1));
            deltawlin = (Dendw - w) / (Dw_zahl - 1);
            k180d_pi = 180.0 / pi;
            pi05 = pi * 0.5; pi2 = pi * 2; pi15 = pi * 1.5;
            toolStripProgressBar1.Visible = true;
            toolStripProgressBar1.Maximum = Dw_zahl;

            for (wzaehler = 0; wzaehler <= Dw_zahl - 1; wzaehler++)
            {
                toolStripProgressBar1.Value = wzaehler;
                Application.DoEvents();
                wt0 = w * t0run;
                rez = teta[1 + Dmgrad]; /* =b0*/
                imz = 0; ren = 1; imn = 0;
                for (i = 1; i <= Dmgrad; i++)
                {
                    bi = teta[1 + i + Dmgrad];
                    sini = Math.Sin(i * wt0);
                    cosi = Math.Cos(i * wt0);
                    rez = rez + bi * cosi;
                    imz = imz - bi * sini;
                    ai = teta[i];
                    ren = ren + ai * cosi;
                    imn = imn - ai * sini;
                }
                betrag1 = Math.Sqrt((rez * rez + imz * imz) / (ren * ren + imn * imn));
                phi = Math.Atan2(imz, rez) - Math.Atan2(imn, ren) - (tzint * t0run + tdelay) * w;
                /* Winkelcorrection, that phi between +pi/2 and -3/2pi */
                /* correction, that phi between +pi/2  &&-3/2pi */
                if (rb270.Checked)
                {
                    while (phi < -pi15) phi = phi + pi2;
                    while (phi > pi05) phi = phi - pi2;
                }
                if (rb180.Checked)
                {
                    while (phi < -pi) phi = phi + pi2;
                    while (phi > pi) phi = phi - pi2;

                }

                strw = (w/2/Math.PI).ToString("G16");  /*frequency f lin*/

                if (radioButton_lin.Checked) w = w + deltawlin;
                else w = w * deltawlog;

                if (betrag1 < minbetrag) bi = -maxdb; /*-limit */
                else if (betrag1 > maxbetrag) bi = maxdb;   /*+limit */
                else bi = 20.0 * Math.Log10(betrag1);

                strmag = (bi).ToString("G16");
                strph = (phi * k180d_pi).ToString("G16");
                this.tBMagnitude.AppendText("      " + strw + " " + strmag + CRLF);
                this.tBPhi.AppendText("      " + strw + " " + strph + CRLF);
                this.textBox3.AppendText("      " + strw + " " + strmag + " " + strph + CRLF);
            } /* w-Schleife */
            //lastaccess = "Bode digital";
            this.tBMagnitude.Visible = true;
            this.tBPhi.Visible = true;
            this.textBox3.Visible = true;
            toolStripProgressBar1.Visible = false;


            bottomtitle = "<-- " + radianfrequencyw + "-->";


        }


        bool impulson;



        private void Etz_TextChanged(object sender, EventArgs e)
        {

        }

        private void commlab_DoubleClick(object sender, EventArgs e)
        {
            ecomment.Visible = true;
            ecomment.Text = commlab.Text;
        }

        private void ecomment_Leave(object sender, EventArgs e)
        {
            ecomment.Visible = false;
            commlab.Text = ecomment.Text;

        }


        private void Etz_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Etz.Text, ref tzint);
        }

        private void Et0des_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Et0des.Text, ref t0des);
        }

        private void Et0run_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Et0run.Text, ref t0run); 
            if (t0run == 0) t0run = 0.0001;
            //slimit.Caption = (1 / 2.0 / t0run).ToString("G10") + " Hz";
            meinMain.fstepresp.Et0run.Text = Et0run.Text;
        }

        private void open_Click_1(object sender, EventArgs e)
        {
            try
            {
                List<String> pList = new List<String>();


                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {

                    tabControl1.SelectedTab = tabpage1;
                    labelFN.Text = openFileDialog1.FileName;
                    FilterName = System.IO.Path.GetFileNameWithoutExtension(openFileDialog1.FileName);

                    StreamReader filestream = new StreamReader(openFileDialog1.FileName, Encoding.Default);
                    string line = "";
                    while (line != null)
                    {
                        line = filestream.ReadLine();
                        if (line != null)
                        {
                            pList.Add(line);
                        }
                    }
                    filestream.Close();
                    copyList2DigitalFilterForm(pList);

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }

        }

        public void copyList2DigitalFilterForm(List<String> pList)
        {
            int i;
            int len = pList.Count;
            string[] outstr = new string[10];
            ecomment.Text = pList[0];
            ecomment.Visible = true;
            double Dmgrad = Convert.ToInt32(pList[1]);
            int aktrowcount = dataGridView1.RowCount - 1;
            for (i = 0; i < aktrowcount; i++)  //Clear Datagridview
                degreen.Value--;

            if ((Dmgrad + 4) > len) MessageBox.Show(wrongfileformat);
            else
            {
                meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');
                dataGridView1.Rows[0].Cells[1].Value = outstr[0];
                dataGridView1.Rows[0].Cells[2].Value = outstr[1] ;
                for (i = 3; i <= (Dmgrad + 2); i++)
                {
                    degreen.Value++;
                    meinMain.datatools.Str2NString(pList[i], ref outstr, ' ');
                    dataGridView1.Rows[i - 2].Cells[1].Value = outstr[0];
                    dataGridView1.Rows[i - 2].Cells[2].Value = outstr[1] ;

                }
                meinMain.ConvertToDouble(pList[i], ref t0des);
                Et0des.Text = (t0des).ToString("G16");
                Et0run.Text = Et0des.Text;
                if (len > i + 1) // some files ,not all contain in last row the integer delay time n+T0
                {
                    meinMain.ConvertToDouble(pList[i + 1], ref tzint);
                    Etz.Text = (tzint).ToString("G16");
                }
                if (len > i + 2)  // some files contains  continuous delay
                    if (pList[i + 2] != "") tBContDelay.Text = pList[i + 2];
            }

        }




        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void FDigitalFilter_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void FAwritewedit()
        {
            Ewstart.Text = Dw_start.ToString("G10");
            Dendw = Dw_start * Math.Exp(ln10 * Ddek);
            Ewend.Text = Dendw.ToString("G10");
            Efstart.Text = (Dw_start / 2.0 / Math.PI).ToString("G10");
            Efend.Text = (Dendw / 2.0 / Math.PI).ToString("G10");
            Edek.Text = Ddek.ToString("G10");
            Epoints.Text = Dw_zahl.ToString("G10");
            Elogw.Text = Math.Log10(Dw_start).ToString("G10");
            ElogwEnd.Text = Math.Log10(Dendw).ToString("G10");
        }

        private void Ewstart_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Ewstart.Text, ref Dw_start);
            //if (radioButton_log.Checked) endw = w_start * Math.Exp(ln10 * dek);
            FAwritewedit();

        }

        private void Efstart_Leave(object sender, EventArgs e)
        {
            double help = Dw_start / 2.0 / Math.PI;
            meinMain.ConvertToDouble(Efstart.Text, ref help);
            Dw_start = help * 2.0 * Math.PI;
            //if (radioButton_log.Checked) endw = w_start * Math.Exp(ln10 * dek);
            FAwritewedit();

        }

        private void Ewend_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Ewend.Text,ref Dendw);
            Ddek = Math.Log10(Dendw / Dw_start);
            FAwritewedit();

        }

        private void Efend_Leave(object sender, EventArgs e)
        {
            double help= Dendw / 2.0 / Math.PI;
            meinMain.ConvertToDouble(Efend.Text, ref help);
            Dendw = help * 2.0 * Math.PI;
            Ddek = Math.Log10(Dendw / Dw_start);
            FAwritewedit();

        }

        private void Edek_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Edek.Text, ref Ddek);
            //if (radioButton_log.Checked) endw = w_start * Math.Exp(ln10 * dek);
            FAwritewedit();

        }
        private void Edek_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Edek_Leave(sender, e);
        }


        private void Epoints_Leave(object sender, EventArgs e)
        {
            if (!int.TryParse(Epoints.Text, out Dw_zahl))
            {
                Dw_zahl = 100;
                Epoints.Text = "100";
            }
            if (Dw_zahl > anzahl)
            {
                Dw_zahl = anzahl;
                Epoints.Text = Dw_zahl.ToString();
            }

        }

        private void Elogw_Leave(object sender, EventArgs e)
        {
            double x=Math.Log10(Dw_start);
            meinMain.ConvertToDouble(Elogw.Text, ref x);
            Dw_start = Math.Exp( x* ln10);
            FAwritewedit();

        }

        private void ElogwEnd_Leave(object sender, EventArgs e)
        {
            double x=Math.Log10(Dendw);
            meinMain.ConvertToDouble(ElogwEnd.Text, ref x);
            Dendw = Math.Exp( x* ln10);
            Ddek = Math.Log10(Dendw / Dw_start);
            FAwritewedit();

        }
        void readw_values()
        {   // before calcbode all data from textfields are actualized

            if (!int.TryParse(Epoints.Text, out Dw_zahl))
            {
                Dw_zahl = 100;
                Epoints.Text = "100";
            }
            if (Dw_zahl > anzahl)
            {
                Dw_zahl = anzahl;
                Epoints.Text = Dw_zahl.ToString();
            }
            meinMain.ConvertToDouble(Ewstart.Text,ref Dw_start  );
            meinMain.ConvertToDouble(Ewend.Text,ref Dendw  );
            Ddek = Math.Log10(Dendw / Dw_start);
            FAwritewedit();
        }


        public int DrawPhi()
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = radioButton_log.Checked;
            LOa.toptitle = FilterName + "  " + Epoints.Text + "  " + points;
            LOa.legend = "DigFilt Phi";
            LOa.bottomtitle = bottomtitle;
            meinMain.BringToFront();
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, tBPhi, ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            return (a);
        }

        public void toolStripButtonWritephi_Click(object sender, EventArgs e)
        {
            dataGridView1.EndEdit();
            calcbodedig();
            int a = DrawPhi();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton17PhiD.Enabled = true;
                meinMain.ToolButton23MagD.Enabled = true;
                meinMain.BringToFront();
            }

        }

        public int DrawMag()
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = radioButton_log.Checked;
            LOa.toptitle = FilterName + "  " + Epoints.Text + "  " + points;
            LOa.legend = "DigFilt Mag";
            LOa.bottomtitle = bottomtitle;
            meinMain.BringToFront();
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, tBMagnitude, ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            return (a);
        }

        
        public void toolStripButtonWriteF_Click(object sender, EventArgs e)
        {
            dataGridView1.EndEdit();
            calcbodedig();
            int a = DrawMag();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton17PhiD.Enabled = true;
                meinMain.ToolButton23MagD.Enabled = true;
                meinMain.ToolButton19SR.Enabled = true;

            }

        }

// Digitale realtime Filter ----------------------------------------------------------------------


        void EventVomMMTimer(object sender, MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {
            int i=0;
            double help = 0, duration;
            starttmMM = stoptmMM;
            stoptmMM = stopwatch.ElapsedTicks;
            timeAvrMM += (stoptmMM - starttmMM);  // Period
            cntMM++;
            // Now filter calculation
            if (cBFilteron.Checked)
            {
                for (i = Dmgrad + 1; i >= 2; i--)    /* shifting */
                {
                    Dxout[i] = Dxout[i - 1];
                    Dxein[i] = Dxein[i - 1];
                }
                Dxout[1] = sum; sum = 0;
            }
            if (impulson) meinMain.DACoutput((short)nudChanImpulse.Value , 1);  // 1V-test-impulse
            if(cBADon.Checked) meinMain.ADCinput((short)nudChanAD.Value,ref help);  // Filter Input ADC
            if (cBFilteron.Checked)
            {
                Dxein[1] = help;
                sum = DF2[0] * Dxein[1];      /* b0*xein(n) */
                for (i = 1; i <= Dmgrad; i++)
                {
                    sum = sum - DF1[i] * Dxout[i];      /*-ai*old outputs */
                    sum = sum + DF2[i] * Dxein[i + 1];    /*+bi*inputs */
                }
            }
            else sum = help; // only "Sample and Hold"
            if (cBDACon.Checked) meinMain.DACoutput((short)nudChanDA.Value , sum);  // Signal out to DAC

            if (impulson) meinMain.DACoutput((short)nudChanImpulse.Value , 0);  // 1V-test-impulse

            stoptm = stopwatch.ElapsedTicks;
            duration=stoptm-stoptmMM;// Duration
            timeAvr+=duration;
            if (duration < TimeMin) TimeMin = duration; // look for minimal duration time
        }

        private void buttonDFoff_Click(object sender, EventArgs e)
        {

            labelDurationTime.Visible = false;
            labelDuration.Visible = false;
            labelPeriod.Visible = false;
            label1.Visible = false;
            labelMinDurNb.Visible = false;
            labelMinDur.Visible = false;

            _microTimer.Stop();
            timerDisplay.Enabled = false;
        }

        private void butStopq2Reg_Click(object sender, EventArgs e)
        {
            string keypath = "Software\\FHL\\Windf";
            string num;
            string denom;
            int deg = dataGridView1.RowCount-1;
            num = deg.ToString()+ " " + dataGridView1.Rows[0].Cells[2].Value.ToString(); ;  // b0 immer Null
            denom = dataGridView1.Rows[0].Cells[1].Value.ToString();
            for (int i = 1; i <= deg; i++)
            {
                num += " " + dataGridView1.Rows[i].Cells[2].Value.ToString();
                denom += " " + dataGridView1.Rows[i].Cells[1].Value.ToString();
            }
            denom += " " + Etz.Text.ToString();
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "Num FZ", num, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "Denom Fz", denom, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 T0", Et0run.Text.ToString(), true);

        }

        public void initDF()
        {
            for (int i = 0; i <= Dmgrad; i++)
            {
                Dxein[i] = 0;
                Dxout[i] = 0;
            }
            for (int i = 1; i <= Dmgrad; i++)   // globaler Zwischenspeicher
            {
                meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[1].Value.ToString(), ref DF1[i]); /*ai*/
                meinMain.ConvertToDouble(this.dataGridView1.Rows[i].Cells[2].Value.ToString(), ref DF2[i]);/*bi*/
            }
            meinMain.ConvertToDouble(dataGridView1.Rows[0].Cells[2].Value.ToString(), ref DF2[0]);// b0

        }
        
        private void buttonDFon_Click(object sender, EventArgs e)
        {
            labelDurationTime.Visible = true;
            labelDuration.Visible = true;
            labelPeriod.Visible = true;
            label1.Visible = true;
            labelMinDurNb.Visible = true;
            labelMinDur.Visible = true;
            initDF();

            double help = _microTimer.Interval / 1000000.0;
            meinMain.ConvertToDouble(Et0run.Text, ref help);
            _microTimer.Interval = (long)(help * 1000000.0);  //Et0run in sec
            _microTimer.Start();
            timerDisplay.Enabled = true;
        }

        private void timerDisplay_Tick(object sender, EventArgs e)
        {
            if (cntMM > 0)
            {
                labelPeriod.Text = (timeAvrMM / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                labelDurationTime.Text = (timeAvr / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                labelMinDurNb.Text = (TimeMin / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                timeAvrMM = 0;
                timeAvr = 0;
                cntMM = 0;
                TimeMin = 1e10;
            }

        }

        private void cBImpulseOn_CheckedChanged(object sender, EventArgs e)
        {
            impulson = cBImpulseOn.Checked;
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            meinMain.frmxwcalc.Show();
        }

        private void toolStripButton1_Click_1(object sender, EventArgs e)
        {
            saveFileDialog2.FileName = System.IO.Path.GetFileNameWithoutExtension(openFileDialog1.FileName);
            if (saveFileDialog2.ShowDialog() == DialogResult.OK)
            {
                string fn = saveFileDialog2.FileName;
                string fnWoExt = System.IO.Path.ChangeExtension(fn, ".gpf");
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fnWoExt);
                sw.Write(tBMagnitude.Text);
                sw.Close();
                fnWoExt = System.IO.Path.ChangeExtension(fn, ".gpp");
                System.IO.StreamWriter sw1 = new System.IO.StreamWriter(fnWoExt);
                sw1.Write(tBPhi.Text);
                sw1.Close();
                fnWoExt = System.IO.Path.ChangeExtension(fn, ".bdf");
                System.IO.StreamWriter sw2 = new System.IO.StreamWriter(fnWoExt);
                sw2.Write(textBox3.Text);
                sw2.Close();
            }

        }

        private void save_Click_1(object sender, EventArgs e)  //Save *.fz file
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                pList.Add(ecomment.Text);
                pList.Add(degreen.Value.ToString());
                for (int i = 1; i <= degreen.Value+1; i++)
                {
                    pList.Add(dataGridView1.Rows[i - 1].Cells[1].Value + " "
                        + dataGridView1.Rows[i - 1].Cells[2].Value);
                }
                pList.Add(Et0des.Text);
                pList.Add(Etz.Text);    // Integer delay n*T0
                pList.Add(tBContDelay.Text);  // Continuous dalay

                System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialog1.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();

            }

        }

        private void close_Click_1(object sender, EventArgs e)
        {
            this.Close();
        }

        private void dataGridView1_Leave(object sender, EventArgs e)
        {
            dataGridView1.EndEdit();
        }

 

    }
}