﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
//using System.Drawing;
using WINDF7CSharp;

namespace WINDF7CSharp
{
    public partial class Meshform : Form
    {
        #region Constructor
        /// <summary>
        /// Constructor with MainForm handover
        /// </summary>
        /// <param name="meinAF">TFAnalogfilter tfanalogfilter</param>
        TFAnalogfilter meinAF;

        static int maxcell = 40;

        public Meshform(TFAnalogfilter m)
        {
            meinAF = m;
            InitializeComponent();
            p4 = new Pen(Color.Red, 1);
            p5 = new Pen(Color.Black, 1);
            
        }
        #endregion


        #region Felder

        /// <summary>
        /// Instance of the MainForm TFAnalogFilter
        /// </summary>


        //Copied Fields:
        const double pi = Math.PI;
        double ln10 = Math.Log(10);
        const int dist = 10; /*distance of to for PaintBox*/
        const double pid180 = pi / 180.0;
        double gridw,grids;
        double[,] Cells = new double[3, maxcell];
        int[,] Fmag = new int[1000, 1000];  // array for mag values

        double sqr(double x)
        {
            return (x * x);
        }



        #endregion


        /// <summary>
        /// FormClosing
        /// </summary>        
        //extern double w_start, endw, dek;     // aus  Uanalogfilter.cpp
        //extern int w_zahl, FAaktmaxi, FAaktnr, FAaktnc, FAaktpr, FAaktpc;  // aus  Uanalogfilter.cpp
        //extern double FAkaf, FAtzaf, t1af, t2af, FAt0; // DC-Gain, delay time, analog filter af}
        Graphics gPB; 
        Pen p1, p2;   // For coordinate system
        Pen p4, p5; //for Mesh
        SolidBrush sb1;

        private void Meshform_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Hide();
        }

        private void Meshform_Load(object sender, EventArgs e)
        {
            for (int i = 1; i <= meinAF.FAaktmaxi; i++)
                for (int j = 1; j < 3; j++)
                    meinAF.meinMain.ConvertToDouble(meinAF.StringGrid1.Rows[i - 1].Cells[j].Value.ToString(), ref Cells[j, i]);
            BtnPlot.Enabled = false;

        }


        /// <summary>
        /// Calc_Mag
        /// </summary>
        /// <param name="w">?</param>
        /// <param name="s">?</param>
        /// <returns></returns>
        double calc_mag(double w, double s)  // one value
        {
            int i, j;
            double im, re, a, b, d, w0, dw0, w02, betrag, nen;
            meinAF.meinMain.ConvertToDouble(meinAF.EK.Text, ref  meinAF.FAkaf);


            j = 0; betrag = meinAF.FAkaf;
            for (i = 1; i <= meinAF.FAaktnr; i++)
            {
                a = Cells[1, i + j];
                b = w * a;
                betrag = betrag * Math.Sqrt(sqr(1.0 + s * a) + b * b);
            }
            j = meinAF.FAaktnr;
            for (i = 1; i <= meinAF.FAaktnc; i++)
            {
                d = Cells[1, i + j];
                w0 = Cells[2, i + j];
                dw0 = 2.0 * d / w0;                  /*2d/w0*/
                w02 = 1.0 / sqr(w0);               /*1/w0^2*/
                im = dw0 * w + 2.0 * w * s * w02;
                re = 1 + dw0 * s + (s * s - w * w) * w02;
                betrag = betrag * Math.Sqrt(sqr(re) + sqr(im));
            }
            j = j + meinAF.FAaktnc;

            for (i = 1; i <= meinAF.FAaktpr; i++)
            {
                a = Cells[1, i + j];
                b = w * a;
                nen = Math.Sqrt(sqr(1 + s * a) + b * b);
                if (Math.Abs(nen) < 1e-10) nen = 1e-10;  /* avoid div by 0 */
                betrag = betrag / nen;
            }
            j = j + meinAF.FAaktpr;
            for (i = 1; i <= meinAF.FAaktpc; i++)
            {
                d = Cells[1, i + j];
                w0 = Cells[2, i + j];
                dw0 = 2.0 * d / w0;                  /*2d/w0*/
                w02 = 1.0 / sqr(w0);               /*1/w0^2*/
                im = dw0 * w + 2.0 * w * s * w02;
                re = 1 + dw0 * s + (s * s - w * w) * w02;
                nen = Math.Sqrt(sqr(re) + sqr(im));
                if (Math.Abs(nen) < 1e-10) nen = 1e-10;  /* avoid div by 0 */
                betrag = betrag / nen;
            }

            /* Correction for (negative K */
            if (betrag < 0) betrag = Math.Abs(betrag);
            return (betrag);

        }

        double endw, ends, betrmax;
        int x0, y0, w_zahl, s_zahl, zmax, dlr; 
        double alph;

        void calcAllFmag()
        {
            initKK();
            double x, y=0, betr, zr, w = 0, s = 0;
            int dx = (int)(w_zahl * 1.0 / gridw) + 1; 
            int dy = (int)(s_zahl * 1.0 / grids) + 1;
            double deltawlin = dx * (endw) / (w_zahl - 1.0);
            double deltaslin = dy * (ends) / (s_zahl - 1.0);
            int indx=0, indy = 0;
            
            while (y <= s_zahl)
            {
                x = 0; w = 0; indx = 0;
                while (x <= w_zahl)
                {

                    betr = calc_mag(w, s);
                    zr = betr / betrmax * zmax;
                    if (zr < 0) zr = 0;
                    //if (zr > zmax) zr = zmax;  // wil be done during plot
                    Fmag[indx,indy] = (int)(zr + 0.5);
                    indx++;
                    x = x + dx; w = w + deltawlin;
                } /* while x...*/
                y = y + dy;
                s = s + deltaslin;
                indy++;
            }  /* while y.....*/
            y=0;
        }
        
        
        private void BtnPlot_Click(object sender, EventArgs e)
        {
            
            const int p3d = 2048;

            initKK();
            
            int dx, dy;
            double w, deltawlin;
            double s, deltaslin, zr, dxs;

            /* plot3d */
            int x, y, z, yp, xpvor, ypvor, xp;
            int[] Max = new int[p3d];
            int[] Min = new int[p3d];   // definition von arrays

            for (x = 0; x < p3d; x++)
            {
                Max[x] = 0; Min[x] = 8000;
            }
           
            koordinatenkreuz();
            dx = (int)(w_zahl * 1.0 / gridw) + 1; 
            dy = (int)(s_zahl * 1.0 / grids) + 1;
            deltawlin = dx * (endw) / (w_zahl - 1.0);
            deltaslin = dy * (ends) / (s_zahl - 1.0);
            int indx = 0, indy = 0;


            /* drawing of 3 D - picture */
            x = 0; y = 0; ypvor = 0;
            s = 0; dxs = 0;
            w = 0;
            while (y <= s_zahl)
            {
                x = 0; w = 0; xpvor = 20 + y; indx = 0;
                while (x <= w_zahl)
                {


                    z = Fmag[indx, indy];
                    if (z > zmax) z = zmax;
                    indx++;
                    yp = y0 - z - y; xp = (int)(x0 + x + dxs);
                    if (x != 0)
                    {

                        if ((ypvor >= Max[xpvor]) && (yp >= Max[xp]))
                        {
                            
                            gPB.DrawLine(p5, xpvor, ypvor, xp, yp);

                            Max[xp] = yp;

                        }

                        if ((ypvor <= Min[xpvor]) && (yp <= Min[xp]))
                        {
                           
                            gPB.DrawLine(p4, xpvor, ypvor, xp, yp);
                            Min[xp] = yp;
                        }
                    }
                    ypvor = yp; xpvor = xp; x = x + dx; w = w + deltawlin; 
                } /* while x...*/
                y = y + dy; s = s + deltaslin; dxs = dxs + dy * dlr * 1.0 / s_zahl; indy++;
            }  /* while y.....*/

            koordinatenkreuz();
        }  /* void calc_mag */


        /// <summary>
        /// 
        /// </summary>
        /// <param name="endw">?</param>
        /// <param name="ends">?</param>
        /// <param name="betrmax">?</param>
        /// <param name="x0">?</param>
        /// <param name="y0">?</param>
        /// <param name="wz">?</param>
        /// <param name="sz">?</param>
        /// <param name="zm">?</param>
        /// <param name="dlr">?</param>
 
        void initKK()
        {
            double temp=0;
            if (gPB != null) gPB.Dispose();
            gPB = Graphics.FromHwnd(pictureBox1.Handle);
            if (sb1 == null) sb1 = new SolidBrush(Color.White);
            gPB.FillRectangle(sb1, 0, 0, pictureBox1.Width, pictureBox1.Height);
            meinAF.meinMain.ConvertToDouble(edgridw.Text, ref temp);
            gridw = temp;
            meinAF.meinMain.ConvertToDouble(edgrids.Text, ref temp);
            grids = temp;
            alph = (double)hor_eye.Value * pid180;  /* angle in rad*/
            dlr = (int)Math.Truncate(Math.Sin(alph) / (Math.Sin(Math.Abs(alph)) + Math.Cos(alph)) * pictureBox1.Width);
            alph = (double)vert_eye.Value * pid180;  /* angle in rad*/
            s_zahl = (int)Math.Truncate(Math.Sin(alph) / (Math.Sin(alph) + Math.Cos(alph)) * pictureBox1.Height);
            meinAF.meinMain.ConvertToDouble(edendw.Text, ref temp);
            endw = temp;
            meinAF.meinMain.ConvertToDouble(edends.Text, ref temp);
            ends = temp;
            meinAF.meinMain.ConvertToDouble(edmagmax.Text, ref temp);
            betrmax = temp;
            w_zahl = pictureBox1.Width - Math.Abs(dlr) - 1 - 2 * dist;  /* horizontal pixels */
            s_zahl = s_zahl - 1;                         /* pixel in;i<=picture, depth */
            zmax = pictureBox1.Height - s_zahl - 2 * dist;     /* vertical pixels */
            if (dlr > 0) x0 = dist; else x0 = dist - dlr;
            y0 = pictureBox1.Height - 1 - dist;

        }


        void koordinatenkreuz()
        /* covered borders dotted, Axis blau, block green
         x0: left  y0: bottom wz:width  sz: depth zm: height
          dlr left/right distance*/
        {
            int xe, ye;
            int x0h, y0h, xeh, yeh;

            xe = w_zahl + x0; ye = y0 - zmax;
            x0h = x0 + dlr; y0h = y0 - s_zahl; xeh = w_zahl + x0 + dlr; yeh = y0 - s_zahl - zmax;
            

            p1 = new Pen(Color.Blue, 2);   // blue for the three axis
            p2 = new Pen(Color.Green, 1);  // green  for the rest of the box
            gPB.DrawLine(p1, x0, y0, xe, y0);                  /* x-Axis */
            gPB.DrawLine(p1, xe, y0, xe, y0 + dist);               /* x-Mark */


            gPB.DrawLine(p1, x0, y0, x0, ye);          /* z-Axis */
            gPB.DrawLine(p1, x0, ye, x0 - dist, ye);          /* z-Mark */


            //gPB.DrawLine(p1, x0, y0, x0, ye);          /* z-Axis */
            //gPB.DrawLine(p1, x0, ye, x0 - dist, ye);          /* z-Mark */
            //p5 = new Pen(Color.Blue, 2);
            if (dlr > 0) p1.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;        
            else p1.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;

            gPB.DrawLine(p1, x0, y0, x0h, y0h);      /* y-Axis */
            //gPB.DrawLine(p1, x0, y0, x0h - dist, y0h);       /* y-Mark */

            // textout
            Font font = new Font("Arial", 16);
            SolidBrush drawBrush = new SolidBrush(Color.Black);
            gPB.DrawString(endw.ToString(), font, drawBrush, xe + 10, y0 - dist);


            if ((y0 > 200) && (xeh > 200))  /*if place enough */
                if (dlr > 0)
                {
                    gPB.DrawString(endw.ToString(), font, drawBrush, xe + 10, y0 - dist);
                    //gPB.DrawString(x0, ye - 60);
                    gPB.DrawString(betrmax.ToString(), font, drawBrush, x0, ye - 40);
                    //gPB.DrawString(xeh, y0h + 20);
                    gPB.DrawString(ends.ToString(), font, drawBrush, xeh - 40, y0h + 60);

                }
                else  /*dlr<0*/
                {
                    gPB.DrawString(endw.ToString(), font, drawBrush, xe - 60, y0 - dist);
                   // gPB.DrawString(xe - 60, ye - 60);
                    gPB.DrawString(betrmax.ToString(), font, drawBrush, xe - 60, ye - 40);
                    //gPB.DrawString(x0h, y0h + 20);
                    gPB.DrawString(ends.ToString(), font, drawBrush, x0h, y0h + 60);

                }
            /* Quader  */
        

            gPB.DrawLine(p2, x0, ye, x0h, yeh);       /* square on the top */
            gPB.DrawLine(p2, x0h, yeh, xeh, yeh);
            gPB.DrawLine(p2, xeh, yeh, xe, ye);
            gPB.DrawLine(p2, xe, ye, x0, ye);
            gPB.DrawLine(p2, xe, y0, xe, ye);      /*front right*/
            p2.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;         //das
            gPB.DrawLine(p2, x0h, y0h, xeh, y0h);     /* behind bottom*/
            if (dlr > 0)
            {
                p2.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;     //das
                gPB.DrawLine(p2, xe, y0, xeh, y0h);       /* right side */
                gPB.DrawLine(p2, xeh, y0h, xeh, yeh);
                p2.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;     //sol
                gPB.DrawLine(p2, x0h, y0h, x0h, yeh);         /*behind left */
            }
            else
            {
                p2.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;    // das
                gPB.DrawLine(p2, xe, y0, xeh, y0h);     /* right side */
                gPB.DrawLine(p2, xeh, y0h, xeh, yeh);
                p2.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;    // sol
                gPB.DrawLine(p2, x0h, y0h, x0h, yeh);      /*behind left */
            }

           
        }/*void koordinatenkreuz */

        private void vert_eye_ValueChanged(object sender, EventArgs e)
        {
            initKK();
            koordinatenkreuz();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            calcAllFmag();
            BtnPlot.Enabled = true;
        }

        private void OKBtn_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void edendw_TextChanged(object sender, EventArgs e)
        {
            BtnPlot.Enabled = false;
        } 





    }
}
