using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;



namespace WINDF7CSharp
{

    public partial class Fa2d : Form
    {
        //---------------------------------------------------------------------
        double t0des, FAkaf;
        //---------------------------------------------------------------------

        FormMain meinMain;
        Finfoa2d fa2dinfo;

        public Fa2d(FormMain mm)
        {
            InitializeComponent();
            meinMain=mm;
            t0des= 0.1;
            outfreq();
            fa2dinfo = new Finfoa2d();

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
        private double sqr(double x)
        {
            return (x*x);
        }


        private void ToolBOK_Click(object sender, EventArgs e)
        {
            int i, j, n, m, jh, grad=0;
            //int bi;

            
            //double a[maxgrad+1],b[maxgrad+1],wertzk[maxgrad+1,3];
            int maxgrad = meinMain.fanalogfilter.FAaktnr + 2 * meinMain.fanalogfilter.FAaktnc+ meinMain.fanalogfilter.FAaktpr + 2 * meinMain.fanalogfilter.FAaktpc;

            
            double[] a = new double[maxgrad + 1];
            double[] b = new double[maxgrad + 1];
            double[,] wertzk = new double[maxgrad + 1, 3];
            double kz, T, d, wo, b0, b1, b2, a1, a2;


            Et0des_Leave(sender, e);  // actualize the T0 - value
            //RGmethod.SetFocus(); // force to leave any Edit-field
            //groupBox1.Focus;
            //Et0desExit(Sender);
            //FDigitalfilter.Et0des.Text=Et0des.Text; // Copy T0 into DF-Window

            //FormMain1.ToolButton23MagD.Enabled=true;
            //FormMain1.digfilavailable=true;
            //FormMain1.ToolButton17PhiD.Enabled=true;
            //FormMain1.drawmagdigitalfilter1.Enabled=true;
            //FormMain1.calcresponse1.Enabled=true;
            //FormMain1.drawphasedigitalfilter1.Enabled=true;
            //FormMain1.ToolButton19SR.Enabled=true;

            //if (RGmethod.ItemIndex==0 )  method='r' ;else method='t';
            



            // preparations
            meinMain.ConvertToDouble(meinMain.fanalogfilter.EK.Text, ref FAkaf);

            for (i = 1; i <= meinMain.fanalogfilter.FAaktmaxi; i++) // Copy analog filter values
            {
                meinMain.ConvertToDouble(meinMain.fanalogfilter.StringGrid1.Rows[i - 1].Cells[1].Value.ToString(), ref wertzk[i, 1]);
                meinMain.ConvertToDouble(meinMain.fanalogfilter.StringGrid1.Rows[i - 1].Cells[2].Value.ToString(), ref wertzk[i, 2]);
            } /* for*/

            for (i = 1; i <= meinMain.fanalogfilter.FAaktmaxi; i++) { a[i] = 0; b[i] = 0; } 
            a[0] = 1; 
            b[0] = 1;
            if (rBtrapezoidal.Checked == true)
            {
                /* Here starts the Boxer-Thaler (= trapezoidal) -transformation p=(1-z^-1)/2To/(1+z^-1)*/
                j = 0; //bi=1;
                for (i = 1; i <= meinMain.fanalogfilter.FAaktnr; i++)
                {
                    T = wertzk[i + j, 1]; b0 = 1 + 2 * T / t0des; b1 = 1 - 2 * T / t0des;
                    b[maxgrad] = b[maxgrad - 1] * b1;
                    for (jh = maxgrad - 1; jh >= 1; jh--)
                        b[jh] = b[jh] * b0 + b[jh - 1] * b1;
                    b[0] = b[0] * b0;
                }
                j = meinMain.fanalogfilter.FAaktnr;
                for (i = 1; i <= meinMain.fanalogfilter.FAaktnc; i++)
                {
                    d = wertzk[i + j, 1]; wo = wertzk[i + j, 2];
                    b0 = 1 + 4 * d / wo / t0des + 4 / sqr(wo * t0des);
                    b1 = 2 - 8 / sqr(wo * t0des);
                    b2 = 1 - 4 * d / wo / t0des + 4 / sqr(wo * t0des);
                    b[maxgrad] = b[maxgrad - 2] * b2;
                    if (maxgrad > 2) b[maxgrad - 1] = b[maxgrad - 3] * b2 + b[maxgrad - 2] * b1;
                    for (jh = maxgrad - 2; jh >= 2; jh--)
                        b[jh] = b[jh] * b0 + b[jh - 1] * b1 + b[jh - 2] * b2;
                    b[1] = b[1] * b0 + b[0] * b1;
                    b[0] = b[0] * b0;
                }
                j = j + meinMain.fanalogfilter.FAaktnc;
                kz = FAkaf;
                for (i = 1; i <= meinMain.fanalogfilter.FAaktpr; i++)
                {
                    T = wertzk[i + j, 1]; b0 = 1 / (1 + 2 * T / t0des);
                    a1 = (1 - 2 * T / t0des) * b0;
                    kz = kz * b0;
                    a[maxgrad] = a[maxgrad - 1] * a1;
                    for (jh = maxgrad - 1; jh >= 1; jh--)
                        a[jh] = a[jh] + a[jh - 1] * a1;
                }
                j = j + meinMain.fanalogfilter.FAaktpr;
                for (i = 1; i <= meinMain.fanalogfilter.FAaktpc; i++)
                {
                    d = wertzk[i + j, 1]; wo = wertzk[i + j, 2];
                    b0 = 1 / (1 + 4 * d / wo / t0des + 4 / sqr(wo * t0des));
                    a1 = b0 * (2 - 8 / sqr(wo * t0des));
                    a2 = b0 * (1 - 4 * d / wo / t0des + 4 / sqr(wo * t0des));
                    kz = kz * b0;
                    a[maxgrad] = a[maxgrad - 2] * a2;
                    if (maxgrad>2) a[maxgrad - 1] = a[maxgrad - 3] * a2 + a[maxgrad - 2] * a1;
                    for (jh = maxgrad - 2; jh >= 2; jh--)
                        a[jh] = a[jh] + a[jh - 1] * a1 + a[jh - 2] * a2;
                    a[1] = a[1] + a[0] * a1;
                }

                for (i = 0; i <= maxgrad; i++) b[i] = b[i] * kz;
                m = meinMain.fanalogfilter.FAaktnr + 2 * meinMain.fanalogfilter.FAaktnc; n = meinMain.fanalogfilter.FAaktpr + 2 * meinMain.fanalogfilter.FAaktpc;
                if (n == m) grad = n
                  ;
                else if (n > m)
                {
                    grad = n;
                    for (i = m; i <= n - 1; i++)      /* *(1+z^-1)^n-m */
                    {
                        b[maxgrad] = b[maxgrad - 1];
                        for (j = maxgrad - 1; j >= 1; j--)
                            b[j] = b[j] + b[j - 1];
                    }
                }
                else
                {
                    grad = m;
                    for (i = n; i <= m - 1; i++)      /* /(1+z^-1)^m-n */
                    {
                        a[maxgrad] = a[maxgrad - 1];
                        for (j = maxgrad - 1; j >= 1; j--)
                            a[j] = a[j] + a[j - 1];
                    }
                }

            }  /* trapezoidal */
            if (rBRectangular.Checked == true)
            {  /* rectangular approx. */
                /* Here starts the rectangular transformation p=(1-z^-1)/t0*/
                j = 0; //bi=1;
                for (i = 1; i <= meinMain.fanalogfilter.FAaktnr; i++)
                {
                    T = wertzk[i + j, 1]; b0 = 1 + T / t0des; b1 = -T / t0des;
                    b[maxgrad] = b[maxgrad - 1] * b1;
                    for (jh = maxgrad - 1; jh >= 1; jh--)
                        b[jh] = b[jh] * b0 + b[jh - 1] * b1;
                    b[0] = b[0] * b0;
                }
                j = meinMain.fanalogfilter.FAaktnr;
                for (i = 1; i <= meinMain.fanalogfilter.FAaktnc; i++)
                {
                    d = wertzk[i + j, 1]; wo = wertzk[i + j, 2];
                    b0 = 1 + 2 * d / wo / t0des + 1 / sqr(wo * t0des);
                    b1 = -2 * d / wo / t0des - 2 / sqr(wo * t0des);
                    b2 = 1 / sqr(wo * t0des);
                    b[maxgrad] = b[maxgrad - 2] * b2;
                    if (maxgrad > 2) b[maxgrad - 1] = b[maxgrad - 3] * b2 + b[maxgrad - 2] * b1;
                    for (jh = maxgrad - 2; jh >= 2; jh--)
                        b[jh] = b[jh] * b0 + b[jh - 1] * b1 + b[jh - 2] * b2;
                    b[1] = b[1] * b0 + b[0] * b1;
                    b[0] = b[0] * b0;
                }
                j = j + meinMain.fanalogfilter.FAaktnc;
                kz = FAkaf;
                for (i = 1; i <= meinMain.fanalogfilter.FAaktpr; i++)
                {
                    T = wertzk[i + j, 1]; b0 = 1 / (1 + T / t0des);
                    a1 = (-T / t0des) * b0;
                    kz = kz * b0;
                    a[maxgrad] = a[maxgrad - 1] * a1;
                    for (jh = maxgrad - 1; jh >= 1; jh--)
                        a[jh] = a[jh] + a[jh - 1] * a1;
                }
                j = j + meinMain.fanalogfilter.FAaktpr;
                for (i = 1; i <= meinMain.fanalogfilter.FAaktpc; i++)
                {
                    d = wertzk[i + j, 1]; wo = wertzk[i + j, 2];
                    b0 = 1 / (1 + 2 * d / wo / t0des + 1 / sqr(wo * t0des));
                    a1 = b0 * (-2 * d / wo / t0des - 2 / sqr(wo * t0des));
                    a2 = b0 * (1 / sqr(wo * t0des));
                    kz = kz * b0;
                    a[maxgrad] = a[maxgrad - 2] * a2;
                    if (maxgrad > 2) a[maxgrad - 1] = a[maxgrad - 3] * a2 + a[maxgrad - 2] * a1;
                    for (jh = maxgrad - 2; jh >= 2; jh--)
                        a[jh] = a[jh] + a[jh - 1] * a1 + a[jh - 2] * a2;
                    a[1] = a[1] + a[0] * a1;
                }

                for (i = 0; i <= maxgrad; i++) b[i] = b[i] * kz;
                m = meinMain.fanalogfilter.FAaktnr + 2 * meinMain.fanalogfilter.FAaktnc; n = meinMain.fanalogfilter.FAaktpr + 2 * meinMain.fanalogfilter.FAaktpc;  // n order numerator m denom
                if (n >= m) grad = n; else grad = m;
            }       /* rectangular approx. */

   // copy results into Digital filter window

            List<String> pList = new List<String>();

            pList.Add("Converted from analog Filter "+ labelActFilter.Text);
            pList.Add(grad.ToString());
            pList.Add("1 " + b[0].ToString());
            for (i = 1; i <= grad; i++)
            {
                pList.Add(a[i].ToString() + " " + b[i].ToString());
            }
            pList.Add(t0des.ToString());
            meinMain.fstepresp.Et0run.Text = t0des.ToString();
            meinMain.fdigfilt.copyList2DigitalFilterForm(pList);
            meinMain.ToolButton19SR.Enabled = true;
            Hide();
        }

        private void ToolBinfo_Click(object sender, EventArgs e)
        {
             fa2dinfo.Show();
        }

        private void ToolBCancel_Click(object sender, EventArgs e)
        {
            Hide();
        }

//---------------------------------------------------------------------------

        public void deutsch()
        {
            this.Text = "Modifiziere digitales Filter";
            this.Label1.Text = "Analoges Filter";
            this.label4.Text = "Abtastfrequenz fo";
            this.label6.Text = "Shannongrenze fo/2";
            this.label8.Text = "Abtastkreisfrequenz wo";
            this.label10.Text = "Shannongrenze wo/2";
            this.Designt0.Text = "Entwurfsabtastzeit To";
            this.Warning.Text = "Berechnung zerstrt altes digitales Filter ! ";
            this.checkBox1.Text = "Keine obige Warnung mehr";

            //Fa2d->RGmethod->Caption = "Methode";
            //Fa2d->RGmethod->Items->Strings[0] = "Rechteckintegration";
            //Fa2d->RGmethod->Items->Strings[1] = "Trapezint. (bilin.)";
            this.groupBox1.Text = "Methode";
            this.rBRectangular.Text = "Rechteckintegration";
            this.rBtrapezoidal.Text = "Trapezint. (bilin.)";

            this.ToolBCancel.ToolTipText = "Schliee ohne Berechnung";
            this.ToolBinfo.ToolTipText = "Hinweis zu den Konversionsmethoden";
            this.ToolBOK.ToolTipText = "Schliee mit Berechnung der dig. Filterkoeffizienten";

        }
//---------------------------------------------------------------------------
        private void outfreq()
        {
            Et0des.Text=t0des.ToString();
            Efo.Text = (1.0 / t0des).ToString();
            Efo2.Text = (1.0 / t0des / 2.0).ToString();
            Ewo.Text = (2.0 * Math.PI / t0des).ToString();
            Ewo2.Text = (Math.PI / t0des).ToString();
        }

        private void Et0des_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(Et0des.Text, ref t0des);
            outfreq();
        }

        private void Efo_Leave(object sender, EventArgs e)
        {
            double help = 1.0 / t0des;
            meinMain.ConvertToDouble(Efo.Text,ref help);
            t0des = 1.0 / help;
            outfreq();
        }

        private void Ewo_Leave(object sender, EventArgs e)
        {
            double help = 2.0 * Math.PI / t0des;
            meinMain.ConvertToDouble(Ewo.Text, ref help);
            t0des = 2.0 * Math.PI / help;
            outfreq();
        }

        private void Efo2_Leave(object sender, EventArgs e)
        {
            double help = 1.0 / t0des / 2.0;
            meinMain.ConvertToDouble(Efo2.Text,ref help);
            t0des = 1.0 / 2.0 / help;
            outfreq();
        }

        private void Ewo2_Leave(object sender, EventArgs e)
        {
            double help=Math.PI/t0des;
            meinMain.ConvertToDouble(Ewo2.Text, ref help);
            t0des = Math.PI / help;
            outfreq();
        }

        private void Fa2d_Activated(object sender, EventArgs e)
        {
        //   actfname.Caption=FilterName;
        //    actcomment.Caption=FAnalogfilter.commlab.Caption;

        //    if ((FilterName!="new") )
        //        if ((CheckBox1.Checked==false) )
        //        {
        //            Warning.Visible=true;
        //            CheckBox1.Visible=true;
        //        } /*if*/ else {
        //        Warning.Visible=false;
        //        CheckBox1.Visible=false;
        //    } /* ;else*/
       
        }

        private void Et0des_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Et0des_Leave(sender, e);
        }

        private void Efo_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Efo_Leave(sender, e);
        }

        private void Efo2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Efo2_Leave(sender, e);
        }

        private void Ewo_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Ewo_Leave(sender, e);
        }

        private void Ewo2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Ewo2_Leave(sender, e);
        }

        private void Fa2d_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }
       
 
    }
}