﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WINDF7CSharp.ChartTools
{
    public partial class FormCurvePlotter : Form
    {
        FormMain meinMain;

        public FormCurvePlotter(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            int serie=meinMain.chart2D1.Counter+1;
            if (serie > 10)
            {

                MessageBox.Show(meinMain.notmorethan10curves);
            }
            else
            {
                int i, nb = (int)numericUpDown1.Value;
                meinMain.ConvertToDouble(tBPar1.Text, ref Xmax);
                meinMain.ConvertToDouble(tBpar2.Text, ref amp);

                meinMain.chart2D1.Visible = true;
                meinMain.enableCurveButtons();
                double x, xn1, y = 0;
                for (i = 0; i < nb; i++)
                {
                    x = Xmax * i / (nb - 1);// x goes from 0 to xmax
                    xn1 = Xmax * (i + 1) / (nb - 1); //next point
                    y = function(x);
                    meinMain.chart2D1.setPoint(serie - 1, x, y);
                    if (cBSandHold.Checked)
                        meinMain.chart2D1.setPoint(serie - 1, xn1, y);  // draws horizontal step
                }
                meinMain.chart2D1.CurveNames[serie - 1] = leg;
                meinMain.chart2D1.updateNames();
                meinMain.chart2D1.autoScaling();
                meinMain.chart2D1.startDrawing();
            }

        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Hide();
        }

        public string leg;

        double amp = 0;
        public double Xmax = 0;

        public double function(double x)
        {
            double y = 0;
            double frequ = 0;
            meinMain.ConvertToDouble(textBox1.Text, ref frequ);

            if (radioButtonExp.Checked)
            {
                //y = amp*(1 - Math.Exp(-2.0 * x));
                //leg = "1-exp(-2x)";
                // ......Lösung Bay77 T2 
                //y = 0.5 * (1 +4.50 * Math.Exp(-0.2 * x) * Math.Sin(1.7777 * x - 12.84 * Math.PI / 180.0));
                //leg = "Bay77T2";
                // ......................
                //Sprungaw 3 PT1 T1...T3 Aus RTP V1 T3
                //double t1 = 0.0121, t2 = 0.02303, t3 = 0.09717, k=0.98;
                //y = k * (1 - t1 * t1 * Math.Exp(-x / t1) / (t1 - t2) / (t1 - t3) - t2 * t2 * Math.Exp(-x / t2) / (t2 - t1) / (t2 - t3) - t3 * t3 * Math.Exp(-x / t3) / (t3 - t2) / (t3 - t1));
                //leg = "3 PT1";

                // ......................
                // Ebay99-3
                double t1 = 0.3, t2 = 0.2, k=224;
                y = k * (1 - 2 * Math.Exp(-x / t1)  + Math.Exp(-x / t2));



            }
            if (radioButtonCos.Checked)
            {
                y = amp * (Math.Cos(2 * Math.PI * frequ * x + 140 * Math.PI / 180.0));
                leg = "Cosinus " + textBox1.Text+ " kHz";
                if (cBSandHold.Checked) leg += " +S&H";
            }
            if (radioButtonSin.Checked)
            {

                y = amp*(Math.Sin(2 * Math.PI*frequ*x + 140*Math.PI/180.0 ));   // Phasenverschiebung von 140 °
                leg = "Sinus " + textBox1.Text + " kHz";
                if (cBSandHold.Checked) leg += " +S&H";
            }
            if (rB4.Checked)
            {  //weg mit konstanter Beschleunigung amp, nach der Hälfte konstante Bremsung
                if (x < Xmax/2.0)
                    y = amp * x * x;
                else
                    y = -amp * (Xmax * Xmax / 2 - 2 * x * Xmax + x * x);
            }
            return (y);

        }

        private void FormCurvePlotter_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown1, 10, 1e4);
            if (meinMain.chart2D1.Counter > 0) meinMain.chart2D1.clearLast();
            buttonOK_Click(sender, e);
        }
    }
}
