using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using WINDF7CSharp;

namespace Flash
{
    public partial class FlashForm : Form
    {
        double Ks, T1, T2, d, wo, F_st, Kr, R1, R2, R3, C1, C2, ue, F_phir, tmax;

        string d0d1, notpossible, flashimpossible;
        FormMain meinMain;
        private double phirStart = 60;
        string keypath = "Software\\FHL\\Windf";


        public FlashForm(FormMain parent)
        {
            InitializeComponent();
            meinMain = parent;
            d0d1 = "Value of d is not OK (0<d<1!!!=)";
            notpossible = "st<1 is not possible with this circuit!!!";
            flashimpossible = "Flash design not possiblebecause of delay is not zero";
            tB10phir.Text = phirStart.ToString("F0");
            textBox10_Leave(null, null);
            textBox1_Leave(null, null);
            meinMain = parent;
        }

        public void deutsch()
        {
            d0d1 = "Wert d ist nicht OK (0<d<1 !!!)";
            notpossible = "st<1 ist mit dieser Schaltung nicht mglich";
            this.Text = "Blitzregler-Auslegung";
            toolStripButtonCompute.ToolTipText = "Berechne den Regler neu";
            toolStripButtonReport.ToolTipText = "Zum Report";
            toolStripButtonClose.ToolTipText = "Schlieen uns Verferfen der Ergebnisse";
            toolStripButtonOK.ToolTipText = "Schlieen und bernehmen der Ergbenisse";
            groupBox4.Text = "Regler: PIDT1";
            groupBox1.Text = "Strecke:   2PT1";
            groupBox2.Text = "Dmpfung des geschlossenen Kreises";
            label25.Text = "Entwurfs-Parameter";
            groupBox3.Text = "Schnelligkeit des geschlossenen Kreises";
            label29.Text = "Schaltung";
            label23.Text = "Klicke hier fr einen neuen PIDT1-Entwurf";
            flashimpossible = "Blitzentwurf ist nicht mglich, da Totzeit nicht Null";
            button1.Text = "Ignoriere Tz";
            button2.Text = "Gehe zum FKL";
            cBRSR.Text = "Zeichne die Fhrungssprungantwort";
            label24.Text = "Grafik der Fhrungssprungantwort des geschlossenen Regelkreises";
            label26.Text = "Zeitachse in Sekunden";
            chart2D1.Germanlanguage = true;
            toolTip1.SetToolTip(butSto, "Speichere PIDT1- Daten in registry fr andere Progamme");
        }

        private void FlashForm_Load(object sender, EventArgs e)
        {
 
        }



        private double phasenReserve(double d)
        {
            return (90.0 - 180.0 / Math.PI * Math.Atan(Math.Sqrt(Math.Sqrt(0.25 + 1.0 / Math.Pow(Math.Pow(2.0 * d, 2), 2)) - 0.5)));
        }

        private double daempfung(double phi)
        {
            double x;
            x = Math.PI / 180.0 * (90.0 - phi);
            return (0.5 * Math.Sqrt(Math.Sqrt(1.0 / (Math.Pow(Math.Pow(Math.Sin(x) / Math.Cos(x), 2) + 0.5, 2) - 0.25))));
        }

        private String doubleToSring(double d)
        {
            string help = d.ToString("G6");
            //if (help.Length > 10) help = String.Format("{0:e}", d);
            return help;
        }

        public void textBox1_Leave(object sender, EventArgs e)
        {
            double h1 = 0, h2 = 0;
            meinMain.ConvertToDouble(textBoxTz.Text, ref h1);
            meinMain.ConvertToDouble(textBox2.Text, ref h2);
            if ((h1 / h2 > 1e-7))
            {
                groupBox6.Visible = true;
            }
            meinMain.ConvertToDouble(textBox1.Text, ref Ks);
            meinMain.ConvertToDouble(textBox2.Text, ref T1);
            meinMain.ConvertToDouble(textBox3.Text, ref T2);
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(tB8d.Text, ref d);
            meinMain.ConvertToDouble(tB12st.Text, ref F_st);
            meinMain.ConvertToDouble(tB16R1.Text, ref R1);
            if (d <= 0) MessageBox.Show(d0d1);

            else
            {
                if (d < 1)
                {
                    ue = Math.Exp(-d * Math.PI / Math.Sqrt(1 - d * d));
                    tB9ue.Text = ue.ToString("G6");
                }
                else tB9ue.Text = "no ";// d>=1

                F_phir = phasenReserve(d);
                tB10phir.Text = doubleToSring(F_phir);
            }
            wo = F_st / 2 / d / T2;
            if (d < 1) tmax = Math.PI / wo / Math.Sqrt(1 - d * d); else tmax = 1e10;
            Kr = T1 * F_st / (4 * d * d * Ks * T2);
            tB11wo.Text = doubleToSring(wo);
            tB13Kr.Text = doubleToSring(Kr);
            tB14tmax.Text = doubleToSring(tmax);
            double help = Kr * F_st;
            tB15Krst.Text = doubleToSring(help);
            tB4Kr.Text = doubleToSring(Kr);
            tB5Tn.Text = doubleToSring(T1);
            tB6Tv.Text = doubleToSring(T2);
            tB7st.Text = doubleToSring(F_st);
            R2 = R1 * Kr; C2 = T1 / R2 * 1000.0;
            if (F_st > 1) { R3 = R1 / (F_st - 1); C1 = T2 / F_st / R3 * 1000.0; }
            else { R3 = 0; C1 = 0; }

            tB17C1.Text = doubleToSring(C2);
            tB18R2.Text = doubleToSring(R2);
            tB19C1.Text = doubleToSring(C1);
            tB20R3.Text = doubleToSring(R3);
            panel2.Visible = false;
            rBChange_d.Text = "d=  " + d.ToString("f3");
            rBChange_st.Text = "st=" + F_st.ToString("f1");
            drawStart();

        }

        private void textBox10_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(tB10phir.Text, ref F_phir);
            d = daempfung(F_phir);
            tB8d.Text = doubleToSring(d);
            textBox1_Leave(sender, e);

        }

        private void textBox9_Leave(object sender, EventArgs e)
        {
            double lnue;
            string s = tB9ue.Text;
            if (s != "no ")
            {
                meinMain.ConvertToDouble(s, ref ue);
                if (ue > 0)
                {
                    lnue = Math.Log(ue);
                    d = -lnue / Math.Sqrt(Math.PI * Math.PI + lnue * lnue);
                    tB8d.Text = doubleToSring(d);
                    textBox1_Leave(sender, e);
                }
            }
        }

        private void textBox11_Leave(object sender, EventArgs e)
        {
            double h1;
            /*if wo is given */
            meinMain.ConvertToDouble(textBox2.Text, ref T1);
            meinMain.ConvertToDouble(textBox3.Text, ref T2);
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(tB8d.Text, ref d); ;
            meinMain.ConvertToDouble(tB11wo.Text, ref wo);
            F_st = 2 * d * T2 * wo;
            tB12st.Text = doubleToSring(F_st);
            textBox1_Leave(sender, e);
        }

        private void textBox13_Leave(object sender, EventArgs e)
        {
            double h1;
            /*if Kr is given */
            meinMain.ConvertToDouble(textBox1.Text, ref Ks);
            meinMain.ConvertToDouble(textBox2.Text, ref T1);
            meinMain.ConvertToDouble(textBox3.Text, ref T2);
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(tB8d.Text, ref  d);
            meinMain.ConvertToDouble(tB13Kr.Text, ref Kr);
            F_st = 4.0 * d * d * Ks * Kr * T2 / T1;
            tB12st.Text = doubleToSring(F_st);
            textBox1_Leave(sender, e);
        }

        private void textBox14_Leave(object sender, EventArgs e)
        {
            double h1;
            /*if tmax is given */
            meinMain.ConvertToDouble(textBox2.Text, ref T1);
            meinMain.ConvertToDouble(textBox3.Text, ref T2);
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(tB8d.Text, ref d);
            meinMain.ConvertToDouble(tB14tmax.Text, ref tmax);
            F_st = 2 * d * T2 * Math.PI / tmax / Math.Sqrt(1 - d * d);
            tB12st.Text = doubleToSring(F_st);
            textBox1_Leave(sender, e);
        }

        private void textBox15_Leave(object sender, EventArgs e)
        {
            double h1, ymax = 0;
            /*if ymax=krst is given */
            meinMain.ConvertToDouble(textBox1.Text, ref Ks);
            meinMain.ConvertToDouble(textBox2.Text, ref T1);
            meinMain.ConvertToDouble(textBox3.Text, ref T2);
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(tB8d.Text, ref d);
            meinMain.ConvertToDouble(tB15Krst.Text, ref ymax);
            F_st = 2 * d * Math.Sqrt(Ks * ymax * T2 / T1);
            tB12st.Text = doubleToSring(F_st);
            textBox1_Leave(sender, e);
        }

        private void textBox17_Leave(object sender, EventArgs e)
        {
            double h1;
            /*if C2 is given */
            meinMain.ConvertToDouble(tB17C1.Text, ref C2);
            meinMain.ConvertToDouble(tB5Tn.Text, ref T1);
            meinMain.ConvertToDouble(tB6Tv.Text, ref T2);
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(tB4Kr.Text, ref Kr);
            R1 = T1 / (Kr * C2 * 0.001);
            tB16R1.Text = doubleToSring(R1);
            textBox1_Leave(sender, e);
        }

        private void textBox4_Leave(object sender, EventArgs e)
        {

            string Krold, T1old, T2old, F_stold;
            meinMain.ConvertToDouble(tB16R1.Text, ref R1);
            Krold = Kr.ToString("G6");
            T1old = T1.ToString("G6");
            T2old = T2.ToString("G6");
            F_stold = F_st.ToString("G6");
            if ((tB4Kr.Text != Krold) || (tB5Tn.Text != T1old) || (tB6Tv.Text != T2old) || (tB7st.Text != F_stold))
            {
                panel2.Top = 43; panel2.Left = 12;
                panel2.Width = 230;
                panel2.Height = 480;
                panel2.Visible = true;

            }
            meinMain.ConvertToDouble(tB4Kr.Text, ref Kr);
            meinMain.ConvertToDouble(tB5Tn.Text, ref T1);
            meinMain.ConvertToDouble(tB6Tv.Text, ref T2);
            meinMain.ConvertToDouble(tB7st.Text, ref F_st);

            R2 = R1 * Kr; C2 = T1 / R2 * 1000.0;
            if (F_st < 1) MessageBox.Show(notpossible);
            else
                if (F_st > 1) { R3 = R1 / (F_st - 1); C1 = T2 / F_st / R3 * 1000.0; }
                else { R3 = 0; C1 = 0; }

            tB17C1.Text = doubleToSring(C2);
            tB18R2.Text = doubleToSring(R2);
            tB19C1.Text = doubleToSring(C1);
            tB20R3.Text = doubleToSring(R3);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            textBoxTz.Text = "0";
            groupBox6.Visible = false;
            label22.Visible = false;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            Hide();
            meinMain.fra.Show();
            // If "Yes" then open the FRA- Design
        }

        private void FlashForm_Activated(object sender, EventArgs e)
        {
            textBox1_Leave(sender, e);
            double h1 = 0, h2 = 0;
            meinMain.ConvertToDouble(textBoxTz.Text, ref h1);
            meinMain.ConvertToDouble(textBox2.Text, ref h2);
            if ((h1 / h2 > 1e-7))
            {
                groupBox6.Top = 60;
                groupBox6.Left = 10;
                groupBox6.Visible = true;
                label22.Text = flashimpossible;
                label22.Visible = true;
            }
        }

        private void panel2_Click(object sender, EventArgs e)
        {
            textBox1.Focus();
            textBox1_Leave(sender, e);
            panel2.Visible = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string a = "      ";
            meinMain.tBMainReport1.AppendText(a + "____________________________________\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");

            if (!panel2.Visible)
            {
                meinMain.tBMainReport1.AppendText(a + this.Text + "\r\n");
                meinMain.tBMainReport1.AppendText("\r\n");

                meinMain.tBMainReport1.AppendText(a + groupBox1.Text + "\r\n");

                meinMain.tBMainReport1.AppendText(a + label1.Text + " = " + textBox1.Text + "  " + label2.Text + " = " + textBox2.Text + " s   " + label3.Text + " = " + textBox3.Text + " s\r\n");
                meinMain.tBMainReport1.AppendText("\r\n");
                meinMain.tBMainReport1.AppendText(a + label25.Text + "\r\n");
                meinMain.tBMainReport1.AppendText(a + groupBox2.Text + "\r\n");
                meinMain.tBMainReport1.AppendText(a + label8.Text + " = " + tB8d.Text + "  " + label9.Text + " = " + tB9ue.Text + "   " + label10.Text + " = " + tB10phir.Text + "\r\n");
                meinMain.tBMainReport1.AppendText("\r\n");
                meinMain.tBMainReport1.AppendText(a + groupBox3.Text + "\r\n");
                meinMain.tBMainReport1.AppendText(a + label11.Text + " = " + tB11wo.Text + " 1/s  " + label12.Text + " = " + tB12st.Text + "   " + label13.Text + " = " + tB13Kr.Text + "\r\n");
                meinMain.tBMainReport1.AppendText(a + label14.Text + " = " + tB14tmax.Text + " s  " + label15.Text + " = " + tB15Krst.Text + "   " + "\r\n");
            }
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText(a + groupBox4.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label4.Text + " = " + tB4Kr.Text + "  " + label5.Text + " = " + tB5Tn.Text + " s   " + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label6.Text + " = " + tB6Tv.Text + " s  " + label7.Text + " = " + tB7st.Text + "   " + "\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText(a + label29.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label16.Text + " = " + tB16R1.Text + " kOhm\r\n");
            meinMain.tBMainReport1.AppendText(a + label17.Text + " = " + tB17C1.Text + " F\r\n");
            meinMain.tBMainReport1.AppendText(a + label18.Text + " = " + tB18R2.Text + " kOhm\r\n");
            meinMain.tBMainReport1.AppendText(a + label19.Text + " = " + tB19C1.Text + " F\r\n");
            meinMain.tBMainReport1.AppendText(a + label20.Text + " = " + tB20R3.Text + " kOhm\r\n");
            meinMain.tBMainReport1.AppendText(a + "____________________________________\r\n");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.Hide();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            Hide();
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            Hide();
            // Copy results into KT->pq window
            meinMain.fpidpq.tBKR1.Text = tB4Kr.Text;// KR
            meinMain.fpidpq.tBTN2.Text = tB5Tn.Text;//Tn
            meinMain.fpidpq.tBTv3.Text = tB6Tv.Text;//Tv
            meinMain.fpidpq.tBst4.Text = tB7st.Text;//st
            meinMain.fpidpq.labelDontFit.Visible = true;
        }


        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox1_Leave(sender, e);
        }

        private void textBox9_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox9_Leave(sender, e);
        }

        private void textBox10_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox10_Leave(sender, e);
        }

        private void textBox11_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox11_Leave(sender, e);
        }

        private void textBox13_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox13_Leave(sender, e);
        }

        private void textBox14_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox14_Leave(sender, e);
        }

        private void textBox15_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox15_Leave(sender, e);
        }

        private void textBox4_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox4_Leave(sender, e);
        }

        private void textBox17_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox17_Leave(sender, e);
        }

        private void FlashForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;

        }

        private void cBRSR_Click(object sender, EventArgs e)
        {
            if (cBRSR.Checked)
                FlashForm.ActiveForm.Width = 1280;
            else
                FlashForm.ActiveForm.Width = 512;
        }

        double startVal = 0;
        int trackcase = 0;

      private void drawTrack(double dneu,double woneu)
      {
          if (chart2D1.Counter == 2) chart2D1.clearLast();
          int nb = 100;
          double kx = 0, y = 0;
          kx = (double)numericUpDown1.Value;
          kx = kx / nb;

         
          double sqrD = 0, phi = 0;
          double T1 = 1, T2 = 2;
          if (dneu < 1)
          {
              sqrD = Math.Sqrt(1 - dneu * dneu);
              phi = Math.Atan(sqrD / dneu);
          }
          else
          {
              sqrD = Math.Sqrt(-1 + dneu * dneu);
              T1 = (dneu + sqrD) / woneu;
              T2 = (dneu - sqrD) / woneu;
          }

          for (int i = 0; i < nb; i++)
          {

              double x = kx * i;
              if (dneu < 1)
                  y = 1 - Math.Exp(-dneu * woneu * x) / sqrD * Math.Sin(woneu * sqrD * x + phi);
              else if (dneu > 1)
                  y = 1 - T1 / (T1 - T2) * Math.Exp(-x / T1) - T2 / (T2 - T1) * Math.Exp(-x / T2);
              chart2D1.setPoint(1, x, y);
          }
          chart2D1.startDrawing();
          chart2D1.autoScaling();

      }

        
        
        // double d = 0.7071;
        private void button3_Click_1(object sender, EventArgs e)
          {
             double dneux = d;
             double woneux = wo;
             double stneu = F_st;
            if (rBChange_d.Checked)
            {
           dneux = d * (1 + trackBar1.Value / 100.0);
           woneux = F_st / 2 / dneux / T2;

            }
            else
            {
                dneux = d;
                stneu=F_st * (1 + trackBar1.Value / 100.0);
                woneux = stneu/ 2 / dneux / T2;

            }
            
            drawTrack(dneux,woneux);
            rBChange_d.Text = "d=  " + dneux.ToString("f3");
            rBChange_st.Text = "st=" + stneu.ToString("f1");

        }

        private void drawStart()
        {
            chart2D1.clearAll();
            int nb = 100;
            double kx = 0, y = 0;
            kx = (double)numericUpDown1.Value;
            kx = kx / nb;

            double dneu = d;
            double sqrD=0, phi=0;
            double T1=1, T2=2;
            if (dneu < 1)
            {
                sqrD = Math.Sqrt(1 - dneu * dneu);
                phi = Math.Atan(sqrD / dneu);
            }
            else
            {
                sqrD = Math.Sqrt(-1 + dneu * dneu);
                T1 = (dneu + sqrD) / wo;
                T2 = (dneu - sqrD) / wo;
            }

            for (int i = 0; i < nb; i++)
            {

                double x = kx * i;
                if (dneu < 1)
                    y = 1 - Math.Exp(-dneu * wo * x) / sqrD * Math.Sin(wo * sqrD*x + phi);
                else if (dneu > 1)
                    y = 1-T1/(T1-T2)*Math.Exp(-x/T1)-T2/(T2-T1)*Math.Exp(-x/T2);
                chart2D1.setPoint(0, x, y);
            }
            chart2D1.startDrawing();
            chart2D1.autoScaling();
        }

        private void rBChange_d_CheckedChanged(object sender, EventArgs e)
        {
            trackBar1.Value = 0;
            drawStart();
            rBChange_d.Text = "d=  " + d.ToString("f3");
            rBChange_st.Text = "st=" + F_st.ToString("f1");

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown1, 1e-5, 1e5);
            rBChange_d_CheckedChanged(sender, e);
        }

        private void butSto_Click(object sender, EventArgs e)
        {
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 KR", tB4Kr.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 TN", tB5Tn.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 TV", tB6Tv.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 st", tB7st.Text, true);
            
        }

 
 
    }
    
}