﻿ using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;

using System.Diagnostics;


namespace WINDF7CSharp.RealTimeController
{
    public partial class FormCSIIIduDRDemo : Form
    {
        private readonly MicroLibrary.MicroTimer _microTimer;

        FormMain meinMain;
        double Posmax = 10,
            Posmin = -10,
            Youtmax = 10,
            youtmin = -10;

        double t0end =0, t0start=0, t0 = 0, dtend=0,dt=0;
        Stopwatch stopwatch1;
        string strval="Value= ";
        uint T0MM=6;  // MMTimer with 6 ms
        
        public void deutsch()
        {
            strval="Wert= ";
            this.Text = "DRT Regler für Kranhardware als invertiertes Pendel ";
            cBKranPosReglerOn.Text = "Regler für Kranposition";
            cBKranUnterPendelOn.Text = "Regler für Kran unter Pendel";
            cBPendelgeschwindigkeit.Text = "Regler für Pendelgeschwindigkeit";
            cBPendPosRegler.Text = "Regler für obere Pendelposition";
            butSetZero.Text = "Track auf Null";
            radioButtonDiv10.Text = "Trackwerte /10";
        }
        
        public FormCSIIIduDRDemo(FormMain m)
        {
            InitializeComponent();
            Posmax = 10;  // 10 is spindle val
            Posmin = -10;
            Youtmax = 10;
            youtmin = -10;
            meinMain = m;
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(onMMTimer1);
            _microTimer.Interval = T0MM*1000;
            
           
            stopwatch1 = new Stopwatch();
            stopwatch1.Start();
        }

        double TrackBarWert;
        double Yout = 0;
        double test = 0;
        double AD0, AD1;
        double Bl13Out = 0, AD0old = 0, Bl12in = 0, Bl12inold = 0, Bl12old = 0;
        double Ka = 0, Ki = 0, Tn = 0, q0 = 0, q1 = 0;
        double Bl4out = 0, Bl3out = 0,Pendpos=0;// green loop
        double Bl9out = 0, Bl9outold = 0, Bl10out = 0, Bl10outold = 0, Bl2out = 0, Bl2in = 0, Bl2inold = 0, q0bl2 = 0, q1bl2 = 0; // red loop

        private void cBKranPosReglerOn_CheckedChanged(object sender, EventArgs e)
        {
            if (!cBKranPosReglerOn.Checked)
            {
                // Init Vars in Cascaded controller
                Yout=0;
                AD0old = 0; Bl12inold = 00; Bl12old = 0;
            }
        }

        double Bl1out = 0, Bl1in = 0, Bl1inold = 0,Bl1outold=0;
        double  WagPosSoll;



        void onMMTimer1(object sender, MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {
            t0end = t0start;
            t0start = stopwatch1.ElapsedTicks;
            t0 = (t0start - t0end);  // Period
                                     // time measurement
            if (rBSilverRack.Checked) { Ka = 14; Ki = 2; Tn = 0.3;}
            else  { Ka = 10; Ki = 1; Tn = 0.15;}// black rap

            if (rBSpindle.Checked) { q0bl2 = 3.731; q1bl2 = -2.87; }
            if (rBBlackRap.Checked) { q0bl2 = 8.61; q1bl2 = -6.888; }
            if (rBSilverRack.Checked) { q0bl2 = 4.1192; q1bl2 = -3.168; }

            AD0 = inputAD0();
            AD1 = inputAD1();
            double pend12clock = 2.5;
            Pendpos = AD0 - 5.55 * (AD1 - pend12clock);

            if (Math.Abs(AD1-pend12clock) < 0.4)  // Only in small area in vertical position active, 0.4V=14.4°
            {
                if (cBPendPosRegler.Checked)
                {  // here control of vertical pendulum position 
                    Bl1in = TrackBarWert - WagPosSoll;
                    Bl1out = Bl1outold + 0.14378 * Bl1in - 0.1436 * Bl1inold; // PI
                    Bl1inold = Bl1in;Bl1outold = Bl1out;
                }
                else { Bl1out = 0; Bl1outold = 0;  } //

                if (cBPendelgeschwindigkeit.Checked)
                {    // here control of pendulum speed
                    Bl9out = 0.9426 * Bl9outold + 0.057416 * Pendpos; // PT1
                    Bl10out = 0.8868 * Bl10outold + 5.649 * Bl9out - 5.649 * Bl9outold; // DT1
                    Bl2in = Bl1out - Bl10out;
                    Bl2out = q0bl2 * Bl2in + q1bl2 * Bl2inold; // PD
                    if (Bl2out > Posmax) Bl3out = Posmax;  // Block 3 limiter
                    else if (Bl2out < Posmin) Bl3out = Posmin;
                    else Bl3out = Bl2out;
                    Bl9outold = Bl9out; Bl10outold = Bl10out; Bl2inold = Bl2in;
                }
                else { Bl3out = 0; Bl9outold = 0; Bl10outold = 0; Bl2inold = 0; }   //
                if (cBKranUnterPendelOn.Checked)
                {     // control of pivot under pendulum 
                    WagPosSoll = Pendpos - Bl3out;
                    if (WagPosSoll > Posmax) WagPosSoll = Posmax;
                    if (WagPosSoll < Posmin) WagPosSoll = Posmin;
                }
                else {WagPosSoll = TrackBarWert; }
            }
            else WagPosSoll = TrackBarWert;
            if (cBKranPosReglerOn.Checked)
            {  // here control of position of pivot to WagPosSoll with cascaded controller
                if (rBSpindle.Checked)
                {
                    Yout = (WagPosSoll - AD0) * (-12);
                }
                else // für RAP- Hardware cascaded controller
                {
                    Bl13Out = (AD0 - AD0old) / 0.001 / T0MM;
                    q1 = -Ki; q0 = Ki * (1 + T0MM * 0.001 / Tn);
                    Bl12in = (WagPosSoll - AD0) * Ka - Bl13Out;
                    Yout = Bl12old + q0 * Bl12in + q1 * Bl12inold;

                    if (cBAWUPosReg.Checked && (Yout > Youtmax || Yout < youtmin)) Yout = Yout - (q0 + q1) * Bl12in; // AWU
                    AD0old = AD0; Bl12inold = Bl12in; Bl12old = Yout;
                }
                outputx(Yout); // P-Controller  
            }
            else outputx(0);

            // time measurement
            dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - t0start);  // dt runtime of function
        }

        private void rBSpindle_CheckedChanged(object sender, EventArgs e)
        {
            if (rBSpindle.Checked)
            {
                Posmax = 10;  // 10 is spindle val
                Posmin = -10;
                Youtmax = 10;
                youtmin = -10;
                cBAWUPosReg.Visible = false;
            }
            else
            {
                Posmax = 4;  // rap val
                Posmin = -4;
                Youtmax = 6;
                youtmin = -6;
                cBAWUPosReg.Visible = true;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            tSSLabel1.Text = "T0=  " + (t0 / Stopwatch.Frequency * 1000.0).ToString("f3") + "  ms   Dauer=  " +
                (dt / Stopwatch.Frequency * 1000.0).ToString("f3");
            labelAD0.Text = "AD0= " + AD0.ToString("f3");
            labelAD1.Text = "AD1= " + AD1.ToString("f3");
            labelDA0.Text = "DA0= " + Yout.ToString("f3");
            labeltestWert.Text = "Test= " + test.ToString("f3");
        }


        private void buttonReset_Click(object sender, EventArgs e)
        {
            if (rBSpindle.Checked) outputx(-4); // Fahre Kran ganz nach rechts in die Lichtschranke 
                                                // drive pivot to right position into light bar to reset position counter
            else
            if (meinMain.toolStripMenuItemNIDAQmx.Checked)
            {
                buttonStop_Click(null, null);  // geht bei dacmx nur bei stop
                meinMain.frmDACmx.butZero_Click(null, null);
            }

        }

        //input of angel ,channel 1
        double inputAD1()
        {
            double val = 0;
            meinMain.ADCinput(1, ref val);
            return val;
        }

        //output of position, channel 0
        void outputx(double y)
        {
            if (y >= Youtmax) y = Youtmax;
            if (y <= youtmin) y = youtmin;

            meinMain.DACoutput(0, y);
        }
        // input of position ,channel 0
        double inputAD0()
        {    // version for new horizontal movement since April 2016 rap-and-pinion drive
            // left 0V start with zero button, then right position 10 V
            double val = 0;
            meinMain.ADCinput(0, ref val);
            if (rBSpindle.Checked)
            {
                if (val < 0) val = 10.0; // Correction of left 10V- Value which must be +10V
                return (3.751 * val - 27.51);
            }
            else return (val);
        }

        private void FormDRTKranregler_FormClosing(object sender, FormClosingEventArgs e)
        {
            _microTimer.Stop();
            outputx(0);
            e.Cancel = true;
            this.Visible = false;
        }

        double Div10 = 1;
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            TrackBarWert = trackBar1.Value / 10.0/Div10;
            labelTrVal.Text = strval+ TrackBarWert.ToString("f1");
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            _microTimer.Start();
            
            timer1.Enabled = true;
        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            _microTimer.Stop();

            outputx(0);
            timer1.Enabled = false;
        }

        private void butSetZero_Click(object sender, EventArgs e)
        {
            trackBar1.Value = 0;
            TrackBarWert = trackBar1.Value / 10.0 / Div10;
            labelTrVal.Text = strval + TrackBarWert.ToString("f1");
        }
        bool butcheck = true;

        private void radioButtonDiv10_Click(object sender, EventArgs e)
        {
            if (butcheck)
            {
                Div10 = 10;
                radioButtonDiv10.Checked = true;
                butcheck = false;
            }
            else
            {
                Div10 = 1;
                radioButtonDiv10.Checked = false;
                butcheck = true;
            }

        }

        private void FormCSIIrap_Load(object sender, EventArgs e)
        {
            meinMain.frmDACmx.rBCnt1.Checked = true;
            meinMain.frmDACmx.rBCnt2.Checked = true;
            //meinMain.frmDACmx.rB6221.Checked = true;        // Diese Version soll auch auf beiden karten bzw. Plätzen laufen
            // meinMain.frmDACmx.rBcartBlack.Checked = true;  // Ab 2017 dort silver rack 
        }



    }
}
