/* ****************************************************
 * *Abgabe 3 - Visuelle Programmierung Prof. Bayerlein* 
 * ****************************************************
 * ** Name: Gack **************************************
 * ** Vorname: Michael ********************************
 * ** Datum: 10-02-2009 *******************************
 * ** Last-Edit: 18:47 / 10-02-2009 *******************
 * ** Ver.: 1.0.1 *************************************
 * ** Mat-Nr.: 154040 *********************************
 * ** Semester: Igi 5 *********************************
 * ****************************************************
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;

namespace FRADesign
{
    public partial class FormFRA : Form
    {            
        string crossfrq = "Crossover freq not found.";
        string d0d1 = "d too small or too large (<0 or >1)";
        string head = "Design of controller with 2pt1 process with delay";
        FormMain meinMain;
        private double phistart = 60;
        string keypath = "Software\\FHL\\Windf";


        public FormFRA(FormMain mymain)
        {
            InitializeComponent();
            textBox7.Text = phistart.ToString();
            meinMain = mymain;
            textBox7_Leave(null, null);
        }

        double sqr(double x)
        {
            return (x * x);
        }

        double phasenreserve(double d)
        { 
            return (90.0 - 180.0 / Math.PI * Math.Atan(Math.Sqrt(Math.Sqrt(0.25 + 1.0 / sqr(sqr(2.0 * d))) - 0.5)));
        }

        double daempfung(double phi)
        {
            double x,tan;
            x = Math.PI / 180.0 * (90.0 - phi);
            tan = Math.Tan(x);
            return (0.5 * Math.Sqrt(Math.Sqrt(1.0 / (sqr(sqr(tan) + 0.5) - 0.25))));
        }

        double atan_form(double ab, double ba)
        {
            double abc = Math.Atan(ab * ba);
            return abc;
        }

        double suche_wd(double T1, double T2, double Tt, double phi)
        {

            /*         { T1,T2 time constants of 2 PT1, phi process phase(wd), w :wd }
                     { normal 2PT1 with delay
                              if T2=0, then Pt1 with delay
                              if T2>=1e10, then IT1 with delay  }
                     { it searches the crossover frequency with intervall step method
                       solving of the equation
                       phisuch=f=arcMath.Tan(w * T1) + arcMath.Tan(w * T2) + w * Tt
                       phisuch is phase in rad, phi is phase in degree }
            */
                double anf, ende, wmaxTt, phisuch, f, w;
                int i;
                phisuch = ((Math.PI / 180.0) * -phi); /*pos. process phase in rad*/
                if (Tt < 1e10) wmaxTt = (100.0 / T2);  // start with 100-times largest corner freq
                else wmaxTt = (phisuch / Tt); // phase of delay block

                ende = wmaxTt;
                anf = 0.0;
                i = 0;
                do
                {
                    w = (anf + (ende - anf) / 2.0); /*w in the centre of interval anf-ende */
                    f = atan_form(w,T1) + atan_form(w,T2) + (w * Tt);
                    if (f > phisuch) ende = w; else anf = w;
                    i++;
                }
                while ((Math.Abs(f - phisuch) > 1e-4) || (i > 30));
                if (i > 30) MessageBox.Show(crossfrq,"Error",MessageBoxButtons.OK, MessageBoxIcon.Error); else return (w);
                return (0.0);
          
        }



        private void button3_Click(object sender, EventArgs e)
        {
            Hide();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            
            String a = "        ";
            meinMain.tBMainReport1.AppendText(a + "______________________________________________________" + "\r\n");
            meinMain.tBMainReport1.AppendText(a + "\r\n");
            meinMain.tBMainReport1.AppendText(a + head + "\r\n");
            meinMain.tBMainReport1.AppendText(a + "\r\n");
            meinMain.tBMainReport1.AppendText(a + groupBox1.Text+ "\r\n");
            meinMain.tBMainReport1.AppendText(a + label2.Text + " = " + textBox1.Text + "   " + label3.Text + " = "
            + textBox2.Text + "   " + label6.Text + " = " + textBox3.Text
            + "   " + label7.Text + " = " + textBox4.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label9.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + groupBox2.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label11.Text + " = " + textBox5.Text + "   " + label12.Text + " = "
            + textBox6.Text + "   " + label13.Text + " = " + textBox7.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + "\r\n");
            meinMain.tBMainReport1.AppendText(a + groupBox3.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label16.Text + " = " + textBox8.Text + "   " + label18.Text + " = "
            + textBox9.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label19.Text + " = " + textBox10.Text + "   " + label20.Text + " = "
            + textBox11.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + "\r\n");
            meinMain.tBMainReport1.AppendText(a + groupBox4.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label22.Text + " = " + tB12Kr.Text + "   " + label23.Text + " = "
            + tB13Tn.Text + "    " + label24.Text + " = " + tB14Tv.Text + "    " + label25.Text
            + " = " + tB15st.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + "\r\n" + "\r\n");
            meinMain.tBMainReport1.AppendText(a + groupBox5.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label29.Text + " = " + textBox16.Text + "  " + label38.Text +"\r\n");
            meinMain.tBMainReport1.AppendText(a + label30.Text + " = " + textBox17.Text + "  " + label33.Text+"\r\n");
            meinMain.tBMainReport1.AppendText(a + label31.Text + " = " + textBox18.Text + "  " + label34.Text+"\r\n");
            meinMain.tBMainReport1.AppendText(a + label32.Text + " = " + textBox19.Text + "  " + label35.Text+"\r\n");
            meinMain.tBMainReport1.AppendText(a + label36.Text + " = " + textBox20.Text + "  " + label37.Text+"\r\n");
            meinMain.tBMainReport1.AppendText(a + "\r\n");
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + "\r\n");
        }

        private void textBox1_Leave(object sender, EventArgs e)
        {
            double h1, Ks = 0, T1 = 0, T2 = 0, Tz = 0, d = 0, st = 0, R1 = 0, R2, R3, C1, C2, ue, phir, wo, Kr, Krst;

            meinMain.ConvertToDouble(textBox1.Text,ref Ks  );
            meinMain.ConvertToDouble(textBox2.Text,ref T1  );
            meinMain.ConvertToDouble(textBox3.Text,ref T2 );
            meinMain.ConvertToDouble(textBox4.Text,ref Tz  );// ? keine ahnung welche txtbox
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(textBox5.Text,ref d  );
            meinMain.ConvertToDouble(textBox9.Text,ref st  );
            meinMain.ConvertToDouble(textBox16.Text,ref R1  );
            if ((d <= 0) || (d >= 1))
            {
                MessageBox.Show(d0d1,"Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
                ue = 1.0; phir = 90.0;
            }
            else
            {
                ue = (Math.Exp(-d * Math.PI / Math.Sqrt(1 - d * d)));
                phir = phasenreserve(d);
                textBox7.Text = phir.ToString("G5");
                textBox6.Text = ue.ToString("G5");
            }
            double T2st = (T2 / st);
            double phirr = (phir - 180);
            wo = suche_wd(1e10, T2st, Tz, phirr);  /* FRA-design */
                     
            /* here variable wo is used for wd crossover freq*/
            Kr = (wo * T1 * Math.Sqrt(1 + sqr(wo * T2st)) / Ks);
            Krst = (Kr * st);
            textBox8.Text = wo.ToString("G5");
            textBox10.Text = Kr.ToString("G5");
            textBox11.Text = Krst.ToString("G5");
            tB12Kr.Text = Kr.ToString("G5");
            tB13Tn.Text = T1.ToString("G5");
            tB14Tv.Text = T2.ToString("G5");
            tB15st.Text = st.ToString("G5");
            R2 = (R1 * Kr); 
            C2 = (T1 / R2) * 1000.0;
            if (st > 1) { R3 = R1 / (st - 1.0); 
                C1 = (T2st / R3) * 1000.0; }
            else { R3 = 0; C1 = 0; }

            textBox17.Text = C2.ToString("G5");
            textBox18.Text = R2.ToString("G5");
            textBox19.Text = C1.ToString("G5");
            textBox20.Text = R3.ToString("G5");
            /*fdigcont.TextBox1.Text=(Kr).ToString("G10");
            fdigcont.TextBox2.Text=(T1).ToString("G10");
            fdigcont.TextBox3.Text=(T2).ToString("G10");
            fdigcont.TextBox4.Text=(st).ToString("G10"); */
        }

        private double assert(double p)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        private void textBox6_Leave(object sender, EventArgs e)
        {
            double lnue, d, ue=0;

            meinMain.ConvertToDouble(textBox6.Text,ref ue );
            lnue = Math.Log(ue);
            d = (-lnue / Math.Sqrt(sqr(Math.PI) + sqr(lnue)));
            textBox5.Text = d.ToString("G5");
            textBox1_Leave(sender,e);
        }

        private void textBox17_Leave(object sender, EventArgs e)
        {
            double h1, C2=0, R1=0, Kr=0, T1=0, T2=0;
            /*if C2 is given */
            meinMain.ConvertToDouble(textBox17.Text,ref C2  );
            meinMain.ConvertToDouble(tB13Tn.Text,ref T1  );
            meinMain.ConvertToDouble(tB14Tv.Text,ref T2  );
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(tB12Kr.Text,ref Kr );
            R1 = T1 / (Kr * C2 * 0.001);
            textBox16.Text = R1.ToString("G5");
            textBox1_Leave(sender, e);
        }

 
        private void button2_Click(object sender, EventArgs e)
        {

        }

        private void textBox7_Leave(object sender, EventArgs e)
        {
            double phir = 0;
            meinMain.ConvertToDouble(textBox7.Text, ref phir);
            double d = daempfung(phir);
            textBox5.Text = d.ToString("G5");
            textBox1_Leave(sender,e);
        }

 
        private void buttonOK_Click(object sender, EventArgs e)
        {
            Hide();
            // Copy results into KT->pq window
            meinMain.fpidpq.tBKR1.Text = tB12Kr.Text;// KR
            meinMain.fpidpq.tBTN2.Text = tB13Tn.Text;//Tn
            meinMain.fpidpq.tBTv3.Text = tB14Tv.Text;//Tv
            meinMain.fpidpq.tBst4.Text = tB15st.Text;//st
            meinMain.fpidpq.labelDontFit.Visible = true;
        }
 
        public void deutsch()
        {
            Text = "FKL-Verfahren fr Strecke 2PT1 mit Totzeit";
            head = Text;
            toolStripButtonCompute.ToolTipText = "Berechne den Regler neu";
            toolStripButtonReport.ToolTipText = "Zum Report";
            toolStripButtonClose.ToolTipText = "Schlieen uns Verferfen der Ergebnisse";
            toolStripButtonOK.ToolTipText = "Schlieen und bernehmen der Ergbenisse";
            groupBox4.Text = "Regler: PIDT1";
            groupBox1.Text = "Strecke:   2PT1";
            groupBox2.Text = "Dmpfung des geschlossenen Kreises";
            groupBox5.Text = "RC- Werte";
            label9.Text = "Entwurfs-Parameter";
            groupBox3.Text = "Schnelligkeit des geschlossenen Kreises";
            label28.Text = "Schaltung";
            label7.Text = "Totzeit";
            toolTip1.SetToolTip(butSto, "Speichere PIDT1- Daten in registry fr andere Progamme");
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox1_Leave(sender, e);
        }

        private void textBox6_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox6_Leave(sender, e);
 
        }

        private void textBox7_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox7_Leave(sender, e);
        }

        private void textBox17_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox17_Leave(sender, e);

        }

        private void toolStripButtonClearReport_Click(object sender, EventArgs e)
        {
            meinMain.tBMainReport1.Clear();
        }

        private void FormFRA_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;
        }

        private void FormFRA_Activated(object sender, EventArgs e)
        {
            textBox1_Leave(sender, e);  // if opened redo calculations
        }

        private void butSto_Click(object sender, EventArgs e)
        {
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 KR", tB12Kr.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 TN", tB13Tn.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 TV", tB14Tv.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 st", tB15st.Text, true);
        }



     }
}