﻿/* ----------------------------------------------------------------------
 * This is a port of the original UcontrollerdesignD19 - project into C#
 * 
 * Please take a second and have a short look at the documentation which
 * is provided as readme.txt within the project - folder
 * 
 * Author: Stefan Graham
 * Date:   06/03/2009
 * Build:  Visual Studio 2008 with .net 3.5
   ---------------------------------------------------------------------- */


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO; // needed to instantiate a StreamWriter - object


namespace WINDF7CSharp
{
    public partial class FpidPQ : Form
    {
        //
        // variable declaration
        //
        double k, t1d;
        double t0rtc, p1, p2, q0, q1, q2,q0PD,q1PD,q2PD; // externUnitcontroller
        double kp, ti, td, kri, tni, tvi, si;   //externUcontrdes
        int designmethod;
        string noEquivalentBode, withMethod, AnalogController, DigitalController,dMethod;
        string NoValuesstoredinregistry;
        string keypath="Software\\FHL\\Windf";
        string isnopidt1 = "Is no PIDT1 - file";

        //
        // constructor
        //
        FormMain meinMain;
        DataTools dt = new DataTools();
        
        public FpidPQ(FormMain m)
        {
            InitializeComponent();

            // definitons for startup
            designmethod = 4;
            noEquivalentBode = "No equivalent bodeform available";
            withMethod = "With method I# not implemented";
            dMethod = "I#";
            AnalogController="Analog Controller";
            DigitalController = "Digital Controller, Design Method ";
            meinMain = m;
            NoValuesstoredinregistry = "No Values stored in registry";
            tB15To.Text = "0.01";
            radioButton3.Checked = true;  // Start with trapezoidal I#

            //edit1Exit(sender);

        }
        // constructor
        public void deutsch()
        {
            noEquivalentBode = "Keine äquivalente Bodeform möglich";
            withMethod = "Mit Methode I# nicht implementiert";
            NoValuesstoredinregistry = "Keine Werte in Registry gefunden";
            isnopidt1 = "ist keine PIDT1 - Datei";

            this.Text = "Berechnung und Konvertierung von PIDT1-Koeffizienten";
            button1.Text = "&berechne";
            button3.Text = "&Schließe";
            label1.Text = "Bode Form";
            label2.Text = "Parallele Form";
            groupBox1.Text = "Methode s. Skript";
            rBDesignI.Text = "I einfacher PID";
            radioButton3.Text = "I# Trapez-Näherung";
            
            label20.Text = "st effektiv";
            label21.Text = "Abtastzeit T0";
            labelDontFit.Text = "Werte passen nicht";
            
            button2.Text = "&rückwärts ";
            //button2.to.to->Hint="Berechne die K/T-Werte aus den p/q-Werten";
            //BCopy->Hint="Kopiere p,q-Werte ins Digital-Filter-Fenster (Bodeplot)";
            label18.Text = "rekursiver Algorithmus:";
            button5.Text = "Zum Report";
            AnalogController = "Analoger Regler";
            DigitalController = "Digitaler Regler, Entwurfsmethode ";
            groupBox3.Text = "Digitaler Regler";
            toolTip1.SetToolTip(butPF_BF, "Konvertiere K, Ti, TD, T1 nach KR, TN, Tv, st ");
            toolTip1.SetToolTip(butBF_PF, "Konvertiere KR, TN, Tv, st nach K, Ti, TD, T1 ");
            toolTip1.SetToolTip(button1, "Konvertiere K,T nach p,q");
            toolTip1.SetToolTip(button2, "Berechne aus den p,q die Werte K,T zurück, geht nicht bei Methode I# Trapez");
            toolTip1.SetToolTip(button4, "Kopiere p,q in die Regler- Fenster");
            toolTip1.SetToolTip(button5, "Kopiere alle Werte in den Report");
            toolTip1.SetToolTip(butSto, "Speichere PIDT1- Daten in registry für andere Progamme");
            toolTip1.SetToolTip(butRcl, "Hole PIDT1- Daten aus Registry von anderen Programmen ");
            toolTip1.SetToolTip(butSaveZk, "Speichere PIDT1- Daten in ein *.ZK- file");
            toolTip1.SetToolTip(butRclZk, "Hole PIDT1- Daten aus einem ZK- file");

        }

        public void english()
        {
            noEquivalentBode = "No equivalent bodeform possible";
            withMethod = "With method I# not implemented";
            NoValuesstoredinregistry = "No Values stored in registry";
            isnopidt1 = "Is no PIDT1 - file";

            this.Text = "Calculation and conversion of PIDT1-coefficients";
            button1.Text = "&recalculate";
            button3.Text = "&Close";
            label1.Text = "Bode form";
            label2.Text = "Parallel form";
            groupBox1.Text = "methods see CS II paper";
            rBDesignI.Text = "II Rectangular Approach";
            radioButton3.Text = "I# Trapezoidal Approach";

            label20.Text = "st effective";
            label21.Text = "Sampling time T0";
            labelDontFit.Text = "Values don't fit";

            button2.Text = "&Backwards Calc ";
            //button2.to.to->Hint="Berechne die K/T-Werte aus den p/q-Werten";
            //BCopy->Hint="Kopiere p,q-Werte ins Digital-Filter-Fenster (Bodeplot)";
            label18.Text = "recursive algorithm:";
            button5.Text = "to report";
            AnalogController = "Analog Controller";
            DigitalController = "Digital controller, design method ";
            groupBox3.Text = "Digital controller";
            toolTip1.SetToolTip(butBF_PF, "Convert KR, TN, Tv, st to K, Ti, TD, T1 ");
            toolTip1.SetToolTip(button1, "Convert K,T to p,q");
            toolTip1.SetToolTip(button2, "Calculate from p,q- values the K,T - values, doesn't work with method 4");
            toolTip1.SetToolTip(button4, "Copy p,q- values into other controller windows");
            toolTip1.SetToolTip(button5, "Copa values into report page");
            toolTip1.SetToolTip(butSto, "Store PIDT1- values into registry for other programs");
            toolTip1.SetToolTip(butRcl, "Recall PIDT1- values from registry from other programs ");
            toolTip1.SetToolTip(butSaveZk, "Store PIDT1- Data to a *.ZK- file");
            toolTip1.SetToolTip(butRclZk, "Recall  PIDT1- Data from a ZK- file");

        }

        //
        // load gui
        //
        private void Form1_Load(object sender, EventArgs e)
        {
            // textBox3.Text = String.Format("{0:" + getFormatString(0.1, 4, 1) + "}", 0.1);
        }
        // load gui


        //
        // edit1Exit
        // fills textBoxs 5 to 14 with desired values
        // recalculates 9 to 14
        //
        public void edit1Exit(object sender)
        {
            // declarations
            double  alpha, steff, k;

            // get values from textBox 1 to 4
            dt.ConvertToDouble(tBKR1.Text,ref kri );
            dt.ConvertToDouble(tBTN2.Text,ref tni );
            dt.ConvertToDouble(tBTv3.Text,ref tvi );
            dt.ConvertToDouble(tBst4.Text,ref si );
            dt.ConvertToDouble(tB15To.Text,ref t0rtc );

            // dont't know
            if (Math.Abs(tni) < 1e-10) tni = 1e-10;
            if ((si) < 1e-10) si = 1e-10;
            if (Math.Abs(t0rtc) < 1e-10) t0rtc = 1e-10;

            k = kri * (tni + tvi) / tni; ti = tni + tvi; td = tvi * tni / ti; t1d = tvi / si;

            // set textBox 5 to 8 with calculated values
            textBox5.Text = k.ToString();
            textBox6.Text = ti.ToString();
            textBox7.Text = td.ToString();
            textBox8.Text = t1d.ToString();

            // Wiki- DT1-modell
            double ka, ta, tb;
            ka = k * (1 - t1d / ti);
            ta = ti - t1d;
            tb = td / (1 - t1d / ti) - t1d;
            tBKa.Text = ka.ToString();
            tBTa.Text = ta.ToString();
            tBTb.Text = tb.ToString();
            tBDT1T1.Text = textBox8.Text;

            // handle different designmethods
            switch (designmethod)
            {
                case 1:
                    {
                        //alpha = 1 / (1 + t1d / t0rtc);
                        q0 = k * (1 + td / t0rtc + t0rtc / ti);
                        q1 = -k * (1 + 2 * td / t0rtc);
                        q2 = k * td / t0rtc;
                        q0PD = k * (1 + td / t0rtc);
                        q1PD = -k * (1 + 2 * td / t0rtc);
                        q2PD = k * td / t0rtc;
                        p1 = 1; p2 = 0;
                        break;
                    }
                case 2:
                    {  // not used, historical
                        alpha = 1 / (1 + t1d / t0rtc);
                        q0 = k * (1 + td / t0rtc + t0rtc / ti) * alpha;
                        q1 = -k * (1 + 2 * td / t0rtc) * alpha;
                        q2 = k * td / t0rtc * alpha;
                        q0PD = k * (1 + td / t0rtc ) * alpha;
                        q1PD = -k * (1 + 2 * td / t0rtc) * alpha;
                        q2PD = k * td / t0rtc * alpha;
                        p1 = (1 + 2 * t1d / t0rtc) * alpha; p2 = -t1d / t0rtc * alpha;
                        break;
                    }
                case 3:
                    {  // not used, historical
                        if (Math.Abs(t1d) < 1e-10) t1d = 1e-10;
                        alpha = td / t1d / (1 + td / t0rtc);
                        q0 = k * (1 + td / t0rtc + t0rtc / ti) * alpha;
                        q1 = -k * (1 + 2 * td / t0rtc) * alpha;
                        q2 = k * td / t0rtc * alpha;
                        q0PD = k * (1 + td / t0rtc ) * alpha;
                        q1PD = -k * (1 + 2 * td / t0rtc) * alpha;
                        q2PD = k * td / t0rtc * alpha;
                        p1 = 2 - alpha; p2 = alpha - 1;
                        break;
                    }
                case 4:
                    {
                        q0 = kri * t0rtc / 2 / tni * (1 + 2 * tni / t0rtc) * (1 + 2 * tvi / t0rtc) / (1 + 2 * t1d / t0rtc);
                        q1 = kri * t0rtc / 2 / tni * ((1 + 2 * tvi / t0rtc) * (1 - 2 * tni / t0rtc) + (1 + 2 * tni / t0rtc)
                             * (1 - 2 * tvi / t0rtc)) / (1 + 2 * t1d / t0rtc);
                        q2 = kri * t0rtc / 2 / tni * (1 - 2 * tni / t0rtc) * (1 - 2 * tvi / t0rtc) / (1 + 2 * t1d / t0rtc);
                        q0PD = kri  * (1 + 2 * tvi / t0rtc) / (1 + 2 * t1d / t0rtc);
                        q1PD = kri * (-4 * tvi / t0rtc)  / (1 + 2 * t1d / t0rtc);
                        q2PD = -kri  * (1 - 2 * tvi / t0rtc) / (1 + 2 * t1d / t0rtc);
                        p1 = 4 * t1d / t0rtc / (1 + 2 * t1d / t0rtc); p2 = 1 - p1;
                        break;
                    }
            } // switch designmethods
            
            // set textBox 9 to 14 with calculated values
            textBox9.Text = p1.ToString(); 
            textBox10.Text = p2.ToString();
            textBox11.Text = q0.ToString();
            textBox12.Text = q1.ToString();
            textBox13.Text = q2.ToString();
            steff = q0 / kri;

            textBox14.Text = steff.ToString();

            // warning-label hidden
            labelDontFit.Visible = false;
        }
        // edit1Exit


        //
        // designmethods
        //
        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            designmethod = 1;
            dMethod = "I";
            edit1Exit(sender);
            tBst4.Enabled = false;
            textBox8.Enabled = false;
            tBDT1T1.Enabled = false;
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
             designmethod=4;
             dMethod="I#";
             edit1Exit(sender);
             tBst4.Enabled = true;
             textBox8.Enabled = true;
             tBDT1T1.Enabled = true;
        }
        // designmethods


        //
        // special cases
        //
        // PIDT1

        // PID

        // PI

        // PDT1

        // PD
        // special cases


        //
        // recompute
        // handles textBoxes 5 to 8 first
        // then takes care of 1 to 4 by envoking edit5Exit
        //
        private void button2_Click(object sender, EventArgs e)
        {
            double alpha, x;
            // make sure selected designmethod is implemented
            bool letsDoThis = false;

            // get values for variables from textBoxes 9 to 13
            dt.ConvertToDouble(textBox9.Text,ref p1 );
            dt.ConvertToDouble(textBox10.Text,ref p2 );
            dt.ConvertToDouble(textBox11.Text,ref q0 );
            dt.ConvertToDouble(textBox12.Text,ref q1 );
            dt.ConvertToDouble(textBox13.Text,ref q2 );

            // handle designmethods
            switch (designmethod)
            {
                case 2:
                    {
                        t1d = t0rtc * (-p2 / (1 + p2));
                        x = 1 + t1d / t0rtc;
                        kp = (-q1 - 2 * q2) * x;
                        alpha = q0 + q1 + q2;
                        if (Math.Abs(alpha) < 1e-10) alpha = 1e-10;
                        ti = kp * t0rtc / x / alpha;
                        if (Math.Abs(kp) < 1e-10) td = 1e10; else td = t0rtc * q2 / kp * x;
                        letsDoThis = true;
                        break;
                    }
                case 3:
                    {
                        x = 1 + p2;
                        kp = (-q1 - 2 * q2) / x;
                        alpha = q0 + q1 + q2;
                        if (Math.Abs(alpha) < 1e-10) alpha = 1e-10;
                        ti = kp * t0rtc * x / alpha;
                        if (Math.Abs(kp) < 1e-10) td = 1e10; else td = t0rtc * q2 / kp / x;
                        t1d = td / x / (1 + td / t0rtc);
                        letsDoThis = true;
                        break;
                    }
                case 4:
                    {
                        MessageBox.Show(withMethod);
                        letsDoThis = false;
                        break;
                    }
            } // switch

            // do this if only designmethod 2 or 3 was selected
            if (letsDoThis)
            {
                // write calculated values into textBoxes 5 to 8
                textBox5.Text = kp.ToString();
                textBox6.Text = ti.ToString();
                textBox7.Text = td.ToString();
                textBox8.Text = t1d.ToString();

                // taking care of textBoxes 1 to 4
                edit5Exit(sender);
            }
        }
        // recompute


        //
        // edit5Exit
        // recalculate textBox-values 1 to 4
        // rewrite them , call edit1Exit
        //
        private void edit5Exit(object sender)
        {
            // get values for variables
            dt.ConvertToDouble(textBox5.Text,ref k );
            dt.ConvertToDouble(textBox6.Text,ref ti );
            dt.ConvertToDouble(textBox7.Text,ref td );
            dt.ConvertToDouble(textBox8.Text,ref t1d );

            // some calculation
            double help = 1 - 4 * td / ti;

            if (help < 0)
            {
                MessageBox.Show(noEquivalentBode);
            }
            else
            {
                help = Math.Sqrt(help);
                kri = 0.5 * k * (1 + help);
                tni = 0.5 * ti * (1 + help);
                tvi = 0.5 * ti * (1 - help);
            }
            if (Math.Abs(t1d) < 1e-10)
            {
                si = 1e10;
            }
            else
            {
                si = tvi / t1d;
            }

            // write recalculated values into textBoxes 1 to 4
            tBKR1.Text = kri.ToString(); 
            tBTN2.Text = tni.ToString();
            tBTv3.Text = tvi.ToString();
            tBst4.Text = si.ToString();

            // recalculate and rewrite everything except textBoxes 1 to 4
            edit1Exit(sender);
        }
        // edit5Exit


        //
        // add to main report
        //
        private void button5_Click(object sender, EventArgs e)
        {
            string s = "      ";

            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText(s + this.Text + "\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");

            meinMain.tBMainReport1.AppendText(s + AnalogController+"\r\n");
            meinMain.tBMainReport1.AppendText(s + "Kr = " + tBKR1.Text  + "\t K = " + textBox5.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(s + "TN = " + tBTN2.Text + s + "\t  Ti = " + textBox6.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(s + "Tv = " + tBTv3.Text + s + "\t  Td = " + textBox7.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(s + "st = " + tBst4.Text + s + "\t  T1 = " + textBox8.Text + "\r\n");
            // new DT1- Form
            meinMain.tBMainReport1.AppendText(s + "Ka = " + tBKa.Text   + "\r\n");
            meinMain.tBMainReport1.AppendText(s + "Ta = " + tBTa.Text + s +  "\r\n");
            meinMain.tBMainReport1.AppendText(s + "Tb = " + tBTb.Text + s +"\r\n");
            meinMain.tBMainReport1.AppendText(s + "T1 = " + tBDT1T1.Text + s + "\r\n");

            meinMain.tBMainReport1.AppendText("\r\n");

            meinMain.tBMainReport1.AppendText(s + DigitalController + dMethod + "\n");
            meinMain.tBMainReport1.AppendText("\r\n");

            meinMain.tBMainReport1.AppendText(s + "T0 = " + tB15To.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(s + "                  " + s + "\t q0 = " + textBox11.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(s + "p1 = " + textBox9.Text + s + "\t q1 = " + textBox12.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(s + "p2 = " + textBox10.Text + s + "\t q2 = " + textBox13.Text + "\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");
        }
        // add to main report


        //
        // copy
        //
        public void button4_Click(object sender, EventArgs e)
        {
            double temp = 0;
            // copy results into both real time controller 

            dt.ConvertToDouble(textBox9.Text, ref temp);
            meinMain.frmadaptcon.p1f = temp;
            dt.ConvertToDouble(textBox10.Text, ref temp);
            meinMain.frmadaptcon.p2f = temp;
            dt.ConvertToDouble(textBox11.Text, ref temp);
            meinMain.frmadaptcon.q0f = temp;
            dt.ConvertToDouble(textBox12.Text, ref temp);
            meinMain.frmadaptcon.q1f = temp;
            dt.ConvertToDouble(textBox13.Text, ref temp);
            meinMain.frmadaptcon.q2f = temp;
            meinMain.frmadaptcon.q0fPD = q0PD; // AWU Params
            meinMain.frmadaptcon.q1fPD = q1PD;
            meinMain.frmadaptcon.q2fPD = q2PD;
            //meinMain.frmadaptcon.rbFreecon.Checked = true; // switch to this controller type
            //meinMain.frmadaptcon.rbFreecon_CheckedChanged(sender, e); // Values to controller and display

        }
        // copy


        //
        // close
        //
        private void button3_Click(object sender, EventArgs e)
        {
            Hide();
        }
        // close


        //

        //
        // show "Values don't fit" - warning
        // note: this method was neither called in
        // the original code nor will it in this
        //
        private void showValueWarning(object sender)
        {
            labelDontFit.Visible = true;
        }

        private void butBF_PF_Click(object sender, EventArgs e)
        {
            edit1Exit(sender);
        }

        private void butPF_BF_Click(object sender, EventArgs e)
        {
            edit5Exit(sender);
        }

        private void FpidPQ_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Hide();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            edit1Exit(sender);
        }

        private void butParallel2DT1_Click(object sender, EventArgs e)
        {

            edit1Exit(null);
        }

        private void butDT12Parallel_Click(object sender, EventArgs e)
        {

            double ka=0, ta=0, tb=0, t1d = 0;
            dt.ConvertToDouble(tBKa.Text, ref ka);
            dt.ConvertToDouble(tBTa.Text, ref ta);
            dt.ConvertToDouble(tBTb.Text, ref tb);
            dt.ConvertToDouble(tBDT1T1.Text, ref t1d);
            k = ka * (1 + t1d / ta);
            td = ka / k * (t1d + tb);
            ti = k / ka * ta;
            textBox5.Text = k.ToString();
            textBox6.Text = ti.ToString();
            textBox7.Text = td.ToString();
            textBox8.Text = t1d.ToString();
            edit5Exit(null);

        }

 
        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return)
                edit1Exit(null);
        }

        private void textBox5_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return)
                edit5Exit(null);

        }

        private void tBKa_Leave(object sender, EventArgs e)
        {
            butDT12Parallel_Click(sender, e);
        }

        private void tBKa_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return)
                butDT12Parallel_Click(sender, null);
        }

        private void butRcl_Click(object sender, EventArgs e)
        {
            object inRV = TestRegistry.RegistryUtils.ReadValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 KR", null);
            if (inRV != null)
            {
                tBKR1.Text = inRV.ToString();
                 inRV = TestRegistry.RegistryUtils.ReadValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 TN", null);
                 if (inRV != null) tBTN2.Text = inRV.ToString();
                 inRV = TestRegistry.RegistryUtils.ReadValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 TV", null);
                 if (inRV != null) tBTv3.Text = inRV.ToString();
                 inRV = TestRegistry.RegistryUtils.ReadValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 st", null);
                 if (inRV != null) tBst4.Text = inRV.ToString();
                 edit1Exit(null);
            }
            else
                MessageBox.Show(NoValuesstoredinregistry);

        }

        private void butSto_Click(object sender, EventArgs e)
        {
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 KR", tBKR1.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 TN", tBTN2.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 TV", tBTv3.Text, true);
            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, keypath, "PIDT1 st", tBst4.Text, true);

        }

        private void FpidPQ_Activated(object sender, EventArgs e)
        {
            //edit1Exit(null);
        }

        private void butSaveZk_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                pList.Add("! PIDT1");
                pList.Add("2 0 2 0 " + (kri * 1e50).ToString());

                pList.Add(tni.ToString() + " 0");
                pList.Add(tvi.ToString() + " 0");
                pList.Add((tni * 1e50).ToString() + " 0");
                pList.Add((tvi / si).ToString() + " 0");

                pList.Add("0");  // Delay

                System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialog1.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();

            }
        }

        private void butRclZk_Click(object sender, EventArgs e)
        {
            double temp=0;    
            List<String> pList = new List<String>();
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    StreamReader filestream = new StreamReader(openFileDialog1.FileName, Encoding.Default);
                    string line = "";
                    while (line != null)
                    {
                        line = filestream.ReadLine();
                        if (line != null)
                        {
                            pList.Add(line);
                        }
                    }
                    filestream.Close();
                    string test=pList[1].Substring(0, 7);
                    if (test != "2 0 2 0")
                        MessageBox.Show(isnopidt1);
                    else
                    {
                        dt.ConvertToDouble(pList[1].Substring(7, pList[1].Length - 7),ref temp);
                        kri = temp;
                        dt.ConvertToDouble(pList[2].Substring(0, pList[2].Length - 2), ref temp);
                        tni = temp;
                        dt.ConvertToDouble(pList[3].Substring(0, pList[3].Length - 2), ref temp);
                        tvi = temp;
                        dt.ConvertToDouble(pList[4].Substring(0, pList[4].Length - 2), ref temp);
                        kri = kri/temp*tni;
                        dt.ConvertToDouble(pList[5].Substring(0, pList[5].Length - 2), ref temp);
                        si = tvi/temp;
                        tBKR1.Text = kri.ToString();
                        tBTN2.Text = tni.ToString();
                        tBTv3.Text = tvi.ToString();
                        tBst4.Text = si.ToString();
                        edit1Exit(null);


                    }
                }
        }
        // show Warning
    }
}
