﻿using System;
using System.Globalization;  // für CultureInfo

using System.Windows.Forms;   // in Call arguments TextBox

// -------------------------------------------------------------------------
//      public class CHMinMax  ab nov 2014 entfernt, da nicht mehr nötig mit Chart  DotNet
//      public class LoadOpt
//      public int Str2NString(string txt, ref string[] val, char sep)
//      public void StrTo2Float(String a, ref double xi, ref double yi,char sep)
//      public int ConvertTB2ChartAdd(ref AxChartfxLib.AxChartfx Chart, TextBox TB, ref CHMinMax chmm, LoadOpt LO)
//      public int ConvertTB2Chart(ref AxChartfxLib.AxChartfx Chart, TextBox TB, LoadOpt LO)
//      public void kttoteta(int processmodel,double[] KTpar, ref double[] teta)
//      public double disturbanceGain(double[] p, double[] q, int m, char algorithm)
//      public void DB_aus_teta(double[] teta, ref double[] p, ref double[] q, int m) /*in:teta,m out: p,q*/
//      public void DB1_aus_teta(double[] teta, ref double[] p, ref double[] q, int m, double r)
//      public void OR_aus_teta(double[] t, ref double[] p, ref double[] q, int m, ref double f3)

// new: since windf 7.5.xx (start 7/2014)
// since .NET 4 the drawing is done with the .NET- Chart, so Log- Display is suppoerted
// Passt ab Windf 7.6.7 dazu, benutzt neue Chart2D.Counter, die Kurvenanzahl angibt. ChartTool.dll Ab V 7.9
 
namespace WINDF7CSharp
{
    public class CHMinMax
    {
        //public double xmin, xmax, ymin, ymax;
        //public int serie;  //actual number of curves
        //public int pts;    // actual number of points
        public int progress;
        public void init()
        {
            //xmin = 1e10; xmax = -1e10; ymin = 1e10; ymax = -1e10;
            //serie = 0; pts = 0; 
            progress = 0;
        }
    }




    public class LoadOpt
    {
        public int selectedCurve;
        public int IgnoreFirstLines;
        public double factor;
        public double offset;
        public double delay;
        public bool XaxisLog;
        public char separator;
        public string bottomtitle;
        public string legend;
        public string toptitle;
        public string phasewrap;
        public int nbofpointslastcurve;
        public bool WithSampleAndHold;
        public bool sec2min;
        public bool sec2hour;
        public void init()
        {
            selectedCurve = 1; IgnoreFirstLines = 0; factor = 1; offset = 0; delay = 0;
            XaxisLog = false;
            separator = ' ';
            bottomtitle = "";
            toptitle = "";
            legend = "";
            phasewrap = "no";  // "90" and "180" is possible
            WithSampleAndHold = false;
            sec2min = false;
            sec2hour = false;
        }
    }


    public class DataTools

    {

        //public DataTools()
        //{
            
        //}
        
        ////FormMain meinMain;

        public int maxcrvs = 20;  // max number of curves
        string tetanotdefined = "Array teta is not defined";
        string a1mustbenegative = "a1 must be negative";
        string wrongDataFormat = "wrong Data Format";
        double OldY = 0;

        public int Str2NString(string txt, ref string[] val, char sep)
        {// separator defined with RadioButtons in this Form
            // separates the input string txt into any number of substrings separated with separator 
            // output string array is val. Returns the number of strings, which are found
            //char sep = getSeparator();
            string sepstr = sep.ToString();
            int startx, chnb, cnt = 0;
            int pos, px = 0;
            if (txt.Length > 2)
            {// Minimum Lengh is 3 char
                while (txt.Substring(px, 1) == sepstr) px++; //skip leading seps
                startx = px;
                pos = px + 1;
                while ((px >= 0) && (pos < txt.Length))  // search for all separators
                {
                    px = txt.IndexOf(sep, pos);
                    chnb = px - startx;
                    while ((px > -1) && (px < txt.Length - 1) && (txt.Substring(px + 1, 1) == sepstr)) px++; // if more than one sep skip

                    if ((px < txt.Length) && (px >= 0))
                    {

                        val[cnt] = txt.Substring(startx, chnb);
                        cnt++;
                        pos = px + 1;
                        startx = pos;
                    }
                }
                if ((startx != txt.Length) && (px < 0)) // No sep at the end
                {
                    val[cnt] = txt.Substring(startx, txt.Length - startx);
                    cnt++;
                }
            }
            else return (-1);
            return (cnt);
        }


        public void StrTo2Float(String a, ref double xi, ref double yi,char sep)
        // Converts a String with two numbers into two doubles
        {
            string[] outstr = new string[10];
            int cnt = Str2NString(a, ref outstr, sep);
            if (cnt > 1)
            {
                ConvertToDouble(outstr[0],ref xi );
                ConvertToDouble(outstr[1],ref yi );
            }
        }

        public char comF, comR;   // to correct Comma- / point problem comF : wrong seperator
        // comR  : correct separator



        public void ConvertToDouble(string text, ref double nb)
        {
            // Secure Conversion independant of Komma- Version of PC
            // comF contains String with wrong camma, comR contains string with correct comma
            // if number format is wrong, result is old number
            // Call :  ConvertToDouble(text,ref number);
            // removes all thousand- Seperators
            // examples: (if decimal sep =".")
            // 1000,000,000.23 --> 1000000000.23
            // 1000.000.000,23 --> 1000000000.23
            // 0.23 --> 0.23
            // 0,23 --> 0.23
            // 1000,023 --> 1000.023
            // 1000.023 --> 1000.023

            // examples: (if decimal sep =",")
            // 1000,000,000.23 --> 1000000000,23
            // 1000.000.000,23 --> 1000000000,23
            // 0.23 --> 0,23
            // 0,23 --> 0,23
            // 1000,023 --> 1000,023
            // 1000.023 --> 1000,023

            string TestText = (0.1).ToString("f1");

            if (TestText.Substring(1, 1) == ".")  // Check which is the actual Decimal separator
            { comF = ','; comR = '.'; }
            else
            { comF = '.'; comR = ','; }

            double number = 0;
            char[] seps = new char[2];
            seps[0] = ','; // both possible decimal seperators
            seps[1] = '.';
            // check if Thousand- group sign is available. If more than one sign, all left signs are removed
            int index = 0, cnt = 0;
            while (index > -1)  // count number of seperators
            {
                index = text.IndexOfAny(seps, index);  // look for next position of seps
                if (index > -1) { cnt++; index++; }
            }
            string newtext = text;
            if (cnt > 1)  // If more than one sign, all left signs are removed
            {
                string leftSign = text.Substring(text.IndexOfAny(seps), 1);  // what is the left sign?
                newtext = text.Replace(leftSign, "");// Remove all left signs
            }
            string help = newtext.Replace(comF, comR); // Change into correct decimal sep
            if (Double.TryParse(help, out number))
                nb = number;
            else MessageBox.Show(wrongDataFormat);

        }

        public int ConvertTB2ChartAdd(ref ChartTool.Chart2D Chart2d, TextBox TB, ref CHMinMax chmm, LoadOpt LO)
        {
            // Draw content of textbox TB to Chart, max  curves in Var maxcrvs
            // return=0 OK
            // return=1 error curve number selected doesnot exist
            // return=2 sep=0
            // return=3 Ignorefirstlines >nb
            // return=4 too many curves(>10)
            // return=5 TB empty or 1 line
            // uses the Params  in LO
            // Separator and selected curve and other parameter LO
            // now with .NET Chart and Log- Display
            // if in LO.XaxisLog is true, x is converted into radian freq w
 
            string[] outStr = new string[maxcrvs];
            int nb=TB.Lines.Length;
            string[] TBtemp = new string[nb]; // temporary array to accelerate
        
            TBtemp = TB.Lines; // convert TB.text into Array 1 time
            if (nb < 1) return (4);
            int select = LO.selectedCurve;
            if (select > 0)
            {
                int i, cnt = 0;
                while (TBtemp[nb - 1].Length < 3) nb--; //ignore last lines if empty or too less char
                int starti = LO.IgnoreFirstLines;

                if (nb > starti) nb = nb - starti;
                else return (3);

                int serie = Chart2d.Counter+1;
                if (serie > 10) return (4);


                LO.nbofpointslastcurve = nb;
                Chart2d.Visible = true;
                double x = 0, y = 0, factor, offset, delay;
                factor = LO.factor;
                offset = LO.offset;
                delay = LO.delay;
                Chart2d.CurveNames[serie - 1] = LO.legend;
                for (i = 0; i < nb; i++)
                {
                    chmm.progress = i;
                    cnt = Str2NString(TBtemp[i + starti], ref outStr, LO.separator);
                    // Now in outStr are all readable values between the separators, cnt is number of read values, cnt-1 is nb of curves

                    if (select > (cnt - 1)) return (1);
                    ConvertToDouble(outStr[0], ref x);
                    x = x - delay;
                    if (LO.XaxisLog) x = (2 * Math.PI * x);
                    if (LO.sec2min) x = x / 60.0;
                    if (LO.sec2hour) x = x / 3600.0;

                    ConvertToDouble(outStr[select], ref y);
                    y = factor * (y - offset);
                    if (LO.phasewrap == "90")
                    {
                        while (y > 90) y = y - 360;
                        while (y < -270) y = y + 360;
                    }
                    if (LO.phasewrap == "180")
                    {
                        while (y > 180) y = y - 360;
                        while (y < -180) y = y + 360;
                    }

                    if (LO.WithSampleAndHold && i != 0)
                        Chart2d.setPoint(serie - 1, x, OldY); // S&H- effect
                    Chart2d.setPoint(serie - 1, x, y);
                    OldY = y;
                }
                Chart2d.TopTitle = LO.toptitle;
                Chart2d.BottomTitle = LO.bottomtitle;
                Chart2d.XLOG = LO.XaxisLog;

                Chart2d.autoScaling();
                Chart2d.startDrawing();
                return (0);
            }
            else return (2);
        }

        public int ConvertTB2Chart(ref ChartTool.Chart2D Chart2d, TextBox TB, LoadOpt LO)
        {
            // Writes allways into  series with number 1 and delete old content and resizes to nb of lines
            // Draw content of textbox TB to Chart, only 1 curve
            // uses the Params of the LoadOption- in LO
            // Separator and selected curve and other parameter defined in LO
            // return=3 Ignorefirstlines >nb
            // if xaxislog == true then frequency f is converted into log(w): Bodeplot text data in F / Hz 

            string[] outStr = new string[maxcrvs];
            int nb = TB.Lines.Length;
            string[] TBtemp = new string[nb]; // temporary array to accelerate
 
            TBtemp = TB.Lines; // convert TB.text into Array 1 time
            int select = LO.selectedCurve;
            if (select > 0)
            {
                int i,  cnt;
                if (TBtemp[nb - 1].Length < 3) nb--; //ignore last line if empty or too less char
                int starti = LO.IgnoreFirstLines;

                if (nb > starti) nb = nb - starti;
                else return (3);
                LO.nbofpointslastcurve = nb;
                Chart2d.clearAll();
                double x=0, y = 0, factor, offset, delay;
                factor = LO.factor;
                offset = LO.offset;
                delay = LO.delay;
                Chart2d.CurveNames[0] = LO.legend; 
                for (i = 0; i < nb; i++)
                {
                    
                    cnt = Str2NString(TBtemp[i + starti], ref outStr, LO.separator);
                    // Now in outStr are all readable values between the separators, cnt is number of read values, cnt-1 is nb of curves

                    ConvertToDouble(outStr[0],ref x);
                    x = x - delay;
                    if ((LO.XaxisLog)&&(x > 0)) x = Math.Log10(2*Math.PI* x);

                    ConvertToDouble(outStr[select],ref y);
                    y = factor * (y - offset);
                    if (LO.phasewrap == "90")
                    {
                        while (y > 90) y = y - 360;
                        while (y < -270) y = y + 360;
                    }
                    if (LO.phasewrap == "180")
                    {
                        while (y > 180) y = y - 360;
                        while (y < -180) y = y + 360;
                    }
                    if (LO.WithSampleAndHold && i != 0)
                        Chart2d.setPoint(0, x, OldY); // S&H- effect
                    Chart2d.setPoint(0, x, y);
                    OldY = y;
                }

                Chart2d.TopTitle=LO.toptitle;
                Chart2d.BottomTitle=LO.bottomtitle;
                Chart2d.autoScaling();
                Chart2d.startDrawing();
                return (0);

            }
            else return (1);
        }
        //---------------------------------------------------------------------------
        public int ConvertArray2ChartAdd(ref ChartTool.Chart2D Chart2d, double[,] data, int nb, ref CHMinMax chmm, LoadOpt LO)
        {
            // Draw content of double array to Chart, max  curves in Var maxcrvs
            // return=0 OK
            // return=1 error curve number selected doesnot exist
            // return=2 sep=0
            // return=3 Ignorefirstlines >nb
            // uses the Params  in LO
            // Separator and selected curve and other parameter LO
            

            int select = LO.selectedCurve;
            if (select > 0)
            {
                int i;
                int starti = LO.IgnoreFirstLines;

                if (nb > starti) nb = nb - starti;
                else return (3);
                LO.nbofpointslastcurve = nb;


                int serie = Chart2d.Counter + 1;

                if (serie > 10) return (4);

                Chart2d.Visible = true;
                double x, y = 0, factor, offset, delay;
                factor = LO.factor;
                offset = LO.offset;
                delay = LO.delay;
                Chart2d.CurveNames[serie - 1] = LO.legend;

                for (i = 0; i < nb; i++)
                {
                    chmm.progress = i;
                    x = data[i,0];
                    x = x - delay;
                    if ((LO.XaxisLog) && (x > 0)) x = Math.Log10(2 * Math.PI * x);


                    y = data[i,1];
                    y = factor * (y - offset);
                    if (LO.phasewrap == "90")
                    {
                        while (y > 90) y = y - 360;
                        while (y < -270) y = y + 360;
                    }
                    if (LO.phasewrap == "180")
                    {
                        while (y > 180) y = y - 360;
                        while (y < -180) y = y + 360;
                    }

                    if (LO.WithSampleAndHold && i != 0)
                        Chart2d.setPoint(serie - 1, x, OldY); // S&H- effect

                    Chart2d.setPoint(serie - 1, x, y);
                    OldY = y;
                }

         
                Chart2d.autoScaling();
                Chart2d.TopTitle=LO.toptitle;
                Chart2d.BottomTitle=LO.bottomtitle;
                Chart2d.startDrawing();
 
                return (0);
            }
            else return (2);
        }        
        //---------------------------------------------------------------------------
        public void kttoteta(int processmodel,double[] KTpar, ref double[] teta)
        {
            // KTpar[0] K, KTpar[1] T1, KTpar[2] T2, KTpar[3] T0, KTpar[4] T3
            double a1, a2, a3, a4, b1, b2, b3, b4, c, c1, c2, c3, c4, weg, d1, d2, d3, d4, tt1cd, tt2cd, tt3cd, tt4cd;  // kttoteta()

            for (int i = 0; i < teta.Length; i++) teta[i] = 0;//Clear
            double T0 = KTpar[3];
            switch (processmodel)
            {
                case 1:
                    {  /*it1*/
                        d1 = KTpar[0]* KTpar[1];
                        d2 = KTpar[3] / KTpar[1]; c = Math.Exp(-d2);
                        a1 = -1 - c; a2 = c;
                        b1 = d1 * (d2 - 1 + c); b2 = -d1 * (d2 * c - 1 + c);
                        teta[1] = a1; teta[2] = a2; teta[3] = 0;
                        teta[4] = b1; teta[5] = b2;
                        break;
                    } /*it1*/
                case 0:
                    { /*2Pt1*/
                        tt1cd = KTpar[1];
                        tt2cd = KTpar[2];
                        if (tt1cd < tt2cd) { weg = tt2cd; tt2cd = tt1cd; tt1cd = weg; } /*swap*/
                        c3 = Math.Exp(-KTpar[3] / tt1cd); c2 = Math.Exp(-KTpar[3] / tt2cd);
                        d1 = KTpar[0] * tt1cd * tt2cd / (tt2cd - tt1cd); d2 = 1 / tt1cd - 1 / tt2cd - c2 / tt1cd + c3 / tt2cd;
                        d3 = (1 / tt1cd - 1 / tt2cd) * c2 * c3 - c3 / tt1cd + c2 / tt2cd;
                        a1 = -c2 - c3; a2 = c2 * c3; b1 = d1 * d2; b2 = d1 * d3;
                        teta[1] = a1; teta[2] = a2; teta[3] = 0;
                        teta[4] = b1; teta[5] = b2;
                        break;
                    } /*2pt1*/
                case 2:
                    { /*PT1*/
                        a1 = -Math.Exp(-KTpar[3] / KTpar[1]); b1 = KTpar[0] * (1 + a1);
                         teta[1] = a1; teta[2] = 0; teta[3] = b1;
                        break;
                    } /*Pt1*/
                case 3:
                    { //PT2
                        double d, wo, z0, t0, del, cosw, sinw, w;
                        d = KTpar[1]; wo = KTpar[2]; t0 = KTpar[3];
                        if (d < 1)
                        {
                            z0 = Math.Exp(-d * t0 * wo); del = d * wo; w = wo * Math.Sqrt(1 - d * d);
                            cosw = Math.Cos(w * t0); sinw = del / w * Math.Sin(w * t0);
                            teta[1] = -2 * z0 * cosw;            /*a1*/
                            teta[2] = z0 * z0;
                            teta[4] = KTpar[0] * (1 - z0 * (cosw + sinw));   /*b1*/
                            teta[5] = KTpar[0] * z0 * (z0 - cosw + sinw);
                            teta[3] = 0;
                        }
                        else
                        { // convert into 2PT1
                            tt1cd = (d + Math.Sqrt(d * d - 1)) / wo;
                            tt2cd = (d - Math.Sqrt(d * d - 1)) / wo;
                            if (tt1cd < tt2cd) { weg = tt2cd; tt2cd = tt1cd; tt1cd = weg; } /*swap*/
                            c3 = Math.Exp(-KTpar[3] / tt1cd); c2 = Math.Exp(-KTpar[3] / tt2cd);
                            d1 = KTpar[0] * tt1cd * tt2cd / (tt2cd - tt1cd); d2 = 1 / tt1cd - 1 / tt2cd - c2 / tt1cd + c3 / tt2cd;
                            d3 = (1 / tt1cd - 1 / tt2cd) * c2 * c3 - c3 / tt1cd + c2 / tt2cd;
                            a1 = -c2 - c3; a2 = c2 * c3; b1 = d1 * d2; b2 = d1 * d3;
                            teta[1] = a1; teta[2] = a2; teta[3] = 0;
                            teta[4] = b1; teta[5] = b2;
                        }
                        

                        break;
                    } //PT2
                case 4:
                    {  // neu ab Mai 2015 3PT1

                        tt1cd = KTpar[1];
                        tt2cd = KTpar[2];
                        tt3cd = KTpar[4];
                        //if (tt1cd < tt2cd) { weg = tt2cd; tt2cd = tt1cd; tt1cd = weg; } /*swap*/
                        if (tt1cd != 0 && tt2cd != 0 && tt3cd != 0 && tt1cd != tt2cd && tt2cd != tt3cd && tt1cd != tt3cd)  // alle 3 T müssen ungleich  und ungleich 0 sein
                        {
                            c1 = Math.Exp(-T0 / tt1cd); c2 = Math.Exp(-T0 / tt2cd); c3 = Math.Exp(-T0 / tt3cd);
                            d1 = -KTpar[0] / (1 - tt2cd / tt1cd) / (1 - tt3cd / tt1cd);
                            d2 = -KTpar[0] / (1 - tt1cd / tt2cd) / (1 - tt3cd / tt2cd);
                            d3 = -KTpar[0] / (1 - tt2cd / tt3cd) / (1 - tt1cd / tt3cd);
                            a1 = -c1 - c2 - c3;
                            a2 = c1 * c2 + c2 * c3 + c1 * c3;
                            a3 = -c1 * c2 * c3;
                            b1 = KTpar[0] * a1 - d1 * (1 + c2 + c3) - d2 * (1 + c1 + c3) - d3 * (1 + c1 + c2);
                            b2 = KTpar[0] * a2 + d1 * (c2 + c3 + c2 * c3) + d2 * (c1 + c3 + c1 * c3) + d3 * (c1 + c2 + c1 * c2);
                            b3 = KTpar[0] * a3 - d1 * c2 * c3 - d2 * c1 * c3 - d3 * c1 * c2;
                            teta[1] = a1; teta[2] = a2; teta[3] = a3; teta[4] = 0;
                            teta[5] = b1; teta[6] = b2; teta[7] = b3;
                        }
                        break;
                    }
                case 5:
                    {  // neu ab Mai 2015 4PT1

                        tt1cd = KTpar[1];
                        tt2cd = KTpar[2];
                        tt3cd = KTpar[4];
                        tt4cd = KTpar[5];

                        //if (tt1cd < tt2cd) { weg = tt2cd; tt2cd = tt1cd; tt1cd = weg; } /*swap*/
                        if (tt1cd != 0 && tt2cd != 0 && tt3cd != 0 && tt4cd != 0 && tt1cd != tt2cd && tt2cd != tt3cd && tt1cd != tt3cd)  // alle 4 T müssen ungleich  und ungleich 0 sein
                            if (tt1cd != tt4cd && tt2cd != tt4cd && tt3cd != tt4cd)
                            {
                                c1 = Math.Exp(-T0 / tt1cd); c2 = Math.Exp(-T0 / tt2cd); c3 = Math.Exp(-T0 / tt3cd); c4 = Math.Exp(-T0 / tt4cd);
                                d1 = -KTpar[0] / (1 - tt2cd / tt1cd) / (1 - tt3cd / tt1cd) / (1 - tt4cd / tt1cd);
                                d2 = -KTpar[0] / (1 - tt1cd / tt2cd) / (1 - tt3cd / tt2cd) / (1 - tt4cd / tt2cd);
                                d3 = -KTpar[0] / (1 - tt2cd / tt3cd) / (1 - tt1cd / tt3cd) / (1 - tt4cd / tt3cd);
                                d4 = -KTpar[0] / (1 - tt1cd / tt4cd) / (1 - tt2cd / tt4cd) / (1 - tt3cd / tt4cd);
                                a1 = -c1 - c2 - c3 - c4;
                                a2 = c1 * c2 + c2 * c3 + c1 * c3 + c1 * c4 + c2 * c4 + c3 * c4;
                                a3 = -c1 * c3 * c4 - c2 * c3 * c4 - c1 * c2 * c3 - c1 * c2 * c4;
                                a4 = c1 * c2 * c3 *c4;
                                b1 = KTpar[0] * a1 - d1 * (1 + c2 + c3 + c4) - d2 * (1 + c1 + c3 + c4) - d3 * (1 + c1 + c2 + c4) - d4 * (1 + c1 + c2 + c3);
                                b2 = KTpar[0] * a2 + d1 * (c2 + c3 + c4 + c2 * c3 + c2 * c4 + c3 * c4) + d2 * (c1 + c3 + c4 + c1 * c3 + c1 * c4 + c3 * c4);
                                b2 += d3 * (c1 + c2 + c4 + c1 * c2 + c1 * c4 + c2 * c4) + d4 * (c1 + c2 + c3 + c1 * c2 + c1 * c3 + c2 * c3);
                                b3 = KTpar[0] * a3 + d1 * (-c3 * c4 - c2 * c3 * c4 - c2 * c3 - c2 * c4) + d2 * (-c1 * c3 * c4 - c3 * c4 - c1 * c3 - c1 * c4);
                                b3 += d3 * (-c1 * c4 - c2 * c4 - c1 * c2 - c1 * c2 * c4) + d4 * (-c1 * c3 - c2 * c3 - c1 * c2 * c3 - c1 * c2);
                                b4 = KTpar[0] * a4 + d1 * c2 * c3 * c4 + d2 * c1 * c3 * c4 + d3 * c1 * c2 * c4 + d4 * c1 * c2 * c3;
                                teta[1] = a1; teta[2] = a2; teta[3] = a3; teta[4] = a4; teta[5] = 0;
                                teta[6] = b1; teta[7] = b2; teta[8] = b3; teta[9] = b4;
                            }
                        break;
                    }
            } /*switch (*/
        }


        public double disturbanceGain(double[] p, double[] q, int m, char algorithm)
        {
            double sp, sq;
            int i;
            sp = 1; for (i = 1; i <= m; i++) sp = sp - p[i];
            sq = 0; for (i = 0; i <= m; i++) sq = sq + q[i];
            if (Math.Abs(sq) > 1e-8) return (sp / sq);
            else //sq=0
                if (Math.Abs(sp) > 1e-8) return (1e10);
                else //sq and sp=0 -. d'hospital
                    if (algorithm == 'i')
                    {
                        sp = 0; for (i = 1; i <= m; i++) sp = sp + i * p[i];
                        sq = 0; for (i = 1; i <= m; i++) sq = sq - i * q[i];
                        if (Math.Abs(sq) > 1e-10) return (sp / sq);
                        else return (1e11);
                    }
                    else
                    { //*r
                        sp = 0; for (i = 1; i <= m; i++) sp = sp + (i + 1) * p[i];
                        sq = 0; for (i = 1; i <= m; i++) sq = sq - i * q[i];
                        if (Math.Abs(sq) > 1e-10) return (sp / sq);
                        else return (1e12);
                    }

        }



        //---------------------------------------------------------------------------



        public void DB_aus_teta(double[] teta, ref double[] p, ref double[] q, int m) /*in:teta,m out: p,q*/
        {
            /* version with b0 in teta, b0 will be ignored */
            int hzp;
            double hv, q0;
            hv = 0;
            for (hzp = 0; hzp < p.Length; hzp++) p[hzp] = 0; // Clear
            for (hzp = 0; hzp < q.Length; hzp++) q[hzp] = 0; 

            for (hzp = 1; hzp <= m; hzp++) hv = hv + teta[m + hzp + 1];
            if (hv == 0) hv = 1000; else hv = 1.0 / hv;
            q0 = hv;
            q[0] = q0;
            for (hzp = 1; hzp <= m; hzp++)
            {
                q[hzp] = q0 * teta[hzp];
                p[hzp] = q0 * teta[m + hzp + 1];
            }


        } /*DB_aus_teta*/
        //---------------------------------------------------------------------------

        public void DB1_aus_teta(double[] teta, ref double[] p, ref double[] q, int m, double r)
        /*in:teta,m,r out p,q*/
        /* version with b0 in teta, b0 will be ignored */
        {
            int hzp;
            double hv, q0, q0max, q0min;
            hv = 0;
            for (hzp = 0; hzp < p.Length; hzp++) p[hzp] = 0; // Clear
            for (hzp = 0; hzp < q.Length; hzp++) q[hzp] = 0;
            
            for (hzp = 1; hzp <= m; hzp++) hv = hv + teta[m + hzp + 1];
            if (hv == 0) hv = 1000; else hv = 1.0 / hv;
            if ((1 - teta[1]) == 0) q0min = 1000; else q0min = hv / (1 - teta[1]);
            q0max = hv;
            q0 = q0min + (1 - r) * (q0max - q0min);
            q[0] = q0;
            q[1] = q0 * (teta[1] - 1) + hv;
            p[1] = q0 * teta[m + 2];
            if (m > 1)
            {
                for (hzp = 2; hzp <= m; hzp++)
                    q[hzp] = q0 * (teta[hzp] - teta[hzp - 1]) + teta[hzp - 1] * hv;
                for (hzp = 2; hzp <= m; hzp++)
                    p[hzp] = q0 * (teta[m + hzp + 1] - teta[m + hzp])
                                   + teta[m + hzp] * hv;
            }
            q[m + 1] = teta[m] * (-q0 + hv);
            p[m + 1] = -teta[m + m + 1] * (q0 - hv);
        } /*DB1_aus_teta*/

        //---------------------------------------------------------------------------

        public void OR_aus_teta(double[] t, ref double[] p, ref double[] q, int m, ref double f3)

                /* version with b0 in teta, b0 will be ignored */
        {
            int i,hzp;
            double[] a = new double[m+3];
            double[] b = new double[m+3];
            double h1, hvkl;
            /* Orientierungsregler (nur m<=3)
               nach W. Ehrlich Automatisierungstechnik 39(1991) 8 S. 272*/
            /* erst Umtopfen zum besseren Verständnis */

            for (hzp = 0; hzp < p.Length; hzp++) p[hzp] = 0; // Clear
            for (hzp = 0; hzp < q.Length; hzp++) q[hzp] = 0; 

            for (i = 1; i <= m; i++) { a[i] = t[i]; b[i] = t[i + m + 1]; }
            a[0] = 1; b[0] = 0;
            for (i = m + 1; i <= m + 2; i++) { a[i] = 0; b[i] = 0; }
            hvkl = a[1] * a[1] - a[2];
            h1 = b[1] + b[2] + b[3] - a[1] * (b[1] + b[2] - a[1] * b[1]) - a[2] * b[1];
            if (h1 == 0) f3 = 1000; else f3 = 1.0 / h1;
            for (i = 1; i <= m; i++) q[i] = (a[i + 2] - a[1] * a[i + 1] + hvkl * a[i]) * f3;
            for (i = 2; i <= m; i++) p[i] = (b[i + 2] - a[1] * b[i + 1] + hvkl * b[i]) * f3;
        }

        //---------------------------------------------------------------------------
////---------------------------------------------------------------------------

        public void kt_aus_tetab0(ref double k, ref double t1, ref double t2, double t0L, double[] teta, int m,
                              ref string typ, ref string error)
        /* version teta with bo !!   1. Wert a1 auf Index 1*/
        {
            double c, c1, c2, c3, a1, a2, b1, b2, sa, sb, b0;
            int i, j, m2;
            error = "";
            if (typ == "adc") { k = 0; t1 = 0; t2 = 0; error = "adc"; goto ex_kt; };
            j = 0; m2 = 2 * m;
            for (i = 1; i <= m2 + 1; i++) if (teta[i] != 0) j = j + 1;
            if (j != 0)
            {
                k = 0; t1 = 0; t2 = 0; a1 = teta[1]; typ = ""; b0 = teta[1 + m];
                if ((Math.Abs(b0) > 1e-7) && (m < 3))
                {
                    t1 = 0; t2 = 0; typ = "b0>0";
                    sa = 0; sb = teta[1 + m]; /*b0*/
                    for (i = 1; i <= m; i++) { sa = sa + teta[i]; sb = sb + teta[i + m + 1]; }
                    if (Math.Abs(1.0 + sa) < 1.0e-20) k = 1.0e20; else k = sb / (1.0 + sa);
                    goto ex_kt;
                }
                if (a1 >= 0) { k = 0; t1 = 0; t2 = 0; error = a1mustbenegative; goto ex_kt; }
                else
                {
                    if (m == 1)
                    {
                        b1 = teta[3];
                        if (a1 == -1)
                        {
                            k = 1.0e10 * b1 / t0L; t1 = 1.0e10; typ = "I";
                        }
                        else
                        {
                            t1 = -t0L / Math.Log(-a1);
                            k = b1 / (1.0 + a1);
                            typ = "PT1";
                        }  /*else*/
                    }  /*if ( m=1*/
                    if (m == 2)
                    {
                        a2 = teta[2]; b1 = teta[4]; b2 = teta[5];
                        if (a2 <= 0) { k = 0; t1 = 0; t2 = 0; typ = "nix"; }
                        else
                        {
                            c1 = Math.Abs(b1 + b2);
                            if (c1 <= 0.0001)
                            {
                                c1 = a1 * a1 / 4.0 - a2;
                                if (c1 < 0)
                                {
                                    c3 = Math.Sqrt(a2);
                                    c2 = Math.Log(c3);
                                    c3 = -a1 / 2.0 / c3;
                                    c1 = -1.0 / c2 * Math.Atan(Math.Sqrt(1.0 - c3 * c3) / c3);
                                    t1 = 1.0 / Math.Sqrt(1.0 + c1 * c1);      /*d*/
                                    t2 = -c2 / t1 / t0L;             /*wo*/
                                    typ = "DT2";
                                }
                                else
                                {
                                    c3 = -a1 / 2.0 - Math.Sqrt(c1);
                                    c2 = -a1 / 2.0 + Math.Sqrt(c1);
                                    typ = "D2T1";
                                    t1 = -t0L / Math.Log(c3); t2 = -t0L / Math.Log(c2);
                                }
                                k = b1 * (t1 - t2) / (c3 - c2);

                            } /*dt2*/
                            else
                            {
                                c = (1.0 + a1 + a2) / (b1 + b2);
                                if ((Math.Abs(c) < 0.001))     /*it1*/
                                {
                                    if (a1 >= -1) { k = 1.0e5; t1 = 0; t2 = 0; error = "a1 wrong"; goto ex_kt; };
                                    typ = "IT1";
                                    t1 = -t0L / Math.Log(-1.0 - a1);
                                    k = (b1 + b2) / t0L / (1.0 - a2);
                                }   /*it1*/
                                else    /*2pt1*/
                                {
                                    k = 1.0 / c;
                                    c1 = a1 * a1 / 4.0 - a2;
                                    if (c1 < 0)
                                    {
                                        c3 = Math.Sqrt(a2);
                                        c2 = Math.Log(c3);
                                        c3 = -a1 / 2.0 / c3;
                                        c1 = -1.0 / c2 * Math.Atan(Math.Sqrt(1.0 - c3 * c3) / c3);
                                        t1 = 1.0 / Math.Sqrt(1.0 + c1 * c1);      /*d*/
                                        t2 = -c2 / t1 / t0L;             /*wo*/
                                        typ = "PT2";
                                    }
                                    else
                                    {
                                        c3 = -a1 / 2.0 - Math.Sqrt(c1);
                                        c2 = -a1 / 2.0 + Math.Sqrt(c1);
                                        if ((c2 > 0) && (c3 > 0))
                                        {  // at special cases c2 or c3 could be negative --> nix
                                            typ = "2PT1";
                                            t1 = -t0L / Math.Log(c3); t2 = -t0L / Math.Log(c2);
                                        }
                                        else typ = "nix";
                                    }
                                }  /*2pt1*/
                            }  /*else dt2*/
                        }
                    } /* if ( m=2*/
                }  /*else a1 negativ */
                if (m > 2)
                {   /* calc HF(z=1) */
                    sa = 0; sb = teta[1 + m]; /*b0*/
                    for (i = 1; i <= m; i++) { sa = sa + teta[i]; sb = sb + teta[i + m + 1]; };
                    if (Math.Abs(1 + sa) < 1.0e-20) k = 1.0e20; else k = sb / (1.0 + sa);
                    typ = "m>2";
                }  /*if ( m>2*/
            }
            else /* case if ( teta complete is 0 */
            {
                typ = "000";   /* if ( teta not defined */
                k = 0; t1 = 0; t2 = 0; error = tetanotdefined;
            }
        ex_kt: ;
        } /*kt_aus_tetab0 */




    }
}