﻿using System;
using System.Collections.Generic;
using System.Linq;


namespace matinvert
{
    class matinvert1
    {

       // public const int maxn=400;
   
        public int matinv(ref double[,] a, int n, ref double det, ref double kond)

        {
          //  int matinv(double[][maxn-1] a  ,int n, ref double det, ref double kond);
            // version 1.2 with corrected sign of det
            // and no internal Mamtrix, because not necessary
            /* { matinv inverts the matrix with dimensionen n*n with the
               Gauss-Jordan-algorithm with column pivoting
               err=0 : all ok,
               err<0 : singular Matrix
               err=1 : n to large
                 -. includes calculation of determinant and Hadarmard condition
                     number, which is a normalized determinant between 0 and 1
                     0: singular   1:  pure diagonal matrix }

            */

            { 
                int maxn=400;
                int i,j,s,t,el=0;
                int[] v = new int[maxn-1];          
                double b,max,mw;
                double norm,hilf;

                   if (n>maxn) return(1);


                /*  Hadamard Condition number will be prepared. For that the determinant
                    will be divided by all geometrical row averages */
                  norm=1;
                  for (i=0;i<n;i++ )
                    {
                      mw=0;
                      for (j=0;j<n;j++) mw=mw+a[i,j]*a[i,j];
                      norm=norm*Math.Sqrt(mw);
                    } // end for

                   hilf=1;
                   for (s=0;s<n;s++)                   // { s: comumn }
                        {
                        v[s]=s;
                        max=0;

                        for (t=s;t<n;t++)               //   { Pivoting }
                            {
                            b=Math.Abs(a[t,s]);
                            if (b>max) {max=b; el=t;};
                            };      // {for t...}

                        if (max==0) return(-1);

                        if (el != s)                   //     { largest element at top }  
                           {
                           for (j=0;j<n;j++)             //     { swap rows }
                               {
                               b=a[s,j];a[s,j]=a[el,j];a[el,j]=b;
                               };
                           v[s]=el;                    //        { store nb. of swapped row }
                           hilf=-hilf;   //    {each swap changes det-sign}
                           };  // {if el<> s then ...}

                        b=1/a[s,s];               //    { normalize with largest element }
                        hilf=hilf*a[s,s];
                        a[s,s]=1;

                        for (j=0;j<n;j++) a[s,j]=b*a[s,j]; //   { in row s all divide with max }

                        for (t=0;t<n;t++) if (t!=s)
                            {                          //   { in all other rows }
                            b=a[t,s];
                            a[t,s]=0;                     //   { in column s make a 0 }
                            for (j=0;j<n;j++) a[t,j]=a[t,j]-b*a[s,j];
                            };    //{for t...}

                        };     //{ for s....}


                                   //                       { swap back }
                    for (s=n-1;s>=0;s--)
                    {
                    if (v[s]!=s)
                        for (j=0;j<n;j++)
                            {
                            b=a[j,s];a[j,s]=a[j,v[s]];a[j,v[s]]=b;
                            };

                    }; //for ...until s=0;


                // ______________________________________________________________-


                  det=hilf;
                  hilf=Math.Abs(hilf);  // this is the determinant }
                  kond=hilf/norm;

                return (0);
            }
}
    }
}

