﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Printing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WINDF7CSharp
{
    public partial class FormReport : Form
    {
        public FormReport()
        {
            InitializeComponent();
        }

        private void FormReport_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            toolStripButtonPreview.ToolTipText = "Druckvorschau";
            toolStripButton42StoreTxt.ToolTipText = "Speichere Report als .txt- Datei";
            toolStripButton41Clear.ToolTipText = "Lösche Report";
            toolStripButton32SetUp.ToolTipText = "Druckerseiten einrichten";
            toolStripButton31Print.ToolTipText = "Drucke Report";

        }

        private int startSeite;		    // Anzahl der Druckseiten
        private int anzahlSeiten;		// aktuelle Seitenzahl
        private int seitenNummer;		// zu druckender Text
        private string strPrintText;    // der Name der geöffneten Datei


        private void toolStripButton31Print_Click(object sender, EventArgs e)
        {
            printDialog1.AllowSomePages = true;
            if (printDialog1.ShowDialog() == DialogResult.OK)
            {
                printDocument1.DocumentName = "Dokument";
                // Startwerte abhängig vom zu druckenden Text initialisieren
                switch (printDialog1.PrinterSettings.PrintRange)
                {
                    case PrintRange.AllPages:
                        strPrintText = tBMainReport.Text;
                        startSeite = 1;
                        anzahlSeiten = printDialog1.PrinterSettings.MaximumPage;
                        break;
                    case PrintRange.SomePages:
                        strPrintText = tBMainReport.Text;
                        startSeite = printDialog1.PrinterSettings.FromPage;
                        anzahlSeiten = printDialog1.PrinterSettings.ToPage - startSeite + 1;
                        break;
                }
                // Drucken starten
                seitenNummer = 1;
                printDocument1.Print();
            }

        }

        private void toolStripButton32SetUp_Click(object sender, EventArgs e)
        {
            pageSetupDialog1.ShowDialog();
        }

        private void toolStripButtonPreview_Click(object sender, EventArgs e)
        {
            printDialog1.AllowSomePages = true;
            strPrintText = tBMainReport.Text;
            startSeite = 1;
            anzahlSeiten = printDialog1.PrinterSettings.MaximumPage;
            seitenNummer = 1;
            printPreviewDialog1.ShowDialog();
        }

        private void toolStripButton41Clear_Click(object sender, EventArgs e)
        {
            tBMainReport.Clear();
        }

        private void toolStripButton42StoreTxt_Click(object sender, EventArgs e)
        {
            if (tBMainReport.Lines.Length > 0)
                if (saveFileDialogReport.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter myStream1 = new StreamWriter(saveFileDialogReport.OpenFile(), Encoding.Default);
                    myStream1.WriteLine(tBMainReport.Text);
                    myStream1.Close();
                }

        }

        private void tsbHistory_Click(object sender, EventArgs e)
        {
            StreamReader filestream = new StreamReader("history.txt", Encoding.Default);
            string line = "", crlf = "\r\n";
            tBMainReport.Visible = false;
            while (line != null)
            {
                line = filestream.ReadLine();
                if (line != null)
                {
                    tBMainReport.AppendText(line + crlf);
                }
            }
            tBMainReport.Visible = true;
            filestream.Close();
        }

        public void english()
        {
            toolStripButtonPreview.ToolTipText = "Printing preview";
            toolStripButton42StoreTxt.ToolTipText = "Store report as .txt- file";
            toolStripButton41Clear.ToolTipText = "Clear Report";
            toolStripButton32SetUp.ToolTipText = "Setup printer";
            toolStripButton31Print.ToolTipText = "Print Report";
        }
    }
}
