using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Schwarze;                 //FormSchschwarze
using PReuter;                  //FormReuter
using FRADesign;                // FormFRADesign
using Flash;                    //FlashForm
using smallTools;               //in small tools/
using System.Drawing.Printing;   // Printer settings 
using System.IO;
using DFUFK;                    //in UFKmodule
using System.Globalization;
using ZPR;                      //in Identification/FormZPR
using idregress;                // in FRegression
using UScope;                   // in FScope
using System.Diagnostics;       // stopwatch
using CraneModelMuk;
using RealTimerDevice;
using DAQmx_Basics;
using cRIO_Basics;
using USBOrlowskiDLL;
using WINDF7CSharp.ChartTools;
using DT9062;
using me4660;
using USBOrlowskiDLL20;

namespace WINDF7CSharp
{
 
    
    public partial class FormMain : Form
    {

        FormSchwarze schwarze;
        FormReuter reuter;
        public FormFRA fra;
        public FlashForm flash;
        wrc2pt1 wrc2;
        pt2equ pt2;
        pt1id pt1;
        nichols nichol;
        public DFUFK1 dfufk;
        FormInfo frminfo;
        public frmLoadOptions frmLO;
        FormZPR frmZpr;
        public F_Regress fregress;
        public FScope fscope;
        public DataTools datatools;
        public TFAnalogfilter fanalogfilter;
        public FContrdes fcontrdes;
        public FpidPQ fpidpq;
        public Fa2d fa2d;
        public FDigitalFilter fdigfilt;
        FormGPA frmGPA;
        FormME2600 frmMe2600;
        public FormXWCalc frmxwcalc;
        FormCraneMuk_rap frmCrane;
        FormCraneModelMuk frmCraneSpindle;
        public Hardwaretools.FormHardwareSimul frmSimul;
        
        small_tools.FormPIDMagPhase frmPID;
        public FormRTdevice frmRTdevice;
        public DAQmx_Basic frmDACmx;
        cRIO_Basics_2Channels frmcRIO;
        Hardwaretools.FDigitalRTFilter frmRTFilt;
        Init.FInit frmInit;
        FormUSBOrl frmusborl;
        public FormLSOffline frmlsoff;
        public AdaptControl.FormAdaptControl frmadaptcon;
        RealTimeController.FormDRTKranregler frmDTRKran;
        RealTimeController.FormCSIIrap1 frmCSIIrap;
        RealTimeController.FormCSIIIduDRDemo frmCSIIdemo;
        FormTestComma frmtestComma;
        public AD_Filter.FStepRespDF fstepresp;
        public FormSaveCurve frmsavecurve;
        FormDT9062 frmDT9062;
        public FormME4660 frmME4660;
        FormUSBOrl20 frmusborl20;
        public fuzzy.FormFuzEditor frmFuzEdit;
        Hardwaretools.FormSampleHold frmSH;
        Formxypendel frmXYPendel;
        public UNIT_Interface_RS232 frmUNI_T;
        Hardwaretools.FormTransferline frmTransferLine;
        public FormRigolScope frmRigol;
        wrc3pt1 wrc3;
        public FormReport frmreport;
        Hardwaretools.FormBatCapacity frmBatCap;
        Hardwaretools.FormTempLogger frmTempLog;
        Hardwaretools.FormDataLogger frmDataLog;
        es_PendelDemo10.Form1 frmESPendel;
        public I2C.I2CCH341 frmI2cCH341;
        Hardwaretools.FoGA286 frmGA286;
        Hardwaretools.FormADCLinCheck frmLinCheck;

        public string wrongDataFormat = "Wrong Data format";

        public string errorConvert = "Fehler bei Konvertierung Nr.: ";
        public string selectedADC = "no card";
        public string controlBoxSelector = "";
        public string notmorethan10curves="Not more than 10 curves";
        string nocurve = "No Curve";

        public char comF, comR;   // to correct Comma- / point problem comF : wrong seperator
                                 // comR  : correct separator

        PrinterSettings printsetgs = new PrinterSettings();
        public TextBox tBMainReport1;

        public FormMain()
        {
            InitializeComponent();
            frmreport = new FormReport();
            tBMainReport1 = frmreport.tBMainReport;
            tBMainReport1.Clear();


            schwarze = new FormSchwarze(this);
            reuter = new FormReuter(this);
            fra = new FormFRA(this);
            flash = new FlashForm(this);
            flash.Width = 512;
            wrc2 = new wrc2pt1(this);
            pt2 = new pt2equ(this);
            pt1 = new pt1id(this);
            nichol = new nichols(this);
            dfufk = new DFUFK1(this);
            frminfo = new FormInfo();
            frmLO = new frmLoadOptions(this);
            frmZpr = new FormZPR(this);
            fregress = new F_Regress(this);
            fscope = new FScope(this);
            initChart(chart2D1);
            LOMain.init();
            datatools = new DataTools();
            fanalogfilter = new TFAnalogfilter(this);
            fcontrdes = new FContrdes(this);
            fpidpq = new FpidPQ(this);
            fa2d = new Fa2d(this);
            fdigfilt = new FDigitalFilter(this);
            frmGPA = new FormGPA(this);
            frmMe2600 = new FormME2600(this);
            frmxwcalc = new FormXWCalc(this);
            frmCrane = new FormCraneMuk_rap(this);
            frmCraneSpindle = new FormCraneModelMuk(this);
            frmSimul = new Hardwaretools.FormHardwareSimul(this);
            
            frmPID = new small_tools.FormPIDMagPhase(this);
            frmRTdevice = new FormRTdevice(this);
            frmDACmx = new DAQmx_Basic();
            frmcRIO = new cRIO_Basics_2Channels();
            frmRTFilt = new Hardwaretools.FDigitalRTFilter(this);
            frmInit = new Init.FInit();
            frmusborl = new FormUSBOrl();
            frmlsoff = new FormLSOffline(this);
            frmadaptcon = new AdaptControl.FormAdaptControl(this);
            frmCSIIrap = new RealTimeController.FormCSIIrap1(this);
            frmCSIIdemo = new RealTimeController.FormCSIIIduDRDemo(this);
            frmDTRKran = new RealTimeController.FormDRTKranregler(this);
            frmtestComma = new FormTestComma(this);
            fstepresp = new AD_Filter.FStepRespDF(this);
            frmsavecurve = new FormSaveCurve();
            frmDT9062 = new FormDT9062(this);
            frmcp = new FormCurvePlotter(this);
            frmME4660 = new FormME4660();
            frmFuzEdit = new fuzzy.FormFuzEditor(this);
            frmusborl20 = new FormUSBOrl20();
            frmSH = new Hardwaretools.FormSampleHold(this);
            frmXYPendel = new Formxypendel(this);
            frmUNI_T = new UNIT_Interface_RS232(this);
            frmTransferLine = new Hardwaretools.FormTransferline(this);
            frmRigol = new FormRigolScope(this);
            frmBatCap = new Hardwaretools.FormBatCapacity(this);
            frmTempLog = new Hardwaretools.FormTempLogger(this);
            frmDataLog = new Hardwaretools.FormDataLogger(this);
            frmESPendel = new es_PendelDemo10.Form1();
            frmI2cCH341 = new I2C.I2CCH341();
            wrc3 = new wrc3pt1(this);
            frmGA286 = new Hardwaretools.FoGA286(this);
            frmLinCheck = new Hardwaretools.FormADCLinCheck(this);

            stopwatch.Start();
            chart2D1.clearAll();  // To start with no curves and counter -1
            //frmlsoff
        }




        //----------------------------------------------------------------------------------
        //chartfx- init
        //----------------------------------------------------------------------------------


        FormCurvePlotter frmcp ;

        Stopwatch stopwatch=new Stopwatch();



        public CHMinMax minmaxMain = new CHMinMax();
        public LoadOpt LOMain = new LoadOpt();

        public void ConvertToDouble(string text,ref double nb)
        {
            // Secure Conversion independant of Komma- Version of PC
            // comF contains String with wrong camma, comR contains string with correct comma
            // if number format is wrong, result is old number
            // Call :  ConvertToDouble(text,ref number);
            // removes all thousand- Seperators
            // examples: (if decimal sep =".")
            // 1000,000,000.23 --> 1000000000.23
            // 1000.000.000,23 --> 1000000000.23
            // 0.23 --> 0.23
            // 0,23 --> 0.23
            // 1000,023 --> 1000.023
            // 1000.023 --> 1000.023

            // examples: (if decimal sep =",")
            // 1000,000,000.23 --> 1000000000,23
            // 1000.000.000,23 --> 1000000000,23
            // 0.23 --> 0,23
            // 0,23 --> 0,23
            // 1000,023 --> 1000,023
            // 1000.023 --> 1000,023

            string TestText = (0.1).ToString("f1");

            if (TestText.Substring(1, 1) == ".")  // Check which is the actual Decimal separator
            { comF = ','; comR = '.'; }
            else
            { comF = '.'; comR = ','; }
            
            double number = 0;
            char []seps =new char[2];
            seps[0]=','; // both possible decimal seperators
            seps[1]='.';
            // check if Thousand- group sign is available. If more than one sign, all left signs are removed
            int index=0,cnt=0;
            while(index>-1)  // count number of seperators
            {
                index=text.IndexOfAny(seps,index);  // look for next position of seps
                if (index>-1) {cnt++;index++;}
            }
            string newtext=text;
            if (cnt > 1)  // If more than one sign, all left signs are removed
            {
                string leftSign=text.Substring(text.IndexOfAny(seps),1);  // what is the left sign?
                newtext = text.Replace(leftSign, "");// Remove all left signs
            }
            string help = newtext.Replace(comF,comR); // Change into correct decimal sep
            if (Double.TryParse(help, out number))
                nb = number;
            else MessageBox.Show(wrongDataFormat);
        
        }
        
        private void initChart(ChartTool.Chart2D chart)
        {
           chart.LastClearButton = true;
           chart.LegendButton = true;
           chart.LoadButton = true;
           chart.PenScaleButton = true;
           chart.PrintButton = true;
           chart.SaveButton = true;
           chart.ScallingButton = true;
           chart.TitleButton = true;
           chart.XGrid = true;
           chart.XGridButton = true;
           chart.YGrid = true;
           chart.YGridButton = true;
           chart.ZoomButton = true;
           chart.AllClearButton = true;
           chart.LastClearButton = true;
        }

        public void enableCurveButtons()
        {

            this.ToolButton15Store.Enabled = true;
        }

        private void disableCurveButtons()
        {


            this.ToolButton15Store.Enabled = false;

        }

        
        //----------------------------------------------------------------------------------
        //chartfx- init
        //----------------------------------------------------------------------------------


 

        private void TBger_Click(object sender, EventArgs e)
        {
            maindeutsch();
            schwarze.deutsch();
            reuter.deutsch();
            fra.deutsch();
            flash.deutsch();
            wrc2.deutsch();
            wrc3.deutsch();
            pt2.deutsch();
            pt1.deutsch();
            nichol.deutsch();
            dfufk.deutsch();
            frmLO.deutsch();
            frmZpr.deutsch();
            fregress.deutsch();
            fanalogfilter.deutsch();
            fpidpq.deutsch();
            fcontrdes.deutsch();
            fa2d.deutsch();
            fscope.deutsch();
            frmxwcalc.deutsch();
            fdigfilt.deutsch();
            frmGPA.deutsch();
            
            frmadaptcon.deutsch();
            frmSimul.deutsch();
            frmRTFilt.deutsch();
            frmInit.deutsch();
            frmlsoff.deutsch();
            frmsavecurve.deutsch();
            frmFuzEdit.deutsch();
            frmDTRKran.deutsch();
            frmCSIIdemo.deutsch();
            frmCSIIrap.deutsch();
            frmRigol.deutsch();
        }

        void maindeutsch()
        {

            this.Text = "Toolsammlung fr Regelungstechnik   ..... Prof. Dr. Bayerlein";
            /* menue*/
            this.deutsch1.Text = "english text only at start";
            this.load1.Text = "Lade Graphik-file";
            this.deletelastfile1.Text = "Lsche letzte Kurve";
            this.deleteallfiles1.Text = "Lsche alle Kurven";
 
            this.quit1.Text = "Beenden";
            this.info1.Text = "Infobox";
            this.file1.Text = "Datei";
            this.options1.Text = "Aktionen";
            this.deletelastfile1.Text = "Lsche letzte Kurve";
            this.deleteallfiles1.Text = "Lsche alle Kurven";
            this.loadanlogfilterzk1.Text = "Definiere analoges Filter";
            this.loaddigitalfilterzk1.Text = "Definiere digitales Filter";
            this.InvertedxyPendulum1.Text = "Stehendes xy-Pendel";
            this.modifyanalogfilterufk1.Text = "Berechne UFK -. ZK ";
            this.identification1.Text = "Identifikation";
            this.bytimefunctionLS1.Text = "Regression ber f(t)";
            this.byoffLineLSFz1.Text = "Offline-LS-Verfahren -.F(z)";
            this.Realtimefunctions1.Text = "Echtzeit-Funktionen";
            this.dRTVersuch3PendelToolStripMenuItem.Text = "Pendel- Software";

            this.Flashdesign2PT11.Text = "Blitzreglerentwurf";
            this.FRA2PT1delay1.Text = "FKL-Verfahren 2PT1+ Totzeit";
            this.N2pointcontrollerident1.Text = "Zweipunktregleridentifikation";
            this.ControllerDesign2.Text = "Reglerentwurf";
            this.PT2Equations1.Text = "PT2-Gleichungen";
            this.PT1with2Points1.Text = "PT1 mit 2 Punkten";
            this.Flashdesign2PT11.Text = "Blitzregler PID+2PT1";
            this.FRA2PT1delay1.Text = "FKL PID+2PT1+Totzeit";
            this.Calculateqi1.Text = "PIDT1- Konverter";
            this.freqCalculatorToolStripMenuItem.Text = "Bode-Frequenzrechner";
            this.ADCard1.Text = "AD-Karte";
            this.label2.Text = "C# Tool Sammlung fr Regelungstechnik";
            this.label3.Text = "Projektleiter Prof. Dr. Bayerlein";
            this.label4.Text = "Komplett berarbeitet in MS C#";
            this.label5.Text = "Grafische Darstellung verschiedener Diagramme, z. B. Bodediagramme";
            this.label6.Text = "Entwurf von analogen und digitalen Filtern, Entwurf digitaler Filter";
            this.label7.Text = "Diverse Identifikationsprogramme, Interfaces zu Scopes und GPA";
            this.label8.Text = "Echtzeitreglerfunktion mit AD-Karten Interface und,und, und ...";
            this.designofToolStripMenuItem.Text = "Entwurf digitaler PID- Reg.";
            this.someToolsToolStripMenuItem.Text = "Einige Tools";
            this.rCBlockToolStripMenuItem.Text = "2 RC- Tiefpass";
            this.schwarze2PT1IdentificationToolStripMenuItem.Text = "2PT1- Identifikation nach Schwarze";
            this.mUKSpindleDriveToolStripMenuItem.Text = "MUK- Modell Kran";
            this.eSModulRapToolStripMenuItem.Text = "Stehendes Pendel ES";
            this.cSIIRackandpinionToolStripMenuItem.Text = "IduDR Lab Zahnstange";
            this.cSIILabToolStripMenuItem.Text="IduDR Lab Spindel";
            this.mUKSoftwareRapToolStripMenuItem.Text="MUK-Software Zahnstange";
            this.activeFilterToolStripMenuItem.Text = "Aktives Filter";
            this.nicholsEquationsToolStripMenuItem.Text = "Nichols- Gleichungen";
            this.noCardToolStripMenuItem.Text = "Keine Karte";
            // tooltips in deutsch
            ToolButton11LoadFile.ToolTipText = "Lade Datei mit graphischen Daten (z.B. *.dat)";
            ToolButton10AnalogF.ToolTipText = "Lade oder definiere analoges Filter fr Bodediagramm";


            ToolButton11LoadFile.ToolTipText = "Lade Datei mit graphischen Daten (z.B. *.dat)";
            //openFileDialog1.Title="Lade Datei mit graphischen Daten (z.B. *.dat)";
            ToolButton12DigF.ToolTipText = "Lade oder definiere digitales Filter fr Bodediagramm";
            TBClose.ToolTipText = "Schliee Anwendung";
            ToolButton21MagA.ToolTipText = "Zeichne die Betragskurve des analogen Filters";
            ToolButton23MagD.ToolTipText = "Zeichne die Betragskurve des digitalen Filters";
            ToolButton22PhiA.ToolTipText = "Zeichne die Phasenkurve des analogen Filters";
            ToolButton17PhiD.ToolTipText = "Zeichne die Phasenkurve des digitalen Filters";
            ToolButton18A2D.ToolTipText = "Berechne ein passendes digitales Filter ";
            ToolButton19SR.ToolTipText = "Berechne die Antwort des digitalen Filters";
            ToolButton24UFK.ToolTipText = "Lade Filter in UFK-Form und konvertiere in ZK-Form";
            ToolButton15Store.ToolTipText = "Speichere Diagramm-Werte als File (Export-Funktion)";
            ToolButton28GPA.ToolTipText = "Lese Daten von Gain Phase Analyzer in den PC";
            ToolButton26Scope.ToolTipText = "Lese Daten vom Scope PM38xx in den PC";
            ToolButton29MagGPA.ToolTipText = "Zeichne die letzte gemessene Betragskurve vom GPA";
            ToolButton31PhiGPA.ToolTipText = "Zeichne die letzte gemessene Phasenkurve vom GPA";
            ToolButton27ScopeF.ToolTipText = "Zeichne die letzte gemessene Kurve vom Scope";


            TSBClearLast.ToolTipText= "Lsche letzte Kurve";
            tsbClearAll.ToolTipText="Lsche alle Kurven";
            errorConvert = "Fehler bei Chart- Konvertierung Nr.: ";
            adaptiveAdvancedControllerToolStripMenuItem.Text = "Adaptive Regler";
            wrongDataFormat = "Falsches Zahlenformat";
            notmorethan10curves="Nicht mehr als 10 Kurven mglich";
            chart2D1.Germanlanguage = true;
            devicesToolStripMenuItem.Text = "Gerte";
            scopePhillipsToolStripMenuItem.Text = "Oszillograph Phillips";
            unitTRedLCDToolStripMenuItem.Text = "rotes LCD- Scope UNIT_T";
            gainPhaseAnalyzerToolStripMenuItem.Text = "Frequenzgangmessplatz";
            nocurve = "Keine Kurve";
            tSBReport.ToolTipText = "ffne / schliee das Report- Fenster";
            toolTip1.SetToolTip(butInfoReport,"ffne / schliee das Report- Fenster");
            label9.Text = "Seit Version 7.6.15 ist diese Funktion verschoben in ein neues Fenster hinter der Taste oben:";
        }

        //
        //---------------------------------------------------------------------------------------------------------------
        //  Printing Report        
        //---------------------------------------------------------------------------------------------------------------
        // Seit Version 7.6.15 verschoben nach frmreport
        //---------------------------------------------------------------------------------------------------------------
        //  Printing Report ENd       
        //---------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------
//  All modules to copy data between modules      
//---------------------------------------------------------------------------------------------------------------

        public void reuterOK()
        {// This function copies the result of reuter ident  into all controller design windows

            double help = 0;
            this.ConvertToDouble(reuter.textBox4.Text, ref help);
            flash.textBox2.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox5.Text, ref help);
            flash.textBox3.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox6.Text, ref help);
            flash.textBoxTz.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox4.Text, ref help);
            fra.textBox2.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox5.Text, ref help);
            fra.textBox3.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox6.Text, ref help);
            fra.textBox4.Text = help.ToString("g5");

        }

        public void schwarzeOK()
        {// This function copies the result of schwarze ident  into all controller design windows

            double help = 0;
            this.ConvertToDouble(schwarze.textBox4.Text, ref help);
            flash.textBox2.Text = help.ToString("g5"); //T1
            this.ConvertToDouble(schwarze.textBox5.Text, ref help);
            flash.textBox3.Text = help.ToString("g5");//T2
            this.ConvertToDouble(schwarze.textBox7.Text, ref help);
            flash.textBoxTz.Text = help.ToString("g5");//Tz
            this.ConvertToDouble(schwarze.textBox4.Text, ref help);
            fra.textBox2.Text = help.ToString("g5");
            this.ConvertToDouble(schwarze.textBox5.Text, ref help);
            fra.textBox3.Text = help.ToString("g5");
            this.ConvertToDouble(schwarze.textBox7.Text, ref help);
            fra.textBox4.Text = help.ToString("g5");

        }


 
        public void DFUFK_OK()
        {
            // copy Time Constants to analog Filter window
        }

        public void ZPROK()
        {
            // copy data to controller Design only 2PT1 possible
            double help = 0;
            this.ConvertToDouble(frmZpr.Edit8T1.Text, ref help);
            flash.textBox2.Text = help.ToString("g5");    //T1
            this.ConvertToDouble(frmZpr.Edit9T2.Text, ref help);
            flash.textBox3.Text = help.ToString("g5");    //T2
            this.ConvertToDouble(frmZpr.Edit10Tz.Text, ref help);
            flash.textBoxTz.Text = help.ToString("g5");  //Tz
            this.ConvertToDouble(frmZpr.Edit7K.Text, ref help);
            flash.textBox1.Text = help.ToString("g5");     //K

            this.ConvertToDouble(frmZpr.Edit8T1.Text, ref help);
            fra.textBox2.Text = help.ToString("g5");    //T1
            this.ConvertToDouble(frmZpr.Edit9T2.Text, ref help);
            fra.textBox3.Text = help.ToString("g5");    //T2
            this.ConvertToDouble(frmZpr.Edit10Tz.Text, ref help);
            fra.textBox4.Text = help.ToString("g5");  //Tz
            this.ConvertToDouble(frmZpr.Edit7K.Text, ref help);
            fra.textBox1.Text = help.ToString("g5"); //K 


            fcontrdes.rb2pt1.Checked = true;
            fcontrdes.rb2pt1_Click(null, null);
            fcontrdes.tBcomment.Text = "2PT1 from ZPR";
            this.ConvertToDouble(frmZpr.Edit7K.Text, ref help);
            fcontrdes.edk.Text = help.ToString("g5");
            this.ConvertToDouble(frmZpr.Edit8T1.Text, ref help);
            fcontrdes.Edt1.Text = help.ToString("g5");
            this.ConvertToDouble(frmZpr.Edit9T2.Text, ref help);
            fcontrdes.Edt2.Text = help.ToString("g5");
            this.ConvertToDouble(frmZpr.Edit10Tz.Text, ref help);
            fcontrdes.edtt.Text = help.ToString("g5");
        }

        public void regessionOK(string typ)
        {
            double help = 0;
            if (typ == "2PT1")
            {
                this.ConvertToDouble(fregress.par1.Text, ref help);
                flash.textBox1.Text = help.ToString("g5");// K
                this.ConvertToDouble(fregress.par2.Text, ref help);
                flash.textBox2.Text = help.ToString("g5");// T1
                this.ConvertToDouble(fregress.par3.Text, ref help);
                flash.textBox3.Text = help.ToString("g5");// T2
                this.ConvertToDouble(fregress.par5.Text, ref help);
                flash.textBoxTz.Text = help.ToString("g5");// Tz
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fra.textBox1.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fra.textBox2.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par3.Text, ref help);
                fra.textBox3.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par5.Text, ref help);
                fra.textBox4.Text = help.ToString("g5");
                this.ConvertToDouble(fcontrdes.edk.Text, ref fcontrdes.k2pt1cd);
                this.ConvertToDouble(fcontrdes.Edt1.Text, ref fcontrdes.t12pt1cd);
                this.ConvertToDouble(fcontrdes.Edt2.Text, ref fcontrdes.t22pt1cd);


                fcontrdes.rb2pt1.Checked = true;
                fcontrdes.rb2pt1_Click(null, null);
                fcontrdes.tBcomment.Text = "2PT1 from regress";
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par3.Text, ref help);
                fcontrdes.Edt2.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par5.Text, ref help);
                fcontrdes.edtt.Text = help.ToString("g5");

            }
            if (typ == "IT1")
            {
                fcontrdes.rbit1.Checked = true;
                //fcontrdes.rbit1(null, null);
                fcontrdes.tBcomment.Text = "IT1 from regress";
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");

                this.ConvertToDouble(fregress.par4.Text, ref help);
                fcontrdes.edtt.Text = help.ToString("g5");

            }
            if (typ == "PT1")
            {
                fcontrdes.rbpt1.Checked = true;
                //fcontrdes.rbit1(null, null);
                fcontrdes.tBcomment.Text = "PT1 from regress";
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par5.Text, ref help);
                fcontrdes.edtt.Text = help.ToString("g5");
           }
            if (typ=="3pt1")
            {

                //fcontrdes.rbit1(null, null);
                fcontrdes.tBcomment.Text = "3PT1 from regress";
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par6.Text, ref help);
                fcontrdes.edtt.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par3.Text, ref help);
                fcontrdes.Edt2.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par4.Text, ref help);
                fcontrdes.par4.Text = help.ToString("g5");
                this.ConvertToDouble(fcontrdes.edk.Text, ref fcontrdes.k2pt1cd);
                this.ConvertToDouble(fcontrdes.Edt1.Text, ref fcontrdes.t12pt1cd);
                this.ConvertToDouble(fcontrdes.Edt2.Text, ref fcontrdes.t22pt1cd);
                 fcontrdes.rBPT3.Checked = true;
                 fcontrdes.rBPT3_Click(null, null);
            }
        }

        public void LSoffOK(string typ)
        {
            double help = 0;
            if (typ == "2PT1")
            {
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                flash.textBox1.Text = help.ToString("g5");// K
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                flash.textBox2.Text = help.ToString("g5");// T1
                this.ConvertToDouble(frmlsoff.par3.Text, ref help);
                flash.textBox3.Text = help.ToString("g5");// T2
                flash.textBoxTz.Text = frmlsoff.tzLS.ToString("g5");// Tz
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                fra.textBox1.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                fra.textBox2.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par3.Text, ref help);
                fra.textBox3.Text = help.ToString("g5");
                fra.textBox4.Text = frmlsoff.tzLS.ToString("g5");// Tz

                fcontrdes.rb2pt1.Checked = true;
                fcontrdes.tBcomment.Text = "2PT1 from LS Offline";
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par3.Text, ref help);
                fcontrdes.Edt2.Text = help.ToString("g5");
                fcontrdes.edtt.Text = frmlsoff.tzLS.ToString("g5");// Tz
            }
            if (typ == "IT1")
            {
                fcontrdes.rbit1.Checked = true;

                fcontrdes.tBcomment.Text = "IT1 from LS Offline";
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");

                fcontrdes.edtt.Text = frmlsoff.tzLS.ToString("g5");// Tz
            }
            if (typ == "PT1")
            {
                fcontrdes.rbpt1.Checked = true;

                fcontrdes.tBcomment.Text = "PT1 from LS Offline";
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");

                fcontrdes.edtt.Text = frmlsoff.tzLS.ToString("g5");// Tz
            }


        }

        
        
        //---------------------------------------------------------------------------------------------------------------
        //  All modules to copy data between modules  end----------------------------       
//---------------------------------------------------------------------------------------------------------------
 
        
        private void FRA2PT1delay1_Click(object sender, EventArgs e)
        {
            fra.Show();
            if (fra.WindowState == FormWindowState.Minimized)
                fra.WindowState = FormWindowState.Normal;
            fra.BringToFront();
        }

        private void Flashdesign2PT11_Click(object sender, EventArgs e)
        {
            flash.Show();
            if (flash.WindowState == FormWindowState.Minimized)
                flash.WindowState = FormWindowState.Normal;
            flash.BringToFront();
        }

        private void TBClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void schwarze2PT1IdentificationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            schwarze.Show();
            if (schwarze.WindowState == FormWindowState.Minimized)
                schwarze.WindowState = FormWindowState.Normal;
            schwarze.BringToFront();
        }

        private void reuter2PT1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reuter.Show();
            if (reuter.WindowState == FormWindowState.Minimized)
                reuter.WindowState = FormWindowState.Normal;
            reuter.BringToFront();
        }

        private void toolStripButton41_Click(object sender, EventArgs e)
        {
        }

        private void PT1with2Points1_Click(object sender, EventArgs e)
        {
            pt1.Show();
            if (pt1.WindowState == FormWindowState.Minimized)
                pt1.WindowState = FormWindowState.Normal;
            pt1.BringToFront();
        }

        private void nicholsEquationsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            nichol.Show();
            if (nichol.WindowState == FormWindowState.Minimized)
                nichol.WindowState = FormWindowState.Normal;
            nichol.BringToFront();
        }

        private void PT2Equations1_Click(object sender, EventArgs e)
        {
            pt2.Show();
            if (pt2.WindowState == FormWindowState.Minimized)
                pt2.WindowState = FormWindowState.Normal;
            pt2.BringToFront();
        }

        private void rCBlockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            wrc2.Show();
            if (wrc2.WindowState == FormWindowState.Minimized)
                wrc2.WindowState = FormWindowState.Normal;
            wrc2.BringToFront();
        }

        private void toolStripButton32_Click(object sender, EventArgs e)
        {
         }

        private void ToolButton24UFK_Click(object sender, EventArgs e)
        {
            dfufk.Show();
            if (dfufk.WindowState == FormWindowState.Minimized)
                dfufk.WindowState = FormWindowState.Normal;
            dfufk.BringToFront();
        }

        private void info1_Click(object sender, EventArgs e)
        {

        }

        private void N2pointcontrollerident1_Click(object sender, EventArgs e)
        {
            frmZpr.Show();
            if (frmZpr.WindowState == FormWindowState.Minimized)
                frmZpr.WindowState = FormWindowState.Normal;
            frmZpr.BringToFront();
        }

        private void designofToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fcontrdes.Show();
            if (fcontrdes.WindowState == FormWindowState.Minimized)
                fcontrdes.WindowState = FormWindowState.Normal;
            fcontrdes.BringToFront();
        }

        private void Calculateqi1_Click(object sender, EventArgs e)
        {
            fpidpq.Show();
            if (fpidpq.WindowState == FormWindowState.Minimized)
                fpidpq.WindowState = FormWindowState.Normal;
            fpidpq.BringToFront();
        }

        private void ToolButton10AnalogF_Click(object sender, EventArgs e)
        {
            if (fanalogfilter.WindowState == FormWindowState.Minimized)
                fanalogfilter.WindowState = FormWindowState.Normal;
            fanalogfilter.Show();
            fanalogfilter.BringToFront();
        }

        private void ToolButton18A2D_Click(object sender, EventArgs e)
        {
            if (fa2d.WindowState == FormWindowState.Minimized)
                fa2d.WindowState = FormWindowState.Normal;
            fa2d.Show();
            fa2d.BringToFront();

        }

        private void ToolButton12DigF_Click(object sender, EventArgs e)
        {
            if (fdigfilt.WindowState == FormWindowState.Minimized)
                fdigfilt.WindowState = FormWindowState.Normal;
            fdigfilt.labelADCCard.Text = selectedADC;
            fdigfilt.Show();
            fdigfilt.BringToFront();

        }

        private void curvePlotterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmcp.Show();
            // this drawing uses following global params: 
            // lastminmaxMain.maxpts: 
            // minmaxMain.maxpts actual Max points
            // minmaxMain.serie: Number of Curve starting with 0
            // xmax,xmin,ymax,ymin as MinMax- values of Curves

       }

        private void ToolButton2SetUp_Click(object sender, EventArgs e)
        {

        }

        private void TBcolchange_Click(object sender, EventArgs e)
        {
            ////frmcs.axChartfx1 = axChartfx1;  // pointer verbiegen 
            //if (frmcs.WindowState == FormWindowState.Minimized)
            //    frmcs.WindowState = FormWindowState.Normal;
            //frmcs.Show();
            //frmcs.BringToFront();
        }

        private void ToolButton7Datashow_Click(object sender, EventArgs e)
        {

        }


        private void deleteAllPoints()
        {
            minmaxMain.init();
        }

        private void ToolButton11LoadFile_Click(object sender, EventArgs e)
        {
            //frmLO.ChartfxLoadOpt = axChartfx1;  // set pointer to destination Chart
            frmLO.ShowDialog();
            if ( frmLO.DialogResult== DialogResult.OK)
            {

                long strt, stp;
                strt = stopwatch.ElapsedTicks;
                chart2D1.XLOG = frmLO.LO1.XaxisLog;  // Umschalten Chart x- Axhse
                int a = datatools.ConvertTB2ChartAdd(ref chart2D1, frmLO.textBox1, ref minmaxMain,frmLO.LO1);//ConvertTB2Chart(meinm;
                enableCurveButtons();
                stp = stopwatch.ElapsedTicks;
                toolStripStatusLabel4.Text = ((stp - strt) / (float)Stopwatch.Frequency * 1000).ToString() + " ms";
                if (a > 0) MessageBox.Show(errorConvert + a.ToString());
                else enableCurveButtons();
            }
         
        }

        private void ToolButton15Store_Click(object sender, EventArgs e)
        {
            frmsavecurve.RefToChart2D = chart2D1;
            if (frmsavecurve.WindowState == FormWindowState.Minimized)
                frmsavecurve.WindowState = FormWindowState.Normal;
            frmsavecurve.Show();
            frmsavecurve.BringToFront();
        }

        private void bytimefunctionLS1_Click(object sender, EventArgs e)
        {
            fregress.labelADCCard.Text = selectedADC;
            if (fregress.WindowState == FormWindowState.Minimized)
                fregress.WindowState = FormWindowState.Normal;
            fregress.Show();
            fregress.BringToFront();
        }

        private void ToolButton26Scope_Click(object sender, EventArgs e)
        {
            if (fscope.WindowState == FormWindowState.Minimized)
                fscope.WindowState = FormWindowState.Normal;
            fscope.Show();
            fscope.BringToFront();
        }

        private void ToolButton27ScopeF_Click(object sender, EventArgs e)
        {
            if (fscope.textBox2.TextLength > 10)
                fscope.buttonDrawScope_Click(sender, e);
            else if (frmRigol.tBRigol.TextLength > 10)
                frmRigol.btWerteDarstellen_Click(sender, e);
            else MessageBox.Show(nocurve);
        }

        private void ToolButton21MagA_Click(object sender, EventArgs e)
        {
            fanalogfilter.drawMag();
        }

        private void ToolButton22PhiA_Click(object sender, EventArgs e)
        {
            fanalogfilter.drawPhi();
        }

        private void ToolButton23MagD_Click(object sender, EventArgs e)
        {
            fdigfilt.DrawMag();
        }

        private void ToolButton17PhiD_Click(object sender, EventArgs e)
        {
            fdigfilt.DrawPhi();
        }

        private void ToolButton28GPA_Click(object sender, EventArgs e)
        {
            if (frmGPA.WindowState == FormWindowState.Minimized)
                frmGPA.WindowState = FormWindowState.Normal;
            frmGPA.Show();
            frmGPA.BringToFront();
        }

        private void ToolButton29MagGPA_Click(object sender, EventArgs e)
        {
            frmGPA.buttonGPADrawF_Click(sender, e);
        }

        private void ToolButton31PhiGPA_Click(object sender, EventArgs e)
        {
            frmGPA.buttonGPADrawPhi_Click(sender, e);
        }

/// <summary>
///  Adc - Control section
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>

        private void uSBFHLOriginalToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

 
        public void ADCinput(short chan,ref double val)
        {
            
            if (meilhausME2600ToolStripMenuItem.Checked)
                frmMe2600.inputME(chan, ref val);
            if (hardwareSimulationToolStripMenuItem.Checked)
                frmSimul.inputSimul(chan, ref val);
            if (toolStripMenuItemNIDAQmx.Checked)
                frmDACmx.InputNImx(chan, ref val);
            if (uSBFHL10VToolStripMenuItem.Checked)
                frmusborl.inputOrl(chan, ref val);
            if (tsmcRIO.Checked)
                frmcRIO.inputcrio(chan, ref val);
            if (meilhausME4660ToolStripMenuItem.Checked)
                frmME4660.input(chan, ref val);
            if (uSBFHLOrlowski20ToolStripMenuItem.Checked)
                frmusborl20.inputOrl(chan, ref val);
            if (i2CCH341ToolStripMenuItem.Checked)
                frmI2cCH341.InputI2C(chan, ref val);
        }


        public void DACoutput(short chan, double val)
        {
            if (frmadaptcon.cBPowerLin.Checked) val=frmadaptcon.templin(val);
            // Linearization if checkbox in adaptive controller page parameter is checked
            if (meilhausME2600ToolStripMenuItem.Checked)
                frmMe2600.outputMe(chan, val);
            if (hardwareSimulationToolStripMenuItem.Checked)
                frmSimul.outputSimul(chan, val);
            if (toolStripMenuItemNIDAQmx.Checked)
                frmDACmx.OutputNImx(chan, val);
            if (uSBFHL10VToolStripMenuItem.Checked)
                frmusborl.outputOrl(chan, val);
            if (tsmcRIO.Checked)
                frmcRIO.outputcrio(chan, val);
            if (meilhausME4660ToolStripMenuItem.Checked)
                frmME4660.output(chan, val);
            if (uSBFHLOrlowski20ToolStripMenuItem.Checked)
                frmusborl20.outputOrl(chan,  val);
            if (i2CCH341ToolStripMenuItem.Checked)
                frmI2cCH341.OutputI2C(chan, val);


        }

        private void meilhausME2600ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            adcmenuAllUnchecked();
            meilhausME2600ToolStripMenuItem.Checked = true;
            selectedADC = "Me2600";
            frmMe2600.Show();
            if (frmMe2600.WindowState == FormWindowState.Minimized)
                frmMe2600.WindowState = FormWindowState.Normal;
            frmMe2600.BringToFront();
        }

        private void noCardToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "no card";
            meilhausME2600ToolStripMenuItem.Checked = false;
            hardwareSimulationToolStripMenuItem.Checked = false;
        }

        private void freqCalculatorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (frmxwcalc.WindowState == FormWindowState.Minimized)
                frmxwcalc.WindowState = FormWindowState.Normal;
            frmxwcalc.Show();
            frmxwcalc.BringToFront();
        }

        //private void axChartfx1_LButtonDblClk(object sender, AxChartfxLib._DChartfxEvents_LButtonDblClkEvent e)
        //{
        //    EventArgs weg =new EventArgs();
        //    short ser = e.nSerie;  // copy values to calc
        //    int poi = e.nPoint;
        //    axChartfx1.ThisSerie = ser;
        //    frmxwcalc.Elogw.Text = axChartfx1.get_XValue((short)poi).ToString();
        //    frmxwcalc.Elogw_Leave(sender, weg);
        //    frmxwcalc.textBoxDB.Text = axChartfx1.get_Value((short)poi).ToString();
        //    frmxwcalc.textBox1_Leave(sender, weg);

        //}

       private void craneModelMUKToolStripMenuItem_Click(object sender, EventArgs e)
        {
           // Version with rack-and-pinion drive
            frmCrane.label8.Text = "ADC: " + selectedADC;
            frmCrane.Show();
            if (frmCrane.WindowState == FormWindowState.Minimized)
                frmCrane.WindowState = FormWindowState.Normal;
            frmCrane.BringToFront();
           //chart2D1.
        }

       private void mUKSpindleDriveToolStripMenuItem_Click(object sender, EventArgs e)
        {
           // Version with spindle drive
            frmCraneSpindle.label8.Text = "ADC: " + selectedADC;
            frmCraneSpindle.Show();
            if (frmCraneSpindle.WindowState == FormWindowState.Minimized)
                frmCraneSpindle.WindowState = FormWindowState.Normal;
            frmCraneSpindle.BringToFront();

        }
 



        private void adcmenuAllUnchecked()
        {
            meilhausME2600ToolStripMenuItem.Checked = false;
            hardwareSimulationToolStripMenuItem.Checked = false;
            noCardToolStripMenuItem.Checked = false;
            uSBFHL10VToolStripMenuItem.Checked = false;
            toolStripMenuItemNIDAQmx.Checked = false;
            tsmcRIO.Checked = false;
            meilhausME4660ToolStripMenuItem.Checked = false;
            uSBFHLOrlowski20ToolStripMenuItem.Checked = false;
            i2CCH341ToolStripMenuItem.Checked = false;
        }

        
        private void hardwareSimulationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "HW- Simul";
            adcmenuAllUnchecked();
            hardwareSimulationToolStripMenuItem.Checked = true;
            frmSimul.Show();
            if (frmSimul.WindowState == FormWindowState.Minimized)
                frmSimul.WindowState = FormWindowState.Normal;
            frmSimul.BringToFront();
        }

        private void toolStripMenuItemNIDAQmx_Click(object sender, EventArgs e)
        {
            selectedADC = "DAQmx";
            adcmenuAllUnchecked();
            toolStripMenuItemNIDAQmx.Checked = true;
            frmDACmx.Show();
            if (frmDACmx.WindowState == FormWindowState.Minimized)
                frmDACmx.WindowState = FormWindowState.Normal;
            frmDACmx.BringToFront();
        }


        private void pIDMagToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmPID.Show();
            if (frmPID.WindowState == FormWindowState.Minimized)
                frmPID.WindowState = FormWindowState.Normal;
            frmPID.BringToFront();

        }

        private void tsmcRIO_Click(object sender, EventArgs e)
        {
            selectedADC = "NI cRIO";
            adcmenuAllUnchecked();
            tsmcRIO.Checked = true;
            frmcRIO.Show();
            if (frmcRIO.WindowState == FormWindowState.Minimized)
                frmcRIO.WindowState = FormWindowState.Normal;
            frmcRIO.BringToFront();
        }

        private void activeFilterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmRTFilt.Show();
            if (frmRTFilt.WindowState == FormWindowState.Minimized)
                frmRTFilt.WindowState = FormWindowState.Normal;
            frmRTFilt.BringToFront();
        }
        private void sampleHoldToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmSH.labelADCCard.Text = selectedADC;
            frmSH.Show();
            if (frmSH.WindowState == FormWindowState.Minimized)
                frmSH.WindowState = FormWindowState.Normal;
            frmSH.BringToFront();
        }
 
        private void measureStaticTransferLineToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmTransferLine.labelADCCard.Text = selectedADC;
            frmTransferLine.Show();
            if (frmTransferLine.WindowState == FormWindowState.Minimized)
                frmTransferLine.WindowState = FormWindowState.Normal;
            frmTransferLine.BringToFront();

        }

 


        private void initStudControlToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmInit.Show();
        }

        private void uSBFHL10VToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "USB Orl";
            adcmenuAllUnchecked();
            uSBFHL10VToolStripMenuItem.Checked = true;
            frmusborl.Show();
            if (frmusborl.WindowState == FormWindowState.Minimized)
                frmusborl.WindowState = FormWindowState.Normal;
            frmusborl.BringToFront();
        }

        private void meilhausME4660ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "ME4660";
            adcmenuAllUnchecked();
            meilhausME4660ToolStripMenuItem.Checked = true;
            frmME4660.Show();
            if (frmME4660.WindowState == FormWindowState.Minimized)
                frmME4660.WindowState = FormWindowState.Normal;
            frmME4660.BringToFront();

        }
        private void uSBFHLOrlowski20ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "USB Orl 2.0";
            adcmenuAllUnchecked();
            uSBFHLOrlowski20ToolStripMenuItem.Checked = true;
            frmusborl20.Show();
            if (frmusborl20.WindowState == FormWindowState.Minimized)
                frmusborl20.WindowState = FormWindowState.Normal;
            frmusborl20.BringToFront();

        }

        private void i2CCH341ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "I2C CH341";
            adcmenuAllUnchecked();
            i2CCH341ToolStripMenuItem.Checked = true;
            frmI2cCH341.Show();
            if (frmI2cCH341.WindowState == FormWindowState.Minimized)
                frmI2cCH341.WindowState = FormWindowState.Normal;
            frmI2cCH341.BringToFront();

        }


        private void byoffLineLSFz1_Click(object sender, EventArgs e)
        {
            frmlsoff.Show();
            if (frmlsoff.WindowState == FormWindowState.Minimized)
                frmlsoff.WindowState = FormWindowState.Normal;
            frmlsoff.BringToFront();
        }

        private void adaptiveAdvancedControllerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmadaptcon.label18.Text = "ADC: " + selectedADC;
            frmadaptcon.Show();
            if (frmadaptcon.WindowState == FormWindowState.Minimized)
                frmadaptcon.WindowState = FormWindowState.Normal;
            frmadaptcon.BringToFront();
            controlBoxSelector = "adapt";
        }

        private void dRTVersuch3PendelToolStripMenuItem_Click(object sender, EventArgs e)
        {

            frmDTRKran.label18.Text = "ADC: " + selectedADC;
            frmDTRKran.Show();
            if (frmDTRKran.WindowState == FormWindowState.Minimized)
                frmDTRKran.WindowState = FormWindowState.Normal;
            frmDTRKran.BringToFront();

        }

        private void commaInfoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmtestComma.Show();
        }

        private void ToolButton19SR_Click(object sender, EventArgs e)
        {
            fstepresp.Show();
            if (fstepresp.WindowState == FormWindowState.Minimized)
                fstepresp.WindowState = FormWindowState.Normal;
            fstepresp.BringToFront();

        }

 
        private void TSBClearLast_Click(object sender, EventArgs e)
        {
       
             chart2D1.clearLast();
             chart2D1.BottomTitle = "";
             chart2D1.TopTitle = "";
             chart2D1.Visible = true; 
        }

        private void tsbClearAll_Click(object sender, EventArgs e)
        {
            chart2D1.clearAll();
            minmaxMain.init();
            chart2D1.BottomTitle = "";
            chart2D1.TopTitle = "";
            chart2D1.Visible = true;

        }

        private void chart2D1_CoordClick(object sender, ChartTool.CoordClickEventArgs e)
        {
                EventArgs weg =new EventArgs();
                frmxwcalc.Ewstart.Text = e.x.ToString();
                frmxwcalc.Ewstart_Leave(sender, weg);
                frmxwcalc.textBoxDB.Text = e.y.ToString();
                frmxwcalc.textBox1_Leave(sender, weg);
        }

        private void dataLoggerDTToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmDT9062.Show();
        }

        private void fuzzyControllerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmFuzEdit.Show();
            if (frmFuzEdit.WindowState == FormWindowState.Minimized)
                frmFuzEdit.WindowState = FormWindowState.Normal;
            frmFuzEdit.BringToFront();

        }

        private void toolStripStatusLabel1_Click(object sender, EventArgs e)
        {
            info1_Click(null, null);  // show history
        }

        private void InvertedxyPendulum1_Click(object sender, EventArgs e)
        {
            frmXYPendel.Show();
            if (frmXYPendel.WindowState == FormWindowState.Minimized)
                frmXYPendel.WindowState = FormWindowState.Normal;
            frmXYPendel.BringToFront();

        }

        private void unitTRedLCDToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmUNI_T.Show();
            if (frmUNI_T.WindowState == FormWindowState.Minimized)
                frmUNI_T.WindowState = FormWindowState.Normal;
            frmUNI_T.BringToFront();
        }

        private void tSBRigol_Click(object sender, EventArgs e)
        {
            frmRigol.Show();
            if (frmRigol.WindowState == FormWindowState.Minimized)
                frmRigol.WindowState = FormWindowState.Normal;
            frmRigol.BringToFront();

        }


        private void rCBlockToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            wrc3.Show();
            if (wrc3.WindowState == FormWindowState.Minimized)
                wrc3.WindowState = FormWindowState.Normal;
            wrc3.BringToFront();

        }

        public void nUD1_2_5(NumericUpDown nud, double min, double max)
        {    // verstellt mit den up / down - Tasten den Wert des nud in 1-2-5- Abstnden wie beim Scope
             // wird im  ValueChanged- Event aufgerufen 
            double intern = (double)nud.Value;
            double logintern = Math.Log10(intern);
            int exp = (int)Math.Truncate(logintern);
            if (logintern < 0) exp--;
            double val = intern / Math.Pow(10, exp);  // val nun Zahl zwischen 1 und 9.99999, in exp steht zehnerpotenz
            if (val > 5)
            {
                val = 1;
                exp++;
            }
            else if (val > 2)
                val = 5;
            else if (val > 1) val = 2;
            // jetzt ist Zahl val auf nchsten 1 2 5 - Wert vergrert
            if (exp < 0)
                nud.DecimalPlaces = -exp;
            else nud.DecimalPlaces = 0;
            double newval=(val * Math.Pow(10, exp));
            if (newval <= max && newval >= min)
            {
                nud.Value = (decimal)newval;
                
            }
            nud.Increment = (decimal)(val / 1.5 * Math.Pow(10, exp));
            nud.Maximum = (decimal)max;
            nud.Minimum = (decimal)min;

        }

        private void tSBReport_Click(object sender, EventArgs e)
        {
            if (!frmreport.Visible)
            {
                frmreport.Show();
                if (frmreport.WindowState == FormWindowState.Minimized)
                    frmreport.WindowState = FormWindowState.Normal;
                frmreport.BringToFront();
            }
            else frmreport.Hide();
        }

        private void toolStripButton42StoreTxt_Click(object sender, EventArgs e)
        {

        }

        private void measurBatteryCapacityToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmBatCap.Show();
            if (frmBatCap.WindowState == FormWindowState.Minimized)
                frmBatCap.WindowState = FormWindowState.Normal;
            frmBatCap.BringToFront();
            frmBatCap.labelADCCard.Text = selectedADC;

        }

        private void tempLoggerI2CELVToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmTempLog.Show();
            if (frmTempLog.WindowState == FormWindowState.Minimized)
                frmTempLog.WindowState = FormWindowState.Normal;
            frmTempLog.BringToFront();

        }

        private void eSModulPendelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmESPendel.Show();
            if (frmESPendel.WindowState == FormWindowState.Minimized)
                frmESPendel.WindowState = FormWindowState.Normal;
            frmESPendel.BringToFront();

        }

        private void cSIIRackandpinionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmCSIIrap.label18.Text = "ADC: " + selectedADC;
            frmCSIIrap.Show();
            if (frmCSIIrap.WindowState == FormWindowState.Minimized)
                frmCSIIrap.WindowState = FormWindowState.Normal;
            frmCSIIrap.BringToFront();

        }

        string sourceOK = "", dest = "", sourceEmpty = "";

        private void activateNISourceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int cnt = 0;
            try
            {
                File.Copy(sourceOK + "DAQmx_Basics_NChannel.cs", dest + "DAQmx_Basics_NChannel.cs", true);
                cnt++;
                File.Copy(sourceOK + "DAQmx_Basics_NChannel.designer.cs", dest + "DAQmx_Basics_NChannel.designer.cs", true);
                cnt++;
                File.Copy(sourceOK + "DAQmx_Basics_NChannel.resx", dest + "DAQmx_Basics_NChannel.resx", true);
                cnt++;
                // auch FormES_Pendel1
                File.Copy(sourceOK + "FormES_Pendel1.cs", dest + "FormES_Pendel1.cs", true);
                cnt++;
                File.Copy(sourceOK + "FormES_Pendel1.designer.cs", dest + "FormES_Pendel1.designer.cs", true);
                cnt++;
                File.Copy(sourceOK + "FormES_Pendel1.resx", dest + "FormES_Pendel1.resx", true);
                cnt++;

            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            toolStripStatusLabel5.Text = cnt + " files copied";

        }

        private void demoCSIiIduDRToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmCSIIdemo.label18.Text = "ADC: " + selectedADC;
            frmCSIIdemo.Show();
            if (frmCSIIdemo.WindowState == FormWindowState.Minimized)
                frmCSIIdemo.WindowState = FormWindowState.Normal;
            frmCSIIdemo.BringToFront();

        }

        private void gA286ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmGA286.Show();
        }

        private void dataLoggerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmDataLog.Show();
            if (frmDataLog.WindowState == FormWindowState.Minimized)
                frmDataLog.WindowState = FormWindowState.Normal;
            frmDataLog.BringToFront();

        }

        private void aDCLinearityCheckToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmLinCheck.Show();
            if (frmLinCheck.WindowState == FormWindowState.Minimized)
                frmLinCheck.WindowState = FormWindowState.Normal;
            frmLinCheck.BringToFront();
        }

        private void deactivateNISourceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int cnt = 0;
            try
            {
                File.Copy(sourceEmpty + "DAQmx_Basics_NChannel.cs", dest + "DAQmx_Basics_NChannel.cs", true);
                cnt++;
                File.Copy(sourceEmpty + "DAQmx_Basics_NChannel.designer.cs", dest + "DAQmx_Basics_NChannel.designer.cs", true);
                cnt++;
                File.Copy(sourceEmpty + "DAQmx_Basics_NChannel.resx", dest + "DAQmx_Basics_NChannel.resx", true);
                cnt++;
                // auch FormES_Pendel1
                File.Copy(sourceEmpty + "FormES_Pendel1.cs", dest + "FormES_Pendel1.cs", true);
                cnt++;
                File.Copy(sourceEmpty + "FormES_Pendel1.designer.cs", dest + "FormES_Pendel1.designer.cs", true);
                cnt++;
                File.Copy(sourceEmpty + "FormES_Pendel1.resx", dest + "FormES_Pendel1.resx", true);
                cnt++;

            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            toolStripStatusLabel5.Text = cnt + " files copied";

        }

        string curdir = "";
        
        private void FormMain_Load(object sender, EventArgs e)
        {
            curdir = Directory.GetCurrentDirectory();
            curdir = curdir.Substring(0, curdir.Length - 9);  // ohne bin\debug
            toolStripStatusLabel5.Text = curdir;
            sourceEmpty = curdir + "NiDaqmx Dummy\\";
            sourceOK = curdir + "NI DAQmx OK\\";
            dest = curdir + "Hardwaretools\\";
        }

  
 
      }
}