﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using NationalInstruments.DAQmx;
using System.Diagnostics;

namespace DAQmx_Basics
{
    public partial class DAQmx_Basic : Form
    {
        // AnalogSingleChannelReader rschan;    // ab 7.6.38 nur noch Multichannelreader
        // AnalogSingleChannelWriter wschan;
        AnalogMultiChannelReader reader ;
        AnalogMultiChannelWriter writer ;
        
        Task taskAI ;
        Task taskAO ;

        double[] dAI = new double[2];
        double[] dAO = new double[2];
        bool initOK = false;
        string NoInit = "No Init possible";

        double AD0Display = 0, DA0Display = 0;

        Stopwatch stopwatch1 = new Stopwatch();

        int MinI = -10;
        int MaxI = 10;
        int MinO = -10;
        int MaxO = 10;

        // Für Zähler von ES
        private NationalInstruments.DAQmx.Task Task_Wagen;      //w. Auswahl : System.Threading.Tasks;
        private CounterReader countsinglechannel_Wagen;
        private double WagenPosition, WagenVolt;

        private NationalInstruments.DAQmx.Task Task_Pendel;      //w. Auswahl : System.Threading.Tasks;
        private CounterReader countsinglechannel_Pendel;
        private double PendelPosition, Alpha;

       
 
        private bool zIndexEnable = false;
        double zIndexValue = 0.0;

        private void startMessung()
        {

            try
            {
                CICountEdgesActiveEdge AktiveFlanke = CICountEdgesActiveEdge.Rising;
                CICountEdgesCountDirection ZaehlRichtung = CICountEdgesCountDirection.ExternallyControlled;

                // Für NI 6221 Quadratur on board
                CIEncoderDecodingType encoderType = CIEncoderDecodingType.X4;
                CIEncoderZIndexPhase encoderPhase = CIEncoderZIndexPhase.AHighBHigh;


 

                Task_Wagen = new NationalInstruments.DAQmx.Task();
                if (rB6024.Checked)
                    Task_Wagen.CIChannels.CreateCountEdgesChannel(actdev+"/ctr0", "", AktiveFlanke, 0, ZaehlRichtung);
                if (rB6221.Checked)
                    Task_Wagen.CIChannels.CreateAngularEncoderChannel(actdev+"/ctr0",
                   "", encoderType, zIndexEnable, zIndexValue, encoderPhase, 1024,
                   0.0, CIAngularEncoderUnits.Ticks);
                Task_Wagen.Start();
                countsinglechannel_Wagen = new CounterReader(Task_Wagen.Stream);

                Task_Pendel = new NationalInstruments.DAQmx.Task();
                if (rB6024.Checked)
                    Task_Pendel.CIChannels.CreateCountEdgesChannel(actdev+"/ctr1", "", AktiveFlanke, 0, ZaehlRichtung);
                if (rB6221.Checked)
                    Task_Pendel.CIChannels.CreateAngularEncoderChannel(actdev+"/ctr1",
                  "", encoderType, zIndexEnable, zIndexValue, encoderPhase, 1024,
                  0.0, CIAngularEncoderUnits.Degrees);

                Task_Pendel.Start();
                countsinglechannel_Pendel = new CounterReader(Task_Pendel.Stream);

            }
            catch (DaqException exception)
            {
                MessageBox.Show(exception.Message);
            }

        }

        
        
        
        // ende Zähler von ES
 
        public DAQmx_Basic()
        {
            InitializeComponent();
            stopwatch1.Start();

         }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            if (timer1.Enabled)
            {
                //timerAnzeigeZeiten.Stop();
                timer1.Stop();
                dtavr = 0; dtavr2 = 0;
            }
         
        }

        long dtend = 0, dt = 0,  dtavr = 0, cntT0 = 0, dtavr2 = 0;


        private void timer1_Tick(object sender, EventArgs e)
        {
            // This timer writes to DA, so in normal mode this should be disabled
            long dtstart = stopwatch1.ElapsedTicks;

                dAI = reader.ReadSingleSample();       //
                dtend = stopwatch1.ElapsedTicks;
                tBAI0.Text = dAI[0].ToString("f3");
                tBAI1.Text = dAI[1].ToString("f3");
                toolStripStatusLabel1.Text = "AD0=  " + dAI[0].ToString("f2") + "  DA0=  " + dAI[1].ToString("F2");
            
            dt = (dtend - dtstart);  // Time AD
            dtavr = dtavr + dt;
            dtstart = stopwatch1.ElapsedTicks;
            writer.WriteSingleSample(false, dAO);    //numAO=numericUpDown-Feld
           

            // Zähler von ES

            if (Task_Wagen != null) WagenPosition = (double)(Int16)countsinglechannel_Wagen.ReadSingleSampleInt32();
            //***   Inkremente * 4 (QuadEncoder) , Umfang = 0,0392m (Durchmesser) * pi   ------ FHL-Aufbau
            //***   Inkremente * 4 (QuadEncoder) , Umfang = 0,02963m (Durchmesser) * pi  ------ Quanser-Aufbau
            double WagenPosm;
            if (rBCartSilver.Checked)
                WagenPosm = WagenPosition / 4 / 1024.0 * 0.0392 * Math.PI;  // Position in Meter
            else
                WagenPosm = WagenPosition / 4 / 1024.0 * 0.02963 * Math.PI;  // Position in Meter
             
            //tBWagenMeter.Text = "   " + WagenPosition.ToString("f3") + "  m";
            WagenVolt = WagenPosm * 10 / 0.75;// max. Länge = 75cm entspricht 10 Volt
            tBWagenVolt.Text = "   " + WagenVolt.ToString("f3") + "   V";
            labPosCnt.Text = WagenPosition.ToString();

            if (Task_Pendel != null)
                if (rBCartSilver.Checked) 
                    PendelPosition = -(double)(Int16)countsinglechannel_Pendel.ReadSingleSampleInt32();
                else
                    PendelPosition = (double)(Int16)countsinglechannel_Pendel.ReadSingleSampleInt32();
            labcnt.Text = PendelPosition.ToString();
            PendelPosition-=1024;   // egal welcher Zählerstand immer 0-4095, 3 Uhr ist Vorzeichenwechsel, oben 2.5

            while (PendelPosition>4095)
                PendelPosition -= 4096;
            while (PendelPosition < 0)
                PendelPosition += 4096;
            //PendelPosition = PendelPosition / 4 / 1024 * 360;
            //PendelPosition = (PendelPosition) % 360; // Modulo 360° -> kein Aufzählen der Umdrehungen   
            //tBPendelDegree.Text = "   " + PendelPosition.ToString("f1") + "  deg";
            //PendelUhr = ((360 - PendelPosition + 180) % 360) * 12 / 360;
            //tBPendelUhrzeit.Text = "   " + PendelUhr.ToString("f2") + "   h";
            labcntCorr.Text = PendelPosition.ToString();
            Alpha=PendelPosition/409.6; // nun 0-10 Volt
            tBPendelVolt.Text = Alpha.ToString("f2") + "  V";




            // Ende Zähler



            dt = (stopwatch1.ElapsedTicks - dtstart);  // Time DA
            dtavr2 = dtavr2 + dt;
            
            cntT0++;
        }
 
        private void timerAnzeigeZeiten_Tick(object sender, EventArgs e)
        {
            if (cntT0 > 0)
            {
                double dtavr1 = dtavr / cntT0 / (double)Stopwatch.Frequency * 1000;
                toolStripStatusLabel2.Text = "DtAD= " + dtavr1.ToString("f3");
                double dtav2 = dtavr2 /cntT0/ (double)Stopwatch.Frequency * 1000;
                toolStripStatusLabel2.Text += " ms  DtDA= " + dtav2.ToString("f3")+ " ms";
                dtavr2 = 0; dtavr = 0; cntT0 = 0;
            }

        }
        string actdev = "";
        private void butInit_Click(object sender, EventArgs e)
        {
            try
            {
                if (!initOK)
                {
                    taskAI = new Task("abci");
                    taskAO = new Task("abco");
                     if (rBRange05V.Checked)
                    { 
                        MinO = 0; MaxO = 5;
                        numAO0.Maximum = MaxO;
                        numAO1.Maximum = MaxO;
                        numAO0.Minimum = MinO;
                        numAO1.Minimum = MinO;
                    }
                    actdev = comboBox1.Text;
                    taskAI.AIChannels.CreateVoltageChannel(actdev + "/ai0", "aiChannel0",
                         AITerminalConfiguration.Rse, MinI, MaxI, AIVoltageUnits.Volts);
                    taskAI.AIChannels.CreateVoltageChannel(actdev + "/ai1", "aiChannel1",
                        AITerminalConfiguration.Rse, MinI, MaxI, AIVoltageUnits.Volts);
                    taskAO.AOChannels.CreateVoltageChannel(actdev+"/ao0", "aoChannel0",
                        MinO, MaxO, AOVoltageUnits.Volts);
                    taskAO.AOChannels.CreateVoltageChannel(actdev + "/ao1", "aoChannel1",
                        MinO, MaxO, AOVoltageUnits.Volts);

                    reader = new AnalogMultiChannelReader(taskAI.Stream);
                   

                    writer = new AnalogMultiChannelWriter(taskAO.Stream);
                   
                    taskAI.Start();
                    taskAO.Start();


                    timer1.Start(); 
                    timerAnzeigeZeiten.Enabled = true;
                    initOK = true;
                    label5NOK.Text = "OK";
                    dAO[1] = 0;
                    startMessung();
                }
                else timer1.Start();
            }
            catch
            {
                MessageBox.Show(NoInit);
            }
        }
 
        private void DAQmx_Basic_FormClosed(object sender, FormClosedEventArgs e)
        {
                taskAI.Dispose();
                taskAO.Dispose(); 
        }
 
        public void InputNImx(short chan, ref double val)
        {
            if (initOK)
                if (rBA2.Checked||rBAI1.Checked)
                      dAI = reader.ReadSingleSample();
                
            if (chan == 0)
                if (rBAI1.Checked) val = dAI[0];
                else
                {
                    if (Task_Wagen != null) WagenPosition = (double)(Int16)countsinglechannel_Wagen.ReadSingleSampleInt32();
                    double WagenPosm;
                    if (rBCartSilver.Checked)
                        WagenPosm = WagenPosition / 4 / 1024.0 * 0.0392 * Math.PI;  // Position in Meter
                    else
                        WagenPosm = WagenPosition / 4 / 1024.0 * 0.02963 * Math.PI;  // Position in Meter
                    WagenVolt = WagenPosm * 10 / 0.75;// max. Länge = 75cm entspricht 10 Volt
                    val = WagenVolt;
                }
                    
                    
            if (chan == 1)
                if (rBA2.Checked) val = dAI[1];
                else
                {
                    if (Task_Pendel != null)
                        if (rBCartSilver.Checked)
                            PendelPosition = -(double)(Int16)countsinglechannel_Pendel.ReadSingleSampleInt32();
                        else
                            PendelPosition = (double)(Int16)countsinglechannel_Pendel.ReadSingleSampleInt32();

                    PendelPosition -= 1024;   // egal welcher Zählerstand immer 0-4095, 3 Uhr ist Vorzeichenwechsel von 0 - 4095, oben 1024
                    while (PendelPosition > 4095)
                        PendelPosition -= 4096;
                    while (PendelPosition < 0)
                        PendelPosition += 4096;
                    //PendelPosition = PendelPosition / 4 / 1024 * 360;
                    //PendelPosition = (PendelPosition) % 360; // Modulo 360° -> kein Aufzählen der Umdrehungen   
                    //tBPendelDegree.Text = "   " + PendelPosition.ToString("f1") + "  deg";
                    //PendelUhr = ((360 - PendelPosition + 180) % 360) * 12 / 360;
                    //tBPendelUhrzeit.Text = "   " + PendelUhr.ToString("f2") + "   h";
                    Alpha = PendelPosition / 409.6; // nun 0-10 Volt
                    
                    val = Alpha;
                }
            AD0Display = val;
        }

        private void numAO0_ValueChanged(object sender, EventArgs e)
        {
            dAO[0] = (double)numAO0.Value;
            if (initOK)
                writer.WriteSingleSample(false, dAO);    //numAO=numericUpDown-Feld
                

        }

        private void numAO1_ValueChanged(object sender, EventArgs e)
        {
            dAO[1] = (double)numAO1.Value;
            if (initOK) writer.WriteSingleSample(false, dAO);    //numAO=numericUpDown-Feld

        }

        public void OutputNImx(short chan, double val)
        {
            if (val > MaxO) val = MaxO;
            if (val < MinO) val = MinO;
            if (chan == 0) dAO[0] = val;
            if (chan == 1) dAO[1] = val;
            if (initOK)
               writer.WriteSingleSample(false, dAO);    //numAO=numericUpDown-Feld
               
            DA0Display = val;

        }

        public void butZero_Click(object sender, EventArgs e)
        {
            if (initOK)
            {
                Task_Wagen.Stop();
                Task_Pendel.Stop();
                startMessung();
            }

        }

        private void butStopTask_Click(object sender, EventArgs e)
        {
            if (initOK)
            {
                timer1.Enabled = false;
                Task_Pendel.Stop();
                Task_Wagen.Stop();
                taskAI.Stop();
                taskAO.Stop();
                taskAI.Dispose();
                taskAO.Dispose();
                initOK = false;
            }


        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {

        }

   

 
    }
}
