﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;
using WINDF7CSharp;


// ab März 2018 fehlerhafte For loop beim Einlesen der RS232- Daten korrigiert


namespace UScope
{
    public partial class FScope : Form
    {
        FormMain meinMain;
        string points = "Points";
        
        public FScope(FormMain m)
        {
            InitializeComponent();
            serialPort1.Encoding = Encoding.Default;
            meinMain = m;
        }

        public void deutsch()
        {
            groupBox1.Text = "Serielle Schnittstelle";
            buttonOpen.Text = "Comport öffnen";
            groupBox2.Text = "Daten empfangen";
            groupBox3.Text = "Scope- Daten";
            groupBox4.Text = "Daten konvertieren speichern und zeichnen";
            points = "Punkte";


        }
        
        
        private void buttonOpen_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) serialPort1.Close();
            serialPort1.PortName = cbPort.Text;
            
            serialPort1.Open();

            if(serialPort1.IsOpen)
            {
                buttonSend.Enabled=true;
                buttonStratRec.Enabled = true;
                label2.Text=serialPort1.PortName+"  is now open";
                buttonStratRec_Click(sender, e);
            } else
                label2.Text = "No Port is open";
        }

        private void buttonSend_Click(object sender, EventArgs e)
        {
            string tx = textBoxCommand.Text;
            serialPort1.Write(tx+"\x0d");
            
            ind = 0; cnt = 0;
            textBox1.Clear();
            textBox2.Clear();
            //buttonConvert.Enabled = false;
        }

        private void comboBox1_SelectedValueChanged(object sender, EventArgs e)
        {
            buttonClose_Click(sender, e);
            serialPort1.PortName = cbPort.Text;


        }

        private void Check_Click(object sender, EventArgs e)
        {
            cbPort.Items.Clear();

            foreach (string s in SerialPort.GetPortNames())
            {
                cbPort.Items.Add(s);
            }

        }

        private void buttonStratRec_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) 
                if (timer1.Enabled)
                {
                    timer1.Enabled = false;
                    buttonStratRec.Text = "Start again";
                }
                else
                {
                    timer1.Enabled = true;
                    buttonStratRec.Text = "Stop";
                }
        }
        
        string inp="";
        int cnt = 0,ind=0;
        byte [] buf=new byte[1025];

        private void timer1_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = DateTime.Now.ToString();// only to see thats timer is running

            while (serialPort1.BytesToRead > 0)
            {
                textBox2.Visible = false;
                progressBar1.Visible = true;

                int c = serialPort1.ReadByte();
                char ch = (char)c;
                byte bt = (byte)c;
                if (cnt < 17)
                {
                    if (ch == ',')
                    {
                        inp = inp + "\x0d" + "\x0a";//
                        cnt++;
                    }
                    else inp = inp + ch;
                }
                else
                {
                    buf[ind] = bt;
                    ind++; if (ind > 1024) ind = 1024;
                    progressBar1.Value = ind;
                    Application.DoEvents();
                }

                textBox1.AppendText(inp);
                inp = "";
                if (ind == 1024)
                {
                    textBox2.Visible = true;
                    progressBar1.Visible = false;
                    buttonConvert.Enabled = true;
                    ind = 0;
                }
            }
        }

        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            buttonClose_Click(sender, e);
            int help = 0;
            int.TryParse(comboBox1.Text, out help);
            serialPort1.BaudRate = help;
        }

 
        private void buttonClose_Click(object sender, EventArgs e)
        {
            serialPort1.Close();
            label2.Text = " No COM open";
            timer1.Enabled = false;
            buttonSend.Enabled = false;
            buttonStratRec.Enabled = false;


        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            
        }

        private void buttonClearTB1_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            textBox2.Clear();
        }


        private void buttonSaveTB2_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new
                StreamWriter(saveFileDialog1.OpenFile(), Encoding.Default);
                myStream1.WriteLine(textBox2.Text);
                myStream1.Close();
            }
        }

        private void buttonConvert_Click(object sender, EventArgs e)
        {
            int T = 0;
            textBox2.Visible = false;
            int nb = 512, dnb = nb * 2;
            progressBar1.Visible = true;
            progressBar1.Maximum = dnb;
            for (int i = 0; i < dnb; i++)
            {
                double yoff = 0, yres = 0, xoff = 0, xres = 0;
                byte te = buf[i];
                sbyte sb = (sbyte)buf[i];
                int z = sb * 256 + buf[i + 1];
                meinMain.ConvertToDouble(textBox1.Lines[4],ref yoff );
                meinMain.ConvertToDouble(textBox1.Lines[6],ref yres );
                double y = yoff + yres * z;
                meinMain.ConvertToDouble(textBox1.Lines[5],ref xoff );
                meinMain.ConvertToDouble(textBox1.Lines[7],ref xres );
                double x = xoff + xres * T;
                textBox2.AppendText(x.ToString() + " ");
                textBox2.AppendText(y.ToString());
                if (i < (dnb-2)) textBox2.AppendText("\x0d" + "\x0a");// last line no Cr LF
 
                i++;
                T++;
                progressBar1.Value = i;
                Application.DoEvents();
            }
            textBox2.Visible = true;
            progressBar1.Visible = false;
        }

 
        private void FScope_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Hide();
            buttonClose_Click(sender, e);


        }

        private void radioButton2_Click(object sender, EventArgs e)
        {
            textBoxCommand.Text = "QW002";
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void radioButton1_Click(object sender, EventArgs e)
        {
            textBoxCommand.Text = "QW001";

        }

        private void radioButton3_Click(object sender, EventArgs e)
        {
            textBoxCommand.Text = "QW011";

        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            textBoxCommand.Text = "QW012";

        }

        public void buttonDrawScope_Click(object sender, EventArgs e)
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = false;
            LOa.toptitle = "Scope curve  " + textBox2.Lines.Length.ToString() + "  " + points;
            //LOa.bottomtitle = "<------     w=10^x     ---->";
            LOa.legend = "Scope";
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, textBox2, ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton27ScopeF.Enabled = true;
                meinMain.BringToFront();
            }

        }
    }
}
