﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WINDF7CSharp.Hardwaretools
{
    public partial class FoGA286 : Form
    {
        FormMain meinMain;
        public FoGA286(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            timersave.Interval = 1000 * 60 * 60; // Alle Stunde
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled)
            {
                //Stop
                timer1.Enabled = false;
                timer2.Enabled = false;
                timersave.Enabled = false;
                textBox2.Text = cycles.ToString();
                button1.Text = "Start";
                textBox1.AppendText(" cycles = " + cycles.ToString() + "\r\n");
                textBox1.AppendText("Stopped at " + DateTime.Now.ToString() + "\r\n");
            }
            else
            {
                // Start
                timer1.Enabled = true;
                timer2.Enabled = true;
                timersave.Enabled = true;
                cycles = Convert.ToInt32(textBox2.Text);
                textBox1.AppendText("Started at " + DateTime.Now.ToString() + "\r\n");
                button1.Text = "Stop";
            }

        }

        bool Dac1 = false;

        private void timer1_Tick(object sender, EventArgs e)
        { //alle sec Umschalten
            if (Dac1)
                Dac1 = false;
            else
                Dac1 = true;
            cnt = 0;
            if (timer1.Interval>3600000) // Wenn an/ Aus größer als 1 Stunde
               textBox1.AppendText("Position umgeschaltet " + DateTime.Now.ToString() + "\r\n");
        }

        int cnt = 0;
        double val = 0;
        long cycles = 0;
        int namecnt = 0;
        private void timer2_Tick(object sender, EventArgs e)
        {  // für 100 ms auf 0V --> Impuls auf Controller dann wieder auf 10V
            if (Dac1)
                if (cnt == 0)
                {
                    meinMain.DACoutput(0, 0);
                    label1.Text = "1";
                    cycles++;
                }
                else
                {
                    meinMain.DACoutput(0, 10);
                    label1.Text = "0";
                    if (cnt==3) // Check ob Pos erreicht
                    {
                        meinMain.ADCinput(0, ref val);
                        if ((val < 5)&&checkBox1.Checked) textBox1.AppendText("Alarm CH0 Pos not reached at " + DateTime.Now.ToString() + "\r\n");
                        label2.Text = val.ToString("f2");
                    }
                }
                    
            else
            {
                if (cnt == 0)
                {
                    meinMain.DACoutput(1, 0);
                    label3.Text = "1";
                }
                else
                {
                    meinMain.DACoutput(1, 10);
                    label3.Text = "0";

                    if (cnt == 3) // Check ob Pos erreicht
                    {
                        meinMain.ADCinput(1, ref val);
                        if ((val < 5) && checkBox1.Checked) textBox1.AppendText("Alarm CH1 Pos not reached at " + DateTime.Now.ToString()+"\r\n");
                        label4.Text = val.ToString("f2");

                    }
                }
            }
            cnt++;
        }

        private void FoGA286_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            if (timer1.Enabled) button1_Click(null, null); // Stop
        }

        private void butClear_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            timer1.Interval = 500 * (int)numericUpDown1.Value;
        }

        private void timersave_Tick(object sender, EventArgs e)
        {
            textBox1.AppendText(" cycles = " + cycles.ToString() + "\r\n");
            textBox1.AppendText("Protokollzeit " + DateTime.Now.ToString() + "\r\n");
            saveFileDialog1.FileName = fn+namecnt.ToString()+ ".txt";
             
            StreamWriter myStream1 = new  StreamWriter(saveFileDialog1.OpenFile(), Encoding.Default);
            myStream1.WriteLine(textBox1.Text);
            myStream1.Close();
            namecnt++;

        }
        string fn="default";
        private void butSave_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                fn = saveFileDialog1.FileName;
                fn = fn.Substring(0, fn.Length - 4);
                StreamWriter myStream1 = new StreamWriter(saveFileDialog1.OpenFile(), Encoding.Default);
                myStream1.WriteLine(textBox1.Text);
                myStream1.Close();
            }

        }
    }
}
