﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MicroLibrary;

namespace WINDF7CSharp.Hardwaretools
{
    public partial class FormADCLinCheck : Form
    {


        private readonly MicroLibrary.MicroTimer _microTimer;
        Stopwatch stwDelay = new Stopwatch();

        
        int DLcnt = 0;
        int runden = 1;

        FormMain meinMain;
        public FormADCLinCheck(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(OnTimedEvent);
            stwDelay.Start();
        }

        int sägezahncnt = 0;
        int[] data = new int[4096];
        double input = 0;

        double funcInput()
        {
            double temp = 0;
            short ch = (short)nUDChanIn.Value;
            if (rBI2Cin.Checked)
                meinMain.frmI2cCH341.InputI2C(ch, ref temp);
            if (rBMeilIn.Checked)
                meinMain.frmME4660.input(ch, ref temp);
            if (rBNIin.Checked)
                meinMain.frmDACmx.InputNImx(ch, ref temp);
            return temp;
        }

        void funcoutput(double val)
        {
            short ch = (short)nUDChanout.Value;
            if (rBI2Cout.Checked)
                meinMain.frmI2cCH341.OutputI2C(ch, val);
            if (rBMeilOut.Checked)
                meinMain.frmME4660.output(ch, val);
            if (rBNIOut.Checked)
                meinMain.frmDACmx.OutputNImx(ch, val);
        }
        private void OnTimedEvent(object sender, MicroTimerEventArgs timerEventArgs)
        {
            
            if ( rBSH.Checked)
            {
                double wert = funcInput();
                funcoutput(wert);
            }
            else //Lin Check Schreibt auf DA -10 .. +10 V und liest direkt verbundenen ADC ein
            // Ergebnisdifferenz wird in Chart2D geschrieben
            {
                if (rBLinCheck.Checked)
                {
                     int Microsec = 450;                   
                    //   if (sägezahncnt==1000)
                    //    Microsec = 450;
                    double output = (sägezahncnt / 409.5-5) *2;   // -10 V bis + 10 V
                    funcoutput(output);
                    
                    
                    //Warteschleife 350 µsec

                    long ElapsTicksMicrosec = Microsec * Stopwatch.Frequency / 1000000;
                    long delstart = stwDelay.ElapsedTicks;
                    do
                    {
                    } while ((stwDelay.ElapsedTicks - delstart) < ElapsTicksMicrosec);

                    // Jetzt ADC
                    input = funcInput();
                    

                    data[sägezahncnt] += Convert.ToInt32((output - input)*1000);
                    sägezahncnt++;
                 
                    if (sägezahncnt==4096)
                    {
                        DLcnt++;
                        if (DLcnt<runden)
                        {
                            sägezahncnt = 0;
                        }
                        else
                        _microTimer.Stop();
                    }
                }
            }
        }
        

        private void button_mt_Test_Click(object sender, EventArgs e)
        {

            chart2D1.clearAll();
            DLcnt = 0;
            runden = Convert.ToInt32(tBRunden.Text);
            //UssinmV = Convert.ToInt32(tB5V.Text);
            sägezahncnt = 0;
            isdrawn = false;
            for (int i = 0; i < data.Length; i++) data[i] = 0;
            _microTimer.Interval = Convert.ToInt64( 1000* Convert.ToDouble(textBox1.Text));   /// µSec
            _microTimer.Start();
            timer1.Start();
        }

        private void button_mt_Stop_Click(object sender, EventArgs e)
        {
            _microTimer.Stop();
            timer1.Stop();

        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            _microTimer.Stop();
            timer1.Stop();
        }
        bool isdrawn = false;
        private void timer1_Tick(object sender, EventArgs e)
        {
            labProgress.Text = sägezahncnt.ToString();
            if ((sägezahncnt > 4095) && (DLcnt==runden))
            {
                _microTimer.Stop();
                if (!isdrawn)
                {
                    for (int i = 0; i < 4096; i++)
                        chart2D1.setPoint(0, i, data[i]*1.0/runden);
                    chart2D1.autoScaling();
                    chart2D1.startDrawing();
                    isdrawn = true;
                }
                 
            }

        }

        private void rBLinCheck_CheckedChanged(object sender, EventArgs e)
        {
            textBox1.Text = "2";
        }
    }
}
