﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Diagnostics;

namespace WINDF7CSharp.Hardwaretools
{
    public partial class FormBatCapacity : Form
    {
        FormMain meinMain;
        long time = 0;
        double capacity = 0, Capacityunload = 0, currUnload = 0;
        Stopwatch stw;
        
        public FormBatCapacity(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            comboBox1.Items.Clear();

            foreach (string s in SerialPort.GetPortNames())
            {
                comboBox1.Items.Add(s);
            }
            stw = new Stopwatch();
            stw.Start();
        }

        private void FormBatCapacity_Load(object sender, EventArgs e)
        {
            chart2D1.LegendButton = true;
            chart2D1.ButtonPanel = true;
            chart2D1.CurveNames[0] = "Volt";
            chart2D1.CurveNames[1] = "Load Curr.";
            chart2D1.CurveNames[2] = "Unload C.";
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown1, 1, 1e3);
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {

        }
        double readvoltfromTB = 0.1, readcurrfromTB = 0.1, readunloadfinalVoltage=0;
        private void butStart_Click(object sender, EventArgs e)
        {
            // Test
            timer1.Enabled = true;
            rTBVA.Visible = true;
            meinMain.ConvertToDouble(tBCurrent.Text, ref readcurrfromTB);
            meinMain.ConvertToDouble(tBFinalVolt.Text, ref readvoltfromTB);
            meinMain.ConvertToDouble(tBUnloadVoltage.Text, ref readunloadfinalVoltage);


            if (rBLoad.Checked)
            {
                newcurr = readcurrfromTB;
                newvolt = readvoltfromTB;
                status = "Startload";
            }
            if (rBUnload.Checked)
            {
                newcurr = 0;
                newvolt = readvoltfromTB;
                status = "Startunload";
           }
            if (rBCycle.Checked)
            {
                newcurr = readcurrfromTB;
                newvolt = readvoltfromTB;
                status = "Startcycle";

            }
        }

        private void butInitPS_Click(object sender, EventArgs e)
        {
            Point p = new Point(3, 3);
            rTBVA.Location = p;
            rTBVA.Visible = true;
            timer1.Interval = (int)numericUpDown1.Value *1000;
             if (!serialPort1.IsOpen)
            {
                serialPort1.PortName = comboBox1.Text;
                serialPort1.Open();
                comboBox1.Enabled = false; // geht nur einmal zu Anfang
            }
            if (serialPort1.IsOpen)
            {
                label5.Text = serialPort1.PortName + "  is now open";
                time = 0; 
                // Start Messung von Strom und Spannung
                timer1.Enabled = true;
            }
            else
                label5.Text = "No Port is open";



        }

        private void butStop_Click(object sender, EventArgs e)
        {
            rTBVA.Visible = false;
            timer1.Enabled = false;
            WriteCurr2PS(0);
            meinMain.DACoutput(0, 0);
        }

        string inp = "";
        string status = "",statusold="";
        double voltmeasured = 0, currmeasured = 0;

        double newcurr = 0.0, newvolt = 12.1;

        private void timer1_Tick(object sender, EventArgs e)
        {
            label6.Text = DateTime.Now.TimeOfDay.ToString();
            labStatus.Text = "Status=  " + status;
            serialPort1.Write("GETD" + "\r");  // Hole Messwerte
            int timeout = 0;
            do
            {
               
                    while (serialPort1.BytesToRead>0)
                    {
                        int c = serialPort1.ReadChar();
                        char ch = (char)c;

                        inp = inp + ch; if (ch == '\r') inp = inp + "\n";
                    }
                
                timeout++;
            }
            while (inp.Length < 15 && timeout<100);
            while (serialPort1.BytesToRead > 0)  //Serial Port löschen, falls Fehlermeldung kam
            {
                int c = serialPort1.ReadChar();
                inp = inp + (char)c;
            }
                // Anzeige Messwerte
                if (inp.Length == 15)
            {
                string volt = inp.Substring(0, 2) + "." + inp.Substring(2, 2);
                string current = inp.Substring(4, 2) + "." + inp.Substring(6, 3);
                voltmeasured = Convert.ToDouble(volt);
                currmeasured = Convert.ToDouble(current);
                rTBVA.Text = "Voltage= \r\n " + volt + " V \r\n\r\n";
                rTBVA.Text += "Load Curr.= \r\n" + current + " A\r\n";
                rTBVA.Text += "Unload Curr.= \r\n" + currUnload + " A";
                chart2D1.setPoint(0, time, voltmeasured);
                chart2D1.setPoint(1, time, currmeasured);
                chart2D1.setPoint(2, time, currUnload);

            }
            else rTBVA.Text = "timeout \r\n" +inp;
            inp = "";
            time += timer1.Interval / 1000;
            if (time > 5)
            {
                chart2D1.startDrawing();
                chart2D1.autoScaling();
            }

            // Nun beginnt die Zustandsmaschine. in status sind verschiedene Zustände eingestellt
            // Bei Zustandswechsel werden neue Werte zu Power Supply und Stromsenke geschickt bis 
            // neue Situationen entsehen, die den Zustand dann wechseln  

            switch(status)
            {
                case "Startload":
                    // Konstantstromladung
                    newcurr = readcurrfromTB;
                    newvolt = readvoltfromTB;
                    if (voltmeasured > (newvolt - 0.1))
                    {
                        status = "2load";
                        newvolt = readvoltfromTB-0.5;
                        if (labelADCCard.Text != "None") meinMain.DACoutput(0, 0);
                    }
                     break;
                case "2load":
                    // nun Konstantspannung, Strom wird nun sinken
                    if (currmeasured < 0.2)
                    {
                        status = "3load";
                        newcurr = 0.1;
                        newvolt = 14.2;
                        if (labelADCCard.Text != "None") meinMain.DACoutput(0, 0);
                    }

                    break;
                case "3load":
                    // Geringe Erhaltungsladung
                    if (labelADCCard.Text != "None") meinMain.DACoutput(0, 0);

                    break;
                case "Startunload":
                    //Entladevorgang mit Kruses Stromsenke 1V= 3A
                    //newcurr = 0;
                    //newvolt = 14.2;
                   
                    currUnload= readcurrfromTB ; // Entladestrom in A
                    if (labelADCCard.Text != "None") meinMain.DACoutput(0, currUnload / 3.0); // 1V = 3A
                    if (voltmeasured< readunloadfinalVoltage) // Now loading end voltage is reached, stop unloading
                    {
                        if (labelADCCard.Text != "None") meinMain.DACoutput(0,0); // 00A Stop Entladung
                        status = "2unload";
                        currUnload = 0;
                    }
                    break;
                case "2unload":

                    break;
                case "Pause":
                    if (labelADCCard.Text != "None") meinMain.DACoutput(0, 0); // 00A Stop Entladung
                    break;
                case "Startcycle":
                    newcurr = readcurrfromTB;  // erst VollLaden
                    newvolt = readvoltfromTB;
                    if (voltmeasured > (newvolt - 0.1))
                    {
                        status = "2cycle";
                        newvolt = readvoltfromTB - 0.5;
                        if (labelADCCard.Text != "None") meinMain.DACoutput(0, 0);
                    }
                    break;
                case "2cycle":
                    // nun Konstantspannung, Strom wird nun sinken, wenn voll dann entladen
                    if (currmeasured < 0.2)
                    {
                        status = "3cycle";
                        currUnload = readcurrfromTB; // Entladestrom in A
                        if (labelADCCard.Text != "None") meinMain.DACoutput(0, currUnload / 3.0); // 1V = 3A
                     }
                    break;
                case "3cycle":
                    // Entladevorgang, bis unloadfinalvoltage erreicht
                    if (voltmeasured < readunloadfinalVoltage) 
                    {
                        if (labelADCCard.Text != "None") meinMain.DACoutput(0, 0); // 00A Stop Entladung
                        status = "4cycle";
                        currUnload = 0;
                        newcurr = readcurrfromTB;
                        newvolt = readvoltfromTB;
 
                    }
                    break;
                case "4cycle":
                     // Ladevorgang nach Entladung bis Ladeendspannung erreicht, dann Restladung mit Konstantspannung
                    if (voltmeasured > (newvolt - 0.1))
                    {
                        status = "5cycle";
                        newvolt = readvoltfromTB - 0.5;
                        if (labelADCCard.Text != "None") meinMain.DACoutput(0, 0);
                    }
                    break;
                case "5cycle":
                    // nun Konstantspannung, Strom wird nun sinken
                    if (currmeasured < 0.2)
                    {
                        status = "3load";  //--> Erhaltungsladung
                        newcurr = 0.1;
                        newvolt = 14.2;
                        if (labelADCCard.Text != "None") meinMain.DACoutput(0, 0);
                    }

                    break;
            }

            capacity += currmeasured * (int)numericUpDown1.Value / 3600.0;  // in kWh
            Capacityunload+= currUnload * (int)numericUpDown1.Value / 3600.0;
            labCap.Text = "Capacity Load= " + capacity.ToString("f3") + "  Ah";
            labUnload.Text = "Capacity Unlaod= " + Capacityunload.ToString("f3") + "  Ah";



            if (status!=statusold)
            {// nur bei Wechsel auslösen
                WriteCurr2PS(newcurr);
                ReadSettings();
                Writevolt2PS(newvolt);
                ReadSettings();
               
                tBLog.AppendText(DateTime.Now.ToString() + "  new status " + status + "\r\n");
            }
            statusold = status;
        }

        private void Writevolt2PS(double volt)
        {
            System.Threading.Thread.Sleep(50);
            volt = volt * 10;
            int timeout = 0;
            int voltint = (int)Math.Truncate(volt);
            string ToPs;
            if (voltint < 100)
                ToPs="VOLT0" + voltint.ToString() ;
            else
                ToPs="VOLT" + voltint.ToString() ;
            if (volt == 0)
                ToPs = "VOLT000";

            serialPort1.Write(ToPs + "\r");
            do  // OK abwarten
            {

                while (serialPort1.BytesToRead > 0)
                {
                        int c = serialPort1.ReadChar();
                        char ch = (char)c;

                        inp = inp + ch; if (ch == '\r') inp = inp + "\n"; 
                    }

                
                timeout++;
            }
            while (inp.Length < 4 && timeout<10000);
            while (serialPort1.BytesToRead > 0)  //Serial Port löschen, falls Fehlermeldung kam
            {
                int c = serialPort1.ReadChar();
                inp = inp + (char)c;
            }
            if (timeout == 100) tBLog.AppendText(DateTime.Now.ToString() + "  TIMEOUT " +inp+" \r\n");

            else tBLog.AppendText(DateTime.Now.ToString() + "   " + inp + "  " + volt.ToString() + "  " + ToPs + "\r\n");
           inp="";

        }
        
        private void button1_Click(object sender, EventArgs e)
        {
            long start = stw.ElapsedTicks;
             WriteCurr2PS(0.5);
             ReadSettings();
             Writevolt2PS(3);
            ReadSettings();

            long stop = stw.ElapsedTicks;
            button1.Text = ((stop - start)*1000.0 / Stopwatch.Frequency ).ToString("f3") + "ms";

        }

        private void WriteCurr2PS(double curr)
        {
            int timeout = 0;
            System.Threading.Thread.Sleep(50);

            curr = curr * 10;
            int curint = (int)Math.Truncate(curr);
            string ToPs;
            if (curr < 100)
            {
                ToPs="CURR0" + curint.ToString() ;
            }
            else
                ToPs="CURR" + curint.ToString() ;
            if (curr<10) ToPs = "CURR00" + curint.ToString();
            if (curr ==0)
                ToPs = "CURR000" ;
            serialPort1.Write(ToPs + "\r");

            do  // OK abwarten
            {

                while (serialPort1.BytesToRead > 0)
                {
                        int c = serialPort1.ReadChar();
                        char ch = (char)c;

                        inp = inp + ch; if (ch == '\r') inp = inp + "\n";
                    }

                
                timeout++;

            }
            while (inp.Length < 4 && timeout<10000);
            while (serialPort1.BytesToRead > 0)  //Serial Port löschen, falls Fehlermeldung kam
            {
                int c = serialPort1.ReadChar();
                inp = inp + (char)c;
            }
            if (timeout == 100) tBLog.AppendText(DateTime.Now.ToString() + "  TIMEOUT "+inp+" \r\n");
            else tBLog.AppendText(DateTime.Now.ToString() + "   " + inp + "  " + curr.ToString() + "  " + ToPs + "\r\n");
            inp = "";

        }

        private void ReadSettings()
        {
            serialPort1.Write("GETS" + "\r");
            int timeout = 0;
            do
            {

                while (serialPort1.BytesToRead > 0)
                {
                    int c = serialPort1.ReadChar();
                    char ch = (char)c;

                    inp = inp + ch; if (ch == '\r') inp = inp + "\n";
                }

                timeout++;
            }
            while (inp.Length < 12 && timeout < 10000);
            while (serialPort1.BytesToRead > 0)  //Serial Port löschen, falls Fehlermeldung kam
            {
                int c = serialPort1.ReadChar();
                inp = inp + (char)c;
            }
            // Anzeige Settings
            if (inp.Length >10)
            {
                // ignoriere eventuelle falsche Daten (manchmal kommt ein OK\r\n vor der Settingszahl
                int ii= 0;
                while (Convert.ToChar(inp.Substring(ii, 1)) < '0' || Convert.ToChar(inp.Substring(ii, 1)) > '9') ii++;
                string volt = inp.Substring(ii, 2) + "." + inp.Substring(ii+2, 1);
                string current = inp.Substring(ii+3, 2) + "." + inp.Substring(ii+5, 1);
                //voltmeasured = Convert.ToDouble(volt);
                //currmeasured = Convert.ToDouble(current);
                tBLog.Text +="Settings " + "Voltage=  " + volt + " V ";
                tBLog.Text += "   Current= " + current + " A"+"\r\n";
                //chart2D1.setPoint(0, time, voltmeasured);
                //chart2D1.setPoint(1, time, currmeasured);

            }
            else rTBVA.Text = "timeout \r\n" + inp;
            inp = "";

        }

        private void butPause_Click(object sender, EventArgs e)
        {
            newcurr = 0;
            status = "Pause";
        }

        private void FormBatCapacity_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            WriteCurr2PS(0);

        }
    }
}
