﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Diagnostics;
using WINDF7CSharp;

namespace CraneModelMuk
{
    public partial class FormCraneMuk_rap : Form
    {

        private readonly MicroLibrary.MicroTimer _microTimer;
        FormMain meinMain;
        double cPendxrmin, cPendxrmax;
        double cpendt0 = 0.001;
        double cxda, cxda1, PendelVSoll, cxdm, cxdm1, DeltAlpha, wagposist, wagpossoll;
        double cdxrmax, cdxrmax1s, cq0ax, cq1ax, cq0mx, cq1mx, cpendposx;
        double cpendposxold, cxsoll, PendelV;

        //double cdxrw, cdkx, cdtn, cdkr, cxtdm, cytdm, cxkrm, cykrm, ctna;
        
        double cxinV;
        bool crun = false, cStart = false;
        double cpendpospt1;
        double Pend6Uhr; 
        double Pend12Uhr;  
        double cPendymax = 10, cPendymin = -10; //Max Motor voltage
        double winkel;

        Stopwatch stopwatch1;
        Graphics gPB; Pen p,pbridge; Point p1, p2,pointPendTop,pointPendBottom;
       
        int paintxold, paintyold;
        SolidBrush pbrush;


        public FormCraneMuk_rap(FormMain m)
        {
            InitializeComponent();
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(onMMTimer1);
            _microTimer.Interval = 6000;
            t0rtc = _microTimer.Interval * 0.000001;
            
            stopwatch1 = new Stopwatch();
            p = new Pen(Color.Red,2);
            stopwatch1.Start();
            meinMain = m;
            gPB = Graphics.FromHwnd(pictureBox1.Handle);
            pictureBox1.BackColor=Color.SkyBlue;
            p1 = new Point(50, 20); p2 = new Point(350, 20);
            pbridge = new Pen(Color.Green, 3); pbrush = new SolidBrush(Color.Orange);
        }

        private void FormCraneMuk_rap_FormClosing(object sender, FormClosingEventArgs e)
        {
            _microTimer.Stop();
            crun = false;
            coutputx(0);
            meinMain.DACoutput(0, 0);

            e.Cancel = true;
            this.Visible = false;
        }


       
        double calpha;
        int cxycnt2 = 0;
       
        double KpPreg = 12;     
       
        int reccnt = 0;
        double recampl = 0, Amplitude = 2;
        double t0start = 0, t0end = 0; double dtstart = 0, dtend = 0; double dtmax = 0; double t0 = 0, dt = 0;
        double KPD,KPI;
        double fakWegProWinkel=5.555;


        double WagPosSoll, PendPos, deltAlpha;
        double PendSoll, PendPosPT1, PendPosPT1old;
        double xdPendV, xdPendVold, PendVSoll;
        double xdPendPosold, xdPendPos;
        double TrackBarWert;
        int stateAutoOsc = 0; 

        void onMMTimer1(object sender, MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {


           t0end = t0start;
           t0start = stopwatch1.ElapsedTicks;
           t0 = (t0start - t0end) / (float)Stopwatch.Frequency * 1000;
           double posxd;

           if (crun)
           {
               dtstart = stopwatch1.ElapsedTicks;
              
               cxycnt2++; reccnt++;

               //time counter ,each time timer reachs a certain value, recampl will change
               if (reccnt == 800) recampl = Amplitude;
               if (reccnt == 1600) { recampl = -Amplitude; reccnt = 0; }
               KPD = 1; //trackBar2.Value / 100.0;
               KPI = 1; //(trackBar3.Value) / 100.0;
               wagposist = cinputx();  
 
               if (rbZero.Checked)
               {
                  
                   wagpossoll = 0;
                   posxd = wagpossoll - wagposist;
                   coutputx(posxd);

               }

               if (rbWithoutDamping.Checked)
               {
                  
                   if (cStart) wagpossoll = recampl;        
                   else wagpossoll = 0;
                   posxd = wagpossoll;
                   
                   coutputx(posxd);

               }

               if (rbWithDamping.Checked)
               {
                   cxinV=cinputy(); calpha = cxinV - Pend6Uhr;    
                                      
                   cpendposx = wagposist + fakWegProWinkel * calpha;      
                   cpendpospt1 = 0.940904 * cpendpospt1 + 0.059096 * cpendposx;    
                   PendelV = 0.88692 * PendelV + 5.65398 * (cpendpospt1 - cpendposxold);  
                   cpendposxold = cpendpospt1;

                   cxsoll = recampl;
                   cxda = cxsoll - wagposist;                   
                   PendelVSoll = 0.84 *KPI* cxda;

                   cxdm = PendelVSoll - PendelV;
                   DeltAlpha = 1.57 * cxdm * KPD - 1.2 * cxdm1 * KPD;        
                   cxdm1 = cxdm;
                   //if (DeltAlpha >= cPendxrmax) DeltAlpha = cPendxrmax;    
                   //if (DeltAlpha <= -cPendxrmax) DeltAlpha = -cPendxrmax;

                   wagpossoll = cpendposx + DeltAlpha;
                   if (wagpossoll >= cPendxrmax) wagpossoll = cPendxrmax;
                   if (wagpossoll <= cPendxrmin) wagpossoll = cPendxrmin;

                  
                   if (cStart==false) wagpossoll = 0;
                   posxd = wagpossoll ;
                   
                   coutputx( posxd); 

               }

               if (rbFixedDamped.Checked)       
               {
                   cxinV=cinputy(); calpha = cxinV - Pend6Uhr;   
                                   

                   cpendposx = wagposist + fakWegProWinkel * calpha;      
                   cpendpospt1 = 0.940904 * cpendpospt1 + 0.059096 * cpendposx;    
                   PendelV = 0.88692 * PendelV + 5.65398 * (cpendpospt1 - cpendposxold);  
                   cpendposxold = cpendpospt1;

                   cxsoll = 0;
                   cxda = cxsoll - wagposist;
                   PendelVSoll = 0.84 * KPI * cxda;

                   cxdm = PendelVSoll - PendelV;
                   DeltAlpha = 1.57 * cxdm * KPD - 1.2 * cxdm1 * KPD;        
                   cxdm1 = cxdm;
                   //if (DeltAlpha >= cPendxrmax) DeltAlpha = cPendxrmax;    
                   //if (DeltAlpha <= -cPendxrmax) DeltAlpha = -cPendxrmax;

                   wagpossoll = cpendposx + DeltAlpha;           
                   if (wagpossoll >= cPendxrmax) wagpossoll = cPendxrmax;   
                   if (wagpossoll <= cPendxrmin) wagpossoll = cPendxrmin;

                   
                   if (cStart==false) wagpossoll = 0;
                   posxd = wagpossoll ;
                   coutputx( posxd); 
                  

               }
               if (rbAutoscillation.Checked)
               {
                   double outwert = 0;
                   cxinV=cinputy(); calpha = cxinV - Pend6Uhr;

                   cpendposx = wagposist + fakWegProWinkel * calpha;     
                   cpendpospt1 = 0.940904 * cpendpospt1 + 0.059096 * cpendposx;   
                   PendelV = 0.88692 * PendelV + 5.65398 * (cpendpospt1 - cpendposxold);
                   cpendposxold = cpendpospt1;
                   // now calpha -2V...+2V in area 4-8 a'clock
                   // PendelV >0 --> cw
                   //PendelV <0 --> ccw
                   if (cStart)
                       if ((calpha < 2) && (calpha > -4.5))
                       {
                           switch (stateAutoOsc)
                           {
                               case 1: // Stop movement
                                   cxsoll = 0;
                                   cxda = cxsoll - wagposist;
                                   PendelVSoll = 0.84 * KPI * cxda;

                                   cxdm = PendelVSoll - PendelV;
                                   DeltAlpha = 1.57 * cxdm * KPD - 1.2 * cxdm1 * KPD;
                                   cxdm1 = cxdm;
                                   //if (DeltAlpha >= cPendxrmax) DeltAlpha = cPendxrmax;    
                                   //if (DeltAlpha <= -cPendxrmax) DeltAlpha = -cPendxrmax;

                                   wagpossoll = cpendposx + DeltAlpha;
                                   if (wagpossoll >= cPendxrmax) wagpossoll = cPendxrmax;
                                   if (wagpossoll <= cPendxrmin) wagpossoll = cPendxrmin;


                                   if (cStart == false) wagpossoll = 0;
                                   posxd = wagpossoll;
                                   coutputx(posxd);
                                   if (Math.Abs(wagposist) < 0.1 && Math.Abs(PendelV) < 0.1) stateAutoOsc = 2;  // if now move and cart at 0
                                   break;
                               case 2: // Drive to pos -2
                                   coutputx(-(double)trackBar2.Value/100.0);
                                    if ((Math.Abs(cxinV - Pend12Uhr) < 0.1)) stateAutoOsc = 5;        
                                    if (calpha < -0.2 && PendelV < 0) stateAutoOsc = 3; //if pendulum left position going right


                                   break;
                               case 3: // Drive to pos +2
                                   coutputx(+(double)trackBar3.Value / 100.0);
                                   if ((Math.Abs(cxinV - Pend12Uhr) < 0.1)) stateAutoOsc = 5;          
                                   if (calpha > 0.2 && PendelV > 0) stateAutoOsc = 2; //if pendulum left position going right


                                   break;
                               case 4: // Drive to pos -2
                                   coutputx(-2);
                                   if (calpha < -0.2 && PendelV < 0) stateAutoOsc = 5; //if pendulum left position going right
                                   if ((Math.Abs(cxinV - Pend12Uhr) < 0.1)) stateAutoOsc = 5;

                                   break;
                               case 5:
                                   //coutputx(0);
                                   break;

                           }
                           
                       }
                       else if ((Math.Abs(cxinV - Pend12Uhr) < 0.1) && (cbAutomaticalStandUp.Checked))
                       {

                           PendPosPT1 = 0; PendelV = 0; PendPosPT1old = 0; xdPendPosold = 0;
                           PendVSoll = 0;
                           rbStanding.Checked = true;
                           rbAutoscillation.Checked = false;

                       }
                       else    
                       {
                           //posxd =  wagposist;
                           //coutputx(wagposist);
                       }


                   else coutputx(0);

               }
               if (rbStanding.Checked)
               {
                   //cq0ax = (-cq1ax);// *(1 + 0.006 / 3.19 / trackBar4.Value * 100.0);

                   cxinV=cinputy(); calpha = cxinV - Pend12Uhr; // Bei 12 Uhr ist der Wert Null

                   PendPos = wagposist - fakWegProWinkel * calpha;  // P Block  8 + Summierstelle
                   PendPosPT1 = 0.94258 * PendPosPT1 + 0.057416 * PendPos;  // PT1 Block 9
                   PendelV = 0.8868 * PendelV + 5.649 * PendPosPT1 - 5.649 * PendPosPT1old; //DT1 Block 10
                   PendPosPT1old = PendPosPT1;
                   PendSoll = TrackBarWert;
                  
                   if ((Math.Abs(calpha) < 0.4) && (Math.Abs(PendelV) < 10))
                   {
                       if (cbPositionGeneratorOn.Checked) PendSoll = recampl; else PendSoll = 0;


                       // here control of vertical pendulum position 
                       xdPendPos = PendSoll - wagposist;
                       PendVSoll = PendVSoll + 0.09588 * xdPendPos - 0.09576 * xdPendPosold; //PI Block 1
                       xdPendPosold = xdPendPos;


                       // here control of pendulum speed
                       xdPendV = PendVSoll - PendelV;  //PendVSoll
                       deltAlpha = 2 * 2.0596 * xdPendV - 2 * 1.584 * xdPendVold;  // PD Block 2
                       if (deltAlpha > cPendxrmax) deltAlpha = cPendxrmax;  // Block 34
                       if (deltAlpha < cPendxrmin) deltAlpha = cPendxrmin;
                       xdPendVold = xdPendV;



                       // control of pivot under pendulum 
                       WagPosSoll = PendPos -deltAlpha;

                       coutputx(WagPosSoll);

                   }
                   else
                   {
                  
                       coutputx(0);
                   }
               }

               if (rbPosHand.Checked)
               {
                                

                   if (cStart) wagpossoll = TrackBarWert;  
                   else wagpossoll = 0;
                   posxd = wagpossoll - wagposist;
                   coutputx(posxd);

               }

               dtend = stopwatch1.ElapsedTicks;
               dt = (dtend - dtstart) / Stopwatch.Frequency * 1000;
                  

           }
           else
           { cinit(); }

        }

        //timer displays T0,dT,dTMAX
        private void timerDisplay_Tick(object sender, EventArgs e)
        {
            labelT0.Text = t0.ToString("f2");
            labeldT.Text = dt.ToString("f2");
            if (dtmax < dt)
            {
                dtmax = dt;
            }
            labeldTMAX.Text = dtmax.ToString("f2");
            //labTB2.Text = (KPD).ToString("f2");
           // labTBPI.Text = (KPI).ToString("f2");
            label4.Text = "autostate " + stateAutoOsc.ToString();
            label5.Text = "calpha " + calpha.ToString("f5");
            label9.Text = "wagposist " + wagposist.ToString("f5");//(0.006/(-cq0ax/cq1ax-1)).ToString();
            label10.Text = "PendelV " + PendelV.ToString("f5");

        }

        // input of position ,channel 0
        double cinputx() 
        {
            double val = 0;
            meinMain.ADCinput(0, ref val);
           
            return (val);

        }

        //input of angel ,channel 1
        double cinputy() 
        {
            double val = 0;
            meinMain.ADCinput(1, ref val);
            return val;
        }

        double t0rtc, ncas, x1cas, wncas, xdncas, yold, xdn1cas;


        //output of position, channel 0
        void coutputx(double y)
        {
            // limit position of rack
            if (y > cPendxrmax) y = cPendxrmax;
            else if (y < cPendxrmin) y = cPendxrmin;
            // position control with cascaded controller and AWU
            ncas = (wagposist - x1cas) / t0rtc;  // speed by differentiating 
            wncas = 14 * (y - wagposist);    // outer P-controller 
            // Ka=10 / ki = 1.0, ti = 0.15; for black rap
            // Ka=14 / ki = 2.0, ti = 0.3; for silver rap
            xdncas = wncas - ncas;
            double ki = 2.0, ti = 0.3;
            double Yout = yold + ki * (1 + t0rtc / ti) * xdncas - ki * xdn1cas;   // PI-controller inner loop 
            if (Math.Abs(Yout) > cPendymax) Yout = Yout - (t0rtc / ti) * xdncas;  //AWU
            x1cas = wagposist; xdn1cas = xdncas; yold = Yout;

            if (Yout >= cPendymax) Yout = cPendymax;
            if (Yout <= cPendymin) Yout = cPendymin;

            meinMain.DACoutput(0, Yout);
        }

        void cinit()
        {
                 Pend6Uhr=7.5; 
                 Pend12Uhr= 2.5;  
                 cPendxrmin = -5.0; cPendxrmax = 5.0; 
                
                 cdxrmax1s=100;
                 //cdxrw=0.01;cdkx=0.01;cdtn=0.01;cdkr=0.01;
                 
                 cpendt0=0.006;
                 cq0ax=0;cq1ax=0;
                 cxda=0;cxdm=0;cxdm1=0;cxda1=0;
                 DeltAlpha=0;wagpossoll=0;
                 cxsoll=0;cpendpospt1=0;PendelVSoll=0;
                 PendelV=0;
                 cpendposxold=0;
                 cq0mx=0;cq1mx=0;cq0ax=0;cq1ax=0;
         }

        private void buttonRestPos_Click(object sender, EventArgs e)
        {
            crun = false; 
            cStart = false;
            label6.Visible = false;
            labelT0.Visible = false;
            labeldT.Visible = false;
            labeldTMAX.Visible = false;
            rbStop.Checked=true;
            if (meinMain.toolStripMenuItemNIDAQmx.Checked)
            {
                meinMain.frmDACmx.butZero_Click(null, null);
            }
            cinit();
            timerDrawing.Enabled = true;
        }

        double sinfak;
        private void buttonStart_Click(object sender, EventArgs e)
        {
           
            label2.Visible = true;
            tbX.Visible = true;



            timerDisplay.Enabled = true;  
            label7.Visible = false;
            label6.Visible = false;
            cdxrmax=cdxrmax1s*cpendt0;

            trackBar1.Visible = false;
            labelT0.Visible = true;
            labeldT.Visible = true;
            labeldTMAX.Visible = true;
            double c=Pend6Uhr-Pend12Uhr; if (c==0) c=0.579 ; else c=Math.PI/c;
            sinfak=c;
            
            cStart=true;
            crun=true;
            _microTimer.Start();
        }


        private void buttonAccept12Clock_Click(object sender, EventArgs e)
        {
            label7.Text = "PLEASE SET THE PENDULUM AT 6 O'CLOCK";
            buttonAccept12Clock.Visible = false;
            winkel = cinputy();
            Pend12Uhr = winkel;
        }

        private void buttonAccept6Clock_Click(object sender, EventArgs e)
        {
            winkel = cinputy();
            Pend6Uhr = winkel;
            buttonAccept6Clock.Visible = false;
        }

        private void rbStop_CheckedChanged(object sender, EventArgs e)
        {
            if (rbStop.Checked)
            {
                crun = false; //Stop
                cStart = false;
                label6.Visible = true;
                labelT0.Visible = false;
                labeldT.Visible = false;
                labeldTMAX.Visible = false;
                rbStop.PerformClick();
                coutputx(0);
                meinMain.DACoutput(0, 0);
                trackBar1.Visible = false;
                timerDisplay.Enabled = false;
            }
            

        }

        private void rbWithoutDamping_CheckedChanged(object sender, EventArgs e)
        {
            if (rbWithoutDamping.Checked)
            {
                buttonStart_Click(sender,e);
                 meinMain.ConvertToDouble(tbAmplitude.Text,ref Amplitude );
            }
            
        }

        private void rbWithDamping_CheckedChanged(object sender, EventArgs e)
        {
            if (rbWithDamping.Checked)
            {
                buttonStart_Click(sender, e);
                meinMain.ConvertToDouble(tbAmplitude.Text,ref Amplitude  );
            }
            
        }

        private void rbFixedDamped_CheckedChanged(object sender, EventArgs e)
        {
            if (rbFixedDamped.Checked)
            {
                buttonStart_Click(sender, e);
                PendelVSoll = 0;
                cq0mx = 0.20583 * 10; cq1mx = -0.15833 * 10;
                cq0ax = 0.4794 * 0.2; cq1ax = -0.4788 * 0.2;
            }
            
        }

        private void rbStanding_CheckedChanged(object sender, EventArgs e)
        {
            if (rbStanding.Checked)
            {
                buttonStart_Click(sender, e);
                PendelVSoll = 0;
                cq0mx = 0.20583 * 10; cq1mx = -0.15833 * 10;
                cq0ax = 0.4794 * 0.2; cq1ax = -0.4788 * 0.2;
            }
            
        }

        private void rbAutoscillation_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAutoscillation.Checked)
            {
                buttonStart_Click(sender, e);
                PendPosPT1 = 0; PendelV = 0; PendPosPT1old = 0; xdPendPosold = 0;
                PendVSoll = 0;
                cxdm1 = 0;
                stateAutoOsc = 1; // Start 
            }
            
        }

        private void rbZero_CheckedChanged(object sender, EventArgs e)
        {
            if (rbZero.Checked)
	        {
        		 label2.Visible=true;
                 buttonAccept12Clock.Visible=true;
                buttonAccept6Clock.Visible=true;
                tbX.Visible=true;
                timerDisplay.Enabled=true;
                cStart=false;   
                crun=true;
                _microTimer.Start();
            }
            else
            {
                buttonAccept12Clock.Visible = false;
                buttonAccept6Clock.Visible = false;
            }
            
        }

        private void rbPosHand_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPosHand.Checked)
            {
                buttonStart_Click(sender, e);
                trackBar1.Visible = true;


            }
            else
            {
                trackBar1.Visible = false;
            }
        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
            _microTimer.Stop();
            crun = false;          
            coutputx(0);
            meinMain.DACoutput(0, 0);

            this.Visible = false;
        }


 
        //timer draws graphic
        private void timerDrawing_Tick(object sender, EventArgs e)
        {
            gPB.Clear(Color.SkyBlue);
            int size = 12;
            
            double x = cinputy();


            double c = Pend6Uhr - Pend12Uhr; if (c == 0) c = 0.579; else c = Math.PI / c;
            sinfak = c;
            double sinx = Math.Sin((x - Pend6Uhr) * sinfak);
            double cosx = Math.Cos((x - Pend6Uhr) * sinfak);
            
            //gPB.DrawLine(p,pointPendTop,pointPendBottom);
            double pos = -pictureBox1.Width / 4.0 * wagposist / 10.0;

            paintxold = (int)(pictureBox1.Width / 2.0 + pictureBox1.Width / 4.0*sinx - pos);
            paintyold = (int)(pictureBox1.Height / 2.0 + pictureBox1.Height / 2.3 * cosx);


            pointPendTop = new Point((int)(pictureBox1.Width/2.0-pos), (int)(pictureBox1.Height/2.0));
            pointPendBottom = new Point((int)(paintxold), (int)(paintyold));
            gPB.DrawLine(p ,pointPendTop,pointPendBottom);
            gPB.FillEllipse(pbrush, (float)(paintxold-size*0.5) , (float)(paintyold-size*0.5),size,size);
            
            
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            TrackBarWert= (double)((trackBar1.Value / 20.0));  // von -5 bis 5
        }

        private void FormCraneMuk_rap_Load(object sender, EventArgs e)
        {
            meinMain.frmDACmx.rBCnt1.Checked = true;
            meinMain.frmDACmx.rBCnt2.Checked = true;
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            labTB2.Text = trackBar2.Value.ToString();
        }

        private void trackBar4_Scroll(object sender, EventArgs e)
        {
          
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            labTBPI.Text = trackBar3.Value.ToString();
        }


        






    }
}
