﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WINDF7CSharp.Hardwaretools
{
    public partial class FormDataLogger : Form
    {
        FormMain meinMain;
        
        public FormDataLogger(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown1, 1, (double)numericUpDown1.Maximum);
            timer1.Interval = (int)numericUpDown1.Value * 1000;
        }

        private void butInit_Click(object sender, EventArgs e)
        {
           
            timer1.Interval = (int)numericUpDown1.Value * 1000;
            time = 0;
            timer1.Enabled = true;
            chart2D1.clearAll();
            chart2D1.XMax = 10 * (int)numericUpDown1.Value;
        }

        string inp = "";
        long time = 0;

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (labSelADC.Text!="no card")
            {
                double volt = 0, volt2=0;
                meinMain.ADCinput(0, ref volt);
                if (cB2ndChan.Checked) meinMain.ADCinput(1, ref volt2);
                labTemp.Text = volt.ToString("f2") + "V";


                time += (int)numericUpDown1.Value;  // Aktuelle Sek ab Start
                if (time > chart2D1.XMax)
                    chart2D1.XMax += 10 * (int)numericUpDown1.Value;
                tSSLabel1.Text = time.ToString() + " sec";
                chart2D1.realTimeChart(0, time, volt);
                if (cB2ndChan.Checked)
                {
                    chart2D1.realTimeChart(1, time, volt2*2000.0);  // Strom gemessen über 0.5 Ohm in mA
                    chart2D1.setY2(1, true);
                }
                if (time % 50 == 0)
                {
                    chart2D1.autoScaling();
                    if (cB2ndChan.Checked) chart2D1.autoscaleY2();
                    saveFile();
                }
                    

            }
        }

        bool SaveOK = false;

        private void button1_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog()==DialogResult.OK)
            {
                saveFile();
                SaveOK = true;
            }
        }
        int cntfile = 0;
        private void saveFile()
        {
            if (SaveOK)
            {
                double[,] temp,temp2;
                temp = chart2D1.getPoints(0);
                temp2 = temp;
                if (cB2ndChan.Checked) temp2 = chart2D1.getPoints(1);
                string data = "";
                for (int i = 0; i < temp.Length / 2; i++)
                    if (i % (int)nUDDatareduction.Value == 0)
                    {
                        data += temp[i, 0].ToString() + " " + temp[i, 1].ToString();
                        if (cB2ndChan.Checked) data += " "+ temp2[i, 1].ToString();
                        data += "\r\n";

                    }
                string fn = saveFileDialog1.FileName.Substring(0,saveFileDialog1.FileName.Length-4) + cntfile.ToString()+ ".sim";
                StreamWriter myStream1 = new StreamWriter(fn);
                myStream1.WriteLine(data);
                myStream1.Close();
                cntfile++;
            }

        }

        private void FormTempLogger_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void FormDataLogger_Load(object sender, EventArgs e)
        {
            labSelADC.Text = meinMain.selectedADC;
            if (labSelADC.Text != "no card") butInit.Enabled = true;
        }

        private void FormDataLogger_Activated(object sender, EventArgs e)
        {
            labSelADC.Text = meinMain.selectedADC;
            if (labSelADC.Text != "no card") butInit.Enabled = true;

        }

        private void butStartStop_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled)
            {
                timer1.Enabled = false;
                butStartStop.Text = "Restart Timer";
            }
            else
            {
                timer1.Enabled = true;
                butStartStop.Text = "Stop Timer";
            }



        }

        private void chart2D1_CoordClick(object sender, ChartTool.CoordClickEventArgs e)
        {
            if (tBStart.Focused) 
                tBStart.Text = Math.Truncate(e.x).ToString();
            if (tBEnd.Focused)
                tBEnd.Text = Math.Truncate(e.x).ToString();
        }

        private void butCalcmAh_Click(object sender, EventArgs e)
        {
            double[,] temp;
            temp = chart2D1.getPoints(0);
            int st, en;
            double sum = 0;
            st = Convert.ToInt32(tBStart.Text);
            en = Convert.ToInt32(tBEnd.Text);

            for (int i = st; i < en; i++)
                sum += temp[i, 1];
            // Integriert über die Spannung. Wenn mit R in Ohm entladen, dann Strom = U/R * 1000 in mA
            double res = Convert.ToDouble(tBResistor.Text);
            sum = sum / res * 1000.0;
            labmAsec.Text = sum.ToString("f0");
            labmAmin.Text = (sum / 60.0).ToString("f0");
            labmAh.Text = (sum / 3600.0).ToString("f0");
        }
    }
}
