﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;
using NationalInstruments.DAQmx;



namespace es_PendelDemo10
{
    public partial class Form1 : Form
    {



        private NationalInstruments.DAQmx.Task analogOutTask;
        private NationalInstruments.DAQmx.AnalogSingleChannelWriter writesinglechannel;
        double ao0Value = 0.0, maxaoValue;

        private NationalInstruments.DAQmx.Task Task_Wagen;      //w. Auswahl : System.Threading.Tasks;
        private NationalInstruments.DAQmx.Task Task_Pendel_Kurz;
        private NationalInstruments.DAQmx.Task Task_Pendel_Lang;
        private CounterReader countsinglechannel_Wagen;
        private CounterReader countsinglechannel_Pendel_Kurz;
        private CounterReader countsinglechannel_Pendel_Lang;
        
       
        private bool zIndexEnable = false;
        double zIndexValue = 0.0;

        private double TicksWagenEncoder, WagenPosition, WagenPosition_n_1, WagenPosition_n_2;
        private double Wagen_DT2_Out, Wagen_DT2_Out_n_1, Wagen_DT2_Out_n_2;
        private double Wagen_I_Out, Wagen_I_Out_n_1;
        private double Pendel_KurzPosition, inv_alpha, inv_alpha_n_1, inv_alpha_n_2;
        private double PendelKurz_DT2_Out, PendelKurz_DT2_Out_n_1, PendelKurz_DT2_Out_n_2;
        private double Pendel_LangPosition, Pendel_LangPosition_n_1, Pendel_LangPosition_n_2;
        private double PendelLang_DT2_Out, PendelLang_DT2_Out_n_1, PendelLang_DT2_Out_n_2;
        private double kleiner_10_deg = 10 * Math.PI / 180;
        private double kleiner_5_deg = 5 * Math.PI / 180;
        private double Notstopp_Konstante = 0.35;  // +- 35 cm Fahrbereich

        private double counts_to_meter_Qu = 0.0932 / (4 * 1024);  // hier ist Pi drin
        private double counts_to_meter_FH = 0.1232 / (4 * 1024);  // hier ist Pi drin
        private double radians_to_degrees = 180 / Math.PI;
        private double Kp_x = -42, Kp_x_V;   //Orignal Wert -42
        private double Kd_x = -31, Kd_x_V;
        private double Ki_x = -10, Ki_x_V;
        private double Kp_alpha = 180, Kp_alpha_V;
        private double Kd_alpha = 48, Kd_alpha_V;
        private double Kp_theta = 417, Kp_theta_V;
        private double Kd_theta = 43, Kd_theta_V;
        private double m_to_mm = 1e3;
        private double t0 = 0.002;  // T0 = 2 ms
        
        private double CartPID, ShortPendulumPD, MediumPendulumPD, BalanceControl;

        private double DT2_p1_P = 1.78336936054716;
        private double DT2_p2_P = -0.797506111391242;
        private double DT2_q0_P = 3.53418771102163;
        private double DT2_q1_P = 7.069900220813E-13;
        private double DT2_q2_P = -3.53418771102092;

        private double DT2_p1_C = 1.08317908238986;
        private double DT2_p2_C = -0.320403138504956;
        private double DT2_q0_C = 59.3060140287809;
        private double DT2_q1_C = 1.18660636871937E-11;
        private double DT2_q2_C = -59.306014028769;


        // *****
        private double Wagen_DT1_Out, Wagen_DT1_Out_n_1;
        private double Pendel_DT1_Out, Pendel_DT1_Out_n_1;

        private double CartPD, PendulumPD;
        
        private double Kp_x_s = 20, Kp_x_s_V;
        private double Kd_x_s = 40, Kd_x_s_V;
        private double Kp_alpha_s = -100, Kp_alpha_s_V;
        private double Kd_alpha_s = -20, Kd_alpha_s_V;
        private double DT1_p1 = 0.95129512195122;
        private double DT1_q0 = 47.6190476192857;

        // ****

        private long dtstart, dtStart_n_1, dtstop;
        private double dtsec, t0sec;
        private double alpha_Nenner;

        private readonly MicroLibrary.MicroTimer _microTimer;

        private Stopwatch stopwatch_1 = new Stopwatch();


        public Form1()
        {
            InitializeComponent();

            maxaoValue = 10; // maximale Ausgangsspannung = 10 Volt

            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(EventMMTimerWork);
            _microTimer.Interval = (long)(1000000 * t0);
           
            stopwatch_1.Start();
            alpha_Nenner = Math.PI * 2;

            chart2D1.XMax = 5;
            chart2D1.XMin = 0;
            chart2D1.YMax = 0.2;
            chart2D1.YMin = -0.2;
            chart2D1.initializeScopeMode();
            chart2D1.toggleLegend();

        }

        void EventMMTimerWork(object sender, MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {
            dtstart = stopwatch_1.ElapsedTicks;
           
            if (Task_Wagen != null) TicksWagenEncoder = (double)countsinglechannel_Wagen.ReadSingleSampleInt32();
            //***   Inkremente * 4 (QuadEncoder) , Umfang = 0,02963m (Durchmesser) * pi ----- Quanser
            if (rBcartBlack.Checked) WagenPosition = TicksWagenEncoder * counts_to_meter_Qu;
            if (rBCartSilver.Checked) WagenPosition = TicksWagenEncoder * counts_to_meter_FH;  // Position in Meter
            if (Math.Abs(WagenPosition) >= Notstopp_Konstante) { NOTStopp(null, null); MessageBox.Show("Wagen außerhalb der erlaubten Grenzen"); }
            
            if (rBEinfachPendel.Checked)
            {
                Kp_x_s_V = Kp_x_s * WagenPosition;
                Wagen_DT1_Out = Wagen_DT1_Out_n_1 * DT1_p1 + (WagenPosition - WagenPosition_n_1) * DT1_q0;
                Wagen_DT1_Out_n_1 = Wagen_DT1_Out;
                WagenPosition_n_1 = WagenPosition;
                Kd_x_s_V = Kd_x_s * Wagen_DT1_Out;
                CartPD = Kp_x_s_V + Kd_x_s_V;
            }
            if (rBDoppelPendel.Checked)
            { 
                Kp_x_V = Kp_x * WagenPosition;
                Wagen_DT2_Out = Wagen_DT2_Out_n_1 * DT2_p1_C + Wagen_DT2_Out_n_2 * DT2_p2_C + WagenPosition * DT2_q0_C + WagenPosition_n_1 * DT2_q1_C + WagenPosition_n_2 * DT2_q2_C;
                Wagen_DT2_Out_n_2 = Wagen_DT2_Out_n_1;
                Wagen_DT2_Out_n_1 = Wagen_DT2_Out;
                WagenPosition_n_2 = WagenPosition_n_1;
                WagenPosition_n_1 = WagenPosition;
                Kd_x_V = Kd_x * Wagen_DT2_Out;
                Wagen_I_Out = Wagen_I_Out_n_1 + (WagenPosition * t0);
                Wagen_I_Out_n_1 = Wagen_I_Out;
                Ki_x_V = Ki_x * Wagen_I_Out;
                CartPID = Kp_x_V + Kd_x_V + Ki_x_V;
            }
            

            // ***   positives Vorzeichen für Quanser-Aufbau  negatives Vorzeichenh für FH- Aufbau
            // **   "Pendel_Kurz_counts_to_radian = 2 * Math.PI / (4 * 1024);" bereits in "CreateAngularEncoderChannel"
            // ***   Pendel_KurzPosition ist in "radian"
            if (rBcartBlack.Checked) if (Task_Pendel_Kurz != null) Pendel_KurzPosition = countsinglechannel_Pendel_Kurz.ReadSingleSampleDouble();
            if (rBCartSilver.Checked) if (Task_Pendel_Kurz != null) Pendel_KurzPosition = -countsinglechannel_Pendel_Kurz.ReadSingleSampleDouble();
            inv_alpha = ((Pendel_KurzPosition % alpha_Nenner + alpha_Nenner) % alpha_Nenner) - Math.PI;
            // inv_alpha = Pendel_KurzPosition - Math.PI;
            if (rBEinfachPendel.Checked)
            {
                Kp_alpha_s_V = Kp_alpha_s * inv_alpha;
                Pendel_DT1_Out = Pendel_DT1_Out_n_1 * DT1_p1 + (inv_alpha - inv_alpha_n_1) * DT1_q0;
                Pendel_DT1_Out_n_1 = Pendel_DT1_Out;
                inv_alpha_n_1 = inv_alpha;
                Kd_alpha_s_V = Kd_alpha_s * Pendel_DT1_Out;
                PendulumPD = Kp_alpha_s_V + Kd_alpha_s_V;
            }
            if (rBDoppelPendel.Checked)
            {
                Kp_alpha_V = Kp_alpha * inv_alpha;
                PendelKurz_DT2_Out = PendelKurz_DT2_Out_n_1 * DT2_p1_P + PendelKurz_DT2_Out_n_2 * DT2_p2_P + inv_alpha * DT2_q0_P + inv_alpha_n_1 * DT2_q1_P + inv_alpha_n_2 * DT2_q2_P;
                PendelKurz_DT2_Out_n_2 = PendelKurz_DT2_Out_n_1;
                PendelKurz_DT2_Out_n_1 = PendelKurz_DT2_Out;
                inv_alpha_n_2 = inv_alpha_n_1;
                inv_alpha_n_1 = inv_alpha;
                Kd_alpha_V = Kd_alpha * PendelKurz_DT2_Out;
                ShortPendulumPD = Kp_alpha_V + Kd_alpha_V;
            }
  
            // ***   "Pendel_Kurz_counts_to_radian = 2 * Math.PI / (4 * 1024);" bereits in "CreateAngularEncoderChannel"
            // ***   Pendel_LangPosition ist in "radian"
            if (rBDoppelPendel.Checked)
            {
                if (Task_Pendel_Lang != null) Pendel_LangPosition = -countsinglechannel_Pendel_Lang.ReadSingleSampleDouble();
                Kp_theta_V = Kp_theta * Pendel_LangPosition;
                PendelLang_DT2_Out = PendelLang_DT2_Out_n_1 * DT2_p1_P + PendelLang_DT2_Out_n_2 * DT2_p2_P + Pendel_LangPosition * DT2_q0_P + Pendel_LangPosition_n_1 * DT2_q1_P + Pendel_LangPosition_n_2 * DT2_q2_P;
                PendelLang_DT2_Out_n_2 = PendelLang_DT2_Out_n_1;
                PendelLang_DT2_Out_n_1 = PendelLang_DT2_Out;
                Pendel_LangPosition_n_2 = Pendel_LangPosition_n_1;
                Pendel_LangPosition_n_1 = Pendel_LangPosition;
                Kd_theta_V = Kd_theta * PendelLang_DT2_Out;
                MediumPendulumPD = Kp_theta_V + Kd_theta_V;
            }

            if (rBDoppelPendel.Checked) BalanceControl = CartPID + ShortPendulumPD + MediumPendulumPD;
            if (rBEinfachPendel.Checked) {BalanceControl = CartPD + PendulumPD; Pendel_LangPosition = 0.0;}

            if (Math.Abs(inv_alpha) <= kleiner_5_deg & Math.Abs(Pendel_LangPosition) <= kleiner_10_deg) ao0Value = BalanceControl;
            else ao0Value = 0;


            if (ao0Value >= maxaoValue) ao0Value = maxaoValue;
            if (ao0Value <= -maxaoValue) ao0Value = -maxaoValue;
            writesinglechannel.WriteSingleSample(true, ao0Value);

            dtstop = stopwatch_1.ElapsedTicks;
            dtsec = (dtstop - dtstart) / (double)Stopwatch.Frequency * 1000;
            t0sec = (dtstart - dtStart_n_1) / (double)Stopwatch.Frequency * 1000;
            dtStart_n_1 = dtstart;

        }

        private void startMessung()
        {
            try
            {
                CIEncoderDecodingType encoderType = CIEncoderDecodingType.X4;
                CIEncoderZIndexPhase encoderPhase = CIEncoderZIndexPhase.AHighBHigh;
                analogOutTask = new NationalInstruments.DAQmx.Task();
                writesinglechannel = new AnalogSingleChannelWriter(analogOutTask.Stream);

                analogOutTask.AOChannels.CreateVoltageChannel("Dev1/ao0", "", -10.0, 10.0, AOVoltageUnits.Volts);

                //Wagen
                Task_Wagen = new NationalInstruments.DAQmx.Task();
                Task_Wagen.CIChannels.CreateAngularEncoderChannel("Dev1/ctr0",
                    "", encoderType, zIndexEnable, zIndexValue, encoderPhase, 1024,
                    0.0, CIAngularEncoderUnits.Ticks);
                Task_Wagen.Start();
                countsinglechannel_Wagen = new CounterReader(Task_Wagen.Stream);

                //Pendel_Kurz
                Task_Pendel_Kurz = new NationalInstruments.DAQmx.Task();
                Task_Pendel_Kurz.CIChannels.CreateAngularEncoderChannel("Dev1/ctr1",
                    "", encoderType, zIndexEnable, zIndexValue, encoderPhase, 1024,
                    0.0, CIAngularEncoderUnits.Radians);
                Task_Pendel_Kurz.Start();
                countsinglechannel_Pendel_Kurz = new CounterReader(Task_Pendel_Kurz.Stream);

                //Pendel_Lang
                Task_Pendel_Lang = new NationalInstruments.DAQmx.Task();
                Task_Pendel_Lang.CIChannels.CreateAngularEncoderChannel("Dev2/ctr0",
                    "", encoderType, zIndexEnable, zIndexValue, encoderPhase, 1024,
                    0.0, CIAngularEncoderUnits.Radians);
                Task_Pendel_Lang.Start();
                countsinglechannel_Pendel_Lang = new CounterReader(Task_Pendel_Lang.Stream);
                timer1.Enabled = true;

            }
            catch (DaqException exception)
            {
                MessageBox.Show(exception.Message);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            label1.Text = "Wagen Position         :  " + (WagenPosition * m_to_mm).ToString("f3") + "  mm";
            label6.Text = "Ausgangsspannung   :  " + ao0Value.ToString("f3") + "  V";
            label9.Text = "Pendel_Kurz Position :  " + (inv_alpha * radians_to_degrees).ToString("f3") + "  deg";
            label2.Text = "Pendel_Lang Position:  " + (Pendel_LangPosition * radians_to_degrees).ToString("f3") + "  deg";
            toolStripStatusLabel1.Text = " Datum/Uhrzeit:  " + DateTime.Now.ToString() + "   |  ";
            toolStripStatusLabel2.Text = " Laufzeit = " + dtsec.ToString("F3") + "  ms" + "   |  ";
            toolStripStatusLabel3.Text = "   t0 = " + t0sec.ToString("F3") + "  ms";

            chart2D1.scopeChart(0, inv_alpha);
            chart2D1.scopeChart(1, Pendel_LangPosition);
        }

        private void btStRe_Click(object sender, EventArgs e)
        {
            _microTimer.Stop();
            Wagen_I_Out = 0;
            Wagen_I_Out_n_1 = 0;
            if (Task_Wagen != null) Task_Wagen.Stop();
            if (Task_Pendel_Kurz != null) Task_Pendel_Kurz.Stop();
            if (Task_Pendel_Lang != null) Task_Pendel_Lang.Stop();
            startMessung();
            _microTimer.Start();
            writesinglechannel.WriteSingleSample(true, 0.0);
            rBCartSilver.Enabled = false;
            rBcartBlack.Enabled = false;
            rBEinfachPendel.Enabled = false;
            rBDoppelPendel.Enabled = false;
        }

        private void btStopp_Click(object sender, EventArgs e)
        {
            ao0Value = 0.0;
            writesinglechannel.WriteSingleSample(true, ao0Value);
            _microTimer.Stop();
            Wagen_I_Out = 0;
            Wagen_I_Out_n_1 = 0;
            if (Task_Wagen != null) Task_Wagen.Stop();
            if (Task_Pendel_Kurz != null) Task_Pendel_Kurz.Stop();
            if (Task_Pendel_Lang != null) Task_Pendel_Lang.Stop();
            rBCartSilver.Enabled = true;
            rBcartBlack.Enabled = true;
            rBEinfachPendel.Enabled = true;
            rBDoppelPendel.Enabled = true;
        }

        private void NOTStopp(object sender, EventArgs e)
        {
            ao0Value = 0.0;
            writesinglechannel.WriteSingleSample(true, ao0Value);
            _microTimer.Stop();
            Wagen_I_Out = 0;
            Wagen_I_Out_n_1 = 0;
            if (Task_Wagen != null) Task_Wagen.Stop();
            if (Task_Pendel_Kurz != null) Task_Pendel_Kurz.Stop();
            if (Task_Pendel_Lang != null) Task_Pendel_Lang.Stop();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            _microTimer.Stop();
            timer1.Enabled = false;
            if (analogOutTask != null) analogOutTask.Stop();
            if (Task_Wagen != null) Task_Wagen.Stop();
            if (Task_Pendel_Kurz != null) Task_Pendel_Kurz.Stop();
            if (Task_Pendel_Lang != null) Task_Pendel_Lang.Stop();
            this.Hide();
        }
    }
}
