﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;
using System.IO; // for stopwatch

namespace WINDF7CSharp.Hardwaretools
{
    public partial class FormHardwareSimul : Form
    {
        FormMain meinMain;
        private readonly MicroLibrary.MicroTimer _microTimer;

        public FormHardwareSimul(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(EventVomMMTimer);
            //       --> less CPU load
            _microTimer.Interval = 10000;                 // --> 10ms interval
            stopwatch.Start();

        }
        private void FormHardwareSimul_Load(object sender, EventArgs e)
        {
            syncCheck();
            tabControl1.SelectedTab = tabPageSimProc;
            butCalcFz_Click(null, null);
        }

        double dacVal0 = 0, dacVal1 = 0, dacvalx=0;
        double FilterOut = 0;
        double OutToAdc = 0;
        int _mgradcd;

        public const int max2n = 40;            //{ a,b of HF(z) }
        double[] tetacd = new double[max2n];
        double[] KT = new double[13];
        double[] delay = new double[101];  // Shift register for delay
        int processmodel = 0;
        double DeadZone = 0;
        string ThereisnoFilter = "There is no Filter";
        string idealAlgTogettherwithbo = "Ideal controller together with bo wont work";
        string processinput = "Process input ";
        string processoutput = "Process output ";


        // Digital realtime Filter  
        double sum = 0;
        double limit=10;
        const int maxgrad = 20;
        private double[] Dxein = new double[maxgrad];
        private double[] Dxout = new double[maxgrad];
        private double[] DF1 = new double[maxgrad];
        private double[] DF2 = new double[maxgrad];
        // 
        Stopwatch stopwatch = new Stopwatch();
        double stoptm, timeAvr = 0;

        double starttmMM, stoptmMM, timeAvrMM = 0, TimeMin = 0;
        int cntMM = 1,t1cnt=0;
        Random NoiseGen = new Random();

        private double tempNonlin(double x)
        {
            double a = 0.0024236199095019,
              b = 0.29910960304402,
              c = 0.077963703757021,
              d = 0.12457307178116,
              e = -0.029019098793364,
              f = 0.0021978619909503,
              g = -5.4960784313727E-05;
            // out = a+bx +cx^2 +dx^3 ...
            if (x < 0) x = 0;  // Limiter
            if (x > 10) x = 10;
            double y = g * x + f;
            y = y * x + e;
            y = y * x + d;
            y = y * x + c;
            y = y * x + b;
            y = y * x + a;
            return (y);
        }



        //  Connection to control applications
        //  Manual:
        //  outputSimul() --> ProgressBar      Trackbar  --> inputSimul()
        //  Simulated process:
        //  outputSimul() --> Digital Filter  --> inputSimul()

        public void outputSimul(short chan, double val)//range -10 till +10 Volt
        {
            // The Values sent to a DACs are displayed in  progress Bars
            // these Values -val - are coming from controller
            if (chan == 0) dacVal0 = val;
            if (chan == 1) dacVal1 = val;
            // dacvalx goes to the Simulator Filter input
            dacvalx = val; // independant of chan
            if (cBPowerNonLin.Checked) dacvalx= tempNonlin(dacvalx);  // Nonlinearity of Phase angle modulator in Power actuator
             
             // Test linearisierung
             //dacvalx = meinMain.frmadaptcon.templin(dacvalx);
        }

        double tbValue1, tbValue2;

        public void inputSimul(short chan, ref double val)
        {
            if (tabControl1.SelectedIndex == 0)
            // The values coming from the ADCs can be manually set with Trackbars
            // These values val are going to the controller
            {
                if (chan == 0) val = tbValue1;
                if (chan == 1) val = tbValue2;
                OutToAdc = tbValue1;  // display StatusBar
            }
            else
            {   // process simulation
                if (cBSync.Checked)
                {
                    Filterstep();
                }
                val = FilterOut;
                OutToAdc = FilterOut; // display StatusBar
            }
        }

        private void FormHardwareSimul_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        public void deutsch()
        {
            ThereisnoFilter = "Es gibt kein Filter";
            idealAlgTogettherwithbo = "Idealer Reglerzusammen mit bo geht leider nicht";
            processinput = "Strecke Eingang ";
            processoutput = "Strecke Ausgang ";
            tabPageManCon.Text = "Manuell";
            tabPageSimProc.Text = "Simulierte Strecke";
            gBmanual.Text = "Manueller Test";
            gBSimulProc.Text = "Simulierte Strecke, DAx ist Eingang, ADx ist Ausgang";
            groupBoxKT.Text = "Definiere K/T";
            groupBoxFz.Text = "Berechnetes F(z)";
            gBLimit.Text = "Begrenzung";
            cBLimit.Text = "Aktivieren";
            cBSync.Text = "Synchron mit Regler";
            labelDuration.Text = "Mittlere Dauer: ";
            labelMinDur.Text = "kleinste Dauer:";
            toolTip1.SetToolTip(butWriteToProcess, "Aktiviere geänderte Daten");
            butWriteToProcess.Text = "Schreibe zur Strecke";
            butCopyFromDF.Text = "Hole aus Digitalen Filter";
            toolTip1.SetToolTip(Btofz,"Speichere F(z) in eine *.fz- Datei");
            toolTip1.SetToolTip(Bfztodf,"Lade *.fz- Datei und ggf errechne die K-T- Werte");
            butCalcFz.Text="Berechne Fz";
            label4.Text = "Rauschen in mV";
            cBAutoConvert.Text = "Auto. Konvert in PTx";
            cBPowerNonLin.Text = "Aktiviere Aktuatornichtlinearität";
            labAddDC.Text = "Zusätzlicher Offset";
            Ldegree.Text = "Grad von F(z)";
        }


        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            tbValue1 = trackBar1.Value / 10.0;
            OutToAdc = tbValue1;
        }

        private void trackBar2_ValueChanged(object sender, EventArgs e)
        {
            tbValue2 = trackBar2.Value / 10.0;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {   // Display each 100ms
            t1cnt++;
            if (dacVal0 > 10) dacVal0 = 10;
            if (dacVal0 < -10) dacVal0 = -10;
            progressBar1.Value = (int)(5 * (dacVal0 + 10));
            labelValADC0.Text = tbValue1.ToString("F2");
            if (dacVal1 > 10) dacVal1 = 10;
            if (dacVal1 < -10) dacVal1 = -10;
            progressBar2.Value = (int)(5 * (dacVal1 + 10));
            labelValADC1.Text = tbValue2.ToString("F2");
            labelValDAC0.Text = dacVal0.ToString("F2");
            labelValDAC1.Text = dacVal1.ToString("F2");
            tSLab1.Text = processinput + dacVal0.ToString("F2") + processoutput + OutToAdc.ToString("F2")+ "  "+(t1cnt/10).ToString();
            if (cntMM > 0)
            {
                labelPeriod.Text = (timeAvrMM / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                labelDurationTime.Text = (timeAvr / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                labelMinDurNb.Text = (TimeMin / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                timeAvrMM = 0;
                timeAvr = 0;
                cntMM = 0;
                TimeMin = 1e10;
            }

        }



        private void FormHardwareSimul_VisibleChanged(object sender, EventArgs e)
        {
            timer1.Enabled = this.Visible; //only running if Form is visible
        }

        private void rBmanual_CheckedChanged(object sender, EventArgs e)
        {
        }

        void tetatocell()
        {
            int i;
            dataGridView1.RowCount = 0;
            dataGridView1.Rows.Add("1", tetacd[_mgradcd + 1].ToString("G8")); /*b0*/
            dataGridView1.Rows[0].HeaderCell.Value = "0";
            for (i = 1; i <= _mgradcd; i++)
            {
                dataGridView1.Rows.Add(tetacd[i].ToString("G8"), tetacd[_mgradcd + 1 + i].ToString("G8")); /*bi*/
                dataGridView1.Rows[i].HeaderCell.Value = i.ToString();
            } /*for (*/


        }

        void T1T2Visible(bool on)
        {

            lpar2.Visible = on;
           
            par2.Visible = on;
            par3.Visible = on;
            if (rBPT3.Checked && on)
            {
                lpar4.Visible = on;
                par4.Visible = on;
            }
            else
            {
                lpar4.Visible = false;
                par4.Visible = false;
            }
            if (rBPT4.Checked && on)
            {
                lpar4.Visible = on;
                par4.Visible = on;
                lpar5.Visible = on;
                par5.Visible = on;
            }
            else
            {
                //lpar4.Visible = false;
                //par4.Visible = false;
                lpar5.Visible = false;
                par5.Visible = false;
            }

            BitBtnt1down.Visible = on;
            BitBtnt1minus.Visible = on;
            BitBtnt1up.Visible = on;
            butCalcFz.Visible = on;
            lpar3.Visible = on;
            par3.Visible = on;
            BitBtnt2up.Visible = on;
            BitBtnt2down.Visible = on;

            if (rBPT1.Checked)
            {
                lpar3.Visible = false;
                par3.Visible = false;
                BitBtnt2up.Visible = false;
                BitBtnt2down.Visible = false;

            }
        }

        private void butCalcFz_Click(object sender, EventArgs e)
        {
            if (rB2PT1.Checked)
            {
                processmodel = 0;
                _mgradcd = 2;
                meinMain.ConvertToDouble(par3.Text,ref KT[2]  );
            }
            if (rBIT1.Checked)
            {
                processmodel = 1;
                _mgradcd = 2;
                meinMain.ConvertToDouble(par3.Text, ref DeadZone);
                KT[2] = 0;
            }
            else DeadZone = 0;
            if (rBPT1.Checked)
            {
                processmodel = 2;
                KT[2] = 0;
                _mgradcd = 1;
            }
            if (rBPT2.Checked)
            {
                processmodel = 3;
                meinMain.ConvertToDouble(par3.Text,ref KT[2] );
                _mgradcd = 2;
            }
            if (rBPT4.Checked)
            {
                processmodel = 5;
                meinMain.ConvertToDouble(par3.Text, ref KT[2]);
                meinMain.ConvertToDouble(par4.Text, ref KT[4]);
                meinMain.ConvertToDouble(par5.Text, ref KT[5]);
                _mgradcd = 4;
            }
            if (rBPT3.Checked)
            {
                processmodel = 4;
                meinMain.ConvertToDouble(par3.Text, ref KT[2]);
                meinMain.ConvertToDouble(par4.Text, ref KT[4]);
                _mgradcd = 3;
            }
            if (!rBFz.Checked)
            {
                meinMain.ConvertToDouble(par1.Text,ref KT[0] );
                meinMain.ConvertToDouble(par2.Text,ref KT[1] );
                meinMain.ConvertToDouble(SpEdpT0.Text, ref KT[3]);
                KT[3] = KT[3] *1e-3;
                meinMain.datatools.kttoteta(processmodel, KT, ref tetacd);
                this.degreen.Value = _mgradcd;
                tetatocell();
                T1T2Visible( true);
                butCopyFromDF.Visible = false;
                degreen.Enabled = false;
            }
            for (int i = 0; i < maxgrad; i++)
            {
                DF1[i] = 0;
                DF2[i] = 0;
            }

            ReadDataGridToFilter();

        }

        public void initFilter()
        {
            // Clear Filter Array
            for (int i = 0; i < Dxein.Length; i++)
            {
                Dxein[i] = 0;
                Dxout[i] = 0;
            }
            sum = 0;
            for (int id = 0; id < delay.Length; id++) delay[id] = 0;

        }

        private void rB2PT1_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "T1";
            lpar3.Text = "T2";
            lpar3.Visible = true;
            lpar4.Visible = false;
            par4.Visible = false;
            par3.Visible = true;
        }


        private void rBPT1_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "T1";
            lpar3.Text = "";
            par3.Visible = false;
            lpar4.Visible = false;
            par4.Visible = false;
            BitBtnt2down.Visible = false;
            BitBtnt2up.Visible = false;
        }

        private void rBIT1_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "T1";
            lpar3.Text = "DZ";  //Dead Zone
            par3.Visible = true;
            lpar4.Visible = false;
            par4.Visible = false;
        }

        private void rBPT2_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "d";
            lpar3.Text = "wo";
            par3.Visible = true;
            lpar4.Visible = false;
            par4.Visible = false;

        }

        private void rBFz_Click(object sender, EventArgs e)
        {
            T1T2Visible( false);
            butCopyFromDF.Visible = true;
            degreen.Enabled = true;
        }

        private void rBPT3_CheckedChanged(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "T1";
            lpar3.Text = "T2";
            lpar3.Visible = true;
            par3.Visible = true;
            lpar4.Visible = true;
            par4.Visible = true;

        }

        private void rBPT4_CheckedChanged(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "T1";
            lpar3.Text = "T2";
            lpar3.Visible = true;
            par3.Visible = true;
            lpar4.Visible = true;
            par4.Visible = true;
            lpar5.Visible = true;
            par5.Visible = true;

        }

        private void Bkup_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par1.Text, ref help);
            par1.Text = (help * 2.0).ToString("G8");
            if (rBFz.Checked)  // alle bi *2
                for (int i = 1; i <= degreen.Value; i++)
                {
                    meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[1].Value.ToString(), ref help);//bi 
                    help = help * 2;
                    dataGridView1.Rows[i].Cells[1].Value = help.ToString();
                }

            butCalcFz_Click(sender, e);
        }

        private void Bkdown_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par1.Text, ref help);
            par1.Text = (help / 2.0).ToString("G8");
            if (rBFz.Checked)  // alle bi *2
                for (int i = 1; i <= degreen.Value; i++)
                {
                    meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[1].Value.ToString(), ref help);//bi 
                    help = help / 2.0;
                    dataGridView1.Rows[i].Cells[1].Value = help.ToString();
                }
            butCalcFz_Click(sender, e);
        }

        private void BitBtnkminus_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par1.Text, ref help);
            par1.Text = (-help).ToString("G8");
            if (rBFz.Checked)  // alle bi *2
                for (int i = 1; i <= degreen.Value; i++)
                {
                    meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[1].Value.ToString(), ref help);//bi 
                    help = help * (-1);
                    dataGridView1.Rows[i].Cells[1].Value = help.ToString();
                }

            butCalcFz_Click(sender, e);
        }

        private void BitBtnt1up_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par2.Text, ref help);
            par2.Text = (help * 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt1down_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par2.Text, ref help);
            par2.Text = (help / 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt1minus_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par2.Text, ref help);
            par2.Text = (-help).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt2up_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par3.Text, ref help);
            par3.Text = (help * 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt2down_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par3.Text, ref help);
            par3.Text = (help / 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void SpEdpT0_ValueChanged(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
           
            meinMain.frmadaptcon.numTimeInterval.Value = SpEdpT0.Value;
        }

        private void tabControl1_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
        }

        private void butCopyFromDF_Click(object sender, EventArgs e)
        {
            if (meinMain.fdigfilt.Dmgrad == 0)
                MessageBox.Show(ThereisnoFilter);
            else
            {
                degreen.Value = meinMain.fdigfilt.Dmgrad;

                for (int i = 0; i <= degreen.Value; i++)
                { // copy datagrid
                    dataGridView1.Rows[i].Cells[0].Value = meinMain.fdigfilt.dataGridView1.Rows[i].Cells[1].Value;
                    dataGridView1.Rows[i].Cells[1].Value = meinMain.fdigfilt.dataGridView1.Rows[i].Cells[2].Value;
                }
            }
        }

        private void degreen_ValueChanged(object sender, EventArgs e)
        {
            dataGridView1.RowCount = (int)degreen.Value + 1;
            for (int i = 0; i <= degreen.Value; i++)
            {
                dataGridView1.Rows[i].HeaderCell.Value = (i).ToString();
            }
        }

        private void ReadDataGridToFilter()
        {
            meinMain.ConvertToDouble(dataGridView1.Rows[0].Cells[1].Value.ToString(),ref DF2[0] );//bo 
            for (int i = 1; i <= degreen.Value; i++)
            {
                meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[0].Value.ToString(),ref DF1[i] );//ai 
                meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[1].Value.ToString(),ref DF2[i] );//bi 
            }
            butWriteToProcess.Visible = false;
        }



        private void Filterstep()
        {
            int i = 0;
            int Dmgrad = (int)degreen.Value;

            // Now filter calculation
            for (i = Dmgrad + 1; i >= 2; i--)    /* shifting */
            {
                Dxout[i] = Dxout[i - 1];
                Dxein[i] = Dxein[i - 1];
            }
            Dxout[1] = sum; sum = 0;


            Dxein[1] = dacvalx; // Filter Input from Output function
            if (Math.Abs(dacvalx) < DeadZone)
                Dxein[1] = 0;

            if (rbIdeal.Checked)
            {  // if ideal alg
                sum = DF2[1] * Dxein[1];      /* ignore bo */
                for (i = 1; i <= Dmgrad; i++)
                {
                    sum = sum - DF1[i] * Dxout[i];      /*-ai*old outputs */
                    sum = sum + DF2[i + 1] * Dxein[i + 1];    /*+bi*inputs */
                }
            }
            else
            {  // if real alg
                sum = DF2[0] * Dxein[1];      /* b0*xein(n) */
                for (i = 1; i <= Dmgrad; i++)
                {
                    sum = sum - DF1[i] * Dxout[i];      /*-ai*old outputs */
                    sum = sum + DF2[i] * Dxein[i + 1];    /*+bi*inputs */
                }
            }

            // limitation   
            if (cBLimit.Checked)
            {
                if (sum > limit) sum = limit;
                if (sum < -limit) sum = -limit;
            }
            // Shifting for delay
            for (int id = delay.Length - 1; id > 0; id--)
                delay[id] = delay[id - 1];
            delay[0] = sum;
            int indexout = (int)nuDDelay.Value;
            FilterOut = delay[indexout] + noise * (NoiseGen.Next(1000) - 500)/ 1000.0 / 1000.0+offset;  // Signal out to Input function, noise in mV
        }

        void EventVomMMTimer(object sender, MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {
            double duration;
            starttmMM = stoptmMM;
            stoptmMM = stopwatch.ElapsedTicks;
            timeAvrMM += (stoptmMM - starttmMM);  // Period
            cntMM++;

            Filterstep();

            stoptm = stopwatch.ElapsedTicks;
            duration = stoptm - stoptmMM;// Duration
            timeAvr += duration;
            if (duration < TimeMin) TimeMin = duration; // look for minimal duration time
        }

        private void butStart_Click(object sender, EventArgs e)
        {

            _microTimer.Interval = (long)SpEdpT0.Value*1000;
            butStart.Enabled = false;
            butStop.Enabled = true;
            for (int i = 0; i < DF1.Length; i++)
            {
                DF1[i] = 0;
                DF2[i] = 0;
            }

            ReadDataGridToFilter();
            initFilter();
            _microTimer.Start();
        }

        private void butStop_Click(object sender, EventArgs e)
        {
            butStart.Enabled = true;
            butStop.Enabled = false;
            _microTimer.Stop();
        }

        private void cBLimit_CheckedChanged(object sender, EventArgs e)
        {
            if (cBLimit.Checked)
            {
                tBLimit.Visible = true;
                labelLimit.Visible = true;
                meinMain.ConvertToDouble(tBLimit.Text,ref limit );
            }
            else
            {
                tBLimit.Visible = false;
                labelLimit.Visible = false;
            }
        }


        private void syncCheck()
        {
            if (cBSync.Checked)
            {
                gBTiming.Visible = false;
                object sd =new object();
                EventArgs weg =new EventArgs();
                butStop_Click(sd, weg);
                //SpEdpT0.Value = meinMain.frmStudContr.numTimeInterval.Value;
                if (rbIdeal.Checked && (DF2[0] != 0))
                    MessageBox.Show(idealAlgTogettherwithbo);
            }
            else
            {
                gBTiming.Visible = true;
            }
        }

        private void cBSync_CheckedChanged(object sender, EventArgs e)
        {
            syncCheck();
        }


        private void dataGridView1_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            butWriteToProcess.Visible = true;
        }

        double offset = 0;

        private void but0V_Click(object sender, EventArgs e)
        {
            trackBar3.Value = 0;
        }

        private void butAny_Click(object sender, EventArgs e)
        {
            trackBar3.Value =(int) nuDAny.Value * 10;
        }

        private void trackBar3_ValueChanged(object sender, EventArgs e)
        {
            labAddDC.Text = (trackBar3.Value / 10.0).ToString("f1");
            offset = trackBar3.Value / 10.0;
         }

        private void butWriteToProcess_Click(object sender, EventArgs e)
        {
            ReadDataGridToFilter();
            butWriteToProcess.Visible = false;
        }

        private void tBLimit_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(tBLimit.Text,ref limit );
        }

        private void tBLimit_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar==0x0d) tBLimit_Leave( sender,  e);
        }

        private void Btofz_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                if (rBPT3.Checked)
                    tBcomment.Text = "3PT1 " + par1.Text + " " + par2.Text + " " + par3.Text + " " + par4.Text;
                if (rBPT4.Checked)
                    tBcomment.Text = "4PT1 " + par1.Text + " " + par2.Text + " " + par3.Text + " " + par4.Text + " " + par5.Text;
                pList.Add(tBcomment.Text);
                pList.Add(degreen.Value.ToString());
                
                for (int i = 1; i <= degreen.Value+1; i++)
                {
                    pList.Add(dataGridView1.Rows[i - 1].Cells[0].Value + " "
                        + dataGridView1.Rows[i - 1].Cells[1].Value);
                }
                double t0help=0;
                meinMain.ConvertToDouble(SpEdpT0.Text, ref t0help);
                pList.Add((t0help / 1000.0).ToString());  // in edto in msec, in file in sec
                pList.Add(nuDDelay.Value.ToString());  // integer delay n*T0
                pList.Add("0"); // no continuous delay

                System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialog1.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
            }

        }

        private void Bfztodf_Click(object sender, EventArgs e)
        {
            // Load *fz file, fill datastringgrid and try to convert into Pt1, It1 or 2PT1
            List<String> pList = new List<String>();
            double t0=0;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                StreamReader filestream = new StreamReader(openFileDialog1.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    if (line != null)
                    {
                        pList.Add(line);
                    }
                }
                filestream.Close();
                //copyList2DigitalFilterForm(pList);   copy from DigitalFilter
                int i;
                int len = pList.Count;
                string[] outstr = new string[10];
                tBcomment.Text = pList[0];
                if (tBcomment.Text.Length > 0)
                {
                    tBcomment.Visible = true;
                    if (tBcomment.Text.Length > 3 && cBAutoConvert.Checked)
                        if (tBcomment.Text.Substring(0, 4) == "3PT1" || tBcomment.Text.Substring(0, 4) == "4PT1")
                        {
                            meinMain.datatools.Str2NString(pList[0], ref outstr, ' ');
                            par1.Text = outstr[1];
                            par2.Text = outstr[2];
                            par3.Text = outstr[3];
                            par4.Text = outstr[4];
                            rBPT3.Checked = true;
                            if (tBcomment.Text.Substring(0, 4) == "4PT1")
                            {
                                par5.Text = outstr[5];
                                rBPT4.Checked = true;
                                rBPT4_CheckedChanged(null, null);
                            }
                            else
                            {
                                rBPT3.Checked = true;
                                rBPT3_CheckedChanged(null, null);
                            }
                        }
                        else rBFz.Checked = true;  // switch to Fz
                }
                int Dmgrad = Convert.ToInt32(pList[1]);
                degreen.Value = Dmgrad;

                tetacd.Initialize();
                if ((Dmgrad + 4) > len) MessageBox.Show(meinMain.fdigfilt.wrongfileformat);
                else
                {
                    meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');  // a0, b0
                    dataGridView1.Rows[0].Cells[0].Value = outstr[0];  //a0
                    dataGridView1.Rows[0].Cells[1].Value = outstr[1] ;  //a0

                    meinMain.ConvertToDouble(outstr[1],ref tetacd[Dmgrad + 1] );  // b0

                    for (i = 3; i <= (Dmgrad + 2); i++)
                    {
                        meinMain.datatools.Str2NString(pList[i], ref outstr, ' ');
                        dataGridView1.Rows[i - 2].Cells[0].Value = outstr[0];
                        meinMain.ConvertToDouble(outstr[0],ref tetacd[i - 2] );  //ai
                        dataGridView1.Rows[i - 2].Cells[1].Value = outstr[1] ;
                        meinMain.ConvertToDouble(outstr[1],ref tetacd[i - 1 + Dmgrad] );  //bi
                    }
                    meinMain.ConvertToDouble(pList[i],ref t0 );
                    if (len > i + 1)  // some files contains  continuous delay
                         if (pList[i + 1] != "") nuDDelay.Value = Convert.ToInt32(pList[i + 1]);
                }
                if (Dmgrad < 3 && cBAutoConvert.Checked)  // recalculation only if cbAutoConvert is checked
                {  // K und T berechnen, geht nur in 1. und 2. Ordnung
                    double _K = 0, _T1 = 0, _T2 = 0;
                    string Typ = "", error = "";
                    meinMain.datatools.kt_aus_tetab0(ref _K, ref _T1, ref _T2, t0, tetacd, Dmgrad, ref Typ, ref error);
                    labelType.Text = "Type=  " + Typ;
                    par1.Text = _K.ToString("G8");
                    if (_T2 > _T1)
                    {
                        par3.Text = _T1.ToString("G8");
                        par2.Text = _T2.ToString("G8");
                    }
                    else
                    {
                        par2.Text = _T1.ToString("G8");
                        par3.Text = _T2.ToString("G8");
                    }
 

                    if (Typ == "PT1")
                    {
                        rBPT1.Checked = true;
                        rBPT1_Click(sender, e);
                    }
                    else if (Typ == "2PT1")
                    {
                        rB2PT1.Checked = true;
                        rB2PT1_Click(sender, e);
                    }
                    else if (Typ == "IT1")
                    {
                        rBIT1.Checked = true;
                        rBIT1_Click(sender, e);
                    }
                    else if (Typ == "PT2")
                    {
                        rBPT2.Checked = true;
                        rBPT2_Click(sender, e);
                    }
                    else rBFz.Checked = true;  // switch to Fz
                }
                else ReadDataGridToFilter();
                SpEdpT0.Text = (t0 * 1000).ToString("G16");  // in edt0 in msec, in File in sec

            }

        }
        double noise = 0;

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(textBox1.Text, ref noise);
        }

        private void buttonClearFilter_Click(object sender, EventArgs e)
        {
            initFilter();
        }

 
 
 
 
    }
}
