﻿
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Diagnostics;// if using dll

namespace WINDF7CSharp
{
    public partial class FormME2600 : Form
    {

        FormMain meinmain;
        Stopwatch stw = new Stopwatch(); 


        public FormME2600(FormMain m)
        {
            InitializeComponent();
            meinmain = m;
            stw.Start();
        }
        [DllImport("ME2600.DLL")]
        public extern static int me2600AOSetMode(int iBoardNumber, int iChannel, int iRange, int iMode);

        [DllImport("ME2600.DLL")]
        // original C++: int me2600AOSingle (int iBoardNumber, int iChannel, short iValue);
        public extern static int me2600AOSingle (int iBoardNumber, int iChannel, short iValue);

        [DllImport("ME2600.DLL")]
        // original :int me2600AISingle(int iBoardNumber, int iChannel, int iMode, short* iValue);
        public extern static int me2600AISingle(int iBoardNumber, int iChannel, int iMode, ref short iValue);

        [DllImport("ME2600.DLL")]
        public extern static int me2600Initialize(int Boardnb);

        [DllImport("ME2600.DLL")]
        public extern static int me2600GetDLLVersion();

          [DllImport("ME2600.DLL")]
        public extern static int me2600GetSerialNumber(int bnb, out int Sernb);

        private void buttonInit_Click(object sender, EventArgs e)
        {
            int ex;
            ex=me2600Initialize(0);
            if (ex == 1) label1.Text = "OK"; else label1.Text = "NOK";
            ex = me2600AOSetMode(0, 0, me2600Def.AO2600_MINUS_10, me2600Def.AO2600_TRANSPARENT);
            ex = me2600AOSetMode(0, 1, me2600Def.AO2600_MINUS_10, me2600Def.AO2600_TRANSPARENT);
            if (ex == 1)
            {
                label1.Text = "OK";
                int iDLLVersion = me2600GetDLLVersion();
                labelVer.Text = iDLLVersion.ToString();
                int iSerialNumber = 0;
                ex = me2600GetSerialNumber(0, out iSerialNumber);
                if (ex == 1) label1.Text = "OK"; else label1.Text = "NOK";
                labelSerNb.Text = iSerialNumber.ToString();
                timer1.Enabled = true;
                numericUpDownVolt_ValueChanged(sender, e);
                numericUpDownDACBVolt_ValueChanged(sender, e);
                meinmain.selectedADC = "ME2600";

            }
            else label1.Text = "NOK";

        }

 
        private void numericUpDownVolt_ValueChanged(object sender, EventArgs e)
        {
            short outval=(short)((int)(numericUpDownVolt.Value + 10) * 4095.0 / 20.0);
            int ex = me2600AOSingle(0, 0, outval);

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            short val=0;
            long start = stw.ElapsedTicks;
            int ex = me2600AISingle(0, 0, me2600Def.AI2600_MINUS_10 + me2600Def.AI2600_SINGLE_ENDED, ref val);
            long ende = stw.ElapsedTicks;
            tSSLabel1.Text = "ADC :" + ((ende - start) / (float)Stopwatch.Frequency * 1000.0).ToString("f3") + " ms";

            label5.Text = "AD Channel 0 =  "+((val - 2048) * 20.0 / 4096).ToString("F3") + " Volt";

            ex = me2600AISingle(0, 1, me2600Def.AI2600_MINUS_10 + me2600Def.AI2600_SINGLE_ENDED, ref val);

            label2.Text = "AD Channel 1 =  " + ((val - 2048) * 20.0 / 4096).ToString("F3") + " Volt";
            short outval = (short)((int)(numericUpDownDACBVolt.Value + 10) * 4095.0 / 20.0);
            start = stw.ElapsedTicks;
            ex = me2600AOSingle(0, 1, outval);
            ende = stw.ElapsedTicks;
            tSSLabel2.Text = "DAC :" + ((ende - start) / (float)Stopwatch.Frequency * 1000.0).ToString("f3") + " ms";

            if (this.WindowState == FormWindowState.Minimized)
            {
                rBTTOff.Checked = true;
                rBTTOff_CheckedChanged(sender, e);
            }
            // Switch off if Minimized
        }

        private void numericUpDownDACBVolt_ValueChanged(object sender, EventArgs e)
        {
            short outval = (short)((int)(numericUpDownDACBVolt.Value + 10) * 4095.0 / 20.0);
            int ex = me2600AOSingle(0, 1, outval);

        }

        private void FormME2600_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            rBTTOff.Checked = true;
            rBTTOff_CheckedChanged(sender, e);
            timer1.Enabled = false;
        }

        public void inputME(short chan, ref double val)
        {
            short valint = 0;
            int ex = me2600AISingle(0, chan, me2600Def.AI2600_MINUS_10 + me2600Def.AI2600_SINGLE_ENDED, ref valint);

            val =((valint - 2048) * 20.0 / 4096);


        }

        public void outputMe(short chan, double val)
        {
            if (val > 10) val = 10;
            if (val < -10) val = -10;
            short outval = (short)((val + 10) * 4095.0 / 20.0);
            int ex = me2600AOSingle(0, chan, outval);

        }

        private void rBTTOff_CheckedChanged(object sender, EventArgs e)
        {
            if (rBTTOff.Checked) timer1.Enabled = false;
            else timer1.Enabled = true;
        }

        private void FormME2600_VisibleChanged(object sender, EventArgs e)
        {
            if (!this.Visible) rBTTOff.Checked = true;
        }


    }
}
