﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Printing;
//using System.Windows.Forms.DataVisualization.Charting;
using NationalInstruments.VisaNS;
using System.IO;

namespace WINDF7CSharp
{

    public partial class FormRigolScope : Form
    {
        /*
        Xinc: 1/SaRate (RAW) or TimeScale/50 (NORMAL);
        Xor: relative time of the trigger points; 
        Xref: X reference; 
        Yinc: Y unit voltage;
        Yor: vertical offset relative to YREF; 
        Yref: Y reference, the middle point of the screen.
         */

        int anzahlPunkteScope = 600;
        double dbYInc, dbYOr, dbYRef, dbXInc, dbXOr, dbXRef;
        string strYInc, strYOr, strYRef, strXInc, strXOr, strXRef;
       
        string dtString;
        string points = "Points";
        string RigolInitIPtxtnotfound = "RigolInitIP.txt not found";
        string DirNotCreate = "Directory could not be created";
        string NoIPAdressstoredinregistry="No IP Adress stored in registry";
        string NoValues = "No Values to display";
   
        /*
         * hier wird die Verbindung zum Scope aufgebaut aufgebaut.
         * Im LAN-Setting-Menu des Scopes muss eine im Netzwerk freie IP4 Nummer
         * eingegeben werden. hier jetzt nur Verbindung zu "192.168.0.100"
         * möglich. im "Labor-Programm" habe ich da Auswahlmenu.
         */

        public MessageBasedSession mbSession;

        FormMain meinMain;

        private void butRemote_Click(object sender, EventArgs e)
        {
            mbSession.Write(":KEY:LOCK DIS");
        }

        FormRigolSreenShot frmScreenshot;
        

        public FormRigolScope(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            frmScreenshot = new FormRigolSreenShot(this);
 
        }

        
        public void deutsch()
        {
            points = "Punkte";
            butConnect.Text = "Mit Scope verbinden";
            btWerte_holen.Text = "Werte vom Scope holen";
            btWerteDarstellen.Text = "Werte im Chart darstellen";
            RigolInitIPtxtnotfound = "RigolInitIP.txt wurde nicht gefunden";
            DirNotCreate = "Verzeichnis konnte nicht erstellt werden";
            NoIPAdressstoredinregistry = "Keine IP - Adresse in Registry gefunden";
            NoValues = "Keine Werte für Kurve";
        }
        
        private void butConnect_Click(object sender, EventArgs e)
        {
            try
            {
                string IP = comboBox1.Text;
                mbSession = (MessageBasedSession)ResourceManager.GetLocalManager().Open("TCPIP0::" + IP + "::INSTR");
                //*************** ab hier ist Neu
                mbSession.Write(":KEY:LOCK DIS");
                //       bis hier *******************
                btWerte_holen.Enabled = true;
                butOpenprintScreen.Enabled = true;
                butDisconnect.Enabled = true;
                butRemote.Enabled = true;
                butConnect.Enabled = false;
                tBRigol.Text = mbSession.LastStatus.ToString();
            }
            catch (InvalidCastException)
            {
                MessageBox.Show("Resource selected must be a message-based session");
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }

        }



        private void btWerte_holen_Click(object sender, EventArgs e)
        {

            int k = 0;

            tBRigol.Text = "..... working";
            Application.DoEvents();

            /*
             * hier erstmal ein paar Voreinstellungen für die 
             * gewünschten Daten, wie ich gerade sehe, müsste wohl nicht jedesmal gemacht werden,
             * höchstens wenn man sicher gehen möchte , falls jemand anderes mit Zugriff zwischen-
             * zeitich die Einstellungen manipuliert hat
             * */
            try
            {
                //NORMal: Return data points currently display on the screen (600 points).
                mbSession.Write(":WAV:POIN:MODE NORM");
                // ASC: ASCii: Returns ASCII values when data ware transformed into character. 
                // BYTE or WORD: They will returns 8 bit and 16 bit values to use datum.
                // ASC liefert den "Spannungswert" Byte oder Word liefert nur den Wert des Bildschirmpunktes
                mbSession.Write(":WAV:FORM ASC");

                /*
                 * jetzt immmer das gleiche:
                 * Befehl als String zum Scope schicken
                 * Antwortstring sofort einlesen
                 * */


                mbSession.Write(":WAV:DATA? " + cBoxChannel.Text);    // Read the data from CH1.

                dtString = mbSession.ReadString();      // String einlesen
                /*
                 * in den ersten zwölf Zeichen steht stets:
                 *   #9 + Füllnullen + Anzahl Werte
                 * */
                dtString = dtString.Substring(12);      // 


                /*
                 * jetzt alle x- und y-Parameter als String holen
                 * und in Byte wandeln
                 * */

                mbSession.Write(":WAV:YINC? " + cBoxChannel.Text);
                strYInc = mbSession.ReadString();
                dbYInc = double.Parse(strYInc, System.Globalization.CultureInfo.InvariantCulture) * 25;

                mbSession.Write(":WAV:YOR? " + cBoxChannel.Text);
                strYOr = mbSession.ReadString();
                dbYOr = double.Parse(strYOr, System.Globalization.CultureInfo.InvariantCulture);

                mbSession.Write(":WAV:YREF?");
                strYRef = mbSession.ReadString();
                dbYRef = double.Parse(strYRef, System.Globalization.CultureInfo.InvariantCulture);

                mbSession.Write(":WAV:XINC? " + cBoxChannel.Text);
                strXInc = mbSession.ReadString();
                dbXInc = double.Parse(strXInc, System.Globalization.CultureInfo.InvariantCulture);

                mbSession.Write(":WAV:XOR? " + cBoxChannel.Text);
                strXOr = mbSession.ReadString();
                dbXOr = double.Parse(strXOr, System.Globalization.CultureInfo.InvariantCulture);
                dbXOr = Math.Round(dbXOr / dbXInc) * dbXInc;

                mbSession.Write(":WAV:XREF?");
                // strXRef = mbSession.ReadString();
                // dbXRef = double.Parse(strXRef, System.Globalization.CultureInfo.InvariantCulture);
                // oder gleich so, spart ne Zeile und vllt Verwirrung
                dbXRef = double.Parse(mbSession.ReadString(), System.Globalization.CultureInfo.InvariantCulture);
                // oder so, ich glauch dann gabs aber irgendwann mal Probleme
                //       dbXRef = Convert.ToDouble(mbSession.ReadString());

                /*
                 * zur Sicherheit das Scope von Remote-Mode
                 * in Local-Mode zurückstellen, ansonsten läßt es sich jetzt nicht mehr
                 * an den Knöppen bedienen
                 * */
                mbSession.Write(":KEY:LOCK DIS");


                /*
                 * so, jetzt Werte vom langen String in die Textbox eintüten
                 * */
                tBRigol.Visible = false;
                tBRigol.Clear();
                double xwert = 0;
                for (int i = 0; i < anzahlPunkteScope; i++)
                {
                    xwert = (dbXInc * i) + dbXOr;
                    tBRigol.AppendText(xwert.ToString() + " " + dtString.Substring(k, 13) + "\r\n");
                    //dbBufferY[i] = double.Parse(dtString.Substring(k, 13), System.Globalization.CultureInfo.InvariantCulture);
                    k = k + 15;
                    //dbBufferX[i] = ((dbXInc * i) + dbXOr);
                }
                tBRigol.Visible = true;

                btWerteDarstellen.Enabled = true;
            }


            catch (Exception exp)
            {
                //*************** ab hier ist Neu
                MessageBox.Show("Keine Werte für :  " + cBoxChannel.Text);
                string dummy =(exp.Message);
                //       bis hier *******************
            }
        }

        public void btWerteDarstellen_Click(object sender, EventArgs e)
        {
            if (tBRigol.Lines.Length > 5)
            {
                LoadOpt LOa = new LoadOpt();
                LOa.init();
                LOa.XaxisLog = false;
                LOa.toptitle = "Rigol Scope curve  " + tBRigol.Lines.Length.ToString() + "  " + points;
                //LOa.bottomtitle = "<------     w=10^x     ---->";
                LOa.legend = "Scope";
                int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, tBRigol, ref meinMain.minmaxMain, LOa);
                meinMain.enableCurveButtons();
                if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
                else
                {
                    meinMain.enableCurveButtons();
                    meinMain.ToolButton27ScopeF.Enabled = true;
                    meinMain.BringToFront();
                }
            }
            else
                MessageBox.Show( NoValues);

         }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
 //               mbSession.Dispose();
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }
            e.Cancel = true;
            this.Hide();
            // Save der letzten IP- Einstellung

            TestRegistry.RegistryUtils.WriteValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, textBoxKey.Text, "IP-Adress", comboBox1.Text, true);
        }

        private void FormRigolScope_Load(object sender, EventArgs e)
        {
            object inRV = TestRegistry.RegistryUtils.ReadValue(TestRegistry.RegistryRootKeys.HKEY_CURRENT_USER, textBoxKey.Text, "IP-Adress", null);
            if (inRV != null)
                comboBox1.Text = inRV.ToString();
            else
                MessageBox.Show(NoIPAdressstoredinregistry);

        }

        private void butOpenprintScreen_Click(object sender, EventArgs e)
        {
            //*************** ab hier ist Neu
            frmScreenshot.Location = new Point(950, 450);
            frmScreenshot.StartPosition = FormStartPosition.Manual;
            //       bis hier *******************
            frmScreenshot.Show();
            
        }

        private void butDisconnect_Click(object sender, EventArgs e)
        {
            try
            {
                mbSession.Dispose();
                tBRigol.AppendText("\r\n  Disconnected \r\n");

                btWerte_holen.Enabled = false;
                butOpenprintScreen.Enabled = false;
                butDisconnect.Enabled = false;
                butRemote.Enabled = false;
                butConnect.Enabled = true;

            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);

            }
 
        }

        

        

      
    }
}

       
