﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Printing;
using System.Windows.Forms.DataVisualization.Charting;
using NationalInstruments.VisaNS;
using System.IO;
using System.Reflection;

namespace WINDF7CSharp
{

    public partial class FormRigolSreenShot : Form
    {    
        
        PrintDocument page = new PrintDocument();
        LegendItem legendTimeScale = new LegendItem();
        LegendItem legendTriggerLevel = new LegendItem();

        FormRigolScope back;
       
        double [] dbYInc = new  double [5];
        double[] dbYOr = new double[5];
        string[] strCoupMode = new string[5];
        double dbXInc, dbXOr, dbTimeBaseScale, dbTrigEdgeLev;
        string strYInc, strYOr, strMATHInc, strMATHOr, strXInc, strXOr, strTimeBaseScale, strTrigEdgeSour, strTrigEdgeLev, strTrigEdgeSlop, strTrigPulseMod;
        double[] dbBufferX = new double[600];
        byte [][] btWavChannel = new byte [5][];
        int [] intChanDisp = new int[10];
        string[] Channels = { "Channel 1", "Channel 2", "Channel 3", "Channel 4", "MATH", "Position 1", "Position 2", "Position 3", "Position 4", "Pos MATH" };
        string TrigModus;
               
        public FormRigolSreenShot(FormRigolScope m)
        {   
            InitializeComponent();
            back = m;

        }

        private void FormRigolSreenShot_Load(object sender, EventArgs e)
        {

            if (back.cBPreview.Checked == false) this.Size = new System.Drawing.Size(200, 100);
            chart1.ChartAreas[0].AxisY.LabelStyle.ForeColor = Color.Transparent;
            chart1.ChartAreas[0].AxisX.LabelStyle.ForeColor = Color.Transparent;
            chart1.ChartAreas[0].AxisY.Maximum = 200;
            chart1.ChartAreas[0].AxisY.Minimum = 0;
            chart1.ChartAreas[0].AxisY.Interval = 25;
            chart1.Legends[0].CustomItems.Add(legendTimeScale);
            legendTimeScale.BorderColor = Color.Transparent;
            legendTimeScale.Color = Color.Transparent;
            chart1.Legends[0].CustomItems.Add(legendTriggerLevel);
            legendTriggerLevel.BorderColor = Color.Transparent;
            legendTriggerLevel.Color = Color.Transparent;

        }


        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                back.mbSession.Write(":TRIG:MODE?");                  //  The command reads the trigger mode as EDGE, PULSe, VIDEO, ALTernation or PATTern trigger.
                TrigModus = back.mbSession.ReadString(4);             //  The query returns EDGE or PULSE, VIDEO, ALTERNATION, PATTERN.
                if (TrigModus == "VIDE") TrigModus = "VIDEO";               //  bei Video sind 5 Zeichen notwendig
                if (!(TrigModus.Substring(0, 3) == "ALT"))                  //  Ausgabe NICHT bei Alterniernder Triggerung
                {

                    back.mbSession.Write(":WAV:POIN:MODE NORM");      //  Return data points currently display on the screen (600 points).
                    back.mbSession.Write(":WAV:FORM BYTE");           //  They will returns 8 bit values to use datum

                    for (int i = 0; i < 10; i++) { intChanDisp[i] = 0; };   //  alle Merker "KanalAnzeigen" löschen

                    for (int j = 1; j < 5; j++)                             //  alle 4 möglichen ScopeKanäle abfragen ob eingeschaltet ?
                    {
                        back.mbSession.Write(":CHAN" + j.ToString() + ":DISP?");  //  The command returns 1 or 0, respectively the channel is ON or OFF.   
                        if (Convert.ToInt16(back.mbSession.ReadString()) == 1)    //  hier weiter wenn Kanal eingeschaltet
                        {
                            intChanDisp[j - 1] = 1;                                     // Merker "KanalAnzeigen" setzen für Messwerte
                            intChanDisp[j + 4] = 1;                                     // Merker "KanalAnzeigen" setzen für Nulllinie

                            //*************** ab hier ist Neu
                            try
                            {
                                //       bis hier *******************
                                back.mbSession.Write(":WAV:DATA? CHAN" + j.ToString());   //  The command reads waveform data from the specified source. <source> may be : CHANnel n
                                btWavChannel[j - 1] = back.mbSession.ReadByteArray();        //  und speichert sie im "btWavChannel-Array"
                                Array.Copy(btWavChannel[j - 1], 11, btWavChannel[j - 1], 0, 600);   //  reduktion auf 600 Messwerte, geliefert werden 612 Werte und zwar
                                //  Startblock mit 11 Werten(ASCII): 35 57 48 48 48 48 48 48 54 48 48 <--> # 9 0 0 0 0 0 0 6 0 0
                                //  -> #9 + 6Nullen + Anzahl der Messwerte und am Ende ein Endblock mit ASCII 10 = LF. 
                                back.mbSession.Write(":WAV:YINC? CHAN" + j.ToString());   //  This command queries the Y unit voltage of the specified source. Source can be: CHANnel n or MATH.
                                strYInc = back.mbSession.ReadString();                    //  The query returns Y unit voltage, and the unit is V.
                                dbYInc[j - 1] = double.Parse(strYInc, System.Globalization.CultureInfo.InvariantCulture) * 25;    // NOTE: returned value= VoltScale /25  and   String2Double

                                back.mbSession.Write(":WAV:YOR? CHAN" + j.ToString());    //  The command queries the vertical offset of specified source. Source may be CHANnel n or MATH.
                                strYOr = back.mbSession.ReadString();                     //  The query returns the value of vertical offset, and the unit is V.
                                dbYOr[j - 1] = double.Parse(strYOr, System.Globalization.CultureInfo.InvariantCulture);   // String2Double

                                back.mbSession.Write(":CHAN" + j.ToString() + ":COUP?");  //  The command sets coupling mode as DC , AC  or GND . The <n> may be 1, 2, 3 or 4.
                                strCoupMode[j - 1] = back.mbSession.ReadString();         //  The query returns AC or DC, GND.
                                //*************** ab hier ist Neu
                            }
                            catch (Exception exp)
                            {

                                MessageBox.Show("Keine Werte im Kanal Nr.:" + j.ToString(), " Kanalwahl korrekt ? ");
                                intChanDisp[j - 1] = 0;                                         // Merker "KanalAnzeigen" ZURUECKsetzen für Messwerte
                                intChanDisp[j + 4] = 0;                                         // Merker "KanalAnzeigen" ZURUECKsetzen für Nulllinie
                                string dummy = exp.Message;
                            }
                            //       bis hier *******************
                        }

                    }

                    back.mbSession.Write(":MATH:DISP?");                      //  Abfragen ob Math.. eingeschaltet ?
                    if (Convert.ToInt16(back.mbSession.ReadString()) == 1)    //  The command returns 1 or 0, respectively the math channel is ON or OFF.   
                    {
                        intChanDisp[4] = 1;                                     // Merker "KanalAnzeigen" setzen für Messwerte
                        intChanDisp[9] = 1;                                     // Merker "KanalAnzeigen" setzen für Nulllinie

                        back.mbSession.Write(":WAV:DATA? MATH");                  //  The command reads waveform data from the specified source. 
                        btWavChannel[4] = back.mbSession.ReadByteArray();         //  und speichert sie im "btWavChannel-Array"
                        Array.Copy(btWavChannel[4], 11, btWavChannel[4], 0, 600);       //  reduktion auf 600 Messwerte,

                        back.mbSession.Write(":WAV:YINC? MATH");                  //  This command queries the Y unit voltage of  MATH.
                        strMATHInc = back.mbSession.ReadString();                 //  The query returns the value of vertical offset, and the unit is V
                        dbYInc[4] = double.Parse(strMATHInc, System.Globalization.CultureInfo.InvariantCulture) * 25;   // NOTE: returned value= VoltScale /25  and   String2Double

                        back.mbSession.Write(":WAV:YOR? MATH");                   //  The command queries the vertical offset of specified source MATH.
                        strMATHOr = back.mbSession.ReadString();                  //  The query returns the value of vertical offset, and the unit is V.
                        dbYOr[4] = double.Parse(strMATHOr, System.Globalization.CultureInfo.InvariantCulture);  // String2Double

                        strCoupMode[4] = "   ";                                          //   sets coupling mode to emtpy string
                        //}
                        //catch(Exception exp)
                        //{
                        //    //MessageBox.Show("Print von FFT noch nicht möglich"); 
                        //    //MessageBox.Show(exp.Message);
                        //    //intChanDisp[4] = 0;                                              // Merker "KanalAnzeigen" löschen für Messwerte
                        //    //intChanDisp[9] = 0;                                              // Merker "KanalAnzeigen" löschen für Nulllinie
                        //}

                    }


                    back.mbSession.Write(":WAV:XINC? CHAN1");     //  The command queries the interval time between two points of the specified source CHAN 1.
                    strXInc = back.mbSession.ReadString();        //  The query returns the value of interval, and the unit is s.
                    dbXInc = double.Parse(strXInc, System.Globalization.CultureInfo.InvariantCulture);

                    back.mbSession.Write(":WAV:XOR? CHAN1");      //  The command queries the time from trigger point to XREF of the specified source. The source is CHANnel1 ．
                    strXOr = back.mbSession.ReadString();         //  The query returns the value of time and the unit is s.
                    dbXOr = double.Parse(strXOr, System.Globalization.CultureInfo.InvariantCulture);
                    dbXOr = Math.Round(dbXOr / dbXInc) * dbXInc;

                    for (int i = 0; i < 600; i++) dbBufferX[i] = ((dbXInc * i) + dbXOr);    // Zeitspalte erstellen

                    back.mbSession.Write(":TIM:SCAL?");               //  The command sets the timebase scale of main mode, and the unit is s/div.
                    strTimeBaseScale = back.mbSession.ReadString();   //  The query returns the value of timebase scale, and the unit is s.
                    dbTimeBaseScale = double.Parse(strTimeBaseScale, System.Globalization.CultureInfo.InvariantCulture);

                    back.mbSession.Write(":TRIG:" + TrigModus + ":SOUR?");    //  The command sets the trigger source as channel (CH n), external trigger (EXT, EXT5) or AC Line.
                    strTrigEdgeSour = back.mbSession.ReadString();        //  The< mode> is :EDGE, the <source> may be CHANnel<n>, EXT, EXT5 or ACLine;

                    back.mbSession.Write(":TRIG:" + TrigModus + ":LEV?"); //  The command sets the voltage level of Edge.
                    strTrigEdgeLev = back.mbSession.ReadString();         //  The query returns the value of voltage level, and the unit is V.
                    dbTrigEdgeLev = double.Parse(strTrigEdgeLev, System.Globalization.CultureInfo.InvariantCulture);

                    back.mbSession.Write(":TRIG:EDGE:SLOP?");             //  The command sets the trigger edge as POSitive (rising edge), NEGative (falling edge) or ALTernation (rising and falling edge).
                    strTrigEdgeSlop = back.mbSession.ReadString();        //  NEGative (falling edge) or ALTernation (rising and falling edge).
                    //  The query returns POSITIVE or NEGATIVE, ALTERNATION. 

                    back.mbSession.Write(":TRIGger:PULSe:MODE?");         //  The command sets the trigger condition
                    strTrigPulseMod = back.mbSession.ReadString();        //  The query returns +GREATER THAN or +LESS THAN, +EQUAL, -GREATER THAN, -LESS THAN, –EQUAL.

                    //    back.mbSession.Write(":KEY:LOCK DIS");




                    foreach (string Kanal in Channels)
                    {
                        chart1.Series[Kanal].Points.Clear();
                        //   chart1.Series[Kanal].LegendText = String.Empty;
                        chart1.Series[Kanal].IsVisibleInLegend = false;

                        if (intChanDisp[Array.IndexOf(Channels, Kanal)] == 1)
                        {
                            if (Array.IndexOf(Channels, Kanal) < 5)
                            {
                                string strCoupModeSy = String.Empty;
                                if ((strCoupMode[Array.IndexOf(Channels, Kanal)].Substring(0, 2)) == "DC") strCoupModeSy = " = ";
                                if ((strCoupMode[Array.IndexOf(Channels, Kanal)].Substring(0, 2)) == "AC") strCoupModeSy = " ~ ";
                                if ((strCoupMode[Array.IndexOf(Channels, Kanal)].Substring(0, 2)) == "GN") strCoupModeSy = " GND ";
                                if ((strCoupMode[Array.IndexOf(Channels, Kanal)].Substring(0, 2)) == "  ") strCoupModeSy = String.Empty;
                                chart1.Series[Kanal].IsVisibleInLegend = true;
                                chart1.Series[Kanal].LegendText = "CH " + (Array.IndexOf(Channels, Kanal) + 1).ToString() + ": " + dbYInc[Array.IndexOf(Channels, Kanal)].ToString("f2") + " V" + strCoupModeSy;
                                if (Array.IndexOf(Channels, Kanal) == 4) chart1.Series[Kanal].LegendText = "MathScale:  " + dbYInc[Array.IndexOf(Channels, Kanal)].ToString("f2") + " V" + strCoupModeSy;

                                //chart1.Legends[0].Position.Auto = false;
                                //chart1.Legends[0].Position.X = 10;
                                //chart1.Legends[0].Position.Y= 10;
                                //chart1.Legends[0].BackColor = Color.Transparent;
                                for (int i = 0; i < 600; i++)
                                {
                                    chart1.Series[Kanal].Points.AddXY(dbBufferX[i], 200 - btWavChannel[Array.IndexOf(Channels, Kanal)][i]);
                                }
                            }
                            else
                            {
                                for (int i = 5; i < 25; i++)
                                {
                                    chart1.Series[Kanal].Points.AddXY(dbBufferX[i], ((dbYOr[(Array.IndexOf(Channels, Kanal)) - 5] / dbYInc[(Array.IndexOf(Channels, Kanal)) - 5] * 25) + 100));
                                }
                            }

                        }
                    }

                    chart1.ChartAreas[0].AxisX.Minimum = dbBufferX[0];
                    chart1.ChartAreas[0].AxisX.Interval = Math.Abs(dbBufferX[0] - dbBufferX[599]) / 12;

                    legendTimeScale.Name = "TB:  " + dbTimeBaseScale.ToString() + " s";
                    string strTriggerSlope = string.Empty;
                    if (strTrigEdgeSlop.Substring(0, 3) == "POS") strTriggerSlope = "";
                    if (strTrigEdgeSlop.Substring(0, 3) == "NEG") strTriggerSlope = "";
                    if (strTrigEdgeSlop.Substring(0, 3) == "ALT") strTriggerSlope = "";

                    if (TrigModus == "PULS" && strTrigPulseMod.Substring(0, 1) == "+") strTriggerSlope = "";
                    if (TrigModus == "PULS" && strTrigPulseMod.Substring(0, 1) == "-") strTriggerSlope = "";
                    if (TrigModus == "VIDEO") strTriggerSlope = "";
                    if (TrigModus == "PATT") strTriggerSlope = "Pat";

                    string strTriggerSour = string.Empty;
                    if (strTrigEdgeSour.Substring(0, 3) == "CHA") strTriggerSour = strTrigEdgeSour.Substring(7, 1);
                    if (strTrigEdgeSour.Substring(0, 3) == "EXT") strTriggerSour = "E";
                    if (strTrigEdgeSour.Substring(0, 3) == "ACL") strTriggerSour = "AC";
                    legendTriggerLevel.Name = strTriggerSlope + "  " + strTriggerSour + "   " + dbTrigEdgeLev.ToString() + " V";

                    chart1.Titles[0].Text = "                Labor für Regelungstechnik   " + System.DateTime.Now.ToString();

                    //chart1.Printing.Print(false);


                    PageSettings ps = new PageSettings();
                    ps.Landscape = true;
                    System.Drawing.Printing.Margins raender = new System.Drawing.Printing.Margins(80, 82, 0, 0);
                    ps.Margins = raender;

                    page = chart1.Printing.PrintDocument;
                    page.DefaultPageSettings = ps;
                    page.Print();

                }
                else MessageBox.Show("Drucken bei alternierenden Trigger nicht möglich!");
                back.mbSession.Write(":KEY:LOCK DIS");
            }
            catch (Exception exp)
            {
               
                MessageBox.Show("Print von FFT noch nicht möglich  \r\n" + exp.Message);
                //intChanDisp[4] = 0;                                              // Merker "KanalAnzeigen" löschen für Messwerte
                //intChanDisp[9] = 0;                                              // Merker "KanalAnzeigen" löschen für Nulllinie
            }


        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            //try
            //{
            //   back.mbSession.Dispose();
            //}
            //catch (Exception exp)
            //{
            //   MessageBox.Show(exp.Message);
            //}
            e.Cancel = true;
            this.Hide();

        }

        private void button1_Click(object sender, EventArgs e)
        {
            back.mbSession.Write(":KEY:LOCK DIS");
        }

     }
}

       
