﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WINDF7CSharp.Hardwaretools
{
    public partial class FormTempLogger : Form
    {
        FormMain meinMain;
        
        public FormTempLogger(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown1, 1, (double)numericUpDown1.Maximum);
            timer1.Interval = (int)numericUpDown1.Value * 1000;
        }

        private void Check_Click(object sender, EventArgs e)
        {
            cbPort.Items.Clear();

            foreach (string s in SerialPort.GetPortNames())
            {
                cbPort.Items.Add(s);
            }

        }

        private void buttonOpen_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) serialPort1.Close();
            serialPort1.PortName = cbPort.Text;
            serialPort1.BaudRate = int.Parse(comboBox1.Text);

            serialPort1.Open();

            if (serialPort1.IsOpen)
            {
                //buttonReadLine.Enabled=true;  // ist gefährlich, da Programm dann auf CR wartet, wenn keines kommt --> Tot
                butInit.Enabled = true;
                label2.Text = serialPort1.PortName + "  is now open";
            }
            else
                label2.Text = "No Port is open";


        }

        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            buttonClose_Click(sender, e);
            serialPort1.BaudRate = int.Parse(comboBox1.Text);


        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
           label2.Text = " No COM open";
            timer1.Enabled = false;
            serialPort1.Close();
            butInit.Enabled = false;
           

        }

        private void cbPort_SelectedIndexChanged(object sender, EventArgs e)
        {
            buttonClose_Click(sender, e);
            serialPort1.PortName = cbPort.Text;

        }

        private void butInit_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine("S90 01 60");// Config mit hoher Auflösung 
            serialPort1.WriteLine("S90 00");// Pointer zurück auf Temp
            timer1.Interval = (int)numericUpDown1.Value * 1000;
            time = 0;
            timer1.Enabled = true;
            chart2D1.clearAll();
            chart2D1.XMax = 10 * (int)numericUpDown1.Value;
        }

        string inp = "";
        long time = 0;

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.WriteLine("S91 02");
                textBox1.Clear();
                do
                {
                    if (serialPort1.BytesToRead > 0)
                    {
                        for (int i = 0; i < serialPort1.BytesToRead; i++)
                        {
                            int c = serialPort1.ReadByte();
                            char ch = (char)c;

                            inp = inp + ch;
                        }
                        textBox1.AppendText(inp);
                        inp = "";
                    }
                }
                while (textBox1.Text.Length < 8);
                //butConvTemp_Click(null, null);
                sbyte high = Convert.ToSByte(textBox1.Text.Substring(0, 2), 16);
                short low = Convert.ToInt16(textBox1.Text.Substring(3, 2), 16);
                labTemp.Text = (high + low / 256.0).ToString("f2") + "°";

                textBox1.Clear();
                time += (int)numericUpDown1.Value;  // Aktuelle Sek ab Start
                if (time > chart2D1.XMax)
                    chart2D1.XMax += 10 * (int)numericUpDown1.Value;
                tSSLabel1.Text = time.ToString() + " sec";
                chart2D1.realTimeChart(0, time, high + low / 256.0);
                if (time % 50 == 0)
                    chart2D1.autoScaling();

            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog()==DialogResult.OK)
            {
                double[,] temp;
                temp = chart2D1.getPoints(0);
                string data="";
                for (int i = 0; i < temp.Length / 2; i++)
                    if (i % (int)nUDDatareduction.Value == 0)
                        data += temp[i, 0].ToString() + " " + temp[i, 1].ToString() + "\r\n";
                StreamWriter myStream1 = new  StreamWriter(saveFileDialog1.OpenFile(), Encoding.Default);
                myStream1.WriteLine(data);
                myStream1.Close();


            }
        }

        private void FormTempLogger_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }
    }
}
