﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WINDF7CSharp.Hardwaretools
{
    public partial class FormTransferline : Form
    {
        FormMain meinMain;
        
        public FormTransferline(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            chart2D1.clearAll();  // To start with no curves and counter -1
        }

        double val = 0;
        double xout = 0;
        double xfrom=0, xto=0, xstep = 0,xtime=0;
        int cntNbOfUDpercurve = 0, cntNbOfCurves = 0, NbOfUDpercurve = 0, NbOfCurves = 0, firstTime=0;


        private void timer1_Tick(object sender, EventArgs e)
        {
            if (firstTime == 0) firstTime = 1;
            else
            {
                firstTime = 1;
                meinMain.ADCinput((short)nudSignalIn.Value, ref val);
                if (labelADCCard.Text == "HW- Simul")
                {
                    int anz = Convert.ToInt32((double)timer1.Interval / (double)meinMain.frmSimul.SpEdpT0.Value);
                    if (anz == 0) anz = 1;
                    for (int i = 0; i < anz; i++) meinMain.ADCinput((short)nudSignalIn.Value, ref val);
                }

                labXout.Text = xout.ToString("f2");
                labYout.Text = val.ToString("f3");
                chart2D1.setPoint(cntNbOfCurves, xout, val);
                xout += xstep;
                meinMain.DACoutput((short)nudChanDA.Value, xout);
                if (checkBoxUpDown.Checked)
                {
                    if (xout > xto) xstep = -xstep;
                    if (xout < xfrom)
                    {
                        xstep = -xstep;
                        xout = xfrom;
                        cntNbOfUDpercurve++;
                        chart2D1.startDrawing();
                        chart2D1.autoScaling();
                        if (cntNbOfUDpercurve >= NbOfUDpercurve)
                            cntNbOfCurves++;
                        if (cntNbOfCurves >= NbOfCurves)
                        {
                            timer1.Enabled = false; //Stop
                            butStartStop.Text = "Start";
                        }
                    }

                }
                else  // only up
                    if (xout > xto)
                    {
                        xout = xfrom;
                        cntNbOfUDpercurve++;
                        chart2D1.startDrawing();
                        chart2D1.autoScaling();
                        if (cntNbOfUDpercurve >= NbOfUDpercurve)
                            cntNbOfCurves++;
                        if (cntNbOfCurves >= NbOfCurves)
                        {
                            timer1.Enabled = false; //Stop
                            butStartStop.Text = "Start";
                        }
                    }


            }
        }


        private void butStartStop_Click(object sender, EventArgs e)
        {
            if (butStartStop.Text == "Start")
            {
                butStartStop.Text = "Stop";
                meinMain.ConvertToDouble(tBFrom.Text, ref xfrom);
                meinMain.ConvertToDouble(tBTo.Text, ref xto);
                meinMain.ConvertToDouble(tBStep.Text, ref xstep);
                meinMain.ConvertToDouble(tBTimeBetweenSteps.Text, ref xtime);
                timer1.Interval = Convert.ToInt16(xtime * 1000.0);
                NbOfUDpercurve = (int)NUDNbInCurve.Value;
                NbOfCurves = (int)NUDCurves.Value;
                cntNbOfUDpercurve = 0; cntNbOfCurves = 0;
                meinMain.DACoutput((short)nudChanDA.Value, xfrom);
                xout = xfrom;
                timer1.Enabled = true;
            }
            else
            {
                butStartStop.Text = "Start";
                timer1.Enabled = false;
                meinMain.DACoutput((short)nudChanDA.Value, 0);
                chart2D1.startDrawing();
                chart2D1.autoScaling();

            }
        }

        private void FormTransferline_Load(object sender, EventArgs e)
        {
            meinMain.DACoutput((short)nudChanDA.Value, 0);
        }

        private void FormTransferline_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }
    }
}
