using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace USBOrlowskiDLL20
{
    public partial class FormUSBOrl20 : Form
    {

        Stopwatch stw = new Stopwatch(); 

        public FormUSBOrl20()
        {
            InitializeComponent();
            stw.Start();
            //enum TMode  { StartRealtime = 2, Ready = 3 };          //Nicht unbedingt notwendig
           

        }  
        enum TRange { off, bip_4V, bip_2V, unip_4V, unip_2V }; //Nicht unbedingt notwendig
        
        float [] buf = new float [8];
        float[] databuf = new float[8];
        USBKarteLib.CUSBKarte USBKarte = new USBKarteLib.CUSBKarte();
        // Neue Instanz der Klasse CUSBKarte.
        // Die USBKarte wird neu initialisiert

        bool OK = false;
        private void buttoninit_Click(object sender, EventArgs e)
        {
            USBKarte.Init();  //Initialisierung der USB-Karte
            // Kanal 3-8:bip1_4V=1
            // Kanal 1+2 :bip1_800mV=1
            USBKarte.SetMode(USBKarteLib.CUSBKarte.TMode.StartRealtime); // Aktivierung der analogen Eingnge
            USBKarte.SetKanalBereich(USBKarteLib.CUSBKarte.TRange.bip_4V, 1);
            USBKarte.SetKanalBereich(USBKarteLib.CUSBKarte.TRange.bip_4V, 2);
            USBKarte.SetKanalBereich(USBKarteLib.CUSBKarte.TRange.bip_4V, 3);
            USBKarte.SetKanalBereich(USBKarteLib.CUSBKarte.TRange.bip_4V, 4);
            USBKarte.SetKanalBereich(USBKarteLib.CUSBKarte.TRange.bip_4V, 5);
            USBKarte.SetKanalBereich(USBKarteLib.CUSBKarte.TRange.bip_4V, 6);
            USBKarte.SetKanalBereich(USBKarteLib.CUSBKarte.TRange.bip_4V, 7);
            groupBoxTimeronoff.Enabled = true;
            //buttoninit.Enabled = false;
            numericUpDown1.Enabled = true;
            numericUpDown2.Enabled = true;
            numericUpDown1_ValueChanged(null, null);
            numericUpDown2_ValueChanged(null, null);
        }
            
        

        private void timer1_Tick(object sender, EventArgs e)
        {
            double fak;
            string form, Unit;
            if (rBOriginal.Checked)
            {
                fak = 1;
                form = "F0";
                Unit = " mV";
            }
            else
            {
                fak = 10.0 / 4096.0;
                form = "F3";
                Unit = " V";
            }
            long start = stw.ElapsedTicks;
            USBKarte.RealtimeData(out buf);         // Abholen der Messwerte;
            long ende = stw.ElapsedTicks;
            tSSLabel1.Text = "ADC :"+((ende - start) / (float)Stopwatch.Frequency * 1000.0).ToString("f3") + " ms";
            // correction of sign
            
            //for (int i = 0; i < 8; i++) if (buf[i] > 65535) databuf[i] = (buf[i] - 131072);else databuf[i]=buf[i];
            label2.Text = "Ua= " + (buf[1] * fak).ToString(form) + Unit;
            label3.Text = "Ua= " + (buf[2] * fak).ToString(form) + Unit;
            label4.Text = "Ua= " + (buf[3] * fak).ToString(form) + Unit;
            label5.Text = "Ua= " + (buf[4] * fak).ToString(form) + Unit;
            label6.Text = "Ua= " + (buf[5] * fak).ToString(form) + Unit;
            label7.Text = "Ua= " + (buf[6] * fak).ToString(form) + Unit;
            start = stw.ElapsedTicks;
            USBKarte.SetAnalogOut1(Ua1);   // Einstellen einer Spannung in mV am D/A-Ausgang 1

            ende = stw.ElapsedTicks;
            tSSLabel2.Text = "    DAC :" + ((ende - start) / (float)Stopwatch.Frequency * 1000.0).ToString("f3") + " ms";
            if (this.WindowState == FormWindowState.Minimized) rBTTOff.Checked = true;
            // Switch off if Minimized


        }
        ushort Ua1;

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            // nur gltig fr USB Karte mit anschlieenden OP Amp Treibern.
            // Original-ADC hat nur 0 bis 4095 mV

            double U = (double)numericUpDown1.Value,temp;  // U in Volt
            if (rBOriginal.Checked)
                temp = U;
            else
                temp = ((U + 10.0) * 4095.0 / 20.0);

            Ua1 = (ushort)Convert.ToUInt32(temp);
            USBKarte.SetAnalogOut1(Ua1);  // Einstellen einer Spannung in mV am D/A-Ausgang 1
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            // nur gltig fr USB Karte mit anschlieenden OP Amp Treibern.
            // Original-ADC hat nur 0 bis 4095 mV

            double U = (double)numericUpDown2.Value,temp;  // U in Volt
            if (rBOriginal.Checked)
                temp = U;
            else
                temp = ((U + 10.0) * 4095.0 / 20.0);
            ushort Ua2 = (ushort)Convert.ToUInt32(temp);
            USBKarte.SetAnalogOut2(Ua2);   // Einstellen einer Spannung in mV am D/A-Ausgang 1
        }

        private void rBOriginal_CheckedChanged(object sender, EventArgs e)
        {
            if (rBOriginal.Checked)
            {
                numericUpDown1.Maximum = 4096;
                numericUpDown1.Increment = 100;
                numericUpDown1.Minimum = 0;
                numericUpDown2.Maximum = 4096;
                numericUpDown2.Increment = 100;
                numericUpDown2.Minimum = 0;
                label1.Text = " mV";
                label8.Text = " mV";
            }
            else
            {
                numericUpDown1.Maximum = 10;
                numericUpDown1.Increment = 1;
                numericUpDown1.Minimum = -10;
                numericUpDown2.Maximum = 10;
                numericUpDown2.Increment = 1;
                numericUpDown2.Minimum = -10;
                label1.Text = " V";
                label8.Text = " V";
            }

        }

        private void FormUSBOrl_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            timer1.Enabled = false;
            rBTTOff.Checked = true;
        }

        public void inputOrl(short chan, ref double val)
        {
            double fak;
            USBKarte.RealtimeData(out buf);         // Abholen der Messwerte;
            if (rBOriginal.Checked)
            {
                fak = 1/1000.0;
            }
            else
            {
                fak = 10.0 / 4096.0;
            }

            if ((chan > 0)&&(chan<8)) val = buf[chan] * fak;
            else val = buf[2] * fak;


        }

        public void outputOrl(short chan, double val)
        {
            double temp;
            if (rBOriginal.Checked)
            {
                if (val > 4.095) val = 4.095;
                if (val < 0) val = 0;
                temp = val * 1000;
            }
            else
            {
                if (val > 10) val = 10;
                if (val < -10) val = -10;
                temp = ((val + 10.0) * 4095.0 / 20.0);

            }
            ushort Ua2 = (ushort)Convert.ToUInt32(temp);
            if (chan == 0)
                USBKarte.SetAnalogOut1(Ua2);  // Einstellen einer Spannung in mV am D/A-Ausgang 1
            else
                USBKarte.SetAnalogOut2(Ua2);   // Einstellen einer Spannung in mV am D/A-Ausgang 1

        }

        private void rBTTOff_CheckedChanged(object sender, EventArgs e)
        {
            if (rBTTOff.Checked) timer1.Enabled = false;
            else timer1.Enabled = true;
        }

 
      

    }
}