﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using NationalInstruments.DAQmx;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace I2C
{
    public partial class I2CCH341 : Form
    {
         bool initOK = false;
        string NoInit = "No Init possible";

        double AD0Display = 0, DA0Display = 0;

        Stopwatch stopwatch1 = new Stopwatch();

 
        int MinO = -10;
        int MaxO = 10;

        // Für Zähler von ES
 
        private void startMessung()
        {

            try
            {
 
            }
            catch (DaqException exception)
            {
                MessageBox.Show(exception.Message);
            }

        }

        
        
        
        // ende Zähler von ES
 
        public I2CCH341()
        {
            InitializeComponent();
            stopwatch1.Start();
            panel2.Visible = cBSecondADC.Checked;
            label2.Visible = cBSecondDAC.Checked;
            numAO1.Visible = cBSecondDAC.Checked;

        }
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static long CH341OpenDevice(int i);

        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static void CH341CloseDevice(int iIndex);

        // CH341StreamI2C(ChipIndex.Value,wlen,@outbytes,rlen,@inbytes); 
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.StdCall)]
        public extern static bool CH341StreamI2C(int iIndex, int wlen, ref byte WBuf, int rlen, ref byte RBuf);

        // CH341SetStream() konfiguriert I2C und SPI
        // Bit 1-0: I2C speed 00= low speed /20KHz
        // 01= standard /100KHz
        // 10= fast /400KHz
        // 11= high speed /750KHz           plus  0x60  , das ist wichtig. Also :
        // BOOL	WINAPI	CH341SetStream( ULONG iIndex, ULONG	iMode );*/
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static long CH341SetStream(int iIndex, int iMode);

        byte[] WriteBuf = new byte[10];
        byte[] ReadBuf = new byte[10];

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            if (timer1.Enabled)
            {
                //timerAnzeigeZeiten.Stop();
                timer1.Stop();
                dtavr = 0; dtavr2 = 0;
            }
         
        }

        long dtend = 0, dt = 0,  dtavr = 0, cntT0 = 0, dtavr2 = 0;


        private void timer1_Tick(object sender, EventArgs e)
        {
            // This timer writes to DA, so in normal mode this should be disabled
            long dtstart = stopwatch1.ElapsedTicks;
            //numAO0_ValueChanged(null, null);  // Ausgabe DA- Wert
             dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - dtstart);  // Time AD
            dtavr = dtavr + dt;
            dtstart = stopwatch1.ElapsedTicks;

            double temp = 0;
            InputI2C(0, ref temp);

            dt = (stopwatch1.ElapsedTicks - dtstart);  // Time DA
            dtavr2 = dtavr2 + dt;
            cntT0++;
            tBAI0.Text = temp.ToString("f3");
            if (cBSecondADC.Checked)
            {
                InputI2C(1, ref temp);
                tBAI1.Text = temp.ToString("f3");
            }
        }

        private void timerAnzeigeZeiten_Tick(object sender, EventArgs e)
        {
            if (cntT0 > 0)
            {
                double dtavr1 = dtavr / cntT0 / (double)Stopwatch.Frequency * 1000;
                toolStripStatusLabel2.Text = "DtAD= " + dtavr1.ToString("f3");
                double dtav2 = dtavr2 /cntT0/ (double)Stopwatch.Frequency * 1000;
                toolStripStatusLabel2.Text += " ms  DtDA= " + dtav2.ToString("f3")+ " ms";
                dtavr2 = 0; dtavr = 0; cntT0 = 0;
            }

        }

        double gainfactor = 1;
        byte lsbGain = 3;
        private void butInit_Click(object sender, EventArgs e)
        {
            try
            {
                long open = CH341OpenDevice(0);
                if (open != 4294967295)
                {
                    label5NOK.Text = "Chip open with"+ open.ToString("X16");
                    initOK = true;
                }
                else
                {
                    label5NOK.Text = "No Chip could be opened";
                    initOK = false;
                }
                if (initOK)
                {
                    byte conf = 0,conf2=0;
                    if (rB400khz.Checked)
                        CH341SetStream(0, 0x62);//400 kHz Mode
                    else
                        CH341SetStream(0, 0x61);//100 kHz Mode

                    if (rBRange05V.Checked)
                    { 
                        MinO = 0; MaxO = 10;
                    }
                    else if (rB0to5Volt.Checked)
                    {
                        MinO = 0; MaxO = 5;
                    }
                      else
                    {
                        MinO = -10; MaxO = 10;
                    }
                    if (cBOnlyPos.Checked)
                        conf = Convert.ToByte("40", 16);  // A0 singel ended, continuous conversion
                    else
                        conf = Convert.ToByte("00", 16);  // A0 - A1 differential, continuous conversion 

                    numAO0.Maximum = MaxO;
                    numAO1.Maximum = MaxO;
                    numAO0.Minimum = MinO;
                    numAO1.Minimum = MinO;
                   
                    switch (rbGain)
                    {
                        case 23: gainfactor = 2 / 3.0; lsbGain = 0; break;
                        case 1: gainfactor = 1; lsbGain = 2; break;
                        case 2: gainfactor = 2; lsbGain = 4; break;
                        case 4: gainfactor = 4; lsbGain = 6; break; 
                        case 8: gainfactor = 8; lsbGain = 8; break;
                        case 16: gainfactor = 16; lsbGain = 10; break;
                    }
                    conf2 = Convert.ToByte("e3", 16);  // allways   Data rate 3300 SPS , Disable comparator    
                    conf = (byte) (conf | lsbGain); // bitwise OR MUX with PGA factor
                    WriteBuf[0] = Convert.ToByte("92", 16); // Init ADC
                    WriteBuf[1] = Convert.ToByte("01", 16);
                    WriteBuf[2] = conf;
                    WriteBuf[3] = conf2;
                    CH341StreamI2C(0, 4, ref WriteBuf[0], 0, ref ReadBuf[0]);
                    WriteBuf[0] = Convert.ToByte("92", 16);   // Adc Pointer 0, read ADC
                    WriteBuf[1] = Convert.ToByte("00", 16);
                    CH341StreamI2C(0, 2, ref WriteBuf[0], 0, ref ReadBuf[0]);
                    if (cBSecondADC.Checked)
                    {
                        WriteBuf[0] = Convert.ToByte("94", 16); // Init ADC
                        WriteBuf[1] = Convert.ToByte("01", 16);
                        WriteBuf[2] = conf;
                        WriteBuf[3] = conf2;
                        CH341StreamI2C(0, 4, ref WriteBuf[0], 0, ref ReadBuf[0]);
                        WriteBuf[0] = Convert.ToByte("94", 16);   // Adc Pointer 0, read ADC
                        WriteBuf[1] = Convert.ToByte("00", 16);
                        CH341StreamI2C(0, 2, ref WriteBuf[0], 0, ref ReadBuf[0]);
                    }
                    timer1.Start(); 
                    timerAnzeigeZeiten.Enabled = true;
                    initOK = true;
                    
                    //startMessung();
                }
                else MessageBox.Show(NoInit);
            }
            catch
            {
                MessageBox.Show("gecatched");
            }
        }
 
        private void DAQmx_Basic_FormClosed(object sender, FormClosedEventArgs e)
        {
            label5NOK.Text = " No Chip open";
            CH341CloseDevice(0);
        }

        double InputOffset = 0;// = -0.054;

        public void InputI2C(short chan, ref double val)
        {
            if (initOK)
            {
                if (chan == 0)
                {
                    WriteBuf[0] = Convert.ToByte("93", 16);
                    WriteBuf[1] = Convert.ToByte("02", 16);
                    CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);
                    sbyte high = (sbyte)ReadBuf[0];
                    int mvolt = high * 16 + ReadBuf[1] / 16;
                    //                   labADCOut.Text = (mvolt / 204.7).ToString("f3") + " V";
                    val = mvolt / 204.7 + InputOffset;
                    val = val / gainfactor/gainVD;

                }


                if (chan == 1)
                {
                    WriteBuf[0] = Convert.ToByte("95", 16);
                    WriteBuf[1] = Convert.ToByte("02", 16);
                    CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);
                    sbyte high = (sbyte)ReadBuf[0];
                    int mvolt = high * 16 + ReadBuf[1] / 16;
                    //                   labADCOut.Text = (mvolt / 204.7).ToString("f3") + " V";
                    val = mvolt / 204.7 + InputOffset;
                    val = val / gainfactor/gainVD;
                }
                AD0Display = val;
            }
        }

        private void cBSecondADC_CheckedChanged(object sender, EventArgs e)
        {
            panel2.Visible = cBSecondADC.Checked;
        }

        private void rBNoCounter_CheckedChanged(object sender, EventArgs e)
        {
            if (rBNoCounter.Checked)
            {
                labPosCnt.Visible = false;
                rBCnt1.Visible = false;
                rBAI1.Visible = false;
                labPosCnt.Visible = false;
                rBCnt2.Visible = false;
                rBA2.Visible = false;
                labcnt.Visible = false;
            }
            else
            {
                rBCnt1.Visible = true;
                rBAI1.Visible = true;
                rBCnt2.Visible = true;
                rBA2.Visible = true;
                rBCnt1_CheckedChanged(null, null);
                rBA2_CheckedChanged(null, null);
            }
        }
        int rbGain = 1;

        private void rBGain23_CheckedChanged(object sender, EventArgs e)
        {
            if (rBGain23.Checked) rbGain = 23;
            if (rBGain1.Checked) rbGain = 1;
            if (rBGain2.Checked) rbGain = 2;
            if (rBGain4.Checked) rbGain = 4;
            if (rBGain8.Checked) rbGain = 8;
            if (rBGain16.Checked) rbGain = 16;
            butInit_Click(null, null);
        }

        private void rBCnt1_CheckedChanged(object sender, EventArgs e)
        {
            if (rBCnt1.Checked)
            {
                label3.Text = "Counter 1";
                labPosCnt.Visible = true;
            }
            else
            {
                label3.Text = "AI 0 Wert=";
                labPosCnt.Visible = false;
            }
                
        }

        private void rBA2_CheckedChanged(object sender, EventArgs e)
        {
            if (rBCnt2.Checked)
            {
                label1.Text = "Counter 2";
                labcnt.Visible = true;
            }
            else
            {
                label1.Text = "AI 1 Wert=";
                labcnt.Visible = false;
            }

        }
        double gainVD = 1;
        private void rBVoltDevider_CheckedChanged(object sender, EventArgs e)
        {
            if (rBVoltDevider.Checked)
            {
                rBGain23.Text = "Gain 2/3  +-15 Volt";
                rBGain1.Text = "Gain 1     +-10 Volt";
                rBGain2.Text = "Gain 2     +-5 Volt";
                rBGain4.Text = "Gain 4     +-2.5 Volt";
                rBGain8.Text = "Gain 8     +-1.25 Volt";
                rBGain16.Text = "Gain 16   +-0.625 Volt";
                gainVD = 1;
            }
            else
            {
                rBGain23.Text = "Gain 2/3  +-30 Volt";
                rBGain1.Text = "Gain 1     +-15 Volt";
                rBGain2.Text = "Gain 2     +-10 Volt";
                rBGain4.Text = "Gain 4     +-5 Volt";
                rBGain8.Text = "Gain 8     +-2.5 Volt";
                rBGain16.Text = "Gain 16   +-1.25 Volt";
                gainVD = .5;
            }
        }

        private void rB0to5Volt_CheckedChanged(object sender, EventArgs e)
        {
            if (rB0to5Volt.Checked) MinO = 0;MaxO = 5;
            numAO0.Maximum = MaxO;
            numAO1.Maximum = MaxO;
            numAO0.Minimum = MinO;
            numAO1.Minimum = MinO;
        }

        private void rBproto1_CheckedChanged(object sender, EventArgs e)
        {
            if (rBproto1.Checked)
            {
                rBRange05V.Checked = true;
                cBOnlyPos.Checked = true;
                DacAdr1 = "C4"; DacAdr2 = "C2";
            }
        }

        private void rBProto2_CheckedChanged(object sender, EventArgs e)
        {
            if (rBProto2.Checked)
            {
                cBOnlyPos.Checked = false;
                rBRangeStand.Checked = true;
                DacAdr1 = "C0"; DacAdr2 = "C6";
            }
        }

        private void rBSerie_CheckedChanged(object sender, EventArgs e)
        {
            if (rBSerie.Checked)
            {
                cBOnlyPos.Checked = false;
                rBRangeStand.Checked = true;
                DacAdr1 = "C0"; DacAdr2 = "C2";

            }
        }

            private void cBSecondDAC_CheckedChanged(object sender, EventArgs e)
        {
            label2.Visible = cBSecondDAC.Checked;
            numAO1.Visible = cBSecondDAC.Checked;
        }

        private void rBRangeStand_CheckedChanged(object sender, EventArgs e)
        {
           if (rBRangeStand.Checked) MinO = -10; MaxO = 10;
            numAO0.Maximum = MaxO;
            numAO1.Maximum = MaxO;
            numAO0.Minimum = MinO;
            numAO1.Minimum = MinO;
        }

        private void rBRange05V_CheckedChanged(object sender, EventArgs e)
        {
            if (rBRange05V.Checked) MinO = 0; MaxO = 10;
            numAO0.Maximum = MaxO;
            numAO1.Maximum = MaxO;
            numAO0.Minimum = MinO;
            numAO1.Minimum = MinO;
        }

        private void but99Volt_Click(object sender, EventArgs e)
        {
            numAO0.Value = (decimal)9.9;
            numAO1.Value = (decimal)9.9;
        }

        private void but0Volt_Click(object sender, EventArgs e)
        {
            numAO0.Value = 0;
            numAO1.Value = 0;
        }

        private void butneg99V_Click(object sender, EventArgs e)
        {
            numAO0.Value = (decimal)-9.9;
            numAO1.Value = (decimal)-9.9;
        }

        private void but17V_Click(object sender, EventArgs e)
        {
            numAO0.Value = (decimal)1.7;
            numAO1.Value = (decimal)1.7;
        }

        private void but10V_Click(object sender, EventArgs e)
        {
            numAO0.Value = (decimal)10;
            numAO1.Value = (decimal)10;
        }

        private void butM10V_Click(object sender, EventArgs e)
        {
            numAO0.Value = (decimal)-10;
            numAO1.Value = (decimal)-10;

        }

        private void numAO0_ValueChanged(object sender, EventArgs e)
        {
            double output = (double)numAO0.Value;
            OutputI2C(0, output);
            labBufHigh.Text = WriteBuf[1].ToString("X2");
            labBufLow.Text = WriteBuf[2].ToString("X2");
        }

        private void numAO1_ValueChanged(object sender, EventArgs e)
        {
            double output = (double)numAO1.Value;
            OutputI2C(1, output);
            labBufHigh.Text = WriteBuf[1].ToString("X2");
            labBufLow.Text = WriteBuf[2].ToString("X2");
       }

        string DacAdr1 = "C4", DacAdr2 = "C0"; // Start with Proto1
        public void OutputI2C(short chan, double val)
        {

            if (val > MaxO) val = MaxO;
            if (val < MinO) val = MinO;
            if (initOK)
            {
                int mVOut;
                if (rB0to5Volt.Checked)
                     mVOut = (int)Math.Round((val ) / 5.0 * 4095);
                else
                     mVOut = (int)Math.Round((val + 10.0) / 20.0 * 4095);
                int mVoutcorr = mVOut * 5000 / (int)nuDVCCMCP4725.Value;  // VCC- correction: FFF is VCC
                                                                          // Write to DAC
                if (mVoutcorr > 4095) mVoutcorr = 4095; // Limiting


                if (chan == 0)
                {
                    WriteBuf[0] = Convert.ToByte(DacAdr1, 16);
                    byte highout = Convert.ToByte(mVoutcorr / 256);
                    WriteBuf[1] = highout;
                    WriteBuf[2] = Convert.ToByte(mVoutcorr - highout * 256);
                    CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);
                }
                if (chan == 1)
                {
                    WriteBuf[0] = Convert.ToByte(DacAdr2, 16);
                    byte highout = Convert.ToByte(mVoutcorr / 256);
                    WriteBuf[1] = highout;
                    WriteBuf[2] = Convert.ToByte(mVoutcorr - highout * 256);
                    CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);
                }

                DA0Display = val;
            }
        }

        public void butZero_Click(object sender, EventArgs e)
        {
            if (initOK)
            {
                // for Later use if I2C has a encoder interface
                //Task_Wagen.Stop();
                //Task_Pendel.Stop();
                startMessung();
            }

        }



 
    }
}
