using System;

/// <summary>
/// Summary description for me2600Def
/// </summary>
public class me2600Def
{
    //public me2600Def()
	
		//
		// TODO: Add constructor logic here
		//
        public const int PRIORITY_HIGH=	0x1;
		public const int PRIORITY_LOW=	0x0;


	// ADC base clock frequency 
	//--------------------------------------------------------------------
	public const int ADC_BASE_FREQUENCY_1 =3000000;
	public const int ADC_BASE_FREQUENCY_2 =2950000;

	// FIFO-HALF-FULL flag is used to read data
	//--------------------------------------------------------------------
	//public const int ADC_FIFO_HALF_SIZE	1024

	// For a first version we support up to 4 ME2600 boards
	//--------------------------------------------------------------------
	public const int ME_MAX_DEVICES	= 4;



	// Defines used for the Serial Interface UART 16C550
	//--------------------------------------------------------------------
	public const int SIO_RHR	=		0x0;
	public const int SIO_THR	=		0x0;
	public const int SIO_IER	=		0x1;
	public const int SIO_FCR	=		0x2;
	public const int SIO_ISR	=		0x2;
	public const int SIO_LCR	=		0x3;
	public const int SIO_MCR	=		0x4;
	public const int SIO_LSR	=		0x5;
	public const int SIO_MSR	=		0x6;
	public const int SIO_SPR	=		0x7;

	public const int SIO_DLL	=		0x0;
	public const int SIO_DLM	=		0x1;

	public const int SIO_NO_PARITY	=(char) 0x00;
	public const int SIO_ODD_PARITY	=(char) 0x08;
	public const int SIO_EVEN_PARITY	=(char) 0x18;
	public const int SIO_FORCE_ODD	=(char) 0x28;
	public const int SIO_FORCE_EVEN	=(char) 0x38;

	public const int SIO_LEN_7	=	(char) 0x02;
	public const int SIO_LEN_8	=	(char) 0x03;

	public const int SIO_STOP_1	=	(char) 0x00;
	public const int SIO_STOP_2	=	(char) 0x04;

	public const int SIO_LATCH_ENA	=(char) 0x80;
    
	public const int SIO_1200_DIV=	(char) 0x60;
	public const int SIO_2400_DIV	=(char) 0x30;
	public const int SIO_4800_DIV	=(char) 0x18;
	public const int SIO_9600_DIV	=(char) 0x0C;
	public const int SIO_19200_DIV	=(char) 0x06;
	public const int SIO_38400_DIV	=(char) 0x03;
	public const int SIO_57600_DIV	=(char) 0x02;
	public const int SIO_115200_DIV	=(char) 0x01;
	public const int SIO_250000_DIV=	(char) 0x0;

	public const int SIO_LOOPBACK	=(char) 0x10;
    
	public const int SIO_ERROR		=(char) 0xE;

	public const int SIO_POLLING	=	(char) 0x1;
	public const int SIO_INTERRUPT	=(char) 0x2;

	public const int SIO_OVERWRITE=	(char) 0x20;

	public const int SIO_RS485_HALF_DUPLEX	=(char) 0x10;



	// Interrupt sources
	//--------------------------------------------------------------------
	public const int IS_ADFIFO_HALF		=	0x0100;
	public const int IS_EXTERN			=	0x0200;
	public const int IS_CHANLIST_READY	=	0x0400;
	public const int IS_COUNTER_A		=	0x0800;
	public const int IS_COUNTER_B		=	0x1000;
	public const int IS_UART			=		0x2000;
	public const int IS_DAFIFO_HALF		=	0x4000;


	// PWM 
	//--------------------------------------------------------------------
	public const int PWM2600_NORMAL		=		0x1;
	public const int PWM2600_INVERTED	=		0x2;

	// Analog Output Ranges 
	//--------------------------------------------------------------------
	public const int AO2600_PLUS_10		=		0x1 ;    //   0V ..  10V
	public const int AO2600_MINUS_5		=		0x4  ;   // - 5V .. + 5V
	public const int AO2600_MINUS_10	=			0x8;     // -10V .. +10V
        
	// Analog Output Modes 
	//--------------------------------------------------------------------
	public const int AO2600_BUFFERED		=		0x1;
	public const int AO2600_TRANSPARENT		=	0x2;

	// Analog Output Trigger Modes
	//--------------------------------------------------------------------
	public const int AO2600_TRIGGER_TIMER	=	0x01;
	public const int AO2600_TRIGGER_EXT_LOW	=	0x02;
	public const int AO2600_TRIGGER_EXT_HIGH=		0x04;

	// Analog Input Modes and Ranges 
	//--------------------------------------------------------------------
	public const int AI2600_DIFFERENTIAL	=		0x80;
	public const int AI2600_SINGLE_ENDED	=		0x00;

	public const int AI2600_PLUS_10		=		0x40;
	public const int AI2600_PLUS_5		=		0x50;
	public const int AI2600_PLUS_2		=		0x60;
	public const int AI2600_PLUS_1		=		0x70;
	public const int AI2600_MINUS_10	=			0x00;
	public const int AI2600_MINUS_5		=		0x10;
	public const int AI2600_MINUS_2		=		0x20;
	public const int AI2600_MINUS_1		=		0x30;


	// Analog Input Trigger Modes 
	//--------------------------------------------------------------------
	public const int AI2600_TRIGGER_TIMER=	0x01;
	public const int AI2600_TRIGGER_EXT_LOW = 0x02;
	public const int AI2600_TRIGGER_EXT_HIGH =0x04;
	public const int AI2600_TRIGGER_CONTI=	0x08;

	// AO Modes 
	//--------------------------------------------------------------------
	public const uint AO2600_INFINITE	=			0xFFFFFFFF;
	public const int AO2600_INTERRUPT	=		0x00000001;
	public const int AO2600_POLLING		=		0x00000002;


	// AI Modes 
	//--------------------------------------------------------------------
	public const uint AI2600_INFINITE	=			0xFFFFFFFF;
	public const int AI2600_INTERRUPT	=		0x00000001;
	public const int AI2600_POLLING		=		0x00000002;
	public const int AI2600_CHANLIST_INTERRUPT=	0x00000004;
	public const int AI2600_ADFIFO_INTERRUPT=		0x00000008;
	public const int AI2600_ENABLE			=	0x00000010;
	public const int AI2600_DISABLE			=	0x00000020;
	public const int AI2600_SCAN_TO_DISK	=		0x00010000;
	public const int AI2600_SCAN_INFINITE	=	0x00020000;

	// DIO
	//--------------------------------------------------------------------
	public const int LOW_BYTE			=	0x0;
	public const int HIGH_BYTE			=	0x1;

	public const int MEINPUT			=		0x0;
	public const int MEOUTPUT			=	0x1;

	public const int PORTA				=	0x0;
	public const int PORTB				=	0x1;


	// Counter
	//--------------------------------------------------------------------
	public const int COUNTER2600_A		=	0x1;
	public const int COUNTER2600_B		=	0x2;
	public const int COUNTER2600_ENABLE	=	0x4;
	public const int COUNTER2600_DISABLE	=	0x8;


	// Bits of the Control Register 1 of VM1
	//--------------------------------------------------------------------
	public const int VM1_CR1_ENABLE_INT		=	0x8000;
	public const int VM1_CR1_RESERVED_14	=		0x4000;
	public const int VM1_CR1_INT_UART		=	0x2000;
	public const int VM1_CR1_INT_COUNT_B	=		0x1000;
	public const int VM1_CR1_INT_COUNT_A	=		0x0800;
	public const int VM1_CR1_INT_CHANLIST_READY=	0x0400;
	public const int VM1_CR1_INT_EXTERN		=	0x0200;
	public const int VM1_CR1_INT_AD_FIFO_HALF	=0x0100;
	public const int VM1_CR1_RESERVED_7		=	0x0080;
	public const int VM1_CR1_RESERVED_6		=	0x0040;
	public const int VM1_CR1_SCAN_MODE		=	0x0020;
	public const int VM1_CR1_SIMULTANEOUS	=	0x0010;
	public const int VM1_CR1_EXT_TRIGGER_EDGE=	0x0008;
	public const int VM1_CR1_EXT_TRIGGER_MODE=	0x0004;
	public const int VM1_CR1_ADC_MODE_BIT_1	=	0x0002;
	public const int VM1_CR1_ADC_MODE_BIT_0	=	0x0001;
        

	// Bits of the Control Register 2 of VM1
	//--------------------------------------------------------------------
	public const int VM1_CR2_RESERVED_15	=		0x8000;
	public const int VM1_CR2_RESERVED_14	=		0x4000;
	public const int VM1_CR2_RESERVED_13	=		0x2000;
	public const int VM1_CR2_RESERVED_12	=		0x1000;
	public const int VM1_CR2_RESERVED_11	=		0x0800;
	public const int VM1_CR2_RESET_AD_FIFO	=	0x0400;
	public const int VM1_CR2_RESET_CH_FIFO	=	0x0200;
	public const int VM1_CR2_RESERVED_8		=	0x0100;
	public const int VM1_CR2_RESET_PORT_B	=	0x0080;
	public const int VM1_CR2_RESET_PORT_A	=	0x0040;
	public const int VM1_CR2_RESERVED_5		=	0x0020;
	public const int VM1_CR2_RESET_COUNT_B	=	0x0010;
	public const int VM1_CR2_RESET_COUNT_A	=	0x0008;
	public const int VM1_CR2_RESEREVED		=	0x0004;
	public const int VM1_CR2_RESET_DAC		=	0x0002;
	public const int VM1_CR2_DAC_MODE		=	0x0001;


	// Bits of the Control Register 1 of VM2
	//--------------------------------------------------------------------
	public const int VM2_CR1_INT_DA_FIFO_HALF=	0x4000;

	// Bits of the Control Register 2 of VM2
	//--------------------------------------------------------------------
	public const int VM2_CR2_RESET_DA_FIFO	=	0x0800;

	// Bits of the Control Register 3 of VM2
	//--------------------------------------------------------------------	
	public const int VM2_CR3_RESET_PWM		=	0x0080;
	public const int VM2_CR3_PWM_INV		=		0x0040;
	public const int VM2_CR3_RESERVED_5		=	0x0020;
	public const int VM2_CR3_RESERVED_4		=	0x0010;
	public const int VM2_CR3_DAC_TRIGGER_EDGE=	0x0008;
	public const int VM2_CR3_DAC_TRIGGER	=		0x0004;
	public const int VM2_CR3_DAC_MODE_BIT1	=	0x0002;
	public const int VM2_CR3_DAC_MODE_BIT0	=	0x0001;

	// Bits of the Status Register of VM1
	//--------------------------------------------------------------------
	public const int VM1_ST_RESERVED_15		=	0x8000;
	public const int VM1_ST_RESERVED_14		=	0x4000;
	public const int VM1_ST_INT_UART		=		0x2000;
	public const int VM1_ST_INT_COUNT_B		=	0x1000;
	public const int VM1_ST_INT_COUNT_A		=	0x0800;
	public const int VM1_ST_INT_CHANLIST_READY=	0x0400;
	public const int VM1_ST_INT_EXTERN		=	0x0200;
	public const int VM1_ST_INT_AD_FIFO_HALF=		0x0100;
	public const int VM1_ST_RESERVED_7		=	0x0080;
	public const int VM1_ST_RESERVED_6		=	0x0040;
	public const int VM1_ST_RESERVED_5		=	0x0020;
	public const int VM1_ST_ADC_FIFO_FULL	=	0x0010;
	public const int VM1_ST_ADC_FIFO_HALFFULL=	0x0008;
	public const int VM1_ST_ADC_FIFO_EMPTY	=	0x0004;
	public const int VM1_ST_CH_FIFO_FULL	=		0x0002;
	public const int VM1_ST_ADC_FST_ACTIVE	=	0x0001;


	// Bits of the Status Register 2 of VM2
	//--------------------------------------------------------------------
	public const int VM2_ST2_DAC_FIFO_FULL	=	0x0008;
	public const int VM2_ST2_DAC_FIFO_HALFFULL=	0x0004;
	public const int VM2_ST2_DAC_FIFO_EMPTY	=	0x0002;
	public const int VM2_ST2_DAC_FST_ACTIVE	=	0x0001;


	// Some helper defines
	//--------------------------------------------------------------------
	//public const int SETBIT(x)= (1 << (x));

	// 1 / 204.8 = 0.0048828125
	//public const int ADC_TO_VOLT(x) ((x)>=0x800)?(double)(x)*0.0048828125-20:(double)(x)*0.0048828125

	// 2 / 4096 = 0.00048828125
	//public const int ADC_TO_VOLT(x,y,z) (double)((x)^0x800)*0.00048828125*(y)-(z)
	//public const int ADC_TO_VOLT(x,y,z)= (double)(x)*0.00048828125*(y)-(z);

	//public const int MAKE_CHANNELLIST(ch,range) =((ch) & 0x0F) + ((range) & 0xF0);
	//public const int MAKE_DACFIFOENTRY(ch,val)= ((ch) <<12) + ((val) & 0xFFF);

}
