﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;


namespace PReuter
{
    public partial class FormReuter : Form
    {
        FormMain meinMain;
        
        
        public FormReuter(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
        }

        string Tunegativ, resultreut;
        double _T1 = 0, _T2 = 0, _Tz = 0;
        double _Tu = 0, _Tg = 0;
        string S2PT1_Step = "2PT1 Step";
        string Tangent = "Tangent";

        public void deutsch()
        {
            
            Tunegativ = "Tu negativ oder Null, kein Ergebnis !";
            resultreut = "      Ergebnis der Reuter Identifikation ";
            button1.Text = "Zum Report";
            button3.Text = "&Schließen";
            //BitBtn1->Hint="Schließen und Ergebnisse ignorieren" ;
            //BitBtnOK->Hint="Schließen und Ergebnisse in andere Fenster kopieren" ;
            label1.Text = "Identifikation eines 2PT1-";
            label13.Text = "Modelles mit der Me-";
            label14.Text = "thode von Reuter";

            //Label13->Caption="Wendetangente";
            label8.Text = "Totzeit";
            button2.Text = "&Empfindlichkeit";
            Text = "Identifikation mit Wendetangentenmethode nach Reuter";
            chart2D1.Germanlanguage = true;
            label26.Text = "Zeitachse in Sekunden";
            labelPoints.Text = "Anzahl Punkte";
            S2PT1_Step = "2PT1 Sprung";
            Tangent = "Tangente";
           
        }


        
        //---------------------------------------------------------------------------
        double h2PT1(double t, double T1, double T2)
        {
            double ex1, ex2;
            if (Math.Abs(T1) < 1e-10) T1 = 1e-10;
            if (Math.Abs(T2) < 1e-10) T2 = 1e-10;
            if (t / T1 > 80) ex1 = 0.0; else ex1 = Math.Exp(-t / T1);
            if (t / T2 > 80) ex2 = 0.0; else ex2 = Math.Exp(-t / T2);
            if (Math.Abs(T1 - T2) / T1 > 1e-10) return (1 + (-T1 * ex1 + T2 * ex2) / (T1 - T2));
            else return (1 - (T1 + t) / T1 * ex1);
        }
        //---------------------------------------------------------------------------
        double gradh2pt1(double t, double T1, double T2)
        {
            double ex1, ex2;
            if (t / T1 > 80) ex1 = 0.0; else ex1 = Math.Exp(-t / T1);
            if (t / T2 > 80) ex2 = 0.0; else ex2 = Math.Exp(-t / T2);
            if (Math.Abs(T1 - T2) / T1 > 1e-10)
                return ((ex1 - ex2) / (T1 - T2));
            else return ((t / T1 / T1) * ex1);
        }

        //------------------ ---------------------------------------------------------
        void tutg(ref double tu, ref double tg, double T1, double T2)
        {
            double hw, tw, grad;
            if (Math.Abs(T1 - T2) / T1 > 1e-10)
                tw = T1 * T2 / (T1 - T2) * Math.Log(T1 / T2);
            else tw = T1;
            hw = h2PT1(tw, T1, T2);
            grad = gradh2pt1(tw, T1, T2);
            tg = 1 / grad;
            tu = tw - hw / grad;
        }

        private void Reuterident(double tu, double tg, ref double /*&*/  T1, ref double /*&*/ T2, ref double /*&*/ Tz)
        {
            double x, b, hilf;
            double aa, bb, x1, x2, f1, f2, tu1, tg1;
            double[] powerx;
            int i;

            powerx = new double[7];
            x = tu / tg; Tz = 0;
            if (tu <= 0)  MessageBox.Show(Tunegativ);
                       
            else if (x < 0.016)
            {
                T1 = tg; T2 = tu; b = T2 / T1; hilf = tg / T1;
            }
            else if (x > 0.101)
            {
                T1 = 0.4649 * tg; T2 = 0.2789 * tg; Tz = tu - tg / 10.0;
            }
            else
            {    /* switch (0.016<x<0.1*/
                powerx[0] = 1;
                for (i = 1; i <= 6; i++)
                    powerx[i] = powerx[i - 1] * x;
                b = 4.718067869278e-2;
                b = b - 9.221731329728 * powerx[1];
                b = b + 8.154533741866e2 * powerx[2];
                b = b - 2.911008862897e4 * powerx[3];
                b = b + 5.365473286922e5 * powerx[4];
                b = b - 4.819088731821e6 * powerx[5];
                b = b + 1.697919973411e7 * powerx[6];
                hilf = 1.101504362557;
                hilf = hilf - 1.575911053093e1 * powerx[1];
                hilf = hilf + 1.596248432828e3 * powerx[2];
                hilf = hilf - 5.714287489367e4 * powerx[3];
                hilf = hilf + 1.042091887446e6 * powerx[4];
                hilf = hilf - 9.231048230465e6 * powerx[5];
                hilf = hilf + 3.193754111909e7 * powerx[6];
                T1 = tg / hilf;
                T2 = T1 * b;
            }
            if (x <= 0.101)// to improve accuracy one step with linear interpolation
            {
                /*improve T1/T2 */
                tu1 = 0;
                tg1 = 0;
                tutg(ref tu1, ref tg1, T1, T2); x1 = tu1 / tg1; f1 = T2 / T1;   /* 1. point */
                tutg(ref tu1, ref tg1, T1, T2 * 1.01); x2 = tu1 / tg1; f2 = T2 * 1.01 / T1;  /* 2. point */
                aa = (f2 - f1) / (x2 - x1); bb = f1 - aa * x1;
                b = aa * x + bb;
                /*improve Tg/T1 */
                tutg(ref tu1, ref tg1, T1, T2); x1 = tu1 / tg1; f1 = tg1 / T1;   /* 1. point */
                tutg(ref tu1, ref tg1, T1 * 1.01, T2); x2 = tu1 / tg1; f2 = tg1 / T1 / 1.01;  /* 2. point */
                aa = (f2 - f1) / (x2 - x1); bb = f1 - aa * x1;
                hilf = aa * x + bb;
                T1 = tg / hilf;
                T2 = T1 * b;
            }
        }

        private void button1_Click(object sender, System.EventArgs e)
        {
            string a = "              ";
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText(a + resultreut + "\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText(a + label2.Text + " = " + textBox1.Text + "   " + label9.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label3.Text + " = " + textBox2.Text + "   " + label10.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label4.Text + " = " + textBox3.Text + "\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText(a + label6.Text + " = " + textBox4.Text + "   " + label11.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label7.Text + " = " + textBox5.Text + "   " + label12.Text + "\r\n");
            meinMain.tBMainReport1.AppendText(a + label8.Text + " = " + textBox6.Text + "\r\n");
            meinMain.tBMainReport1.AppendText("\r\n");
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________\r\n");
        }

        private void button2_Click(object sender, System.EventArgs e)
        {
            double tu=0, tg=0, t1, t2, tz, dt1, dt2, t1n, t2n, dt1max, dt2max;
            meinMain.ConvertToDouble(textBox1.Text,ref tu );
            meinMain.ConvertToDouble(textBox2.Text,ref tg );
            t1 = 0;
            t2 = 0;
            tz = 0;
            t1n = 0;
            t2n = 0;
            Reuterident(tu, tg, ref t1, ref t2, ref tz);
            label9.Text = "+-1%";
            label10.Text = "+-1%";
            tu = tu * 1.01;
            Reuterident(tu, tg, ref t1n, ref t2n, ref tz);

            dt1max = Math.Abs((t1 - t1n) / t1 * 100);
            dt2max = Math.Abs((t2 - t2n) / t2 * 100);

            tu = tu / 1.01;
            tg = tg * 1.01;
            Reuterident(tu, tg, ref t1n, ref t2n, ref tz);
            if (tz == 0) textBox6.BackColor = Color.WhiteSmoke;
                    else textBox6.BackColor = Color.LightSalmon;

            dt1 = Math.Abs((t1 - t1n) / t1 * 100);
            dt2 = Math.Abs((t2 - t2n) / t2 * 100);

            tg = tg / 1.01;
            if (dt1 > dt1max) dt1max = dt1;
            if (dt2 > dt2max) dt2max = dt2;
            label11.Text = dt1max.ToString("G4") + "%";//FloatToStrF(dt1max,ffFixed,4,1)+"%";
            label12.Text = dt2max.ToString("G4") + "%";//FloatToStrF(dt2max,ffFixed,4,1)+"%";

        }

        private void WinForm_Load(object sender, System.EventArgs e)
        {
            Tunegativ = "Tu can not be negative";
            resultreut = "Result of Reuter Identification";
            textBox1_Leave(sender, e);
        }

        private void button3_Click(object sender, System.EventArgs e)
        {
            this.Hide();

        }

        private void button4_Click(object sender, System.EventArgs e)
        {
            this.Hide();
            meinMain.reuterOK();
        }

        private void textBox1_Leave(object sender, System.EventArgs e)
        {
            double x, tu = 0, tg = 0, t1 = 0, t2 = 0, tz = 0;

            meinMain.ConvertToDouble(textBox1.Text,ref tu );
            meinMain.ConvertToDouble(textBox2.Text,ref tg );
            _Tu = tu;
            _Tg = tg;
            
            Reuterident(tu, tg, ref t1, ref t2, ref tz);
            if (tz == 0) textBox6.BackColor = Color.WhiteSmoke;
                    else textBox6.BackColor = Color.LightSalmon;
            x = tu / tg;
            textBox3.Text = x.ToString("G8");//FloatToStrF(x,ffFixed,10,4);
            textBox4.Text = t1.ToString("G8");//FloatToStrF(t1,ffFixed,10,4);
            textBox5.Text = t2.ToString("G8");//FloatToStrF(t2,ffFixed,10,4);
            textBox6.Text = tz.ToString("G8");//FloatToStrF(tz,ffFixed,10,4);
            label9.Text = ""; /*clear sensitivities */
            label10.Text = "";
            label11.Text = "";
            label12.Text = "";
            _T1 = t1;
            _T2 = t2;
            _Tz = tz;
            drawStart();
        }

        private void textBox4_Leave(object sender, System.EventArgs e)
        {
            double tu=0, tg=0, tz=0, t1=0, t2=0, tmp;
            meinMain.ConvertToDouble(textBox4.Text,ref t1  );
            meinMain.ConvertToDouble(textBox5.Text,ref t2  );
            _T1 = t1;
            _T2 = t2;
            tutg(ref tu, ref tg, t1, t2);
            meinMain.ConvertToDouble(textBox6.Text,ref tz );
            tu = tu + tz;

            textBox1.Text = tu.ToString("G8");//FloatToStrF(tu,ffFixed,10,4);
            textBox2.Text = tg.ToString("G8");//FloatToStrF(tg,ffFixed,10,4);
            tmp = tu / tg;
            textBox3.Text = tmp.ToString("G8");//FloatToStrF(tu/tg,ffFixed,10,4);
            label9.Text = ""; /*clear sensitivities */
            label10.Text = "";
            label11.Text = "";
            label12.Text = "";
            _Tu = tu;
            _Tg = tg;
            _Tz = tz;
            drawStart();
        }

         private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox1_Leave(sender, e);
        }

        private void textBox4_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox4_Leave(sender, e);

        }

        private void FormReuter_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Visible = false;
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown1, 1e-5, 1e5);
            drawStart();
        }

        private void drawStart()
        {
            chart2D1.clearAll();
            int nb = (int)numericUpDown2.Value;
            double kx = 0, y = 0;
            kx = (double)numericUpDown1.Value;
            kx = kx / nb;

            double T1 = _T1, T2 = _T2;
    

            for (int i = 0; i < nb; i++)
            {

                double x = kx * i;
                if (x >= _Tz)
                    y = 1 - T1 / (T1 - T2) * Math.Exp(-(x - _Tz) / T1) - T2 / (T2 - T1) * Math.Exp(-(x - _Tz) / T2);
                else y = 0;
                chart2D1.setPoint(0, x, y);
            }
            chart2D1.setPoint(1, _Tu, 0);
            chart2D1.setPoint(1, _Tu + _Tg, 1);
            chart2D1.CurveNames[0] = S2PT1_Step;
            chart2D1.CurveNames[1] = Tangent;
            chart2D1.updateNames();
            chart2D1.startDrawing();
            chart2D1.autoScaling();
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown2, 10, 1e4);
            drawStart();
        }

    
    
    
    }
}
