﻿using System;  //57 --> 58
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using WINDF7CSharp;
using System.Runtime.InteropServices;
using AConInfo;


// Init Program for student use 
// stud_algorithm() is cleaned


namespace AdaptControl
{
    public partial class FormAdaptControl : Form 
    {
        const int maxpoints = 50001;
        const int maxnp2 = 113;  //max degree of DB / Orientation is 10

        private readonly MicroLibrary.MicroTimer _microTimer;
        double xoff = 0, uoff = 0, amp = 0, xroff = 0; //initialization of voltage
        public double wSoll = 0;                         //public variable wSoll ,the expected output, to be called by other objects
        public double val;                           //public variable val, the voltage input from motor, to be called by other objects

        FormMain meinMain;
        Boolean onRecord = false;  //indication of button RunRSR being pressed or not
        public bool RunOn = false; //public indication of whether motor being running

        int irtc = 0, nb = 0;       //curve point indication i, curve points numbers nb
        int indexRec = 0;            //pulse number

        public double q0p, q0n, q1n, q0d, p1n, q1d, q0i, q1i, q2i, p1i, p1f, p2f, q0f, q1f, q2f, q0fPD, q1fPD, q2fPD; //{PID-params,}
        //p=P //n=PI  //i=PID  // d=PD // f= PIDT1 free // fPD for Antiwindup
        double q0ac, q0ic, q1ic;//cascaded
        double TwoPointUp, TwoPointDown;
        int mgradCon=0,mgradIdent=0;
        double limitation = 0, limit_low = 0;
        double z1 = 0, z2 = 0;
        double t0start = 0, t0end = 0; double dtstart = 0, dtend = 0; double dtmax = 0; double dt = 0; //variables related to standard timer  for displaying dT to and dTMAX
        int cntT0 = 0;
        double t0avr = 0, dtavr = 0;
        int Ncon = 0;  //Ncon stands for selected controller for button RSR
        int InitialType = 0;//InitialType stands for initial controller for button RUN
        string ConType = "P";
        int pulse = 0;
        bool recOn = false; bool stepOn = true;

        bool procSR = false; double procInputBeforePSR = 0, firstVal = 0;
        const int filtnb = 10;  // Digital Filter to get the Process input average before process step response
        private double[] xrBeforeStep = new double[filtnb];

        string[] pars = new string[4];
        int thisdrawnum = 1;

        FromAControlInfo acinfo = new FromAControlInfo();
        Stopwatch stopwatch1 = new Stopwatch();

        double yout = 0; double yold = 0, yold2 = 0; double xdold1 = 0; double xdold2 = 0;
        double youtDisplay = 0, youtdisplayfiltered = 0;
        int idisplay = 0;
        double yoldI, xdn1casI, youtI, x1casI;  // Cascaded controller before RSR
        double q0Init, q1Init, xd1Init = 0;
        double ncas, xdn1cas, xdncas, wncas, x1cas;  // cascaded controller

        public double t0rtc;

        string maxpts = "Max Points= ";
        double[,] ayval = new double[maxpoints, 2]; //storage for double value of points on curves
        double[,] awval = new double[maxpoints, 2];
        double[,] axrval = new double[maxpoints, 2];
        string OneCurvenecessary = "One Curve is necessary";
        int lastNbOfPoints = 0;

        public double[] xd = new double[maxnp2];    // control error
        public double[] xa = new double[maxnp2];    // process output val
        public double[] xr = new double[maxnp2];    // controller output
        int d_DBC = 0;
        string FilterName = "RTC- Data";
        string points = "Points";
        LoadOpt LOrtc = new LoadOpt();
        string CRLF = "\r\n";
        string nlarger2notpossible = "n larger 4 not possible";  // since 7.6.18 3 auch implementiert since 7.6.21 auch n=4
        string Identsensfulreal = "Identification is only valid in real mode";



        double DZcompensation = 0, NoiseAtZ1 = 0;
        Random NoiseZ1 = new Random();

        /*Regelungstechnische PFC Variablen*/
        const int MaxDelay=100;
        double fYr=0;
        double[] fXd = new double[MaxDelay] ;                 //Regeldiffenenz "Schieberegister"              
        double[] fXm = new double[MaxDelay];                 //Modellausgang "Schieberegister"  auch für OR mit delay
        double[] fXm2 = new double[MaxDelay];                 //Modellausgang 2. PT1 "Schieberegister"
        double[] fXg = new double[MaxDelay];                 //Strecke gemessen "Schieberegister"
        double[] fxmr = new double[MaxDelay];                   // new IT1- decomposition field
 


        /*PFC spezifische Variablen*/
        double fA, fAh, fB, fBh, fC, fCh, fKm, fT1, fT2, fLh, fTr, fT0 , fTdec=0;             //fKm=Modellverstärkung, fT1=Zeitkonstante Modell, fT0=Abtastzeit
        double fa1 = 0, fa2 = 0, fa3 = 0, fa4 = 0, fb1 = 0, fb2 = 0, fb3 = 0, fb4 = 0, valold = 0, fYrold = 0, xmodpredold = 0, fYrold2 = 0, fYrold3 = 0, fYrold4 = 0;
        int iH,iHBay;       //iH=Prädiktionshorrizont iH Richalet, iHBay DB BAy
        double valfiltold = 0, valfiltold2 = 0, valfilt = 0, valfiltold3 = 0;
        double fPFCfiltA1 = 0, fPFCfiltB1 = 1;
        double valPFCfiltold = 0;
        int dPFCm = 0, dPFCm2=0;  // Delay time of PFC- Model
        double Kalpha, Kbeta, k1PFC, k2PFC, K0PFC;  // new 2PT1
        double fA1_PFC, fA2_PFC;
        string PFClegend,PFClegendhTr;
        double testmodelin = 0, modelout = 0;  // Test PFC IT1

        double[,] A3 = new double[7, 7]; // für DB Bay n=3 und n=4
        double[] Z = new double[7];
        matinvert.matinvert1 Invert ;
        // Params for disturbance calculation in PFC 
        double fxmz, fxmz1, fxmz2, fyrz, fyrzold, fyrz2, disturbance, youtWithoutDisturb, distcomp, distFilt,distfilt1,distfilta1,distfiltb1,DistGain;
        int delay, delay2;
        double    KiT0It1;


        // for adaptive controllers
        double[] pv = new double[maxnp2 + 1];    // DB (v) Standard
         double[] qv = new double[maxnp2 + 1];
         double[] p1v = new double[maxnp2 + 1];   // DB(v+1)
         double[] q1v = new double[maxnp2 + 1];
         double[] p2v = new double[maxnp2 + 1];   // Orienteering controller
         double[] q2v = new double[maxnp2 + 1];
         double f3or;  // Orientering Contr
         double[] tetaIdent_b0 = new double[maxnp2];
         double[] teta2Con = new double[maxnp2];  // Das teta für die Controller
         double[] uindelay = new double[MaxDelay];  // Speicher für delay in RLS- Ident 

         String binaryfile = "10101100";
         int BitNb = 0;        // Nummer des jeweilig aktuellen Bit in binaryfile
         bool pulseOn = true;  // Bei true wird Amp zu w / z1 / z2 dazuaddiert

        CHMinMax minmax;

        // Timing Histogram
        long[] histT0 = new long[1000];
        long[] histdT = new long[1000];
        double MaxT0 = 0, MaxdT = 0;
        long histcnt = 0;
        string psrtext = "process SR";
        string legendText = "";

        // for Ident Parameter display
        //const int maxPointsIdentDisplay = 1000;

        //double[,] IdentK = new double[maxPointsIdentDisplay, 2]; //storage for double value of points on curves
        //double[,] IdentT1 = new double[maxPointsIdentDisplay, 2];
        //double[,] IdentT2 = new double[maxPointsIdentDisplay, 2];

        //int cntIdentDispl = 0;
 
 

        public FormAdaptControl(FormMain m)
        {
            InitializeComponent();
            Control.CheckForIllegalCrossThreadCalls = false;
            meinMain = m;
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(EventVomMMTimer);
            dataGridViewControllerPar.Rows.Add("0", "0");       //add three new rows in datagridviewControllerPar,waiting for incoming control parameters
            dataGridViewControllerPar.Rows.Add("0", "0");
            dataGridViewControllerPar.Rows.Add("0", "0");
            minmax = new CHMinMax();
            stopwatch1.Start();

            // Init Values Breathing System
            q0p = 4.23; q0d = 31.608; q1d = -23.706;
            q0n = 1.94487; q1n = -1.9148; q0i = 15.528; q1i = -26.704; q2i = 11.294; p1n = 1; p1i = 1;
            // Cascades controller for Breathing system
            q0ac = 30.0; q0ic = 0.201; q1ic = -0.17;
            TwoPointDown = -10.0;
            TwoPointUp = 10.0;
            t0rtc = 0.01;
            labelMaxPoints.Text = maxpts + (maxpoints-1).ToString();
            //numPoints.Maximum = maxpoints-1;
            toolStripButton12_Click(null, null);
            LOrtc.init();
            tBiniQ0_Leave(null, null);
            chart2D1.ButtonPanel = true;
            chart2D1.CurveColor0 = Color.Blue;
            chart2D1.CurveColor3 = Color.Black;
            chart2D1.AllClearButton = false;
            chart2D1.LastClearButton = false;
            chart2D1.ZoomButton = true;
            dataGridView1.RowCount = 3;
            dataGridView1.Rows[0].Cells[0].Value = "1";
            dataGridView1.Rows[0].Cells[1].Value = "0";
            dataGridView1.Rows[1].Cells[0].Value = "0";
            dataGridView1.Rows[1].Cells[1].Value = "0";
            dataGridView1.Rows[2].Cells[0].Value = "0";
            dataGridView1.Rows[2].Cells[1].Value = "0";


            this.chart2D1.AutoScaleButton = true;
            this.chart2D1.BackColorButton = true;
            this.chart2D1.ButtonPanel = true;
            this.chart2D1.ColorBlackButton = true;
            this.chart2D1.EditorButton = true;
            this.chart2D1.InfoButton = true;
            this.chart2D1.LegendButton = true;
            this.chart2D1.LoadButton = true;
            this.chart2D1.PenScaleButton = true;
            this.chart2D1.PrintButton = true;
            this.chart2D1.SaveButton = true;
            this.chart2D1.ScallingButton = true;
            this.chart2D1.TitleButton = true;
            this.chart2D1.XGridButton = true;
            this.chart2D1.YGridButton = true;
            this.chart2D1.ZoomButton = true;
            PFCmod2PT1Delay.Maximum = MaxDelay-1;
            PFCmodPT1delay.Maximum = MaxDelay-1;

            this.chart2D2.AutoScaleButton = true;
            this.chart2D2.BackColorButton = true;
            this.chart2D2.ButtonPanel = true;
            this.chart2D2.ColorBlackButton = true;
            this.chart2D2.EditorButton = true;
            this.chart2D2.InfoButton = true;
            this.chart2D2.LegendButton = true;
            this.chart2D2.LoadButton = true;
            this.chart2D2.PenScaleButton = true;
            this.chart2D2.PrintButton = true;
            this.chart2D2.SaveButton = true;
            this.chart2D2.ScallingButton = true;
            this.chart2D2.TitleButton = true;
            this.chart2D2.XGridButton = true;
            this.chart2D2.YGridButton = true;
            this.chart2D2.ZoomButton = true;

            //nudDisplayIdent.Maximum = maxPointsIdentDisplay;
            chart2D1.clearAll();  // To start with no curves and counter -1
            Invert = new matinvert.matinvert1(); 

        }

        private void FormStudControl_Load(object sender, EventArgs e)
        {
            rbPcon_CheckedChanged(sender, e);
            pq2DataGrid();
            Tabs.SelectedIndex = 4;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[4] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[4] ab.
            Tabs.SelectedIndex = 3;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[3] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[3] ab.
            Tabs.SelectedIndex = 5;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[5] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[5] ab.
            Tabs.SelectedIndex = 0;
            numericUpDown4.Value=2;
            if (Dmgrad==2) but2PT1toFZ_Click(sender, e);  // nur bei 2, da schon in ContrDes das Datagrid belegt wurde
            readpv_valuesfromconrdes();
            rBAdvanced_CheckedChanged(null, null); // stelle auf simple
        }

        public void deutsch()
        {
            OneCurvenecessary = "Mindestens eine Kurve ist nötig";
            maxpts = "Max. Punkte";
            FilterName = "Echtzeitkurve";
            points = "Punkte";
            this.Text = "Echtzeitregler";
            buttonRSR.Text = "Start FSA";
            toolTip1.SetToolTip(buttonRSR, "Starte Führungs- oder Störsprungantwort");
            butProcStepResp.Text = "Start SSA";
            toolTip1.SetToolTip(butProcStepResp, "Starte Streckensprungantwort");
            rsbHelp.ToolTipText = "Öffne Signalflussplan";
            tsbWriteReport.ToolTipText = "Speichere beliebige Kurve als .sim - Datei";
            tsbGreenOK.ToolTipText = "Schließe Fenster und aktiviere Identifikation";
            tsbClose.ToolTipText = "Schließe Fenster und ignoriere Ergebnisse";
            tsbClearX.ToolTipText = "Text löschen";
            tsbClearW.ToolTipText = "Text löschen";
            tsbClearXr.ToolTipText = "Text löschen";
            tsbsaveW.ToolTipText = "Speicher W-Werte als .Sim- Datei";
            tsbSaveX_.ToolTipText = "Speicher X-Werte als .Sim- Datei";
            tsbSaveXr.ToolTipText = "Speicher Xr-Werte als .Sim- Datei";
            tsbReportX_.ToolTipText = "Erzeuge Report der letzten X- Werte";
            tsbReportW.ToolTipText = "Erzeuge Report der letzten W- Werte";
            tsbReportXr.ToolTipText = "Erzeuge Report der letzten Xr- Werte";
            toolTip1.SetToolTip(buttonPQenter, "Übernehme Änderungen der p-q-Werte");
            toolTip1.SetToolTip(cBUnitSR, "Wenn geklickt, konvertiere in Einheitssprungantwort");
            toolTip1.SetToolTip(tbComp, "Kompensation der toten Zone");
            toolTip1.SetToolTip(butProcStepResp,"Messe Streckensprungantwort");
            butProcStepResp.Text = "Start PSA";
            groupBox12.Text = "Echtzeitwerte";
            cbRealtimeDevice.Text = "Echtzeitkurve";
            groupBox2.Text = "Reglertyp";
            rbCascadedcon.Text = "Kask. Beatm.";
            raBCascNew.Text = "Kask. Zahn";
            toolTip1.SetToolTip(butFreeContr, "Freier PID");
            butFreeContr.Text = "Freier PID";
            rbFreecon.Text = "Freier PID";
            groupBox4.Text = "Ablauf Funktion";
            rbStepAutostop.Text = "Sprung, autostop";
            rbRectContinous.Text = "kont. Rechteck";
           
            rbImpulsAutostop.Text = "Impuls, autostop";
            groupBox7.Text = "Anfangswerte nach RUN";
            groupBox5.Text = "Signal AMP an";
            groupBox6.Text = "Xr nach Autostop";
            cbNoiseZ1.Text = "Rauschen an Z1";
            toolTip1.SetToolTip(cbNoiseZ1, "Kann zur LS- Offline-Identifikation genutzt werden");
            rbInitialUoffByP.Text = "Uoff geregelt mit PI";
            rbInitialUoffByPI.Text = "Uoff geregelt mit Kask. Reg.";
            rbInitialXByCon.Text = "Uoff geregelt mit gewähltem Reg";
            groupBox10.Text = "Regler Parameter";
            groupBoxLimit.Text = "Begrenzung Xr";
            cbLimitation.Text = "Aktiviert +-";
            label29.Text = "Totzonen-Komp.";
            groupBox8.Text = "Streckenparameter";
            label21.Text = "Signal X an Kanal";
            toolTip1.SetToolTip(butFreeContr, "Freier PID");
            toolTip1.SetToolTip(buttonStop, "Stoppt Echtzeitmodus");
            toolTip1.SetToolTip(buttonRUN, "Startet Echtzeitmodus");
            labelMaxPoints.Text = maxpts + maxpoints.ToString();
            tabPage1.Text = "Kurven";
            tabPagePar.Text = "Parameter";
            tabPage3AdvPar.Text = "mehr Parameter";
            tabPage5x.Text = "Letzte X- werte";
            tabPage4LastXr.Text = "Letzte Xr- Werte";
            tabPage7LastW.Text = "Letzte W- Werte";
            tabPage6ConPar.Text = "Alle p-q-Reglerparameter";
            label7.Text = "p-q- Liste aller Regler";
            toolTip1.SetToolTip(butLoadContr, "Lade kompletten Set aller Regler");
            toolTip1.SetToolTip(butSaveContr, "Speichere kompletten Set aller Regler");
            toolTip1.SetToolTip(butAktivatepqChange, "Aktiviert Änderungen anden p-q- Werten");
            butAktivatepqChange.Text = "Aktiviere Änderungen";
            groupBox9.Text = "Identifizierte Streckenparameter";
            cbAdaptionActive.Text = "Adaptive Regler aktiv";
            cbIdentificationActive.Text = "Online-Identifikation aktiv";
            TSBClearLast.ToolTipText = "Lösche letzte Kurve";
            tsbClearAll.ToolTipText = "Lösche alle Kurven";
            chart2D1.Germanlanguage = true;
            toolTip1.SetToolTip(butdrawAgain, "Zeichne nochmal");
            acinfo.pictureBoxGer.Visible = true;
            gbReglerWahl.Text = "PFC- Modell Wahl";
            rbPT1.Text = "PT1-Modell 1";
            rb2PT1.Text = "2PT1-Modell 1";
            rB2PT1_2.Text = "2PT1- Modell 2";
            rB2PT1_3.Text = "2PT1 PFC";
            rBFZ2.Text = "2PT1 DB Bay";
            cBModelLimited.Text = "Modell Ausg. begr.";
            gbPT1.Text = "PT1-Modell";
            gb2PT1.Text = "2PT1 - Modell";
            gBIT1.Text = "IT1- Modell";
            buttonActPFCChanges.Text = "Aktiviere Änderung";
            nlarger2notpossible="n>3 nicht möglich";
            label31.Text = "DA- Ausgang";
            label32.Text = "AD- Eingang";
            psrtext = "Strecken-SA";
            butUnitStep.Text = "ESF";
            toolTip1.SetToolTip(butUnitStep , "Zurück zur Einheitssprungfunktion");
            label34.Text = "Totzeit DB/OR";
            toolTip1.SetToolTip(butInitSimul, "Wenn Hardwaresimulator läuft, löscht diese Taste alle Werte auf Null");
            butDelToContr.Text = "-->Regler";
            toolTip1.SetToolTip(butDelToContr, "Kopiere Delay zu den Reglern");
            Identsensfulreal = "Identifikation geht nur im Real Modus";
            rBSimple.Text = "einfache Ansicht";
            rBAdvanced.Text = "komplexe Ansicht";
            toolTip1.SetToolTip(rbCascadedcon, "Kaskadenregler für Beatmungsgerät");
            toolTip1.SetToolTip(raBCascNew,"Kaskadenregler für Zahnstangenantrieb");
            cBPowerLin.Text = "Leistungslinearisierer";
            toolTip1.SetToolTip(cBPowerLin, "Linearisiert die Leistungskurve der Temperaturregelung");
            cBxrWithSH.Text = "Xr mit Sample && Hold";
            cBWfromADC.Text = "Sollwert vom ADC";
            chart2D1.Germanlanguage = true;
            chart2D2.Germanlanguage = true;
        }

 
        // your student parameters should start with _
        // double _newPar;

        public void stud_algorithm()
        {
            double xd0 = 0;
            meinMain.ADCinput((short)nudSignalIn.Value, ref val);
            if (cBSignalInversion.Checked) val = -val;
            meinMain.DACoutput((short)nudChanDA.Value, yout);
            youtDisplay = yout;
            xd0 = wSoll - val;   // control difference

            switch (Ncon)
            {
                case 0: yout = 5.7234 * xd0; break;//P controller
                case 1: yout = 0; break;//PDT1 controller
                case 2: yout = 0; break;//PI controller
                case 3: yout = 0; break; //PIDT1 controller 
                case 5: yout = 0; break; // Pidt1 with Anti Wind Up
                case 6: yout = 0; break; // Dead beat controller
                default: yout = 10 * xd0;
                    break;
            }

            yout = yout + z1;

            if (yout > 0) yout = yout + DZcompensation; else yout = yout - DZcompensation; //Dead Zone compensation

            if (cbLimitation.Checked)
            {
                if (yout > limitation) yout = limitation;
                if (yout < -limit_low) yout = -limit_low;
            }
        }



        private void EventVomMMTimer(object sender, MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {
            double xd0;
            t0end = t0start;
            t0start = stopwatch1.ElapsedTicks;
            double deltaT0=t0start - t0end;
            t0avr = t0avr + (deltaT0);  //calculating t0
            dtstart = stopwatch1.ElapsedTicks;
            if (cbDA1impulse.Checked) meinMain.DACoutput((short)nudChanImpulse.Value , 1); // 1 Volt - Impuls auf 2. DA - Kanal 
            if (onRecord == true)
            {   // after pressing RSR- or PSR button

                if (irtc < (int)numPoints.Value)
                {
                    //calculation loop starts
                    idisplay = irtc;
                    minmax.progress = irtc;
                    ayval[irtc, 0] = irtc * t0rtc;
                    awval[irtc, 0] = irtc * t0rtc;
                    axrval[irtc, 0] = irtc * t0rtc;
                    if (cBWfromADC.Checked)
                    {
                        double temp = 0;
                        meinMain.ADCinput((short)nuDWInputChan.Value, ref temp);
                        if (cBSignalInversion.Checked) temp = -temp;
                        wSoll = temp;
                    }
                    else if ((rbImpulsAutostop.Checked) && (irtc > pulse)) wSoll = uoff;
                    if (procSR)  // process step response autostop
                    {
                        wSoll = amp;   // Only Amplitude is given to process input without offset
                        z1 = 0;
                        z2 = 0;

                        meinMain.DACoutput((short)nudChanDA.Value , youtdisplayfiltered + wSoll);   // Starting Value + w
                        youtDisplay = youtdisplayfiltered + wSoll;
                        meinMain.ADCinput((short)nudSignalIn.Value, ref val);  // //so in Process Simul bo is possible
                        if (cBSignalInversion.Checked) val = -val;
                        // first filtering process output
                        val = fPFCfiltB1 * val - fPFCfiltA1 * valPFCfiltold;
                        valPFCfiltold = val;
                        
                        if (irtc == 0) { firstVal = val; axrval[0, 1] = 0; }
                        

                        if (!cBUnitSR.Checked)
                        {
                            ayval[irtc, 1] = val;
                            axrval[irtc, 1] = wSoll + youtdisplayfiltered;
                        }
                        else
                        {
                            ayval[irtc, 1] = (val - firstVal) / wSoll; // remove offset and Unit step response
                            axrval[irtc, 1] = wSoll;
                        }
                        // in w is the process input
                        
                    }
                    else
                    {   //reference step respose autostop
                        if (irtc == 0)
                        {    // to correct the starting value if not zero
                            yout = youtdisplayfiltered;
                            yold = yout; yold2 = yout;
                            for (int hzp = 1; hzp < xr.Length; hzp++)
                            {
                                xr[hzp] = yout; xa[hzp] = val;
                            }
                            for (int hzp = 0; hzp < fXg.Length; hzp++)
                            {
                                fXg[hzp] = yout; fXm[hzp] = yout; fXm2[hzp] = 0; fxmr[hzp] = 0;
                            }

                            for (int hzp = 0; hzp < fXg.Length; hzp++)
                            {
                                fXm[hzp] = Kalpha * yout; fXm2[hzp] = Kbeta * yout; fxmr[hzp] = val;
                            }
                            CVpred = val;
                            // Also for disturbance compensation DB Bay init values if not zero
                            fyrz = yout;fyrz2 = yout;fyrzold = yout;
                            fxmz1 = val;fxmz2 = val;

                            // Cascaded init
                            x1cas = val; xdn1cas = 0;
                            valold = val; fYrold2 = yout; fYrold = yout; fYrold3 = yout; fYrold4 = yout;
                            valfiltold = val; valfilt = val; fYr = yout; valfiltold2 = val; valfiltold3 = val;
                            valPFCfiltold = val;
                            if (cBWfromADC.Checked)
                            {
                                double temp = 0;
                                meinMain.ADCinput((short)nuDWInputChan.Value, ref temp);
                                if (cBSignalInversion.Checked) temp = -temp;
                                wSoll = temp;
                            }
                            else
                            {
                                if (rbSignalAtW.Checked) { wSoll = uoff + amp; z1 = 0; z2 = 0; }
                                if (rbSignalAtZ1.Checked) { wSoll = uoff; z1 = amp; z2 = 0; }
                                if (rbSignalAtZ2.Checked) { wSoll = uoff; z1 = 0; z2 = amp; }
                            }

                        }
                        if (rBStud.Checked)
                        {
                            stud_algorithm();
                        }
                        else
                        {
                            ProfAlgorithm();
                        }
                        ayval[irtc, 1] = val;
                        awval[irtc, 1] = wSoll;   // in w is the process input
                        double helpvarOut= youtDisplay;
                        if (rBinsteadDist.Checked) helpvarOut = disturbance;
                        if (rBInsteadYk1.Checked) helpvarOut = y1PFC;//youtWithoutDisturb;
                        if (rbInsteadDiv.Checked) helpvarOut = iHBay;
                        if (cBy2Out.Checked)  // Display of other internal variables
                        {
                            if (rbReal.Checked)
                            {
                                //Second output in DB Bay is in y1PFC
                                // disturbance calculation in var disturbance
                                axrval[irtc + 1, 1] = helpvarOut;
                                if (irtc == 0) axrval[0, 1] = 0;
                            }
                            else axrval[irtc, 1] = helpvarOut;// ideal
                        }
                        else
                        {
                            if (rbReal.Checked)
                            {
                                axrval[irtc + 1, 1] = youtDisplay;
                                if (irtc == 0) axrval[0, 1] = 0;
                            }
                            else axrval[irtc, 1] = youtDisplay;// ideal
                        }

                    }
                    irtc++;
                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(wSoll, val, cbDisplayW.Checked, t0rtc);

                    //toolStripStatusLabel1.Text = "i= " + i.ToString();
                    //Application.DoEvents();
                    //calculation loop ends
                }
                else
                {   // now autostop 
                    //after control loop,stops timers, drawing graphic
                    onRecord = false;
                    // Stop the timer
                    _microTimer.Stop();
                    System.Threading.Thread.Sleep(100);//waiting for last dT calculation
                    timer2.Enabled = false;
                    lastNbOfPoints = irtc;

                    if (rbXrAfterStepZero.Checked)
                        meinMain.DACoutput((short)nudChanDA.Value, 0);
                    //tbLastValuesX.Clear();
                    //tBLastValuesXr.Clear();
                    //tBLastValuesW.Clear();
                    tsbReportX__Click_1(sender, null);
                    tsbReportXr_Click(sender, null);
                    tsbReportW_Click(sender, null);

                    nb = irtc;
                    irtc = 0;

                    buttonStop.Enabled = false;
                    buttonRSR.Enabled = false;
                    butProcStepResp.Enabled = false;
                    tStripProgressBar1.Visible = false;
                    RunOn = false;
                    EventArgs weg = new EventArgs();

                    Tabs.SelectedTab = tabPage1;
                    timerDraw.Enabled = true;
                    //tabPage1.Show();
                }
            }
            else
            {
                // continuous initial phase
                // before control loop ,in button RUN 
                if (stepOn)
                {
                    if (cBWfromADC.Checked)
                    {
                        double temp = 0;
                        meinMain.ADCinput((short)nuDWInputChan.Value, ref temp);
                        if (cBSignalInversion.Checked) temp = -temp;
                        wSoll = temp;
                    }

                    valold = val;
                    switch (InitialType)
                    {
                        case 0: youtI = 0; meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            meinMain.ADCinput((short)nudSignalIn.Value, ref val); // to see process output
                            if (cBSignalInversion.Checked) val = -val;
                            // first filtering process output
                            val = fPFCfiltB1 * val - fPFCfiltA1 * valPFCfiltold;
                            valPFCfiltold = val;

                            break;
                        case 1: youtI = xroff; meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            meinMain.ADCinput((short)nudSignalIn.Value, ref val);// to see process output
                            if (cBSignalInversion.Checked) val = -val;
                            // first filtering process output
                            val = fPFCfiltB1 * val - fPFCfiltA1 * valPFCfiltold;
                            valPFCfiltold = val;

                            break;
                        case 2:
                            {
                                meinMain.ADCinput((short)nudSignalIn.Value, ref val);
                                if (cBSignalInversion.Checked) val = -val;
                                // first filtering process output
                                val = fPFCfiltB1 * val - fPFCfiltA1 * valPFCfiltold;
                                valPFCfiltold = val;

                                xd0 = wSoll - val;
                                youtI = yoldI + q0Init * xd0 + q1Init * xd1Init;
                                yoldI = youtI; xd1Init = xd0;
                                if (cbLimitation.Checked)
                                {
                                    if (youtI > limitation) youtI = limitation;
                                    if (youtI < -limit_low) youtI = -limit_low;
                                }
                                meinMain.DACoutput((short)nudChanDA.Value, youtI);

                            } break;
                        case 3:
                            {   // Cascaded controller  q0ak=30;q0ik=0.201;q1ik=-0.17; /
                                meinMain.ADCinput((short)nudSignalIn.Value, ref val);
                                if (cBSignalInversion.Checked) val = -val;
                                // first filtering process output
                                val = fPFCfiltB1 * val - fPFCfiltA1 * valPFCfiltold;
                                valPFCfiltold = val;

                                xd0 = wSoll - val;
                                ncas = (val - x1casI) / t0rtc;  // speed by differentiating 
                                wncas = q0ac * xd0;    // outer P-controller  
                                xdncas = wncas - ncas;
                                youtI = yoldI + q0ic * xdncas +  q1ic * xdn1casI;   // PI-controller inner loop 
                                x1casI = val; xdn1casI = xdncas;
                                if ((youtI > limitation) || (youtI < -limit_low)) youtI = youtI - (q0ic + q1ic) * xdncas;//AWU
                                yoldI = youtI;
                                if (cbLimitation.Checked)
                                {
                                    if (youtI > limitation) youtI = limitation;
                                    if (youtI < -limit_low) youtI = -limit_low;
                                }
                                meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            } break;
                        case 4: ProfAlgorithm(); youtI = yout; break;
                        default:
                            break;
                    }
                    youtDisplay = youtI;
                    youtdisplayfiltered = procInputBeforePSR;
                    xrBeforeStep[filtnb - 1] = youtI;
                    procInputBeforePSR = youtI;
                    for (int i = 0; i < (filtnb - 1); i++)
                    {
                        procInputBeforePSR = procInputBeforePSR + xrBeforeStep[i];
                        xrBeforeStep[i] = xrBeforeStep[i + 1]; //Shifter
                    }
                    procInputBeforePSR = procInputBeforePSR / filtnb;

                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(wSoll, val, cbDisplayW.Checked, t0rtc);
                    Application.DoEvents();

                }
                if (recOn)  // here continuous mode, stop only after Stop button
                {


                    if (binRand)
                    {
                        if ((indexRec == pulse) || (indexRec == (int)numPoints.Value))// only to that times of switching
                        {
                            if (binaryfile.Substring(BitNb, 1) == "1") pulseOn = true; else pulseOn = false;
                            BitNb++;
                            if (BitNb >= binaryfile.Length) BitNb = 0;
                            meinMain.frmRTdevice.label5.Text = BitNb.ToString() + " of " + binaryfile.Length.ToString();
                        }
                    }
                    else
                        if (indexRec < pulse) pulseOn = true; else pulseOn = false;
                    if (cBWfromADC.Checked)
                    {
                        double temp = 0;
                        meinMain.ADCinput((short)nuDWInputChan.Value, ref temp);
                        if (cBSignalInversion.Checked) temp = -temp;
                        wSoll = temp;
                    }
                    else if (pulseOn)
                    {
                        if (rbSignalAtW.Checked) { wSoll = uoff + amp; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ1.Checked) { wSoll = uoff; z1 = amp; z2 = 0; }
                        if (rbSignalAtZ2.Checked) { wSoll = uoff; z1 = 0; z2 = amp; }
                    }
                    else
                    {
                        if (rbSignalAtW.Checked) { wSoll = uoff; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ1.Checked) { wSoll = uoff; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ2.Checked) { wSoll = uoff; z1 = 0; z2 = 0; }
                    }
                    if (cBOpenLoop.Checked)  // process step response autostop
                    {
                        meinMain.DACoutput((short)nudChanDA.Value, wSoll);   // Starting Value + w
                        youtDisplay = wSoll;
                        meinMain.ADCinput((short)nudSignalIn.Value, ref val);  // //so in Process Simul bo is possible
                        if (cBSignalInversion.Checked) val = -val;
                        // first filtering process output
                        val = fPFCfiltB1 * val - fPFCfiltA1 * valPFCfiltold;
                        valPFCfiltold = val;

                    }
                    else
                        ProfAlgorithm();
                    indexRec++;
                    if (indexRec > (int)numPoints.Value)
                    {
                        indexRec = 0;
                    }
                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(wSoll, val, cbDisplayW.Checked, t0rtc);

                    Application.DoEvents();

                }
            }
            if (cbDA1impulse.Checked) meinMain.DACoutput((short)nudChanImpulse.Value, 1); // 1 Volt - Impuls auf 2. DA - Kanal hier zuende 

            dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - dtstart);
            if (dt > dtmax) dtmax = dt;

            dtavr = dtavr + dt;
            cntT0++;
            if (cBHistogram.Checked)
            {
                int Hwert = (int)Math.Round(deltaT0 * 100000.0 / Stopwatch.Frequency);// Vielfaches von 10 µsec
                if (deltaT0 > MaxT0) MaxT0 = deltaT0;
                if (Hwert > 999)
                {
                    Hwert = 999;
                }
                histT0[Hwert]++;
                Hwert = (int)Math.Round(dt * 100000.0 / Stopwatch.Frequency);// Vielfaches von 10 µsec

                if (dt > MaxdT) MaxdT = dt; 
                if (Hwert > 999)
                {
                    Hwert = 999;
                }
                histdT[Hwert]++;
                histcnt++;

            }
        }


        private void FormAdaptiveControl_FormClosing_1(object sender, FormClosingEventArgs e)
        {
            // Stop the timer
            _microTimer.Stop();
            e.Cancel = true;
            this.Visible = false;
            cbRealtimeDevice.Checked = false; // RT - curve stop
        }

        //timer 1 displays X ,Xr and W values
        private void timer1_Tick(object sender, EventArgs e)
        {
            labelX.Text = val.ToString("f3");
            labelXr.Text = youtDisplay.ToString("f3");
            labelW.Text = wSoll.ToString("f3");
            labXFiltered.Text = "xrfilt= "+youtdisplayfiltered.ToString("f3");
            toolStripStatusLabel1.Text = "i= " + minmax.progress.ToString();
            tStripProgressBar1.Maximum = (int)numPoints.Value;
            if (minmax.progress< tStripProgressBar1.Maximum) tStripProgressBar1.Value = minmax.progress;
            if (cbIdentificationActive.Checked)
            {
                teta2DisplayIdent(tetaIdent_b0);
                tetaidtocell(tetaIdent_b0);
            }
            if (cbAdaptionActive.Checked)
            {
                KT2PFC();
                copydatagrid();
                calcPFC_Parameters();
                pq2DataGrid();
            }
        }

        //timer 2 displays t0,dT and dTMAX values
        private void timer2_Tick(object sender, EventArgs e)
        {
            if (cntT0 > 0)
            {
                double t0avr1 = t0avr / cntT0 / (double)Stopwatch.Frequency * 1000;
                labelT0.Text = t0avr1.ToString("f6");
                double dtavr1 = dtavr / cntT0 / (double)Stopwatch.Frequency * 1000;
                labeldT.Text = dtavr1.ToString("f6");
                double dtmax1 = dtmax / (double)Stopwatch.Frequency * 1000;
                labeldTMAX.Text = dtmax1.ToString("f6");
                dtmax = 0; t0avr = 0; dtavr = 0; cntT0 = 0;
            }
            if (cBHistogram.Checked)
            {
                labelHist.Text = histcnt.ToString();
                labelMaxT0.Text = (MaxT0 * 1000.0 / Stopwatch.Frequency).ToString("f2");
            }
        }

        private void initController()
        {
            z1 = 0; z2 = 0;
            yold = 0; yout = 0; xdold2 = 0; xdold1 = 0; yold2 = 0;
            yoldI = 0; xdn1casI = 0; youtI = 0; x1casI = 0;
            xdn1cas = 0; yout = 0; x1cas = 0;

            for (int i = 0; i < xr.Length; i++)
            { xd[i] = 0; xr[i] = 0; xa[i] = 0; }

            for (int i = 0; i < filtnb; i++) xrBeforeStep[i] = 0;
            procInputBeforePSR = 0;

            for (int i = 0; i < fXd.Length; i++)
            {
                fXd[i] = 0;  // Init PFC- Controller
                fXg[i] = 0;
                fXm[i] = 0;
                fXm2[i] = 0;
                fxmr[i] = 0;
            }           
            valold = 0; fYr = 0; fYrold = 0; xmodpredold = 0; fYrold2 = 0; fYrold3 = 0; fYrold4 = 0;
            
            meinMain.ConvertToDouble(tbLimitation.Text,ref limitation  );
            meinMain.ConvertToDouble(tBLowLimit.Text,ref limit_low );
            cntT0 = 0; t0avr = 0; dtavr = 0;
            meinMain.ConvertToDouble(tbXroff.Text,ref xroff );
            meinMain.ConvertToDouble(tBAlpha.Text,ref alpha );
            meinMain.ConvertToDouble(tBVFident.Text,ref wichtung );
        }

        
        
        public void readpv_valuesfromconrdes()
        {
            // read controller from meinMain.fcontrdes.
            q0p = meinMain.fcontrdes.q0p;
            q0n = meinMain.fcontrdes.q0n;
            q1n = meinMain.fcontrdes.q1n;
            q0d = meinMain.fcontrdes.q0d;
            q1d = meinMain.fcontrdes.q1d;
            q0i = meinMain.fcontrdes.q0i;
            q1i = meinMain.fcontrdes.q1i;
            q2i = meinMain.fcontrdes.q2i;
            for (int i = 0; i < pv.Length; i++)
            {
                pv[i] = meinMain.fcontrdes.pv[i];
                qv[i] = meinMain.fcontrdes.qv[i];
                p1v[i] = meinMain.fcontrdes.p1v[i];
                q1v[i] = meinMain.fcontrdes.q1v[i];
                p2v[i] = meinMain.fcontrdes.p2v[i];
                q2v[i] = meinMain.fcontrdes.q2v[i];
                f3or = meinMain.fcontrdes.f3or;
            }
            for (int i = 0; i < tetaIdent_b0.Length; i++)
            {
                tetaIdent_b0[i] = meinMain.fcontrdes.tetacd[i];
                teta2Con[i] = meinMain.fcontrdes.tetacd[i];
            }
            mgradIdent = meinMain.fcontrdes._mgradcd;
            numericUpDown4.Value = mgradIdent;
            mgradCon = mgradIdent;
        }

        private void buttonRUN_Click(object sender, EventArgs e)
        {
            int Tinterval = (int)numTimeInterval.Value;
            _microTimer.Interval = (long)numTimeInterval.Value * 1000;
            _microTimer.Start();
            meinMain.ConvertToDouble(tbUoff.Text, ref uoff);
            meinMain.ConvertToDouble(tbAmp.Text, ref amp);
            meinMain.ConvertToDouble(tbComp.Text, ref DZcompensation);
            meinMain.ConvertToDouble(tbNoiseZ1.Text, ref NoiseAtZ1);

            if (recOn)
            {
                Int32.TryParse(tbPulse.Text, out pulse);
            }
            onRecord = false;
            initController();
            meinMain.DACoutput((short)nudChanDA.Value, 0);

            rBPFCcon_CheckedChanged(sender, e);

            meinMain.ConvertToDouble(tbLimitation.Text, ref limitation);
            meinMain.ConvertToDouble(tBLowLimit.Text, ref limit_low);
            buttonStop.Enabled = true;
            butProcStepResp.Enabled = true;
            buttonRSR.Enabled = true;
            timer1.Enabled = true;
            timer2.Enabled = true;
            cbDisplayW.Visible = true;
            cbDisplayW.Enabled = true;

            meinMain.ConvertToDouble(tbXroff.Text, ref xroff);
            if (cBWfromADC.Checked)
            {
                double temp = 0;
                meinMain.ADCinput((short)nuDWInputChan.Value, ref temp);
                if (cBSignalInversion.Checked) temp = -temp;
                wSoll = temp;
            }
            else if (rbInitialXroff.Checked)
            {
                wSoll = xroff;
            }
            else
            {
                wSoll = uoff;
            }
            RunOn = true;
            meinMain.ConvertToDouble(tBAlpha.Text, ref alpha);
            initident(alpha, mgradIdent, 0); //Initialisierung der Identifikation
            meinMain.ConvertToDouble(tBVFident.Text, ref wichtung);
            //readpv_valuesfromconrdes(); // ab 7.6.13 in Event Form_Load
            calcPFC_Parameters();
            meinMain.frmRTdevice.x = 0;
            meinMain.frmRTdevice.xreal = 0;
            meinMain.frmRTdevice.Clear();
            BitNb = 0;
            butActivateChangeFuz_Click(sender, e);
            valold = 0; fYrold = 0; fYrold2 = 0; fYrold3 = 0; fYrold4 = 0;// PFC
            fxmz = 0; fxmz1 = 0; fyrz = 0; fyrzold = 0; fyrz2 = 0; fxmz2 = 0;
            fYr = 0; xmodpredold = 0; distcomp = 0;
            // init Display for Ident Parameter
            //cntIdentDispl = 0;
            //for (int i5 = 0; i5 < nudDisplayIdent.Value; i5++)
            //{
            //    IdentK[i5, 0] = 0;
            //    IdentK[i5, 1] = 0;
            //    IdentT1[i5, 0] = 0;
            //    IdentT1[i5, 1] = 0;
            //    IdentT2[i5, 0] = 0;
            //    IdentT2[i5, 1] = 0;
            //}
            distfilt1 = 0;
        }

        private void buttonRSR_Click(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(tbUoff.Text,ref uoff  );
            meinMain.ConvertToDouble(tbXroff.Text,ref xoff  );
            meinMain.ConvertToDouble(tbAmp.Text,ref amp  );
            meinMain.ConvertToDouble(tbComp.Text,ref DZcompensation );
            // next lines are shifted into MMTimer - function
            //if (rbSignalAtW.Checked)
            //{
            //    w = uoff + amp;
            //    z1 = 0;
            //    z2 = 0;
            //}
            //if (rbSignalAtZ1.Checked)
            //{
            //    w = uoff;
            //    z1 = amp;
            //    z2 = 0;
            //}
            //if (rbSignalAtZ2.Checked)
            //{
            //    w = uoff;
            //    z2 = amp;
            //    z1 = 0;
            //}

            legendText = ConType;
            thisdrawnum = 0;
            if (cbDisplayW.Checked) thisdrawnum++;
            if (cbDisplayX.Checked) thisdrawnum++;
            if (cbDisplayXr.Checked) thisdrawnum++;
            if (thisdrawnum == 0)
            {
                cbDisplayX.Checked = true;  // at least one curve
                MessageBox.Show(OneCurvenecessary);
                thisdrawnum = 1;
            }
            LOrtc.toptitle = FilterName + "  " + numPoints.Value.ToString() + "  " + points;

            //axChartfx1.Visible = true;
            //axChartfx1.OpenDataEx(def.COD_VALUES, trail + thisdrawnum, (int)numPoints.Value);
            //axChartfx1.OpenDataEx(def.COD_XVALUES, trail + thisdrawnum, (int)numPoints.Value);

            cbDisplayW.Enabled = true;
            tStripProgressBar1.Maximum = (int)numPoints.Value;
            tStripProgressBar1.Visible = true;
            onRecord = true;
            procSR = false;
        }

        private void butProcStepResp_Click(object sender, EventArgs e)
        {  // Measure the process step response
            meinMain.ConvertToDouble(tbUoff.Text,ref uoff );
            meinMain.ConvertToDouble(tbXroff.Text,ref xoff );
            meinMain.ConvertToDouble(tbAmp.Text,ref amp );
            meinMain.ConvertToDouble(tbComp.Text,ref DZcompensation);
            // next lines are shifted into MMTimer - function
            //w = amp;   // Only Amplitude is given to process input without offset
            //z1 = 0;
            //z2 = 0;
            legendText = psrtext;
            if (cBUnitSR.Checked) legendText+="/1/";
            cbDisplayW.Visible = false;
            thisdrawnum = 0;
            cbDisplayW.Checked = false;  // is senseless here
            if (cbDisplayX.Checked) thisdrawnum++;
            if (cbDisplayXr.Checked) thisdrawnum++;
            if (thisdrawnum == 0)
            {
                cbDisplayX.Checked = true;  // at least one curve
                MessageBox.Show(OneCurvenecessary);
                thisdrawnum = 1;
            }
            LOrtc.toptitle = FilterName + "  " + numPoints.Value.ToString() + "  " + points;
            //axChartfx1.Visible = true;
            //axChartfx1.OpenDataEx(def.COD_VALUES, trail + thisdrawnum, (int)numPoints.Value);
            //axChartfx1.OpenDataEx(def.COD_XVALUES, trail + thisdrawnum, (int)numPoints.Value);

            onRecord = true;
            procSR = true;


        }


        private void buttonStop_Click(object sender, EventArgs e)
        {
            meinMain.DACoutput((short)nudChanDA.Value, 0);
            _microTimer.Stop();

            timer1.Enabled = false;
            timer2.Enabled = false;
            RunOn = false;
            buttonStop.Enabled = false;
            butProcStepResp.Enabled = false;
            buttonRSR.Enabled = false;
            irtc = 0; indexRec = 0;
        }


        // Writing report to text box
        private void tsbWriteReport_Click(object sender, EventArgs e)
        {
            meinMain.frmsavecurve.RefToChart2D = chart2D1;
            if (meinMain.frmsavecurve.WindowState == FormWindowState.Minimized)
                meinMain.frmsavecurve.WindowState = FormWindowState.Normal;
            meinMain.frmsavecurve.Show();
            meinMain.frmsavecurve.BringToFront();

        }



        private void buttonPQenter_Click(object sender, EventArgs e)
        {
            switch (Ncon)
            {
                case 0://P
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0p );
                    } break;
                case 1://PD
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0d );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1d );
                    } break;
                case 2:
                case 4://PI
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0n );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1n );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1n );
                    } break;
                case 3:
                case 5://PID
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0i );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1i );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[0].Value.ToString(),ref q2i );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1i );
                    } break;
                case 6://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref meinMain.fcontrdes.qv[i] );
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.pv[i] );
                        }
                    } break;
                case 7://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref meinMain.fcontrdes.q1v[i] );
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.p1v[i] );
                        }
                    } break;
                case 8://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref meinMain.fcontrdes.q2v[i] );
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.p2v[i] );
                        }
                    } break;

                case 9://cascaded
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0ac );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q0ic );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref q1ic );
                    } break;
                case 10://Twopoint Controller
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref TwoPointUp );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[1].Value.ToString(),ref TwoPointDown );
                    } break;

                case 11://PID free
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[0].Value.ToString(),ref q2f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[1].Value.ToString(),ref p2f );
                    } break;

            }
        }

        private void cbLimitation_CheckedChanged(object sender, EventArgs e)
        {
            if (cbLimitation.Checked)
            {
                label32.Visible = true;
                label37.Visible = true;
                tbLimitation.Visible = true;
                tBLowLimit.Visible = true;
            }
            else
            {
                label32.Visible = false;
                label37.Visible = false;
                tbLimitation.Visible = false;
                tBLowLimit.Visible = false;
            }
            cBModelLimited.Checked = cbLimitation.Checked;
        }

        private void rsbHelp_Click(object sender, EventArgs e)
        {
            acinfo.Show();
        }

        private void rbPcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPcon.Checked)
            {
                Ncon = 0;
                ConType = "P";
                mgradCon = 1;
                pq2DataGrid();
            }
        }


        private void rbPDT1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPDT1con.Checked)
            {
                Ncon = 1;
                ConType = "PDT1";
                mgradCon = 2;
                pq2DataGrid();
            }
        }

        private void rbPIcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPIcon.Checked)
            {
                Ncon = 2;
                ConType = "PI";
                mgradCon = 2;
                pq2DataGrid();

            }
        }

        private void rbPIDT1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPIDT1con.Checked)
            {
                Ncon = 3;
                ConType = "PIDT1";
                mgradCon = 3;
                pq2DataGrid();

            }
        }

        private void rbAWU1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAWU1con.Checked)
            {
                Ncon = 4;
                ConType = "PI AWU";
                mgradCon = 2;
                pq2DataGrid();

            }
        }

        private void rbAWU2con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAWU2con.Checked)
            {
                Ncon = 5;
                ConType = "PID AWU";
                mgradCon = 3;
                pq2DataGrid();

            }
        }

        private void rbDBVcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbDBVcon.Checked)
            {
                Ncon = 6;
                ConType = "DB(V)";
                mgradCon = meinMain.fcontrdes._mgradcd;
                pq2DataGrid();

            }
        }

        private void rbDBV1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbDBV1con.Checked)
            {
                Ncon = 7;
                ConType = "DB(V+1)";
                mgradCon = meinMain.fcontrdes._mgradcd + 1;
                pq2DataGrid();

            }
        }


        private void rbORcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbORcon.Checked)
            {
                ConType = "OR ";
                Ncon = 8;
                mgradCon = meinMain.fcontrdes._mgradcd;
                pq2DataGrid();
            }
        }


        private void rbCascadedcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbCascadedcon.Checked)
            {
                ConType = "Casc ";
                Ncon = 9;
                mgradCon = 2;
                q0ac = 30.0; q0ic = 0.201; q1ic = -0.17; // Breathing system
                pq2DataGrid();

            }
        }
        private void raBCascNew_CheckedChanged(object sender, EventArgs e)
        {
            if (raBCascNew.Checked)
            {
                ConType = "Casc ";
                Ncon = 9;
                mgradCon = 2;
                q0ac = 25.0; q0ic = 0.808; q1ic = -0.8;
                // Ka=25, Tni=1, Ki=0.8 Sprung von 0 auf 2 ist OK Black rap gemessen 22.6.2017 
                pq2DataGrid();
            }
        }

 

        private void rb2Pcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rb2Pcon.Checked)
            {
                ConType = "2P ";
                Ncon = 10;
                mgradCon = 1;
                pq2DataGrid();

            }
        }

        public void rbFreecon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbFreecon.Checked)
            {
                ConType = "Free ";
                Ncon = 11;
                mgradCon = 3;
                pq2DataGrid();
            }
        }

        private void rBPFCcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rBPFCcon.Checked)
            {
                Ncon = 12;
                ConType = "PFC";
                mgradCon = 2;
                pq2DataGrid();
                calcPFC_Parameters();
            }
        }

        private void rBFuzzy_CheckedChanged(object sender, EventArgs e)
        {
            if (rBFuzzy.Checked)
            {
                ConType = "Fuz ";
                Ncon = 13;
            }
        }


        void pq2DataGrid()
        {
            int aktgrad;
            if (Ncon == 6) aktgrad = mgradIdent+1;
            else if (Ncon == 7) aktgrad = mgradIdent + 2;
            else if (Ncon == 8) aktgrad = mgradIdent+2;
                
            else aktgrad = mgradCon;
            dataGridViewControllerPar.RowCount = aktgrad;
            for (int i = 0; i < aktgrad; i++)
            {
                dataGridViewControllerPar.Rows[i].Cells[0].Value = "0";
                dataGridViewControllerPar.Rows[i].Cells[1].Value = "0";
                dataGridViewControllerPar.Rows[i].HeaderCell.Value = i.ToString();
            }
            switch (Ncon)
            {
                case 0://P
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0p.ToString("g8");
                    } break;
                case 1://PD
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0d.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1d.ToString("g8");
                    } break;
                case 2:
                case 4://PI
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0n.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1n.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1n.ToString("g8");
                    } break;
                case 3:
                case 5://PID
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0i.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1i.ToString("g8");
                        dataGridViewControllerPar.Rows[2].Cells[0].Value = q2i.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1i.ToString("g8");
                    } break;
                case 6://DB(v)
                    {
                        for (int i = 0; i < aktgrad; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = qv[i].ToString("g8");
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = pv[i].ToString("g8");
                        }
                    } break;
                case 7://DB(v+1)
                    {
                        for (int i = 0; i < aktgrad; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = q1v[i].ToString("g8");
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = p1v[i].ToString("g8");
                        }
                    } break;
                case 8://OR)
                    {
                        for (int i = 0; i < aktgrad; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = q2v[i].ToString("g8");
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = p2v[i].ToString("g8");
                        }
                    } break;

                case 9://cascaded
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0ac.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q0ic.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = q1ic.ToString("g8");
                    } break;
                case 10://Twopoint Controller
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = TwoPointUp.ToString("g8");
                        dataGridViewControllerPar.Rows[0].Cells[1].Value = TwoPointDown.ToString("g8");
                    } break;

                case 11://PID free
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0f.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1f.ToString("g8");
                        dataGridViewControllerPar.Rows[2].Cells[0].Value = q2f.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1f.ToString("g8");
                        dataGridViewControllerPar.Rows[2].Cells[1].Value = p2f.ToString("g8");
                    } break;

            }

        }


        private void rbInitialXr0_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXr0.Checked)
            {
                InitialType = 0;
            }
        }

        private void rbInitialXroff_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXroff.Checked)
            {
                InitialType = 1;
                label17.Show();
                tbXroff.Show();
            }
            else
            {
                label17.Visible = false;
                tbXroff.Visible = false;
            }
        }

        private void rbInitialUoffByP_CheckedChanged(object sender, EventArgs e)
        {  // selectable PI
            if (rbInitialUoffByP.Checked)
            {
                InitialType = 2;
                grBoxInitPI.Visible = true;
            }
            else
                grBoxInitPI.Visible = false;
        }

        private void rbInitialUoffByPI_CheckedChanged(object sender, EventArgs e)
        {   // Cascaded Controller for Breathing system
            if (rbInitialUoffByPI.Checked)
            {
                InitialType = 3;
                q0ac = 30.0; q0ic = 0.201; q1ic = -0.17; // Breathing system
            }
        }

        private void rbInitialXByCon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXByCon.Checked)
            {
                InitialType = 4;
            }
        }
        private void rBInitWithCascRap_CheckedChanged(object sender, EventArgs e)
        {
            if (rBInitWithCascRap.Checked)
            {
                InitialType = 3;
                q0ac = 25.0; q0ic = 0.808; q1ic = -0.8;
                // Ka=25, Tni=1, Ki=0.8 Sprung von 0 auf 2 ist OK Black rap gemessen 22.6.2017 
            }
        }

        private void cbRealtimeDevice_CheckedChanged(object sender, EventArgs e)
        {
            if (cbRealtimeDevice.Checked)
            {
                meinMain.frmRTdevice.Show();
            }
            else
            {
                meinMain.frmRTdevice.Visible = false;
            }
        }

        //clear the last curve
        private void tsbClearLastCurve_Click(object sender, EventArgs e)
        {
         }


        //changing the uoff using button Run time
        private void tbUoff_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                buttonRUN.PerformClick();
            }
        }

        private void rbRectContinous_CheckedChanged(object sender, EventArgs e)
        {
            if (rbRectContinous.Checked)
            {
                label8.Visible = true;
                tbPulse.Visible = true;
                recOn = true;
                buttonRSR.Enabled = false;
                butProcStepResp.Enabled = false;
                // Chart into scope mode
            }
            else
            {
                label8.Visible = false;
                tbPulse.Visible = false;
                recOn = false;
            }
        }

        private void rbStepAutostop_CheckedChanged(object sender, EventArgs e)
        {
            if (rbStepAutostop.Checked)
            {
                stepOn = true;
                butLoadBinary.Visible = false;
                buttonRSR.Enabled = true;
                butProcStepResp.Enabled = true;
            }
            else
            {
                stepOn = false;
            }
        }

        private void toolStripButton12_Click(object sender, EventArgs e)
        {
        }

        private void rBStud_CheckedChanged(object sender, EventArgs e)
        {
            if (rBStud.Checked)
            {
                rb2Pcon.Visible = false;
                rbAWU1con.Visible = false;
                rbAWU2con.Visible = true;
                rbCascadedcon.Visible = false;
                rbDBV1con.Visible = false;
                rbDBVcon.Visible = true;
                rbFreecon.Visible = false;
                rbORcon.Visible = false;
                rBPFCcon.Visible = false;
                butFreeContr.Visible = false;
                raBCascNew.Visible = false;
            }
            else
            {
                rb2Pcon.Visible = true;
                rbAWU1con.Visible = true;
                rbAWU2con.Visible = true;
                rbCascadedcon.Visible = true;
                rbDBV1con.Visible = true;
                rbDBVcon.Visible = true;
                rbFreecon.Visible = true;
                rbORcon.Visible = true;
                butFreeContr.Visible = true;
                rBPFCcon.Visible = true;
                raBCascNew.Visible = true;
            }
        }

        private void butFreeContr_Click(object sender, EventArgs e)
        {
            meinMain.fpidpq.Show();
            if (meinMain.fpidpq.WindowState == FormWindowState.Minimized)
                meinMain.fpidpq.WindowState = FormWindowState.Normal;

            meinMain.fpidpq.BringToFront();
            if (rbFreecon.Checked)
            {
                // copy pi / qi to datagridview in parameter page
                rbFreecon_CheckedChanged(sender, e);
            }
        }

        private void numTimeInterval_ValueChanged(object sender, EventArgs e)
        {
            t0rtc = (double)numTimeInterval.Value * 0.001;  // sampling time in sec
            if (meinMain.frmSimul.cBSync.Checked) meinMain.frmSimul.SpEdpT0.Value = numTimeInterval.Value;
        }


        void xr_db(ref double xrr, double[] p, double[] q, double[] xr, double[] xd, int m, int d)
        {
            double hv;
            int i;
            /*Dead-Beat-controller standard*/
            /*automatically adapting ideal/real mode*/
            hv = 0;
            if (rbReal.Checked) for (i = 1; i <= m; i++) hv = hv + p[i] * xr[i + 1+d] + q[i] * xd[i];
            else for (i = 1; i <= m; i++) hv = hv + p[i] * xr[i+d] + q[i] * xd[i];
            xrr = hv + q[0] * xd[0];
        }


        void xr_db1(ref double xrr, double[] p, double[] q, double[] xr, double[] xd, int m, int d)
        /*Dead-Beat-controller with 1. impulse=2. impulse, needs 1 step more */
        {  /*automatically adapting ideal/real mode*/
            double hv;
            int i;
            hv = 0;
            if (rbReal.Checked) for (i = 1; i <= (m + 1); i++) hv = hv + p[i] * xr[i + 1 + d] + q[i] * xd[i];
            else for (i = 1; i <= (m + 1); i++) hv = hv + p[i] * xr[i+d] + q[i] * xd[i];
            xrr = hv + q[0] * xd[0];
        }


        void xr_or(ref double xrr, double[] p, double[] q, double[] xr, int m, double[] teta, double wil, double f3l, double xl, int d)
        /*Orientierungsregler  only for real mode*/
        {
            double c, hv, hv2=0, xprae,xlnew;
            int i;
           // fXm[0] = -fa1 * fXm[1] - fa2 * fXm[2] + fYr * fb1 + fYrold2 * fb2;// modell jetzt wie PFC orddnung2
            for (i = 1; i <= m; i++) hv2 = hv2 - teta[i] * fXm[i] + teta[i + m + 1] * xr[i + 1];
            fXm[0] = hv2;
            xlnew = xl + fXm[0] - fXm[d];  //jetzt gleiche delay- Idee wie PFC bei OR
            double wnew = 0;
            if (irtc == 5)
                wnew = 1;  //für breakpoint

            xa[0] = xlnew;  
            hv = 0; hv2 = 0;
            for (i = 1; i <= m; i++) hv = hv + teta[i + m + 1];
            for (i = 1; i <= m; i++) hv2 = hv2 + teta[i] * xa[i] - teta[i + m + 1] * xr[i + 1 ];
            if (hv == 0) c = 10 * limitation; else c = (xlnew + hv2) / hv;
            //if (c > 10 * limitation) c = 10 * limitation;
            //if (c < -10 * limit_low) c = -10 * limit_low;
            xprae = 0;
            for (i = 1; i <= m; i++) xprae = xprae + teta[i + m + 1] * (xr[i] - c) - teta[i] * xa[i - 1];
            hv = q[1] * xprae;
            for (i = 2; i <= m; i++) hv = hv - p[i] * (xr[i - 1 ] - c) + q[i] * xa[i - 2 ];
            xrr = f3l * wil - c + hv;
            for (i = xa.Length-1; i > 0; i--) xa[i] = xa[i - 1];

        }

        private void toolStripButton18_Click(object sender, EventArgs e)
        {   // copy datat and close
            if (tbLastValuesX.Lines.Length > 10)
                meinMain.fregress.tsbReadRTC.Enabled = true;
            if ((tbLastValuesX.Lines.Length > 10) && (tBLastValuesXr.Lines.Length > 10))
                meinMain.frmlsoff.rtcDataOK = true;
            Hide();
        }

        private void toolStripButton19_Click(object sender, EventArgs e)
        {  // no copy
            Hide();
        }



        private void tsbClearX__Click_1(object sender, EventArgs e)
        {
            tbLastValuesX.Clear();
        }

        private void tsbSaveX__Click_1(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tbLastValuesX.Text);
                myStream1.Close();
            }
        }

        private void tsbReportX__Click_1(object sender, EventArgs e)
        {
            tbLastValuesX.Clear();
            tbLastValuesX.Visible = false;
            int index;
            string str = "";
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(ayval[index, 0].ToString() + " " + ayval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=(ayval[index, 0].ToString() + " " + ayval[index, 1].ToString());
            tbLastValuesX.AppendText(str);
            tbLastValuesX.Visible = true;
        }

        private void tsbClearXr_Click(object sender, EventArgs e)
        {
            tBLastValuesXr.Clear();
        }

        private void tsbSaveXr_Click(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tBLastValuesXr.Text);
                myStream1.Close();
            }
        }

        private void tsbReportXr_Click(object sender, EventArgs e)
        {
            tBLastValuesXr.Clear();
            tBLastValuesXr.Visible = false;
            int index;
            string str = "";
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(axrval[index, 0].ToString() + " " + axrval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=(axrval[index, 0].ToString() + " " + axrval[index, 1].ToString());
            // Last point without CRLF
            tBLastValuesXr.AppendText(str);
            tBLastValuesXr.Visible = true;
        }

        private void tsbClearW_Click(object sender, EventArgs e)
        {
            tBLastValuesW.Clear();
        }

        private void tsbsaveW_Click(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tBLastValuesW.Text);
                myStream1.Close();
            }
        }

        private void tsbReportW_Click(object sender, EventArgs e)
        {
            tBLastValuesW.Clear();
            tBLastValuesW.Visible = false;
            int index;
            string str = "";
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(awval[index, 0].ToString() + " " + awval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=(awval[index, 0].ToString() + " " + awval[index, 1].ToString());
            tBLastValuesW.AppendText(str);
            tBLastValuesW.Visible = true;
        }

        private void tabPage5x_Enter(object sender, EventArgs e)
        {
            tbLastValuesX.Visible = true;

        }

        private void rbImpulsAutostop_Click(object sender, EventArgs e)
        {
            if (rbImpulsAutostop.Checked)
            {
                label8.Visible = true;
                tbPulse.Visible = true;
            }
            else
            {
                label8.Visible = false;
                tbPulse.Visible = false;
            }
        }


        private void butSaveContr_Click(object sender, EventArgs e)
        {
            saveDialogCon.FilterIndex = 1;
            if (saveDialogCon.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveDialogCon.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tbBeforePQenter.Text);
                myStream1.Close();
            }

        }

        private void butLoadContr_Click(object sender, EventArgs e)
        {
            // Load *con file, copy to p-q values
            openFileDialogCon.FilterIndex = 1;
            if (openFileDialogCon.ShowDialog() == DialogResult.OK)
            {
                tbBeforePQenter.Clear();
                StreamReader filestream = new StreamReader(openFileDialogCon.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    tbBeforePQenter.AppendText(line + CRLF);
                }
                filestream.Close();
                butAktivatepqChange_Click(sender, e);
            }
        }

        double CVpred = 0;
        double y1PFC = 0;

        void ProfAlgorithm()
        {
            double xd0;
            if (rbReal.Checked)
            {
                meinMain.DACoutput((short)nudChanDA.Value, yout);
                //youtDisplay = yout;
            }
            meinMain.ADCinput((short)nudSignalIn.Value, ref val);  // //so in Process Simul bo is possible
            if (cBSignalInversion.Checked) val = -val;
            // first filtering process output
            val = fPFCfiltB1 * val - fPFCfiltA1 * valPFCfiltold;
            valPFCfiltold = val;
 
            xd0 = wSoll - val - z2;
            xd[0] = xd0;
            fXd[0] = xd0; // PFC

            if (cbIdentificationActive.Checked)
            {
                schaetzvec(val, ref tetaid, mgradIdent, gamma);
                teta2tetab0();
            }
            if (cbAdaptionActive.Checked)
            {
                if (Ncon==6||Ncon==7||Ncon==8) mgradCon = mgradIdent;
                calccontroller();
            }

            switch (Ncon)
            {
                case 0: yout = q0p * xd0; break;  //P controller
                case 1: yout = q0d * xd0 + q1d * xdold1; break; //PDT1 controller
                case 2: yout = p1n * yold + q0n * xd0 + q1n * xdold1; break; //PI controller
                case 3: yout = p1i * yold + q0i * xd0 + q1i * xdold1 + q2i * xdold2; break;  //PIDT1 controller
                case 4:
                    {  // PI AWU 
                        yout = p1n * yold + q0n * xd0 + q1n * xdold1; ;  // PI
                        if (cbLimitation.Checked)
                            if ((yout < -limit_low) || (yout > limitation))
                            {
                                yout = yout - (q0n + q1n) * xd0;  // Subtract I- part
                            }
                    } break;
                case 5:
                    {  // PID AWU   
                        yout = p1i * yold + q0i * xd0 + q1i * xdold1 + q2i * xdold2;
                        if (cbLimitation.Checked)
                            if ((yout < -limit_low) || (yout > limitation))
                            {
                                yout = yout - (q0i + q1i + q2i) * xd0;  // Subtract I- part
                            }
                    } break;
                case 6: xr_db(ref yout, pv, qv, xr, xd, mgradCon,d_DBC); break; // DeadBeat v 
                case 7: xr_db1(ref yout, p1v, q1v, xr, xd, mgradCon, d_DBC); break; // Dead beat v+1
                case 8: xr_or(ref yout, p2v, q2v, xr, mgradCon, teta2Con , wSoll, f3or, val, d_DBC); break; // predictive orienteering controller
                case 9:
                    {   // Cascaded controller  q0ak=30;q0ik=0.201;q1ik=-0.17; /
                        ncas = (val - x1cas) / t0rtc;  // speed by differentiating 
                        wncas = q0ac * xd0;    // outer P-controller  
                        xdncas = wncas - ncas;
                        yout = yold + q0ic * xdncas + q1ic * xdn1cas;   // PI-controller inner loop 
                        x1cas = val; xdn1cas = xdncas;
                        if (cbLimitation.Checked)
                        {
                            if ((yout < -limit_low) || (yout > limitation)) yout = yout-(q0ic+q1ic)*xdncas;  //AWU
                          
                        }

                    } break;
                case 10: if (xd0 > 0.0) yout = TwoPointUp; else yout = TwoPointDown; break; /* ZPR 2-point contr.*/
                case 11:
                    {  // PID AWU  free   
                        yout = p1f * yold + p2f * yold2 + q0f * xd0 + q1f * xdold1 + q2f * xdold2;
                        if ((cbLimitation.Checked) && (meinMain.fpidpq.cBAntiwindup.Checked))
                            if ((yout < -limit_low) || (yout > limitation))
                            {
                                //yout = p1f * yold + p2f * yold2 + q0fPD * xd0 + q1fPD * xdold1 + q2fPD * xdold2;// PD- Alg doesnt work
                                yout = yout - (q0f + q1f + q2f) * xd0;  // Subtract I- part changed since 7
                            }
                    } break;

                case 12:                                   //PFC-Algorithmus
                    {
                       
                        if (rbIdeal.Checked)
                        {
                            delay = dPFCm;
                            delay2 = dPFCm2;
                        }
                        else // real Algorithm
                        {
                            delay = dPFCm+1;
                            delay2 = dPFCm2+1;

                        }
                        if (rbPT1.Checked || rBPT1Bay.Checked)
                        { 
                            fXm[0] = fXm[1] * fA + (1 - fA) * fKm * fYr;           //Berechneter Modelausgang (Jetzt)
                            fxmz = fxmz1 * fA + (1 - fA) * fKm * fyrz;              // 2. nd model for disturbance calculation
                            fxmz1 = fxmz;
                        }
                        //fA = Math.Exp(-fT0 / fT1);
                        //fAh = Math.Exp(-iH * fT0 / fT1);
                        //fBh = 1 - fAh;
                        //fa1 = -fA; fb1 = (1 + fa1) * fKm;
                        // fLh = 1 - (double)Math.Exp(-1 * fT0 * iH / fTr);          //Reference Trajectory

                        if (rbPT1.Checked)  // now with delay time and new code of 2nd workshop
                        {
                            fYr = (wSoll - (val + fXm[0] - fXm[delay])) * K0PFC + fXm[0] / fKm;
                            fyrz = (val - fxmz) * K0PFC + fxmz / fKm; ;     // Controller for dist. calc. desired value is output of real process
                            disturbance = fyrz - fYrold;
                        }
                        if (rBPT1Bay.Checked)
                        {  //My special version DB with restriction controller output limited
                           //if (rbIdeal.Checked)
                            double help = 0;
                            valfilt = val + fXm[0] - fXm[delay];  //jetzt gleiche delay- Idee wie PFC bei DB Bay
                            fYr = (wSoll - distcomp + fa1 * valfilt) / fb1; //ideal
                            fyrz = (val + fa1 * fxmz) / fb1;     // Controller for dist. calc. desired value is output of real process
                            if (cBModelLimited.Checked)
                            {
                               
                                if (fyrz > limitation) fyrz = limitation;
                                else if (fyrz < -limit_low) fyrz = -limit_low;
                            }
                            help = fyrz - fYrold;


                            distFilt = -distfilta1 * distfilt1 + distfiltb1 * help;
                            distfilt1 = distFilt;
                            disturbance = distFilt;  // Filtered disturbance to display

                            if (cBDistComp.Checked)
                            {
                                //compensation of disturbance by adding negative dist * disturbance gain, in PT1 case Gz=b1;
                                // in case of a delay compensate with average of d last elements (d=1 two last, d=2 three last etc)
                                distcomp = disturbance * fb1;
                            }
                            else distcomp = 0;
                            //else
                            //{
                            //    double xmodPred = - fa1 * valfilt+ fb1 * fYr; //real, one delay To, 
                            //    fYr = (w + fa1 * xmodPred) / fb1;
                            //}
                            // Disturbance calculation chap 9.8.1

                        }

                        if (rb2PT1.Checked)
                        {   // Graeper code disabled
                            //fXm[0] = fYr * fA + fXm[1] * fB + ((fXm[1] - fXm[2]) / fT0) * fC;
                            //fYr = (fXd[0] * fLh - /*((fXm[0] - fXm[1]) / fT0) * fCh*/ ((fXg[0] - fXg[1]) / fT0) * fCh + fXm[0] * (1 - fBh)) / (fAh);
                            ////fYr = (fXd[0] * fLh - ((fXm[0] - fXm[1]) / fT0) * fCh* ((fXg[0] - fXg[1]) / fT0) * fCh + fXm[0] * (1 - fBh)) / (fAh);
                            
                        }
                        if (rB2PT1_2.Checked)
                        {   // Graeper code disabled
                            //fXm[0] = fYr * fA + fXm[1] * fB + ((fXm[1] - fXm[2]) / fT0) * fC;
                            ////fYr = (fXd[0] * fLh - /*((fXm[0] - fXm[1]) / fT0) * fCh*/ ((fXg[0] - fXg[1]) / fT0) * fCh + fXm[0] * (1 - fBh)) / (fAh);
                            //fYr = (fXd[0] * fLh - ((fXm[0] - fXm[1]) / fT0) * fCh /* ((fXg[0] - fXg[1]) / fT0) * fCh*/ + fXm[0] * (1 - fBh)) / (fAh);
                           
                        }

                        if (rB2PT1_3.Checked)
                        {   //new PFC- code from atp- paper Prof. Haber Köln
                            // one step prediction removed
                            fXm[0] = fXm[1] * fA1_PFC + (1 - fA1_PFC) * Kalpha * fYr;           //Berechneter Modelausgang (1. pt1)
                            fXm2[0] = fXm2[1] * fA2_PFC + (1 - fA2_PFC) * Kbeta * fYr;           //Berechneter Modelausgang (2. pt1)
                            fYr = (wSoll - (val + fXm[0] - fXm[delay2] + fXm2[0] - fXm2[delay2])) * K0PFC + fXm[0] * k1PFC + fXm2[0] * k2PFC;
                       }
                        if (rBIT1PFC.Checked)
                        {   //new PFC- code from atp- paper Prof. Haber Köln and  Richalet Chap 4.6 process IT1
                            // 
                            fXm[0] = fXm[1] * fA1_PFC + (1 - fA1_PFC) * Kalpha * fYr;           //Berechneter Modelausgang (1. pt1)
                            fXm2[0] = fXm2[1] * fA2_PFC + (1 - fA2_PFC) * Kbeta * fYr;           //Berechneter Modelausgang (2. pt1)
                            fxmr[0] = fxmr[1] * fA2_PFC + (1 - fA2_PFC) * CVpred;              //   CVpred is old x process output (CV(n-1))
                            CVpred = val + fXm[0] - fXm[delay2] + fXm2[0] - fXm2[delay2] + fxmr[0] - fxmr[delay2];
                            fYr = (wSoll - CVpred) * K0PFC + fXm[0] * k1PFC + (fXm2[0]  + fxmr[0] - CVpred) * k2PFC; 
                        }


                        if (rBFZ2.Checked)
                        {  // my special version DB ( two step prediction) with restriction controller output limited
                            double wnew = 0;
                            if (irtc == 98)
                                wnew = 1;  //für breakpoint
                            if (Dmgrad==2)
                            {
                                fXm[0] = -fa1 * fXm[1]- fa2 * fXm[2] + fYr * fb1 + fYrold2 * fb2;// modell jetzt
                                valfilt = val + fXm[0] - fXm[delay2];  //jetzt gleiche delay- Idee wie PFC bei DB Bay
                                wnew = valfilt + (wSoll - valfilt) / iHBay;
                                wnew = wnew - distcomp;
                                z1FZ = fb2 * fYrold - fa1 * valfilt - fa2 * valfiltold;
                                z2FZ = -fa2 * valfilt;
                                x1PFC = (fb2 * (wnew - z2FZ + fb2 / fb1 * z1FZ) - fb1 * (wnew * (1 + fa1) - fb1 * wnew*Yinfinit)) * nenfz;
                                fYr = (x1PFC - z1FZ) / fb1;
                                y1PFC = (wnew + fa1 * x1PFC - fb2 * fYr - z2FZ) / fb1;  // not used only for check
                                if (cBY2correction.Checked)
                                    if ((y1PFC < -limit_low || y1PFC > limitation) && y1PFC != 0)
                                    {
                                        iHBay++;  // reduce output with increase h
                                        if (iHBay > numHDBBay.Value) iHBay = (int)numHDBBay.Value;
                                    }
                                // Now disturbance measurement with parallel system and method chap 9.8.1
                                wnew = val;
                                fxmz = -fa1 * fxmz1 - fa2 * fxmz2 + fyrz * fb1 + fyrz2 * fb2;// modell jetzt
                             
                                //valfilt = val + fXm[0] - fXm[delay2];  //jetzt gleiche delay- Idee wie PFC bei DB Bay
                                
                                z1FZ = fb2 * fyrzold - fa1 * fxmz - fa2 * fxmz1;
                                z2FZ = -fa2 * fxmz;
                                x1PFC = (fb2 * (wnew - z2FZ + fb2 / fb1 * z1FZ) - fb1 * (wnew * (1 + fa1) - fb1 * wnew * Yinfinit)) * nenfz;
                                fyrz = (x1PFC - z1FZ) / fb1;
                                double help = fyrz - fYrold;
                                distFilt = -distfilta1 * distfilt1 + distfiltb1 * help;
                                distfilt1 = distFilt;
                                disturbance = distFilt;  // Filtered disturbance to display
                                if (cBDistComp.Checked)
                                {
                                    double help1=DistGain;
                                    if (procGain >= 1e5)
                                    {
                                        if (cBiHswithTo1.Checked)  // if adaption is active calc with iH=1
                                            help1 = DistGain + KiT0It1 * delay2;  // Correction of disturbance gain in IT1 case to get zero control error must be done each To
                                        else // calc with ih
                                            help1 = DistGain + KiT0It1 * delay2 /(double) iHBay;
                                    }

                                    //compensation of disturbance by adding negative dist * disturbance gain, in PT1 case Gz=b1;
                                    // in case of a delay compensate with average of d last elements (d=1 two last, d=2 three last etc)
                                    distcomp = disturbance * help1;
                                }
                                else distcomp = 0;
                             


                            }
                            else if (Dmgrad==3)
                            {
                                fXm[0] = -fa1 * fXm[1] - fa2 * fXm[2] - fa3 * fXm[3] + fYr * fb1 + fYrold2 * fb2 + fYrold3 * fb3;// modell jetzt
                                valfilt = val + fXm[0] - fXm[delay2];  //jetzt gleiche delay- Idee wie PFC bei DB Bay
                                wnew = valfilt + (wSoll - valfilt) / iHBay;
                                Z[0] = -fa1 * valfilt - fa2 * valfiltold - fa3 * valfiltold2 + fYrold * fb2 + fYrold2 * fb3;
                                Z[1] = -fa2 * valfilt - fa3 * valfiltold + fYrold * fb3;
                                Z[2] = -wnew - fa3 * valfilt;
                                Z[3] = -wnew - fa1 * wnew + fb1 * Yinfinit;
                                Z[4] = -wnew * (1 + fa1 + fa2) + (fb1 + fb2) * Yinfinit;
                                fYr = 0;
                                for (int i = 0; i < 5; i++) fYr += A3[0,i] * Z[i];
                                // Now calc y(k+1) to correct if too negative
                                y1PFC = 0;
                                for (int i = 0; i < 5; i++) y1PFC += A3[3, i] * Z[i];
                                if (cBY2correction.Checked)
                                    if  ((y1PFC<-limit_low || y1PFC>limitation)&& y1PFC!=0)
                                    {
                                       iHBay++;  // reduce output with increase h
                                        if (iHBay > numHDBBay.Value) iHBay = (int)numHDBBay.Value;
                                    }

                            }
                            else if (Dmgrad == 4)
                            {
                                fXm[0] = -fa1 * fXm[1] - fa2 * fXm[2] - fa3 * fXm[3] - fa4 * fXm[4] + fYr * fb1 + fYrold2 * fb2 + fYrold3 * fb3 + fYrold4 * fb4;// modell jetzt
                                valfilt = val + fXm[0] - fXm[delay2];  //jetzt gleiche delay- Idee wie PFC bei DB Bay
                                wnew = valfilt + (wSoll - valfilt) / iHBay;
                                Z[0] = -fa1 * valfilt - fa2 * valfiltold - fa3 * valfiltold2 - fa4 * valfiltold3 + fYrold * fb2 + fYrold2 * fb3 + fYrold3 * fb4;
                                Z[1] = -fa2 * valfilt - fa3 * valfiltold - fa4 * valfiltold2 + fYrold * fb3 + fYrold2 * fb4;
                                Z[2] = -fa3 * valfilt - fa4 * valfiltold + fYrold * fb4;
                                Z[3] = -wnew - fa4 * valfilt;
                                Z[4] = -wnew - fa1 * wnew + fb1 * Yinfinit;
                                Z[5] = -wnew * (1 + fa1 + fa2) + (fb1 + fb2) * Yinfinit;
                                Z[6] = -wnew * (1 + fa1 + fa2+ fa3) + (fb1 + fb2 + fb3) * Yinfinit;
                                fYr = 0;
                                for (int i = 0; i < 7; i++) fYr += A3[0, i] * Z[i];
                                // Now calc y(k+1) to correct if too negative
                                y1PFC = 0;
                                for (int i = 0; i < 5; i++) y1PFC += A3[1, i] * Z[i];
                                if (cBY2correction.Checked)
                                    if ((y1PFC < -limit_low || y1PFC > limitation) && y1PFC != 0)
                                    {
                                        iHBay++;  // reduce output with increase h
                                        if (iHBay > numHDBBay.Value) iHBay = (int)numHDBBay.Value;
                                    }
                            }
                            //else // real algorithm
                            //{
                            //    xmodPred = -fa1 * valfilt - fa2 * valfiltold + fb1 * fYrold + fb2 * fYrold2; //Model prediction
                            //    wnew = xmodPred + (w - xmodPred) / iH;
                            //    z1FZ = fb2 * fYrold - fa1 * xmodPred - fa2 * valfilt;
                            //    z2FZ = -fa2 * xmodPred;
                            //    x2PFC = (fb2 * (wnew - z2FZ + fb2 / fb1 * z1FZ) - fb1 * (wnew * (1 + fa1) - fb1 * wnew*Yinfinit)) * nenfz;
                            //    fYr = (x2PFC - z1FZ) / fb1;
                            //    y1PFC = (w + fa1 * x2PFC - fb2 * fYr - z2FZ) / fb1;  // not used only for check

                            //}

                       }
                        
                        if (cBModelLimited.Checked)
                        {

                            if (fYr > limitation || fYr < -limit_low)
                            {
                                if (fYr > limitation) { fYr = limitation; }
                                else if (fYr < -limit_low) { fYr = -limit_low; }
                                if (cBiHswithTo1.Checked)
                                {
                                    iHBay++;// bei Begrenzung schalte hoch auf eingestellten Wert
                                    if (iHBay > numHDBBay.Value) iHBay = (int)numHDBBay.Value;
                                }
                            }
                            else if (cBiHswithTo1.Checked && iHBay != 1) iHBay--; // schaltet runter auf iHBAy=1 wenn keine Begrenzung
                            if (fyrz > limitation) fyrz = limitation;
                            else if (fyrz < -limit_low) fyrz = -limit_low;
                        }
                        valfiltold3 = valfiltold2; valfiltold2 = valfiltold; valfiltold = valfilt; yout = fYr; fYrold4 = fYrold3; fYrold3 = fYrold2; fYrold2 = fYrold; fYrold = fYr;
                        fxmz2 = fxmz1; fxmz1 = fxmz; fyrz2 = fyrzold;fyrzold = fyrz;
                    } break;
                case 13:
                    {  // Fuzzy Controller
                        // yout ist Ausgang, val Eingang und valold alter Eingang
                        // yold alter Ausgang
                        labelFuzFile.Text = meinMain.frmFuzEdit.FuzFileName;
                        if (rBP1.Checked) fuzzyinp[0] = fak1Fuz * val;
                        if (rBD1.Checked) fuzzyinp[0] = fak1Fuz * (val - valold) / t0rtc;
                        if (fuzzyinp[0] > Max1Fuz) fuzzyinp[0] = Max1Fuz;
                        if (fuzzyinp[0] < Min1Fuz) fuzzyinp[0] = Min1Fuz;
                        pBIn1.Value = (int)Math.Round((fuzzyinp[0] - Min1Fuz) * 100.0 / (Max1Fuz - Min1Fuz));
                        labFuzIn1.Text = fuzzyinp[0].ToString("f2");

                        if (rbP2.Checked) fuzzyinp[1] = fak2Fuz * val;
                        if (rBD2.Checked) fuzzyinp[1] = fak2Fuz * (val - valold) / t0rtc;
                        if (fuzzyinp[1] > Max2Fuz) fuzzyinp[1] = Max2Fuz;
                        if (fuzzyinp[1] < Min2Fuz) fuzzyinp[1] = Min2Fuz;
                        pBIn2.Value = (int)Math.Round((fuzzyinp[1] - Min2Fuz) * 100.0 / (Max2Fuz - Min2Fuz));
                        labFuzIn2.Text = fuzzyinp[1].ToString("f2");

                        yout = meinMain.frmFuzEdit.fuzzy(fuzzyinp);
                        yout = yout * fak3OutFuz;
                        if (yout > limitation) yout = limitation;
                        if (yout < -limit_low) yout = -limit_low;
                        pBOutFuz.Value = (int)Math.Round((yout + 10) * 100.0 / 20.0);
                        labFuzOut.Text = yout.ToString("f2");
                        valold = val;

                    } break;
                case 14:
                    {  // Fuzzy Controller fest eingestellt
                        // yout ist Ausgang an DA, val Eingang 
                        // yold alter Ausgang
                        fuzzyinp[0] = val;
                        if (fuzzyinp[0] > 9.9) fuzzyinp[0] = 9.9;
                        if (fuzzyinp[0] < -9.9) fuzzyinp[0] = -9.9;
                        if (rBD2.Checked) fuzzyinp[1] = 0.1 * (val - valold) / t0rtc;
                        if (fuzzyinp[1] > 9.9) fuzzyinp[1] = 9.9;
                        if (fuzzyinp[1] < -9.9) fuzzyinp[1] = -9.9;
 
                        yout = meinMain.frmFuzEdit.fuzzy(fuzzyinp);  //Fuzzy- Funktion
                        yout = yout * 10.0;
                        if (yout > 10) yout = 10;
                        if (yout < -10) yout = -10;
                        valold = val;

                    } break;

                default: yout = q0p * xd0; break;  //P controller

            }
            yold2 = yold; yold = yout; xdold2 = xdold1; xdold1 = xd0;
            int hzp;
            for (hzp = xr.Length-1; hzp > 1; hzp--)
            {
                xr[hzp] = xr[hzp - 1];
                xd[hzp] = xd[hzp - 1];

            } /* shifter */
            xr[1] = yout; xd[1] = xd[0];

            // shifter für PFC

            for (hzp = MaxDelay-1; hzp >= 1; hzp--)
            {
                fXd[hzp] = fXd[hzp - 1];
                fXm[hzp] = fXm[hzp - 1];
                fXm2[hzp] = fXm2[hzp - 1];
                fxmr[hzp] = fxmr[hzp - 1];
            }
            fXg[1] = fXg[0];
            fXg[0] = val;
            if (cbNoiseZ1.Checked)
            {
                //Next : Random number 0-999
                yout = yout + NoiseAtZ1 * (NoiseZ1.Next(1000) / 1000.0-0.5);
            }

            youtWithoutDisturb = yout;
            yout = yout + z1;   // Disturbance in front of process

            if (yout > 0) yout = yout + DZcompensation; else yout = yout - DZcompensation; //Dead Zone compensation

            if (cbLimitation.Checked)
            {
                if (yout > limitation) { yout = limitation; youtWithoutDisturb = limitation; }
                if (yout < -limit_low) { yout = -limit_low; youtWithoutDisturb = -limit_low; }
            }

            if (cbIdentificationActive.Checked)
            {
                korrekvec(yout, val, mgradIdent, kovmat, ref gamma, wichtung, (int)nuDDelayRLSIdent.Value);
                kovmatrix(mgradIdent, ref kovmat, gamma, wichtung);
            }

            if (rbIdeal.Checked)
            {
                meinMain.DACoutput((short)nudChanDA.Value, yout);
                
            }
            youtDisplay = yout;
        }

        double x1PFC = 0, x2PFC = 0, xmodPred = 0;

        private void cBiHswithTo1_CheckedChanged(object sender, EventArgs e)
        {
            if (cBiHswithTo1.Checked == false) iHBay = (int)numHDBBay.Value;
        }

        private void cBEnableDisplay_CheckedChanged(object sender, EventArgs e)
        {
            if (cBEnableDisplay.Checked)
            {
                chart2D2.clearAll();
                chart2D2.XMax = (double)nudDisplayIdent.Value;
                chart2D2.XMin = 0;
                chart2D2.YMax = (double)nuDXmax.Value;
                chart2D2.YMin = (double )nuDXmin.Value;
                chart2D2.initializeScopeMode();
                if (Math.Abs(nuDXmax.Value) < 1) nuDXmax.Increment = (decimal)0.1; else nuDXmax.Increment = 1;
                if (Math.Abs(nuDXmin.Value) < 1) nuDXmin.Increment = (decimal)0.1; else nuDXmin.Increment = 1;
                if ((chart2D2.YMax - chart2D2.YMin) < 2) chart2D2.YMajGrid = 0.1; else chart2D2.YMajGrid = 1;
            }
        }

        private void butStorePFC_Click(object sender, EventArgs e)
        {
            saveDialogCon.FilterIndex = 3;
            if (saveDialogCon.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveDialogCon.OpenFile(), Encoding.Default);
                string cont;
                cont = "All PFC and DB Bay parameters + all process params in control design" + CRLF;
                cont += PFCmod2PT1Delay.Value.ToString() + " PFCmod2PT1Delay" + CRLF; //row 2 in file
                cont += tBnumKmPT1.Text + " tBnumKmPT1" + CRLF; //3
                cont += tBnumT1PT1.Text + " tBnumT1PT1" + CRLF; //4
                cont += PFCmodPT1delay.Value.ToString() + " PFCmodPT1delay" + CRLF; //5
                cont += rB2PT1_3.Checked + " rB2PT1_3" + CRLF; //6
                cont += rBIT1PFC.Checked + " rBIT1PFC" + CRLF; //7
                cont += rbPT1.Checked + " rbPT1" + CRLF; //8
                cont += rBPT1Bay.Checked + " rBPT1Bayy" + CRLF; //9
                cont += tBnumKm2PT1.Text + " tBnumKm2PT1" + CRLF; //010
                cont += tBnumT12PT1.Text + " tBnumT12PT1" + CRLF; //11
                cont += tBnumT22PT1.Text + " tBnumT22PT1" + CRLF; //12
                cont += numH.Value.ToString() + " numH" + CRLF; //13
                cont += numTr.Value.ToString() + " numTr" + CRLF; //14
                cont += tBnumKIT1.Text + " tBnumKIT1" + CRLF; //15
                cont += tBnumTIT1.Text + " tBnumTIT1" + CRLF; //16
                cont += numHDBBay.Value.ToString() + " numHDBBay" + CRLF; //17
                cont += cBiHswithTo1.Checked + " cBiHswithTo1" + CRLF; //18
                cont += cBY2correction.Checked + " cBY2correction" + CRLF; //19
                cont += cBDistComp.Checked + " cBDistComp" + CRLF; //20
                cont += nUDDistTimeConstant.Value.ToString() + " nUDDistTimeConstant" + CRLF; //21
                cont += tBPFCprocessFiltK.Text + " tBPFCprocessFiltK" + CRLF; //22
                cont += tBPFCprocessFiltT.Text + " tBPFCprocessFiltT" + CRLF; //23
                cont += cBPFCFilteractive.Checked + " cBPFCFilteractive" + CRLF; //24
                cont += rbIdeal.Checked + " rbIdeal" + CRLF;//25
                cont += rbReal.Checked + " rbReal" + CRLF;//26
                // jetzt alle Werte aus der Reglerauslegung in Fcontrdes ergänzt, so werden alle Regler abgespeichert
                cont += meinMain.fcontrdes.rb2pt1.Checked + " rb2pt1 in fcontrdes" + CRLF; //27
                cont += meinMain.fcontrdes.rbit1.Checked + " rbit1 in fcontrdes" + CRLF; //28
                cont += meinMain.fcontrdes.rbpt1.Checked + " rbpt1 in fcontrdes" + CRLF; //29
                cont += meinMain.fcontrdes.rBPT3.Checked + " rBPT3 in fcontrdes" + CRLF; //30
                cont += meinMain.fcontrdes.rBPT4.Checked + " rBPT4 in fcontrdes" + CRLF; //31
                cont += meinMain.fcontrdes.rbfz.Checked + " rbfz in fcontrdes" + CRLF; //32
                cont += meinMain.fcontrdes.rbideal.Checked + " rbideal in fcontrdes" + CRLF; //33
                cont += meinMain.fcontrdes.rbreal.Checked + " rbreal in fcontrdes" + CRLF; //34
                cont += meinMain.fcontrdes.rBAnalog.Checked + " rBAnalog in fcontrdes" + CRLF; //35
                cont += meinMain.fcontrdes.degreen.Value.ToString() + " degreen in fcontrdes" + CRLF; //36
                cont += meinMain.fcontrdes.nudDelayDF.Value.ToString() + " nudDelayDF in fcontrdes" + CRLF; //37
                cont += meinMain.fcontrdes.edk.Text + " edk in fcontrdes" + CRLF; //38
                cont += meinMain.fcontrdes.Edt1.Text + " Edt1 in fcontrdes" + CRLF; //39
                cont += meinMain.fcontrdes.Edt2.Text + " Edt2 in fcontrdes" + CRLF; //40
                cont += meinMain.fcontrdes.par4.Text + " par4 in fcontrdes" + CRLF; //41
                cont += meinMain.fcontrdes.par5.Text + " par5 in fcontrdes" + CRLF; //42
                cont += meinMain.fcontrdes.edtt.Text + " edtt in fcontrdes" + CRLF; //43
                cont += meinMain.fcontrdes.edphir.Text + " edphir in fcontrdes" + CRLF; //44
                cont += meinMain.fcontrdes.edto.Text + " edto in fcontrdes T0 in design" + CRLF; //45
                cont += meinMain.fcontrdes.tbAutoTZ.Text + " tbAutoTZ in fcontrdes" + CRLF; //46
                cont += meinMain.fcontrdes.tBstDesIV.Text + " tBstDesIV in fcontrdes" + CRLF; //47  
                cont += meinMain.fcontrdes.tBcomment.Text + CRLF; //48  tBcomment

                cont += numTimeInterval.Value.ToString() + " numTimeInterval To in controller" + CRLF; //49

                myStream1.WriteLine(cont);
                myStream1.Close();
            }
        }
        private string FirstString(string x)
        {
            int pos = x.IndexOf(" "); // position of first blank
            string outp = x.Substring(0, pos);
            return (outp);
        }
        private bool check(string x)
        {
            string temp = FirstString(x);
            if (temp == "False") return (false);
            else return (true);

        }
        private void butLoadPFC_Click(object sender, EventArgs e)
        {
           
            List<String> pList = new List<String>();
            openFileDialogCon.FilterIndex = 3;
            if (openFileDialogCon.ShowDialog() == DialogResult.OK)
            {
                StreamReader filestream = new StreamReader(openFileDialogCon.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    if (line != null)
                    {
                        pList.Add(line);
                    }
                }
                filestream.Close();
                int len = pList.Count;

                if (len > 48)
                {
                    double help = 0; // index von pList ist um 1 kleiner als laufende nummer Textzeile (Nullbasiert)
                    PFCmod2PT1Delay.Value = Convert.ToInt32(FirstString(pList[1])); // row 2
                    tBnumKmPT1.Text = FirstString(pList[2]);
                    tBnumT1PT1.Text = FirstString(pList[3]);
                    PFCmodPT1delay.Value = Convert.ToInt32(FirstString(pList[4]));
                    rB2PT1_3.Checked = check(pList[5]);
                    rBIT1PFC.Checked = check(pList[6]);
                    rbPT1.Checked = check(pList[7]);
                    rBPT1Bay.Checked = check(pList[8]);
                    tBnumKm2PT1.Text = FirstString(pList[9]);
                    tBnumT12PT1.Text = FirstString(pList[10]);
                    tBnumT22PT1.Text = FirstString(pList[11]);
                    numH.Value = Convert.ToInt32(FirstString(pList[12]));
                    meinMain.datatools.ConvertToDouble(FirstString(pList[13]), ref help);
                    numTr.Value = (decimal)help;
                    tBnumKIT1.Text = FirstString(pList[14]);
                    tBnumTIT1.Text = FirstString(pList[15]);
                    numHDBBay.Value = Convert.ToInt32(FirstString(pList[16]));
                    cBiHswithTo1.Checked = check(pList[17]);
                    cBY2correction.Checked = check(pList[18]);
                    cBDistComp.Checked = check(pList[19]);
                    nUDDistTimeConstant.Value = Convert.ToInt32(FirstString(pList[20]));
                    tBPFCprocessFiltK.Text = FirstString(pList[21]);
                    tBPFCprocessFiltT.Text = FirstString(pList[22]);
                    cBPFCFilteractive.Checked = check(pList[23]);
                    buttonActPFCChanges_Click(null, null);
                    rbIdeal.Checked = check(pList[24]);
                    rbReal.Checked = check(pList[25]);
                    // jetzt alle Werte aus der Reglerauslegung in Fcontrdes ergänzt, so werden alle Regler abgespeichert
                    if (check(pList[26])) { meinMain.fcontrdes.rb2pt1.Checked = check(pList[26]); meinMain.fcontrdes.rb2pt1_Click(null, null); } // row 27
                    if (check(pList[27])) { meinMain.fcontrdes.rbit1.Checked = check(pList[27]); meinMain.fcontrdes.rbit1_Click(null, null); } //28
                    if (check(pList[28])) { meinMain.fcontrdes.rbpt1.Checked = check(pList[28]); meinMain.fcontrdes.rbpt1_Click(null, null); } //29
                    if (check(pList[29])) { meinMain.fcontrdes.rBPT3.Checked = check(pList[29]); meinMain.fcontrdes.rBPT3_Click(null, null); } //30
                    if (check(pList[30])) { meinMain.fcontrdes.rBPT4.Checked = check(pList[30]); meinMain.fcontrdes.rBPT4_Click(null, null); } //31
                    if (check(pList[31])) { meinMain.fcontrdes.rbfz.Checked = check(pList[31]); meinMain.fcontrdes.rbfz_Click(null, null); }//32

                    if (check(pList[32])) meinMain.fcontrdes.rbideal.Checked = check(pList[32]); //33
                    if (check(pList[33])) meinMain.fcontrdes.rbreal.Checked = check(pList[33]); //34
                    if (check(pList[34])) meinMain.fcontrdes.rBAnalog.Checked = check(pList[34]); //35
                    meinMain.datatools.ConvertToDouble(FirstString(pList[35]), ref help);
                    meinMain.fcontrdes.degreen.Value = (decimal)help; //36
                    meinMain.datatools.ConvertToDouble(FirstString(pList[36]), ref help);
                    meinMain.fcontrdes.nudDelayDF.Value = (decimal)help; //37
                    meinMain.fcontrdes.edk.Text = FirstString(pList[37]); //38
                    meinMain.fcontrdes.Edt1.Text = FirstString(pList[38]); //39
                    meinMain.fcontrdes.Edt2.Text = FirstString(pList[39]); //40
                    meinMain.fcontrdes.par4.Text = FirstString(pList[40]); //41
                    meinMain.fcontrdes.par5.Text = FirstString(pList[41]);//42
                    meinMain.fcontrdes.edtt.Text = FirstString(pList[42]); //43
                    meinMain.fcontrdes.edphir.Text = FirstString(pList[43]); //44
                    meinMain.fcontrdes.edto.Text = FirstString(pList[44]); //45
                    meinMain.fcontrdes.tbAutoTZ.Text = FirstString(pList[45]); //46
                    meinMain.fcontrdes.tBstDesIV.Text = FirstString(pList[46]); //47 
                    meinMain.fcontrdes.tBcomment.Text = (pList[47]); //48 tBcomment
                    // RadioButton erst clicken, wenn Daten da sind

                    numTimeInterval.Value = Convert.ToInt32(FirstString(pList[48])); //49 
                    meinMain.fcontrdes.design_Click(null, null);
                    meinMain.fcontrdes.OKBtn_Click(null, null);   // in case of IT1 field tBnumKIT1 and tBnumTIT1 are destroyed with OK button
                    // so correction in IT1 case if model of DBbay is different to contrDes
                    if (meinMain.fcontrdes.rbit1.Checked)
                    {
                        tBnumKIT1.Text = FirstString(pList[14]);
                        tBnumTIT1.Text = FirstString(pList[15]);
                        butIT1toFZ_Click(null, null);
                    }
                }

            }
        }

        private void cBWfromADC_CheckedChanged(object sender, EventArgs e)
        {
            if (cBWfromADC.Checked)
            {
                nuDWInputChan.Visible = true;
                label63.Visible = true;
            }
            else
            {
                nuDWInputChan.Visible = false;
                label63.Visible = false;

            }
        }

        double CorrDistComp = 0;
        private void setDiscComp_Click(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(tBDistComp.Text, ref CorrDistComp);
        }

        private void label60_Click(object sender, EventArgs e)
        {

        }

        double[] fuzzyinp = new double[2];
        double Min1Fuz = 0;

        private void nUDDistTimeConstant_ValueChanged(object sender, EventArgs e)
        {
            calcPFC_Parameters();
        }

        double Max1Fuz = 0;
        double Min2Fuz = 0;
        double Max2Fuz = 0;
        double fak1Fuz = 0;
        double fak2Fuz = 0;
        double fak3OutFuz = 1;

        private void butActivateChangeFuz_Click(object sender, EventArgs e)
        {
            meinMain.datatools.ConvertToDouble(tBGain1.Text, ref fak1Fuz);
            meinMain.datatools.ConvertToDouble(tBMin1.Text, ref Min1Fuz);
            meinMain.datatools.ConvertToDouble(tBMax1.Text, ref Max1Fuz);

            meinMain.datatools.ConvertToDouble(tBGain2.Text, ref fak2Fuz);
            meinMain.datatools.ConvertToDouble(tBMin2.Text, ref Min2Fuz);
            meinMain.datatools.ConvertToDouble(tBMax2.Text, ref Max2Fuz);

            meinMain.datatools.ConvertToDouble(tBOutFuz.Text, ref fak3OutFuz);

        }

        private void butAktivatepqChange_Click(object sender, EventArgs e)
        {
            int nb = tbBeforePQenter.Lines.Length;
            string[] pList = new string[nb]; // temporary array to accelerate
            int i;
            pList = tbBeforePQenter.Lines;  // pointer pList to Textbox
            string[] outstr = new string[10];

            meinMain.datatools.Str2NString(pList[0], ref outstr, ' ');//P
            meinMain.ConvertToDouble(outstr[1],ref q0p);
            meinMain.datatools.Str2NString(pList[1], ref outstr, ' ');//PD
            meinMain.ConvertToDouble(outstr[1],ref q0d );
            meinMain.ConvertToDouble(outstr[2],ref q1d );
            meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');//PI
            meinMain.ConvertToDouble(outstr[1],ref q0n );
            meinMain.ConvertToDouble(outstr[2],ref q1n );
            meinMain.ConvertToDouble(outstr[3],ref p1n );
            meinMain.datatools.Str2NString(pList[3], ref outstr, ' ');//PID
            meinMain.ConvertToDouble(outstr[1],ref q0i );
            meinMain.ConvertToDouble(outstr[2],ref q1i );
            meinMain.ConvertToDouble(outstr[3],ref q2i );
            meinMain.ConvertToDouble(outstr[4],ref p1i );

            meinMain.datatools.Str2NString(pList[4], ref outstr, ' ');//DB(v)
            int graddb = Convert.ToInt32(outstr[1]);
            meinMain.fcontrdes._mgradcd = graddb - 1;
            for (i = 0; i < graddb; i++)
            {
                meinMain.datatools.Str2NString(pList[5 + i], ref outstr, ' ');//DB(v)
                meinMain.ConvertToDouble(outstr[0],ref meinMain.fcontrdes.qv[i] );
                meinMain.ConvertToDouble(outstr[1],ref meinMain.fcontrdes.pv[i] );
            }

            meinMain.datatools.Str2NString(pList[5 + graddb], ref outstr, ' ');//DB(v+1)
            int graddb1 = Convert.ToInt32(outstr[1]);
            for (i = 0; i < graddb1; i++)
            {
                meinMain.datatools.Str2NString(pList[6 + graddb + i], ref outstr, ' ');//DB(v+1)
                meinMain.ConvertToDouble(outstr[0],ref meinMain.fcontrdes.q1v[i] );
                meinMain.ConvertToDouble(outstr[1],ref meinMain.fcontrdes.p1v[i] );
            }

            int offs = graddb + graddb1;
            meinMain.datatools.Str2NString(pList[6 + offs], ref outstr, ' ');//OR
            int graddb2 = Convert.ToInt32(outstr[1]);
            for (i = 0; i < graddb2; i++)
            {
                meinMain.datatools.Str2NString(pList[7 + offs + i], ref outstr, ' ');//OR
                meinMain.ConvertToDouble(outstr[0],ref meinMain.fcontrdes.q2v[i] );
                meinMain.ConvertToDouble(outstr[1],ref meinMain.fcontrdes.p2v[i] );
            }
            offs = offs + graddb2;

            meinMain.datatools.Str2NString(pList[7 + offs], ref outstr, ' ');//cascaded
            meinMain.ConvertToDouble(outstr[1],ref q0ac );
            meinMain.ConvertToDouble(outstr[2],ref q0ic );
            meinMain.ConvertToDouble(outstr[3],ref q1ic );

            meinMain.datatools.Str2NString(pList[8 + offs], ref outstr, ' ');//twopoint
            meinMain.ConvertToDouble(outstr[1],ref TwoPointUp);
            meinMain.ConvertToDouble(outstr[2],ref TwoPointDown );

            meinMain.datatools.Str2NString(pList[9 + offs], ref outstr, ' ');//PID free
            meinMain.ConvertToDouble(outstr[1],ref q0f );
            meinMain.ConvertToDouble(outstr[2],ref q1f );
            meinMain.ConvertToDouble(outstr[3],ref q2f );
            meinMain.ConvertToDouble(outstr[4],ref p1f );
            meinMain.ConvertToDouble(outstr[5],ref p2f );
            butAktivatepqChange.Visible = false;
        }

        private void tbBeforePQenter_TextChanged(object sender, EventArgs e)
        {
            butAktivatepqChange.Visible = true;
        }

        private void tBiniQ0_Leave(object sender, EventArgs e)
        {   // KT aus qi at PI
            double q0 =0,q1=0;
            meinMain.ConvertToDouble(tBiniQ0.Text,ref q0);
            meinMain.ConvertToDouble(tBiniQ1.Text,ref q1);
            tbIniKr.Text = (-q1).ToString();
            tBiniTn.Text = (t0rtc / (-q0 / q1 - 1)).ToString();
            q0Init = q0;
            q1Init = q1;
        }

        private void tbIniKr_Leave(object sender, EventArgs e)
        {
            double kr=0,tn=0;
            meinMain.ConvertToDouble(tbIniKr.Text,ref kr );
            meinMain.ConvertToDouble(tBiniTn.Text,ref tn);
            q0Init = kr * (1 + t0rtc / tn);
            q1Init = -kr;
            tBiniQ0.Text = q0Init.ToString();
            tBiniQ1.Text = q1Init.ToString();
        }

        private void Tabs_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (Tabs.SelectedIndex == 6)
            {  // fill TB with all controllers
                tbBeforePQenter.Clear();
                tbBeforePQenter.Visible = false;
                tbBeforePQenter.AppendText("P " + q0p.ToString() + CRLF);
                tbBeforePQenter.AppendText("PD " + q0d.ToString() + " " + q1d.ToString() + CRLF);
                tbBeforePQenter.AppendText("PI " + q0n.ToString() + " " + q1n.ToString() + " " + p1n.ToString() + CRLF);
                tbBeforePQenter.AppendText("PID " + q0i.ToString() + " " + q1i.ToString() + " " + q2i.ToString() + " " + p1i.ToString() + CRLF);
                tbBeforePQenter.AppendText("DB(v) " + (meinMain.fcontrdes._mgradcd + 1).ToString() + CRLF);

                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 1); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.qv[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.pv[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("DB(v+1) " + (meinMain.fcontrdes._mgradcd + 2).ToString() + CRLF);

                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 2); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.q1v[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.p1v[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("OR " + (meinMain.fcontrdes._mgradcd + 1).ToString() + CRLF);
                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 1); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.q2v[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.p2v[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("cascaded " + q0ac.ToString() + " " + q0ic.ToString() + " " + q1ic.ToString() + CRLF);
                tbBeforePQenter.AppendText("Twopoint " + TwoPointUp.ToString() + " " + TwoPointDown.ToString() + CRLF);
                tbBeforePQenter.AppendText("PIDfree " + q0f.ToString() + " " + q1f.ToString() + " " + q2f.ToString() + " " + p1f.ToString() + " " + p2f.ToString());
                tbBeforePQenter.Visible = true;
                butAktivatepqChange.Visible = false;
            }
        }

        private void rbPT1_CheckedChanged(object sender, EventArgs e)
        {
            gb2PT1.Enabled = false;
            gbPT1.Enabled = true;
            //numH.Value = 1;
            gBIT1.Enabled = false;
            if (rBPT1Bay.Checked)
            {
                gbPFCParam.Enabled = false;
                //PFCmodPT1delay.Visible = false;
                labPFCfile.Visible = false;
                dataGridView1.Visible = false;
                labelTyp.Visible = false;
                numTr.Enabled = true;
                numHDBBay.Visible = false;
                labDBBay1.Visible = false;
                labDBBay2h.Visible = false;
            }
            else
            {
                gbPFCParam.Enabled = true;
                labPFCfile.Visible = false;
                dataGridView1.Visible = false;
                labelTyp.Visible = false;
                //PFCmodPT1delay.Visible = true;
                numHDBBay.Visible = false;
                labDBBay1.Visible = false;
                labDBBay2h.Visible = false;

            }
        }

        void CalctwPFC(double t1, double t2, ref double tw, double T0, ref int h)
        {
            if ((t1 != t2) && (t1 != 0) && (t2 != 0)) tw = t1 * t2 / (t1 - t2) * Math.Log(t1 / t2);
            else tw = 1e10;
            h = Convert.ToInt32( tw / T0);
            if (h == 0) h = 1;
            //if (h > numH.Maximum) h = (int)numH.Maximum;
            //numH.Value = h;
        }

        private void rb2PT1_CheckedChanged(object sender, EventArgs e)
        {
            gbPT1.Enabled = false;
            gb2PT1.Enabled = true;
            gBIT1.Enabled = true;
            double tw = 0;
            int h = 0;
            double t12 = 0, t22 = 0;
            meinMain.ConvertToDouble(tBnumT12PT1.Text, ref t12);
            meinMain.ConvertToDouble(tBnumT22PT1.Text, ref t22);
            CalctwPFC(t12, t22, ref tw, t0rtc, ref h);
            labtwPFC.Text = "tw " + tw.ToString("g8");
            labhPropoasal.Text = "h= " + h.ToString();

            if ( rBFZ2.Checked)
            {// F(z) DB bay
                //numTr.Enabled = false;

                gBIT1.Visible = true;
                //PFCmod2PT1Delay.Visible = false;
                but2PT1toFZ.Visible = true;
                gb2PT1.Text = "2PT1-Model";
                labPFC_T2.Text = "T2";
                labPFCfile.Visible = true;
                dataGridView1.Visible = true;  
                labelTyp.Visible = true;
                numHDBBay.Visible = true;
                labDBBay1.Visible = true;
                labDBBay2h.Visible = true;
                gBDBBayOptions.Visible = true;
                gbPFCParam.Visible = false;

            }
            if (rB2PT1_3.Checked||rBIT1PFC.Checked )
            {// PFC
                numTr.Enabled = true;
                dataGridView1.Visible = false;
                numHDBBay.Visible = false;
                labDBBay1.Visible = false;
                labDBBay2h.Visible = false;
                gBDBBayOptions.Visible = false;
                gbPFCParam.Visible = true;

                gBIT1.Visible = false;
                //PFCmod2PT1Delay.Visible = true;
                but2PT1toFZ.Visible = false;
                labPFCfile.Visible = false;
                labelTyp.Visible = false;
                if (rB2PT1_3.Checked)
                {
                    gb2PT1.Text = "2PT1 - PFC";
                    labPFC_T2.Text = "T2";
                    labtwPFC.Visible = true;
                    labhPropoasal.Visible = true;
                }
                else
                {
                    gb2PT1.Text = "IT1 - PFC";
                    labPFC_T2.Text = "Tdec";
                    labtwPFC.Visible = false;
                    labhPropoasal.Visible = false;
                }

            }
            //if (rBFZ2.Checked)
            //{
            //    numH.Enabled = false;
            //}else
            numH.Enabled = true;
            //if (rb2PT1.Checked || rB2PT1_2.Checked)
            //    gBIT1.Visible = false;
            //else gBIT1.Visible = true;
        }

        double procGain;
        void calcPFC_Parameters()
        {
            /*Übernahme der PFC-Parameter*/

            fT0 = t0rtc;  // Sampling time
            iH = (int)numH.Value;
            iHBay = (int)numHDBBay.Value;
            fTr = (double)numTr.Value;
            double lambda = Math.Exp(-fT0 * 3.0 / fTr);
            labLambda.Text= "Lambda= " + lambda.ToString();
            double lamH = Math.Exp(-fT0 * 3.0 * iH / fTr);
            lablambda2h.Text = "Lambda^h= " + lamH.ToString();
            lab1MinusLambda.Text = "1-lambda^h= " + (1 - lamH).ToString(); 
            if (rBFZ2.Checked)
                PFClegendhTr = "h=" + iHBay.ToString();  // in case of F(z) DB Bay use correct h value
            else
                PFClegendhTr = "h=" + iH.ToString();
            if (rbPT1.Checked || rB2PT1_3.Checked)
                PFClegendhTr +=  " Tr=" + fTr.ToString();
            fLh = 1.0 - (double)lamH;          //Reference Trajectory
               //Preparation Disturbance PT1 filter with K=1 and Time constant n*T0
                int DTC = (int)nUDDistTimeConstant.Value;  // Disturbance time constant in n*T0
                if (DTC > 0) distfilta1 = -Math.Exp(-1.0 / DTC); else distfilta1 = 0;
                distfiltb1 = 1 + distfilta1;

            if (rbIdeal.Checked)
            {
                delay = dPFCm;    // from num UpDown PT1
                delay2 = dPFCm2;   // From numerical Up Down 2PT1 / It1
            }
            else // real Algorithm
            {
                delay = dPFCm + 1;
                delay2 = dPFCm2 + 1;
            }
                if ((rbPT1.Checked) || (rBPT1Bay.Checked))                                        //PT1-Modell
            {
                meinMain.ConvertToDouble(tBnumKmPT1.Text, ref fKm);
                meinMain.ConvertToDouble(tBnumT1PT1.Text, ref fT1);
                fA = Math.Exp(-fT0 / fT1);
                fAh = Math.Exp(-iH * fT0 / fT1);
                fBh = 1 - fAh;
                fa1 = -fA; fb1 = (1 + fa1) * fKm;
                Kalpha = 1;
                K0PFC = fLh / fKm / fBh;
                labLambdaH.Text = "KoPFC=" + K0PFC.ToString("F2");
                DistGain = fb1;
                labDistGain.Text = "DistGain= " + DistGain.ToString();
                labA0.Text = "DC-gain DBC= "+ (-fa1 / fb1).ToString();
                labProcGain.Text = "Process gain= " + fKm.ToString();


            }

            if (rbPT1.Checked)
                PFClegend = rbPT1.Text;
            if (rBPT1Bay.Checked)
                PFClegend = rBPT1Bay.Text;


            if ((rb2PT1.Checked) || (rB2PT1_2.Checked))               //2PT1-Modell
            {    // Graeper version disabled
                //meinMain.ConvertToDouble(tBnumKm2PT1.Text,ref fKm );
                //meinMain.ConvertToDouble(tBnumT12PT1.Text,ref fT1 );
                //meinMain.ConvertToDouble(tBnumT22PT1.Text,ref fT2 ); 
                //double fT0_fT1 = Math.Exp(-fT0 / fT1);
                //double fT0_fT2 = Math.Exp(-fT0 / fT2);
                //double fT0ih_fT1 = Math.Exp(-fT0 * iH / fT1);
                //double fT0ih_fT2 = Math.Exp(-fT0 * iH / fT2);

                //fA = fKm * (1 - 1 / (fT1 - fT2) * (fT1 * fT0_fT1 - fT2 * fT0_fT2));
                //fAh = fKm * (1 - 1 / (fT1 - fT2) * (fT1 * fT0ih_fT1 - fT2 * fT0ih_fT2));
                //fB = fT1 / (fT1 - fT2) * fT0_fT1 - fT2 / (fT1 - fT2) * fT0_fT2;
                //fBh = fT1 / (fT1 - fT2) * fT0ih_fT1 - fT2 / (fT1 - fT2) * fT0ih_fT2;
                //fC = fT1 * fT2 / (fT1 - fT2) * (fT0_fT1 - fT0_fT2);
                //fCh = fT1 * fT2 / (fT1 - fT2) * (fT0ih_fT1 - fT0ih_fT2);
            }
            if (rB2PT1_3.Checked)
            {  // preparationn new PFC- version atp-paper Prof Haber
                //double Kalpha, Kbeta, k1PFC, k2PFC, K0PFC;
                meinMain.ConvertToDouble(tBnumKm2PT1.Text, ref fKm);
                meinMain.ConvertToDouble(tBnumT12PT1.Text, ref fT1);
                meinMain.ConvertToDouble(tBnumT22PT1.Text, ref fT2);
                if (Math.Abs((fT2 - fT1) / fT1) > 1e-5)
                {
                    Kalpha = fKm * fT1 / (fT1 - fT2);  // Ki of parallel form
                    Kbeta = fKm * fT2 / (fT2 - fT1);
                }
                else
                {
                    Kalpha = -fKm * 100000;  // Ki of parallel form, if both times are nearly equal
                    Kbeta = fKm * 100001.0;
                }

                fA1_PFC = Math.Exp(-fT0 / fT1);
                fA2_PFC = Math.Exp(-fT0 / fT2);
                double fa1h = Math.Exp(-fT0 * iH / fT1);
                double fa2h = Math.Exp(-fT0 * iH / fT2);
                double denom = Kalpha * (1 - fa1h) + Kbeta * (1 - fa2h);

                K0PFC = fLh / denom;
                k1PFC = (1 - fa1h) / denom;
                k2PFC = (1 - fa2h) / denom;
                PFClegend = rB2PT1_3.Text;
                labLambdaH.Text = "KoPFC=" + K0PFC.ToString("F2");
            }
            if (rBIT1PFC.Checked)
            {  // preparationn new PFC- version atp-paper Prof Haber now IT1 with decomposition 
                // Richalet book chap 4.6
                //double Kalpha, Kbeta, k1PFC, k2PFC, K0PFC;

                meinMain.ConvertToDouble(tBnumKm2PT1.Text, ref fKm);
                meinMain.ConvertToDouble(tBnumT12PT1.Text, ref fT1);
                meinMain.ConvertToDouble(tBnumT22PT1.Text, ref fTdec); //decomposition time
                if (Math.Abs((fTdec - fT1) / fT1) < 1e-5) fTdec = 2 * fT1; // if t1 and Tdec are equal

                Kbeta = fKm * fTdec * fTdec / (fTdec - fT1);
                Kalpha = fKm * fTdec - Kbeta;  //decomposition

                fA1_PFC = Math.Exp(-fT0 / fT1);  // am
                fA2_PFC = Math.Exp(-fT0 / fTdec);  // as
                double fa1h = Math.Exp(-fT0 * iH / fT1);  // am^h
                double fa2h = Math.Exp(-fT0 * iH / fTdec);  // as^h
                double denom = Kalpha * (1 - fa1h) + Kbeta * (1 - fa2h);

                K0PFC = fLh / denom;
                k1PFC = (1 - fa1h) / denom;
                k2PFC = (1 - fa2h) / denom;
                PFClegend = rBIT1PFC.Text;
                labLambdaH.Text = "KoPFC=" + K0PFC.ToString("F2");
            }
            if (rBFZ2.Checked)  // F(z)  Grad 2 / 3 / 4
            {
                fa3 = 0; fb3 = 0; fa4 = 0; fb4 = 0;
                meinMain.ConvertToDouble(dataGridView1.Rows[1].Cells[0].Value.ToString(), ref fa1);
                meinMain.ConvertToDouble(dataGridView1.Rows[1].Cells[1].Value.ToString(), ref fb1);
                meinMain.ConvertToDouble(dataGridView1.Rows[2].Cells[0].Value.ToString(), ref fa2);
                meinMain.ConvertToDouble(dataGridView1.Rows[2].Cells[1].Value.ToString(), ref fb2);
                if (Dmgrad == 3 || Dmgrad==4)
                {
                    meinMain.ConvertToDouble(dataGridView1.Rows[3].Cells[0].Value.ToString(), ref fa3);
                    meinMain.ConvertToDouble(dataGridView1.Rows[3].Cells[1].Value.ToString(), ref fb3);
                }
                if (Dmgrad==4)
                {
                    meinMain.ConvertToDouble(dataGridView1.Rows[4].Cells[0].Value.ToString(), ref fa4);
                    meinMain.ConvertToDouble(dataGridView1.Rows[4].Cells[1].Value.ToString(), ref fb4);
                }

                double sumb = fb1 + fb2 + fb3 + fb4;
                if (sumb != 0) Yinfinit = (1 + fa1 + fa2 + fa3 + fa4) / sumb; else Yinfinit = 1e10;
                nenfz = -fa1 * fb1 * fb2 + fb2 * fb2 + fa2 * fb1 * fb1;
                if (nenfz != 0) nenfz = fb1 / nenfz; else nenfz = 1e10;
                if (Dmgrad==2)
                {
                    // Calc of Disturbance gain see 9.13
                    double nenDis =-fa1 * fb1 * fb2 + fb2 * fb2 + fa2 * fb1 * fb1;
                    nenDis= (fb1 + fb2) *nenDis - fb2 * fb2 * fb2;
                    double A = fb1 * fb2 * fa2 + (fa1 + fa2) * (-fa1 * fb1 * fb2 + fa2 * fb1 * fb1);
                    if (Math.Abs( nenDis) > 1e-12) A = A / nenDis; else A = 1e12;
                    
                    if (sumb != 0) procGain = (1 + fa1 + fa2 + fa3 + fa4) / sumb; else procGain = 1e10;
                    if (Math.Abs( procGain) > 1e-5) procGain = 1 / procGain; else procGain = 1e5;
                    
                    DistGain = procGain / (1 - procGain * A);
                    //labA0.Text = "DC-gain DBC= " + (A).ToString();
                    //labDistGain.Text = "DistGain= " + DistGain.ToString();
                   //labProcGain.Text = "Process gain= " + procGain.ToString();
                    if (procGain>=1e5)
                    {
                        //labDeffective.Text = "d eff= " + delay2.ToString();
                        DistGain = -1 / A;  //if procGain very large "DistGain = procGain / (1 - procGain * A);" leads to -1/A
                        KiT0It1 = (fb1 + fb2) / (1 - fa2);
                        //labKiT0.Text = "KiT0 It1= " + KiT0It1.ToString();
                        //DistGain = DistGain + KiT0It1 * delay2/iH;  // Correction of disturbance gain in IT1 case to get zero control error must be done each To
                        //labIt1distgain.Text = "It1 distGain= " + DistGain.ToString();
                    }
                    else
                    {
                        //labDeffective.Text = "d eff= " + delay2.ToString();
                        //labIt1distgain.Text = "It1 distGain= 0 ";
                      
                        //labKiT0.Text = "KiT0 It1= 0 " ;

                    }
 
                }
                PFClegend = rBFZ2.Text;
                if (Dmgrad==3)
                {  // preparation of Matrix to solve to yk
                    double det = 0, kond = 0;
                    A3[0, 0] = -fb1; A3[0, 1] = 1;   A3[0, 2] = 0;   A3[0, 3] = 0;    A3[0, 4] = 0;
                    A3[1, 0] = -fb2; A3[1, 1] = fa1; A3[1, 2] = 1;   A3[1, 3] = -fb1; A3[1, 4] = 0;
                    A3[2, 0] = -fb3; A3[2, 1] = fa2; A3[2, 2] = fa1; A3[2, 3] = -fb2; A3[2, 4] = -fb1;
                    A3[3, 0] = 0;    A3[3, 1] = fa3; A3[3, 2] = fa2; A3[3, 3] = -fb3; A3[3, 4] = -fb2;
                    A3[4, 0] = 0;    A3[4, 1] = 0;   A3[4, 2] = fa3; A3[4, 3] = 0;    A3[4, 4] = -fb3;
                    int a = Invert.matinv(ref A3,5,ref det,ref kond);
                }
                if (Dmgrad == 4)
                {  // preparation of Matrix to solve to yk
                    double det = 0, kond = 0;
                    A3[0, 0] = -fb1; A3[0, 1] = 0; A3[0, 2] = 0; A3[0, 3] = 0;          A3[0, 4] = 1; A3[0, 5] = 0; A3[0, 6] = 0;
                    A3[1, 0] = -fb2; A3[1, 1] = -fb1; A3[1, 2] = 0; A3[1, 3] = 0;       A3[1, 4] = fa1; A3[1, 5] = 1; A3[1, 6] = 0;
                    A3[2, 0] = -fb3; A3[2, 1] = -fb2; A3[2, 2] = -fb1; A3[2, 3] = 0;    A3[2, 4] = fa2; A3[2, 5] = fa1; A3[2, 6] = 1;
                    A3[3, 0] = -fb4; A3[3, 1] = -fb3; A3[3, 2] = -fb2; A3[3, 3] = -fb1; A3[3, 4] = fa3; A3[3, 5] = fa2; A3[3, 6] = fa1;
                    A3[4, 0] = 0; A3[4, 1] = -fb4; A3[4, 2] = -fb3; A3[4, 3] = -fb2;    A3[4, 4] = fa4; A3[4, 5] = fa3; A3[4, 6] = fa2;
                    A3[5, 0] = 0; A3[5, 1] = 0; A3[5, 2] = -fb4; A3[5, 3] = -fb3;       A3[5, 4] = 0; A3[5, 5] = fa4; A3[5, 6] = fa3;
                    A3[6, 0] = 0; A3[6, 1] = 0; A3[6, 2] = 0; A3[6, 3] = -fb4;          A3[6, 4] = 0; A3[6, 5] = 0; A3[6, 6] = fa4;
                    int a = Invert.matinv(ref A3, 7, ref det, ref kond);
                }

            }
            if (rBPFCcon.Checked)
            {
                ConType = "PFC " + PFClegend + " " + PFClegendhTr;
                if (rBIT1PFC.Checked) ConType += "Tdec= " + tBnumT22PT1.Text;
            }
        }
        double Yinfinit = 0,nenfz=0,z1FZ=0,z2FZ=0;

        private void copydatagrid()
        {
            if (mgradIdent == 2)
            {  // copy identified a/b to PFC- Array
                meinMain.frmadaptcon.Dmgrad=2;
                meinMain.frmadaptcon.dataGridView1.RowCount=3;
                dataGridView1.Rows[1].Cells[0].Value = dataGridViewProcessPar.Rows[1].Cells[0].Value;
                dataGridView1.Rows[1].Cells[1].Value = dataGridViewProcessPar.Rows[1].Cells[1].Value;
                dataGridView1.Rows[2].Cells[0].Value = dataGridViewProcessPar.Rows[2].Cells[0].Value;
                dataGridView1.Rows[2].Cells[1].Value = dataGridViewProcessPar.Rows[2].Cells[1].Value;
            }
            else if (mgradIdent == 3)
            {  // copy identified a/b to PFC- Array
                meinMain.frmadaptcon.Dmgrad=3;
                meinMain.frmadaptcon.dataGridView1.RowCount=4;
                dataGridView1.Rows[1].Cells[0].Value = dataGridViewProcessPar.Rows[1].Cells[0].Value;
                dataGridView1.Rows[1].Cells[1].Value = dataGridViewProcessPar.Rows[1].Cells[1].Value;
                dataGridView1.Rows[2].Cells[0].Value = dataGridViewProcessPar.Rows[2].Cells[0].Value;
                dataGridView1.Rows[2].Cells[1].Value = dataGridViewProcessPar.Rows[2].Cells[1].Value;
                dataGridView1.Rows[3].Cells[0].Value = dataGridViewProcessPar.Rows[3].Cells[0].Value;
                dataGridView1.Rows[3].Cells[1].Value = dataGridViewProcessPar.Rows[3].Cells[1].Value;
            }
            else if (mgradIdent == 4)
            {  // copy identified a/b to PFC- Array
                meinMain.frmadaptcon.Dmgrad = 4;
                meinMain.frmadaptcon.dataGridView1.RowCount = 5;
                dataGridView1.Rows[1].Cells[0].Value = dataGridViewProcessPar.Rows[1].Cells[0].Value;
                dataGridView1.Rows[1].Cells[1].Value = dataGridViewProcessPar.Rows[1].Cells[1].Value;
                dataGridView1.Rows[2].Cells[0].Value = dataGridViewProcessPar.Rows[2].Cells[0].Value;
                dataGridView1.Rows[2].Cells[1].Value = dataGridViewProcessPar.Rows[2].Cells[1].Value;
                dataGridView1.Rows[3].Cells[0].Value = dataGridViewProcessPar.Rows[3].Cells[0].Value;
                dataGridView1.Rows[3].Cells[1].Value = dataGridViewProcessPar.Rows[3].Cells[1].Value;
                dataGridView1.Rows[4].Cells[0].Value = dataGridViewProcessPar.Rows[4].Cells[0].Value;
                dataGridView1.Rows[4].Cells[1].Value = dataGridViewProcessPar.Rows[4].Cells[1].Value;
            }
        }

        private void but2PT1toFZ_Click(object sender, EventArgs e)
        {
            fT0 = t0rtc;  // Sampling time
            double c2, c3, d1, d2, d3;  // HoF(z) aus 2PT1
            meinMain.ConvertToDouble(tBnumKm2PT1.Text, ref fKm);
            meinMain.ConvertToDouble(tBnumT12PT1.Text, ref fT1);
            meinMain.ConvertToDouble(tBnumT22PT1.Text, ref fT2);
            if (fT1 < fT2) { double weg = fT2; fT2 = fT1; fT1 = weg; } /*swap*/
            c3 = Math.Exp(-fT0 / fT1); c2 = Math.Exp(-fT0 / fT2);
            d1 = fKm * fT1 * fT2 / (fT2 - fT1); d2 = 1 / fT1 - 1 / fT2 - c2 / fT1 + c3 / fT2;
            d3 = (1 / fT1 - 1 / fT2) * c2 * c3 - c3 / fT1 + c2 / fT2;
            fa1 = -c2 - c3; fa2 = c2 * c3; fb1 = d1 * d2; fb2 = d1 * d3;
            dataGridView1.RowCount = 3;
            Dmgrad = 2;
            dataGridView1.Rows[1].Cells[0].Value = fa1.ToString();
            dataGridView1.Rows[1].Cells[1].Value = fb1.ToString();
            dataGridView1.Rows[2].Cells[0].Value = fa2.ToString();
            dataGridView1.Rows[2].Cells[1].Value = fb2.ToString();
            labPFCfile.Text = "";
            labelTyp.Text = "2PT1";
        }

        
        private void butIT1toFZ_Click(object sender, EventArgs e)
        {
            fT0 = t0rtc;  // Sampling time
            double c1,  d1, d2;  // HoF(z) aus 2PT1
            meinMain.ConvertToDouble(tBnumKIT1.Text, ref fKm);
            meinMain.ConvertToDouble(tBnumTIT1.Text, ref fT1);
            d1 = fKm * fT1;
            d2 = fT0 / fT1; c1 = Math.Exp(-d2);
            fa1 = -1 - c1; fa2 = c1;
            fb1 = d1 * (d2 - 1 + c1); fb2 = -d1 * (d2 * c1 - 1 + c1);
            dataGridView1.RowCount = 3;
            Dmgrad = 2;
            dataGridView1.Rows[1].Cells[0].Value = fa1.ToString();
            dataGridView1.Rows[1].Cells[1].Value = fb1.ToString();
            dataGridView1.Rows[2].Cells[0].Value = fa2.ToString();
            dataGridView1.Rows[2].Cells[1].Value = fb2.ToString();
            labPFCfile.Text = "";
            labelTyp.Text = "IT1";
        }


        //region Adaptive controller
        //// Alles für Adaption / ident aus BCB

        double[] psi = new double[maxnp2];
        double[] gamma = new double[maxnp2];
        double[,] einh = new double[maxnp2, maxnp2];
        double[,] kovmat = new double[maxnp2, maxnp2];
        double[] tetaid = new double[maxnp2];
        double ui = 0; //Startwerte
        double wichtung, alpha;
        // alle Vektoren und Matrizen starten mit  Index 0!!

        void ZVecMultVec(double[] vec1, double[] vec2, ref double wertz, int a)
        /*Routine zur Multiplikation eines Zeilenvektors mit
         einem Spaltenvektor*/
        {
            wertz = 0;
            for (int r1 = 0; r1 < a; r1++) wertz = wertz + vec2[r1] * vec1[r1];
        } /*PROCEDUREENDE*/
        // --------------------------------------------------------------------------

        void MatMultMat(double[,] mat1, double[,] mat2, ref double[,] mat3, int a)
        /*Routine zur Multiplikation zweier Matritzen*/
        {
            int r1, r2, r3;
            double sum;
            for (r3 = 0; r3 < a; r3++)
                for (r2 = 0; r2 < a; r2++)
                {
                    sum = 0;
                    for (r1 = 0; r1 < a; r1++) sum = sum + mat1[r3, r1] * mat2[r1, r2];
                    mat3[r3, r2] = sum;
                }

        } /*PROCEDUREENDE*/

        //// --------------------------------------------------------------------------
        void MatMultVec(double[,] mat1, double[] vec1, ref double[] vec3, int a)
        /*Routine zur Multiplikation einer Matritze mit einem Vektor*/
        {
            int r1, r2;
            double sum;
            for (r2 = 0; r2 < a; r2++)
            {
                sum = 0;
                for (r1 = 0; r1 < a; r1++) sum = sum + mat1[r2, r1] * vec1[r1];
                vec3[r2] = sum;
            }
        } /*PROCEDUREENDE*/

        //// --------------------------------------------------------------------------

        void VecMultSc(double[] vec1, double Sc, ref double[] vec3, int a)
        /*Routine zur Multiplikation eines Vektors mit einem Skalar*/
        {
            for (int r1 = 0; r1 < a; r1++)
                vec3[r1] = vec1[r1] * Sc;
        } /*PROCEDUREENDE*/


        //// --------------------------------------------------------------------------

        void VecAddVec(double[] vec1, double[] vec2, ref double[] vec3, int a)
        /*Routine zur Addition zweier Vektoren*/
        {
            for (int r1 = 0; r1 < a; r1++) vec3[r1] = vec1[r1] + vec2[r1];
        } /*PROCEDUREENDE*/

        //// --------------------------------------------------------------------------

        void MatSubMat(double[,] mat1, double[,] mat2, ref double[,] mat3, int a)
        /*Routine zur Subtraktion zweier Matritzen*/
        {
            for (int r1 = 0; r1 < a; r1++)
                for (int r2 = 0; r2 < a; r2++) mat3[r1, r2] = mat1[r1, r2] - mat2[r1, r2];
        } /*PROCEDUREENDE*/

        //// --------------------------------------------------------------------------

        void MatMultSc(ref double[,] mat1, double sc, int a)
        {
            // routine dividiert alle werte der Matrix mat1 durch sc
            if (Math.Abs(sc) > 1e-10) sc = 1 / sc; else sc = 1e10;
            for (int r1 = 0; r1 < a; r1++) for (int r2 = 0; r2 < a; r2++) mat1[r1, r2] = mat1[r1, r2] * sc;
        }

        //// --------------------------------------------------------------------------


        void VecMultZVec(double[] Vec1, double[] ZVec2, ref double[,] mat3, int a)
        /*Routine zur Multiplikation eines Spaltenvektors mit
         einem Zeilenvektor*/
        {
            for (int r1 = 0; r1 < a; r1++) for (int r2 = 0; r2 < a; r2++) mat3[r1, r2] = Vec1[r1] * ZVec2[r2];
        } /*PROCEDUREENDE*/


        //// --------------------------------------------------------------------------
        void schaetzvec(double xi, ref double[] tetai, int ni, double[] gamma)
        /* Routine zur Berechnung des Schätzvektors TETA(k) */
        {
            double ei, psit_teta = 0;
            double[] gamma_ei = new double[maxnp2];
            double[] tetain = new double[maxnp2];
            int ni2 = 2 * ni;

            ZVecMultVec(psi, tetai, ref psit_teta, ni2);
            ei = xi - psit_teta;
            VecMultSc(gamma, ei, ref gamma_ei, ni2);
            VecAddVec(tetai, gamma_ei, ref tetain, ni2);
            for (int r1 = 0; r1 < ni2; r1++)      // copy matrices
                tetai[r1] = tetain[r1];

        } /*PROCEDURE-ENDE*/


        //// --------------------------------------------------------------------------

        void kovmatrix(int ni, ref double[,] psfni, double[] gamma, double vf)
        /* Routine zur Berechnung des Kovarianzvektors P(k) */
        {
            int ni2 = 2 * ni;
            double[,] gamma_psit = new double[maxnp2, maxnp2];
            double[,] einh_gamma_psit = new double[maxnp2, maxnp2];

            VecMultZVec(gamma, psi, ref gamma_psit, ni2);
            MatSubMat(einh, gamma_psit, ref einh_gamma_psit, ni2);
            MatMultMat(einh_gamma_psit, psfni, ref gamma_psit, ni2);
            MatMultSc(ref gamma_psit, vf, ni2);
            for (int r1 = 0; r1 < ni2; r1++)      // copy matrices
                for (int r2 = 0; r2 < ni2; r2++) psfni[r1, r2] = gamma_psit[r1, r2];

        } /*PROCEDURE-ENDE*/

        //// --------------------------------------------------------------------------
        void initident(double ai, int ni, double uis)
        /*Initialisierung der Identifikation nach Voridentifikation*/
        {
            int mmax2 = maxnp2, hi1, hi2;
            ui = 0;
            uis=0;                                              /*Startwerte*/
            for (hi1 = 0; hi1 < mmax2; hi1++) for (hi2 = 0; hi2 < mmax2; hi2++)
                    if (hi1 == hi2) kovmat[hi1, hi2] = ai; else kovmat[hi1, hi2] = 0;
            for (hi1 = 0; hi1 < mmax2; hi1++) for (hi2 = 0; hi2 < mmax2; hi2++)
                    if (hi1 == hi2) einh[hi1, hi2] = 1; else einh[hi1, hi2] = 0;
            for (hi1 = 0; hi1 < mmax2; hi1++)
            {
                gamma[hi1] = 0;             /*Korrekturvektor 0 setzen*/
                psi[hi1] = 0;               /*Datenvektor 0 setzen*/
                tetaid[hi1] = 0;
            }
            for (hi1 = 0; hi1 < MaxDelay; hi1++) uindelay[hi1] = 0;

        } /*PROCEDURE-ENDE*/
        

        //// --------------------------------------------------------------------------

        void korrekvec(double uin, double xi, int ni, double[,] psfni,
                            ref double[] gamma, double vf,int del)
        /* Routine zur Berechnung des Korrekturvektors GAMMA(k) */
        {
            double psit_p_psi = 0;
            int ni2 = 2 * ni;
            double[] p_psi = new double[maxnp2];

            for (int hi1 = maxnp2 - 1; hi1 > 0; hi1--) psi[hi1] = psi[hi1 - 1];
            psi[0] = (xi * (-1.0)); 
            psi[ni] = ui;
            MatMultVec(psfni, psi, ref p_psi, ni2);
            ZVecMultVec(psi, p_psi, ref psit_p_psi, ni2);
            psit_p_psi = psit_p_psi + vf;
            psit_p_psi = 1 / psit_p_psi;
            VecMultSc(p_psi, psit_p_psi, ref gamma, ni2);
            // hier neu ab 17.6.2015 ui um d zusätzlich verzögern
            uindelay[0] = uin;
            ui = uindelay[del];
            for (int i = MaxDelay - 1; i > 0; i--) uindelay[i] = uindelay[i - 1];
        } /*PROCEDURE-ENDE*/

 
        //// --------------------------------------------------------------------------

        void teta2tetab0()
        {
            // tetaid : 0,1,2,...kein b0 m,m+1,m+2... Aus RS online 
            // tetacd : 1,2,3,...b0, m+1,m+2,...   für Contrdes
            int i;
            for (i = 0; i < maxnp2; i++)
                tetaIdent_b0[i] = 0; // clear
            for (i = 0; i < mgradIdent; i++)
            {
                tetaIdent_b0[i + 1] = tetaid[i];
                tetaIdent_b0[i + mgradIdent + 2] = tetaid[i + mgradIdent];
            }
            alpha = 100;
        }
        void teta2Controller()
        {
            // tetaid : 0,1,2,...kein b0 m,m+1,m+2... Aus RS online 
            // tetacd : 1,2,3,...b0, m+1,m+2,...   für Contrdes
            int i;
            for (i = 0; i < maxnp2; i++)
                teta2Con[i] = 0; // clear
            for (i = 0; i < mgradIdent; i++)
            {
                teta2Con[i + 1] = tetaid[i];
                teta2Con[i + mgradIdent + 2] = tetaid[i + mgradIdent];
            }
            alpha = 100;
        }


        void calccontroller()
        {
            teta2Controller(); 
            switch (Ncon)
            {
                case 6:
                    {// DB(v)
                        meinMain.datatools.DB_aus_teta(teta2Con, ref pv, ref qv, mgradIdent);

                        break;
                    }
                case 7:
                    {// DB(v+1)
                        meinMain.datatools.DB1_aus_teta(teta2Con, ref p1v, ref q1v, mgradIdent, 1);
                        break;
                    }
                case 8:
                    {// OR
                        meinMain.datatools.OR_aus_teta(teta2Con, ref p2v,
                            ref q2v, mgradIdent, ref f3or);
                        break;
                    }
            }//  end switch
        }

        string TypIdent = "";
        double _K = 0, _T1 = 0, _T2 = 0;  // Variables identified

        int cntIdentOK = 0;

        //void teta2GraficIdentArray(double[] teta)
        //{
        //    //string error = "";
            //meinMain.datatools.kt_aus_tetab0(ref _K, ref _T1, ref _T2, t0rtc, teta, mgradIdent, ref TypIdent, ref error);
            //if (TypIdent == "2PT1")
            //{
            //    IdentK[cntIdentOK, 0] = cntIdentDispl;
            //    IdentK[cntIdentOK, 1] = _K;
            //    IdentT1[cntIdentOK, 0] = cntIdentDispl;
            //    IdentT1[cntIdentOK, 1] = _T1;
            //    IdentT2[cntIdentOK, 0] = cntIdentDispl;
            //    IdentT2[cntIdentOK, 1] = _T2;
            //    cntIdentOK++;
            //}
        //}
        
        
        
        void teta2DisplayIdent(double[] teta)  // for Label output with timer1
        {

            string  error = "";
            meinMain.datatools.kt_aus_tetab0(ref _K, ref _T1, ref _T2, t0rtc, teta, mgradIdent, ref TypIdent, ref error);
            labelType.Text = "Type=  " + TypIdent;
            tBKident.Text = _K.ToString("G8");
            
            if (cBEnableDisplay.Checked)
            {
                //cntIdentDispl++;
                gBParIdent.Enabled = true;
            //    if (cntIdentDispl > nudDisplayIdent.Value - 1)
            //    {
            //        cntIdentDispl = 0;
            //        chart2D2.clearAll();
            //        if (cntIdentOK > 5)
            //        {
            //            for (int i6 = 0; i6 < cntIdentOK; i6++)
            //            {
            //                if (rBIdentK.Checked) chart2D2.setPoint(0, IdentK[i6, 0], IdentK[i6, 1]);
            //                if (rBIdentT1.Checked) chart2D2.setPoint(0, i6, _T1);
            //                if (rBIdentT2.Checked) chart2D2.setPoint(0, i6, _T2);
            //            }
            //            chart2D2.startDrawing();
            //            chart2D2.autoScaling();
            //        }
            //        cntIdentOK = 0;
            //    }
            }
            else
            {
                gBParIdent.Enabled = false;
                //cntIdentDispl = 0;
            }

            if ((TypIdent == "PT1") || (TypIdent == "IT1"))
            {
                tBT2Ident.Visible = false;
                labT2ident.Visible = false;
                labT1ident.Text = "T1";
            }
            if (TypIdent == "2PT1")
            {
                tBT2Ident.Visible = true;
                labT2ident.Visible = true;
                labT1ident.Text = "T1";
                labT2ident.Text = "T2";
                double help = _T2;
                if (_T1<_T2) { _T2 = _T1;_T1 = help; }  // swap so that T1 is larger
                if (cBEnableDisplay.Checked)
                {

                    if (rBIdentK.Checked) chart2D2.scopeChart(0, _K);
                    if (rBIdentT1.Checked) chart2D2.scopeChart(0, _T1);
                    if (rBIdentT2.Checked) chart2D2.scopeChart(0, _T2);
                   
                }
            }
            if (TypIdent == "PT2")
            {
                tBT2Ident.Visible = true;
                labT2ident.Visible = true;
                labT1ident.Text = "wo";
                labT2ident.Text = "d";
            }
            tBT1Ident.Text = _T1.ToString("G8");
            tBT2Ident.Text = _T2.ToString("G8");

        }

        void KT2PFC()
        {
            if ((TypIdent == "PT1") && ((rbPT1.Checked)||(rBPT1Bay.Checked)))
            {
                tBnumKmPT1.Text=tBKident.Text;
                tBnumT1PT1.Text=tBT1Ident.Text;
                calcPFC_Parameters();
            }
            if ((TypIdent == "2PT1") && ((rb2PT1.Checked) || (rB2PT1_2.Checked) || (rB2PT1_3.Checked)))
            {
                tBnumKm2PT1.Text=tBKident.Text;
                tBnumT12PT1.Text=tBT1Ident.Text;
                tBnumT22PT1.Text=tBT2Ident.Text;
                calcPFC_Parameters();
            }

        }
        
        void tetaidtocell(double [] teta)
        {   // with bo- Version
            int i;
            //dataGridViewProcessPar.RowCount = 1;
            dataGridViewProcessPar.Rows[0].Cells[0].Value="1";
            dataGridViewProcessPar.Rows[0].Cells[1].Value= teta[mgradIdent + 1].ToString("G8"); /*b0*/
            dataGridViewProcessPar.Rows[0].HeaderCell.Value = "0";
            for (i = 1; i <= mgradIdent; i++)
            {
                dataGridViewProcessPar.Rows[i].Cells[0].Value=teta[i].ToString("G8");
                dataGridViewProcessPar.Rows[i].Cells[1].Value = teta[mgradIdent + 1 + i].ToString("G8"); /*bi*/
                dataGridViewProcessPar.Rows[i].HeaderCell.Value = i.ToString();
            } /*for (*/


        }

        private void numericUpDown4_ValueChanged(object sender, EventArgs e)
        {
            mgradIdent = (int)numericUpDown4.Value;
            dataGridViewProcessPar.RowCount = (int)numericUpDown4.Value+1;
        }

        private void butSaveIdentProc_Click(object sender, EventArgs e)
        {
            if (saveFileDialogIdentFz.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                pList.Add("From RLS online identification");
                pList.Add(numericUpDown4.Value.ToString());

                for (int i = 1; i <= numericUpDown4.Value + 1; i++)
                {
                    pList.Add(dataGridViewProcessPar.Rows[i - 1].Cells[0].Value + " "
                        + dataGridViewProcessPar.Rows[i - 1].Cells[1].Value);
                }
                pList.Add((t0rtc).ToString());  //  in file in sec
                pList.Add("0");  // no integer delay n*T0
                pList.Add("0"); // no continuous delay

                System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialogIdentFz.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
            }

        }

        private void butInitControl_Click(object sender, EventArgs e)
        {
            initident(alpha, mgradIdent, 0);
            initController();
            // read controller from meinMain.fcontrdes.
            readpv_valuesfromconrdes();
        }

        private void rbIdeal_CheckedChanged(object sender, EventArgs e)
        {
            meinMain.frmSimul.rbIdeal.Checked = rbIdeal.Checked;
        }

        private void rbReal_CheckedChanged(object sender, EventArgs e)
        {
            meinMain.frmSimul.rbReal.Checked = rbReal.Checked;
        }

        private void tsbClearAll_Click(object sender, EventArgs e)
        {
            chart2D1.clearAll();
            minmax.init();
        }

        private void TSBClearLast_Click(object sender, EventArgs e)
        {
                chart2D1.clearLast();

        }

 
        private void timerDraw_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            timerDraw.Enabled = false;
            butdrawAgain_Click(sender, null);
        }

        private void butdrawAgain_Click(object sender, EventArgs e)
        {
            if (cbDisplayX.Checked)
            {
                LOrtc.legend = "X " + legendText;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, ayval, (int)numPoints.Value, ref minmax, LOrtc);
            }
            if (cbDisplayXr.Checked)
            {
                LOrtc.legend = "Xr " + legendText;
                LOrtc.WithSampleAndHold = cBxrWithSH.Checked;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, axrval, (int)numPoints.Value, ref minmax, LOrtc);
                LOrtc.WithSampleAndHold = false;
            }
            if (cbDisplayW.Checked)
            {
                LOrtc.legend = "W " + legendText;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, awval, (int)numPoints.Value, ref minmax, LOrtc);
            }


        }

        bool binRand = false;
        private void rbImpulsAutostop_CheckedChanged(object sender, EventArgs e)
        {
            if (rbImpulsAutostop.Checked)
            {
                butLoadBinary.Visible = true;
                binRand = true;
                label8.Visible = true;
                tbPulse.Visible = true;
                cBOpenLoop.Visible = true;
                recOn = true;
                buttonRSR.Enabled = false;
                butProcStepResp.Enabled = false;
            }
            else
            {
                butLoadBinary.Visible = false;
                binRand = false;
                label8.Visible = false;
                tbPulse.Visible = false;
                recOn = false;
                cBOpenLoop.Visible = false;
            }
        }

        private void butLoadBinary_Click(object sender, EventArgs e)
        {
            if (openFileDialogBinary.ShowDialog() == DialogResult.OK)
            {
                StreamReader filestream = new StreamReader(openFileDialogBinary.FileName, Encoding.Default);
                binaryfile = filestream.ReadLine();
                meinMain.frmRTdevice.label3.Text = System.IO.Path.GetFileName(openFileDialogBinary.FileName);
                filestream.Close();
            }

        }

        private void butCheckBin_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < checkedListBox1.Items.Count; i++)
                if (binaryfile.IndexOf(checkedListBox1.Items[i].ToString()) == -1) checkedListBox1.SetItemChecked(i, false);
                else checkedListBox1.SetItemChecked(i, true);

        }

        private void butChckDispar_Click(object sender, EventArgs e)
        {
            int disparity = -1;
            int nbchar = binaryfile.Length;
            int index = 0;
            for (int i = 0; i < 26; i++)
            {
                checkLBDisparity.SetItemChecked(index, false);
            }
            disparity = -1;
            for (int i = 0; i < nbchar; i++)
            {
                string chr = binaryfile.Substring(i, 1);
                if (chr == "1") disparity++;
                if (chr == "0") disparity--;
                index = disparity;
                if (index > 12) index = 12;
                if (index < -13) index = -13;
                index = 12 - index;  // now Index between 0 and 25
                checkLBDisparity.SetItemChecked(index, true);
            }

        }



        private void butDrawHist_Click(object sender, EventArgs e)
        {
            tbLastValuesX.Clear();
            int nb = histT0.Length - 2;
            for (int i = 0; i < nb; i++)
            {
                tbLastValuesX.AppendText((i/100.0).ToString() + " " + histT0[i].ToString() + CRLF);
            }
            nb++;
            tbLastValuesX.AppendText((nb/100.0).ToString() + " " + histT0[nb].ToString());
            LOrtc.bottomtitle = "time in msec";
            LOrtc.legend = "Histogramm T0";
            meinMain.datatools.ConvertTB2ChartAdd(ref chart2D1, tbLastValuesX, ref minmax, LOrtc);
            labelHist.Text = histcnt.ToString();
            labelMaxT0.Text=" Max T0: " + (MaxT0 * 1000.0 / Stopwatch.Frequency).ToString("f2") + " ms";
        }

        private void cBHistogram_CheckedChanged(object sender, EventArgs e)
        {
            histcnt = 0;
            for (int i = 0; i < histdT.Length; i++)
                histdT[i] = 0;
            for (int i = 0; i < histT0.Length; i++)
                histT0[i] = 0;
            if (!cBHistogram.Checked)
            {
                labelHist.Text = "no histogram";
                MaxT0 = 0;
                MaxdT = 0;
                butDrawHist.Enabled = false;
                butDrawHistDt.Enabled = false;
            }
            else
            {
                butDrawHist.Enabled = true;
                butDrawHistDt.Enabled = true;
            }
        }

        private void butDrawHistDt_Click(object sender, EventArgs e)
        {
            tBLastValuesXr.Clear();
            int nb = histdT.Length-2;
            for (int i = 0; i < nb; i++)
            {
                tBLastValuesXr.AppendText((i/100.0).ToString() + " " + histdT[i].ToString() + CRLF);
            }
            nb++;
            tBLastValuesXr.AppendText((nb / 100.0).ToString() + " " + histdT[nb].ToString());
            LOrtc.bottomtitle = " time in msec";
            LOrtc.legend = "Histogramm DT";
            meinMain.datatools.ConvertTB2ChartAdd(ref chart2D1, tBLastValuesXr, ref minmax, LOrtc);
            labelHist.Text = histcnt.ToString() + " Max: " + (MaxdT * 1000.0 / Stopwatch.Frequency).ToString() + " ms";
        }

         private void nudSignalIn_ValueChanged(object sender, EventArgs e)
        {
            //nudADChan1.Value = nudSignalIn.Value;
            //nudADChan2.Value = nudSignalIn.Value;
        }

        private void nudChanDA_ValueChanged(object sender, EventArgs e)
        {
            nudOutFuz.Value = nudChanDA.Value;
        }

        private void BLoadFuz_Click(object sender, EventArgs e)
        {
            meinMain.frmFuzEdit.Show();
            meinMain.frmFuzEdit.buttonLoadFuz_Click(sender, e);

        }

        private void butFuzEditor_Click(object sender, EventArgs e)
        {
            meinMain.frmFuzEdit.Show();
        }

        double[] tetaPFC = new double[10];  // bis 4.ten Grades OK
        public int Dmgrad = 0;

        private void Bfztodf_Click_1(object sender, EventArgs e)
        {
            // Load *fz file, fill datastringgrid and try to convert into Pt1, It1 or 2PT1
            List<String> pList = new List<String>();
            if (openFileDialogFZPfc.ShowDialog() == DialogResult.OK)
            {
                StreamReader filestream = new StreamReader(openFileDialogFZPfc.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    if (line != null)
                    {
                        pList.Add(line);
                    }
                }
                filestream.Close();
                //copyList2DigitalFilterForm(pList);   copy from DigitalFilter
                int i;
                int len = pList.Count;
                string[] outstr = new string[10];
                labPFCfile.Text = Path.GetFileName(openFileDialogFZPfc.FileName);

                Dmgrad = Convert.ToInt32(pList[1]);
                if (Dmgrad <= 4)
                {
                    for (i = 0; i < tetaPFC.Length; i++) tetaPFC[i] = 0; //Clear
                    if ((Dmgrad + 4) > len) MessageBox.Show(meinMain.fdigfilt.wrongfileformat);
                    else
                    {
                        dataGridView1.RowCount = Dmgrad+1;
                        meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');  // a0, b0
                        //dataGridView1.Rows[0].Cells[1].Value = outstr[0];  //a0
                        if (outstr[1] != "0")
                        {
                            MessageBox.Show(meinMain.fcontrdes.b0notpossible);
                            meinMain.ConvertToDouble(outstr[1], ref tetaPFC[Dmgrad + 1]);  // b0
                        }
                        else tetaPFC[Dmgrad + 1] = 0;
                        for (i = 3; i <= (Dmgrad + 2); i++)
                        {
                            meinMain.datatools.Str2NString(pList[i], ref outstr, ' ');
                            dataGridView1.Rows[i - 2].Cells[0].Value = outstr[0];
                            meinMain.ConvertToDouble(outstr[0], ref tetaPFC[i - 2]);  //ai
                            dataGridView1.Rows[i - 2].Cells[1].Value = outstr[1];
                            meinMain.ConvertToDouble(outstr[1], ref tetaPFC[i - 1 + Dmgrad]);  //bi
                        }
                        meinMain.ConvertToDouble(pList[i], ref t0rtc);
                        numTimeInterval.Value = (decimal)(t0rtc * 1000);  // in numTimeInterval in msec, in File in sec
                    //    if (len > i + 2)  // some files contains  continuous delay
                    //        MessageBox.Show(delaynotpossible);
                    }
                    if (Dmgrad <= 2)
                    {
                        double _K = 0, _T1 = 0, _T2 = 0;
                        string Typ = "", error = "";
                        meinMain.datatools.kt_aus_tetab0(ref _K, ref _T1, ref _T2, t0rtc, tetaPFC, Dmgrad, ref Typ, ref error);
                        labelTyp.Text = "Type=  " + Typ;
                        if (Typ == "PT1")
                        {
                            //edk.Text = _K.ToString("G8");
                            //Edt1.Text = _T1.ToString("G8");
                            tBnumKmPT1.Text = _K.ToString("f5");
                            tBnumT1PT1.Text = _T1.ToString("f5");
                            rBPT1Bay.Checked = true;
                        }
                        else
                            if (Typ == "2PT1")
                            {
                                //edk.Text = _K.ToString("G8");
                                //Edt1.Text = _T1.ToString("G8");
                                //Edt2.Text = _T2.ToString("G8");
                                tBnumKm2PT1.Text = _K.ToString("f5");
                                tBnumT12PT1.Text = _T1.ToString("f5");
                                tBnumT22PT1.Text = _T2.ToString("f5");
                                rBFZ2.Checked = true;
                            }
                            else
                                if (Typ == "IT1")
                                {
                                    //edk.Text = _K.ToString("G8");
                                    //Edt1.Text = _T1.ToString("G8");
                                    //Edt2.Text = _T2.ToString("G8");
                                    tBnumKIT1.Text = _K.ToString("f5");
                                    tBnumTIT1.Text = _T1.ToString("f5");
                                    rBIT1PFC.Checked = true;
                                }
                    }
                    else if (Dmgrad==3)
                    {  // grad ==3
                        rBFZ2.Checked = true;
                        labelTyp.Text = "DB bay n=3 ";
                    } 
                    else
                    {  // grad ==4
                        rBFZ2.Checked = true;
                        labelTyp.Text = "DB bay n=4 ";
                    } 

                }
                else // >4
                    MessageBox.Show(nlarger2notpossible);
            }
        }

        private void cBPFCFilteractive_CheckedChanged(object sender, EventArgs e)
        {
            double KpfcFi=0, TpfcFi=0;
            if (cBPFCFilteractive.Checked && rBFZ2.Checked)  // only active in case of F(z) DB bay is chosen
            {
                meinMain.ConvertToDouble(tBPFCprocessFiltK.Text, ref KpfcFi);  // K
                meinMain.ConvertToDouble(tBPFCprocessFiltT.Text, ref TpfcFi);  // K
                fPFCfiltA1 = -Math.Exp(-t0rtc / TpfcFi);
                fPFCfiltB1 = KpfcFi * (1 + fPFCfiltA1);
            }
            else
            {
                fPFCfiltA1 = 0;
                fPFCfiltB1 = 1;
            }
        }

        private void cbIdentificationActive_CheckedChanged(object sender, EventArgs e)
        {
            if (cbIdentificationActive.Checked)
            {
                cbAdaptionActive.Enabled = true;
                chart2D2.Visible = true;
                if (rbIdeal.Checked)
                    MessageBox.Show(Identsensfulreal);
            }
            else
            {
                cbAdaptionActive.Checked = false;
                cbAdaptionActive.Enabled = false;
                chart2D2.Visible = false;
            }

        }

        private void PFCmodPT1delay_ValueChanged(object sender, EventArgs e)
        {
            dPFCm = (int)PFCmodPT1delay.Value;
        }

        private void PFCmod2PT1Delay_ValueChanged(object sender, EventArgs e)
        {
            dPFCm2 = (int)PFCmod2PT1Delay.Value;

        }

        private void buttonActPFCChanges_Click(object sender, EventArgs e)
        {
            calcPFC_Parameters();
        }

        private void nudDelayDBC_ValueChanged(object sender, EventArgs e)
        {
            d_DBC = (int)nudDelayDBC.Value;
        }

        private void gb2PT1_Enter(object sender, EventArgs e)
        {

        }

        private void butUnitStep_Click(object sender, EventArgs e)
        {
            tbAmp.Text = "1";
            tbUoff.Text = "0";
        }

        private void numPoints_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numPoints, 1, maxpoints-1);
            double help =(double)numPoints.Value;
            help=help/2.0;
            tbPulse.Text = Math.Truncate(help).ToString();
        }

        private void butInitSimul_Click(object sender, EventArgs e)
        {
             if (meinMain.hardwareSimulationToolStripMenuItem.Checked ) meinMain.frmSimul.initFilter();
             if (meinMain.toolStripMenuItemNIDAQmx.Checked)
             {
                 buttonStop_Click(null, null);  // geht bei dacmx nur bei stop
                 meinMain.frmDACmx.butZero_Click(null, null);
             }
            }
               

        private void FormAdaptControl_Activated(object sender, EventArgs e)
        {
            // Taste nur sichtbar, wenn Hardwaresimulator oder NIAQmx gewählt
            if (meinMain.hardwareSimulationToolStripMenuItem.Checked || meinMain.toolStripMenuItemNIDAQmx.Checked)
                butInitSimul.Visible = true;
            else
                butInitSimul.Visible = false;
        }

        private void butDelToContr_Click(object sender, EventArgs e)
        {
            nudDelayDBC.Value = nuDDelayRLSIdent.Value;
            PFCmod2PT1Delay.Value = nuDDelayRLSIdent.Value;
            PFCmodPT1delay.Value = nuDDelayRLSIdent.Value;
        }

        private void groupBox9_Enter(object sender, EventArgs e)
        {

        }

        private void rBslow_CheckedChanged(object sender, EventArgs e)
        {
            tBVFident.Text = "0.999";
            meinMain.ConvertToDouble(tBVFident.Text, ref wichtung);

        }

        private void rBfast_CheckedChanged(object sender, EventArgs e)
        {
            tBVFident.Text = "0.95";
            meinMain.ConvertToDouble(tBVFident.Text, ref wichtung);

        }

        private void rBmedium_CheckedChanged(object sender, EventArgs e)
        {
            tBVFident.Text = "0.99";
            meinMain.ConvertToDouble(tBVFident.Text, ref wichtung);
        }

        private void butCalcCasc_Click(object sender, EventArgs e)
        {
            double temp = 0;
            meinMain.ConvertToDouble(tBKa.Text, ref temp); 
            q0ac = temp;
            meinMain.ConvertToDouble( tBKi.Text, ref temp); 
            q1ic = -temp;  
            meinMain.ConvertToDouble( tBTn.Text, ref temp);
            q0ic = (-q1ic) * (1 +  t0rtc / temp); ;
 
        }

        private void rBAdvanced_CheckedChanged(object sender, EventArgs e)
        {
            if (rBAdvanced.Checked)
            {
                groupBox13.Visible = true;
                rBPFCcon.Visible = true;
                rBFuzzy.Visible = true;
                grBoxInitPI.Visible = true;
                rbImpulsAutostop.Visible = true;    
            }
            else  // simple
            {
                groupBox13.Visible = false;
                Tabs.SelectedIndex = 1;
                rbImpulsAutostop.Visible = false;
                rBPFCcon.Visible = false;
                rBFuzzy.Visible = false;
                grBoxInitPI.Visible = false;

            }
        }
        public double templin(double x)
        {
            double a = 0.036062155824614, 
                b = 1.6671935360783, 
                c = -0.1433015755851, 
                d = -0.13578444411253, 
                e = 0.050573991064708, 
                f = -0.0063151177921761, 
                g = 0.00026915715662378;
            // out = a+bx +cx^2 +dx^3 ...
            if (x < 0) x = 0;  // Limiter
            if (x > 10) x = 10;
            double y = g * x + f;
            y = y * x + e;
            y = y * x + d;
            y = y * x + c;
            y = y * x + b;
            y = y * x + a;
            return (y);
        }







        //// --------------------------------------------------------------------------
    }
}
