﻿ using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;

using System.Diagnostics;


namespace WINDF7CSharp.RealTimeController
{
    public partial class FormDRTKranregler : Form
    {
        private readonly MicroLibrary.MicroTimer _microTimer;
        FormMain meinMain;
        double Pendymin, Pendymax;
        double t0end=0, t0start=0, t0 = 0, dtend=0,dt=0;
        Stopwatch stopwatch1;
        string strval="Value= ";

        
        public void deutsch()
        {
            strval="Wert= ";
            this.Text = "DRT Regler für Kranhardware als invertiertes Pendel ";
            cBKranPosReglerOn.Text = "Regler für Kranposition";
            cBKranUnterPendelOn.Text = "Regler für Kran unter Pendel";
            cBPendelgeschwindigkeit.Text = "Regler für Pendelgeschwindigkeit";
            cBPendPosRegler.Text = "Regler für obere Pendelposition";
            butSetZero.Text = "Track auf Null";
            radioButtonDiv10.Text = "Trackwerte /10";
        }
        
        public FormDRTKranregler(FormMain m)
        {
            InitializeComponent();
            Pendymax = 9.9;
            Pendymin = -9.9;
            meinMain = m;
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(onMMTimer1);
            _microTimer.Interval = 6000;
            stopwatch1 = new Stopwatch();
            stopwatch1.Start();
        }

        double TrackBarWert;
        double Yout = 0;
        double test = 0;
        double AD0, AD1;
 



        void onMMTimer1(object sender, MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {
            t0end = t0start;
            t0start = stopwatch1.ElapsedTicks;
            t0 = (t0start - t0end);  // Period
            // time measurement

            AD0 = inputAD0();
            AD1 = inputAD1();
            double pend12clock = 2.5;
 
            if (Math.Abs(AD1-pend12clock) < 0.4)  // Only in small area in vertical position active, 0.4V=14.4°
            
            {

                if (cBPendPosRegler.Checked)
                {  // here control of vertical pendulum position 
              

                }
                else ; //

                if (cBPendelgeschwindigkeit.Checked)
                {    // here control of pendulum speed
                    

                }
                else ;//
                if (cBKranUnterPendelOn.Checked)
                {     // control of pivot under pendulum 
                    
                }
                else ;
            }
            else ; //WagPosSoll = TrackBarWert;
            if (cBKranPosReglerOn.Checked)
            {  // here control of position of pivot with block 5

                

            } else outputx(0);

            // time measurement
            dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - t0start);  // dt runtime of function
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            tSSLabel1.Text = "T0=  " + (t0 / Stopwatch.Frequency * 1000.0).ToString("f3") + "  ms   Dauer=  " +
                (dt / Stopwatch.Frequency * 1000.0).ToString("f3");
            labelAD0.Text = "AD0= " + AD0.ToString("f3");
            labelAD1.Text = "AD1= " + AD1.ToString("f3");
            labelDA0.Text = "DA0= " + Yout.ToString("f3");
            labeltestWert.Text = "Test= " + test.ToString("f3");
        }


        private void buttonReset_Click(object sender, EventArgs e)
        {
            outputx(-4); // Fahre Kran ganz nach rechts in die Lichtschranke 
            // drive pivot to right position into light bar to reset position counter
        }

        //input of angel ,channel 1
        double inputAD1()
        {
            double val = 0;
            meinMain.ADCinput(1, ref val);
            return val;
        }

        //output of position, channel 0
        void outputx(double y)
        {
            if (y >= Pendymax) y = Pendymax;
            if (y <= Pendymin) y = Pendymin;

            meinMain.DACoutput(0, y);
        }
        // input of position ,channel 0
        double inputAD0()
        {    // version for new horizontal movement since April 2013
            double val = 0;
            meinMain.ADCinput(0, ref val);
            if (val < 0) val = 10.0; // Correction of left 10V- Value which must be +10V
            return (3.751 * val - 27.51);
        }

        private void FormDRTKranregler_FormClosing(object sender, FormClosingEventArgs e)
        {
            _microTimer.Stop();
            e.Cancel = true;
            this.Visible = false;
        }

        double Div10 = 1;
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            TrackBarWert = trackBar1.Value / 10.0/Div10;
            labelTrVal.Text = strval+ TrackBarWert.ToString("f1");
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            _microTimer.Start();
            timer1.Enabled = true;
        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            _microTimer.Stop();
            timer1.Enabled = false;
        }

        private void butSetZero_Click(object sender, EventArgs e)
        {
            trackBar1.Value = 0;
            TrackBarWert = trackBar1.Value / 10.0 / Div10;
            labelTrVal.Text = strval + TrackBarWert.ToString("f1");
        }
        bool butcheck = true;

        private void radioButtonDiv10_Click(object sender, EventArgs e)
        {
            if (butcheck)
            {
                Div10 = 10;
                radioButtonDiv10.Checked = true;
                butcheck = false;
            }
            else
            {
                Div10 = 1;
                radioButtonDiv10.Checked = false;
                butcheck = true;
            }

        }
 


    }
}
