﻿ using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;
using MPS;
using System.Diagnostics;


namespace WINDF7CSharp.RealTimeController
{
    public partial class FormCSIIrap : Form
    {
        TMultimediaTimer MMTimer1;
        FormMain meinMain;
        double Pendymin, Pendymax;
        double t0end=0, t0start=0, t0 = 0, dtend=0,dt=0;
        Stopwatch stopwatch1;
        string strval="Value= ";
        double t0rtc, ncas, x1cas, wncas, xdncas, yold, xdn1cas;
        
        public void deutsch()
        {
            strval="Wert= ";
            this.Text = "DRT Regler für Kranhardware als invertiertes Pendel ";
            cBKranPosReglerOn.Text = "Regler für Kranposition";
            cBKranUnterPendelOn.Text = "Regler für Kran unter Pendel";
            cBPendelgeschwindigkeit.Text = "Regler für Pendelgeschwindigkeit";
            cBPendPosRegler.Text = "Regler für obere Pendelposition";
            butSetZero.Text = "Track auf Null";
            radioButtonDiv10.Text = "Trackwerte /10";
        }
        
        public FormCSIIrap(FormMain m)
        {
            InitializeComponent();
            Pendymax = 6;
            Pendymin = -6;
            meinMain = m;
            MMTimer1 = new TMultimediaTimer(null);
            MMTimer1.Interval = 6;
            t0rtc = MMTimer1.Interval * 0.001; // in sec
            MMTimer1.OnTimer = onMMTimer1;
            stopwatch1 = new Stopwatch();
            stopwatch1.Start();
        }

        double TrackBarWert;
        double Yout = 0;
        double test = 0;
        double AD0, AD1;


        double WagPosIst, WagPosSoll, alpha, PendPos, deltAlpha;
        double PendSoll, PendPosPT1, PendPosPT1old;
        double PendVIst, xdPendV, xdPendVold, PendVSoll;
        double xdPendPosold, xdPendPos;
        double Ktest = 1;


        void onMMTimer1(TMultimediaTimer Sender)
        {
            t0end = t0start;
            t0start = stopwatch1.ElapsedTicks;
            t0 = (t0start - t0end);  // Period
            // time measurement

            AD0 = inputAD0();
            AD1 = inputAD1();
            double pend12clock = 2.5;
            alpha = AD1 - pend12clock; // Bei 12 Uhr ist der Wert Null
            PendPos = AD0 - 5.55 * alpha;  // P Block  8 + Summierstelle
            PendPosPT1 = 0.94258 * PendPosPT1 + 0.057416 * PendPos;  // PT1 Block 9
            PendVIst = 0.8868 * PendVIst + 5.649 * PendPosPT1 - 5.649 * PendPosPT1old; //DT1 Block 10
            PendPosPT1old = PendPosPT1;
            PendSoll = TrackBarWert;
 
            if (Math.Abs(AD1-pend12clock) < 0.4)  // Only in small area in vertical position active, 0.4V=14.4°
            
            {

                if (cBPendPosRegler.Checked)
                {  // here control of vertical pendulum position 
                    xdPendPos = PendSoll - AD0;
                    PendVSoll = PendVSoll + 0.09588 * xdPendPos - 0.09576 * xdPendPosold; //PI Block 1
                    xdPendPosold = xdPendPos;
             

                }
                else { PendVSoll = 0; } //

                if (cBPendelgeschwindigkeit.Checked)
                {    // here control of pendulum speed
                    xdPendV = PendVSoll - PendVIst;
                    deltAlpha = Ktest* 2.0596 * xdPendV - Ktest* 1.584 * xdPendVold;  // PD Block 2
                    if (deltAlpha > Pendymax) deltAlpha = Pendymax;  // Block 34
                    if (deltAlpha < Pendymin) deltAlpha = Pendymin;
                    xdPendVold = xdPendV;                   

                }
                else { deltAlpha = 0; xdPendVold = 0; }   //
                if (cBKranUnterPendelOn.Checked)
                {     // control of pivot under pendulum 
                    WagPosSoll = PendPos-deltAlpha;
                }
                else ;
            }
            else WagPosSoll = TrackBarWert;
            if (cBKranPosReglerOn.Checked)
            {  // here control of position of pivot with cascaded controller
                ncas = (AD0 - x1cas) / t0rtc;  // speed by differentiating 
                wncas = 10 * (WagPosSoll - AD0);    // outer P-controller  
                xdncas = wncas - ncas;
                double ki = 1.0, ti = 0.15;
                Yout = yold + ki*(1+t0rtc/ti) * xdncas - ki * xdn1cas;   // PI-controller inner loop 
                if (Math.Abs(Yout) > Pendymax) Yout = Yout - (t0rtc / ti) * xdncas;  //AWU
                x1cas = AD0; xdn1cas = xdncas; yold = Yout;

                outputx( Yout); // P-Controller  

            } else outputx(0);

            // time measurement
            dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - t0start);  // dt runtime of function
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            tSSLabel1.Text = "T0=  " + (t0 / Stopwatch.Frequency * 1000.0).ToString("f3") + "  ms   Dauer=  " +
                (dt / Stopwatch.Frequency * 1000.0).ToString("f3");
            labelAD0.Text = "AD0= " + AD0.ToString("f3");
            labelAD1.Text = "AD1= " + AD1.ToString("f3");
            labelDA0.Text = "DA0= " + Yout.ToString("f3");
            labeltestWert.Text = "Test= " + test.ToString("f3");
        }


        private void buttonReset_Click(object sender, EventArgs e)
        {
            // outputx(-4); // Fahre Kran ganz nach rechts in die Lichtschranke 
            // drive pivot to right position into light bar to reset position counter
            if (meinMain.toolStripMenuItemNIDAQmx.Checked)
            {
                buttonStop_Click(null, null);  // geht bei dacmx nur bei stop
                meinMain.frmDACmx.butZero_Click(null, null);
            }

        }

        //input of angel ,channel 1
        double inputAD1()
        {
            double val = 0;
            meinMain.ADCinput(1, ref val);
            return val;
        }

        //output of position, channel 0
        void outputx(double y)
        {
            if (y >= Pendymax) y = Pendymax;
            if (y <= Pendymin) y = Pendymin;

            meinMain.DACoutput(0, y);
        }
        // input of position ,channel 0
        double inputAD0()
        {    // version for new horizontal movement since April 2016 rap-and-pinion drive
            // left 0V start with zero button, then right position 10 V
            double val = 0;
            meinMain.ADCinput(0, ref val);
            return (val);
        }

        private void FormDRTKranregler_FormClosing(object sender, FormClosingEventArgs e)
        {
            MMTimer1.Disable();
            outputx(0);
            e.Cancel = true;
            this.Visible = false;
        }

        double Div10 = 1;
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            TrackBarWert = trackBar1.Value / 10.0/Div10;
            labelTrVal.Text = strval+ TrackBarWert.ToString("f1");
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            MMTimer1.Enable();
            yold = 0; xdn1cas = 0;
            timer1.Enabled = true;
        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            MMTimer1.Disable();
            yold = 0; xdn1cas = 0;
            outputx(0);
            timer1.Enabled = false;
        }

        private void butSetZero_Click(object sender, EventArgs e)
        {
            trackBar1.Value = 0;
            TrackBarWert = trackBar1.Value / 10.0 / Div10;
            labelTrVal.Text = strval + TrackBarWert.ToString("f1");
        }
        bool butcheck = true;

        private void radioButtonDiv10_Click(object sender, EventArgs e)
        {
            if (butcheck)
            {
                Div10 = 10;
                radioButtonDiv10.Checked = true;
                butcheck = false;
            }
            else
            {
                Div10 = 1;
                radioButtonDiv10.Checked = false;
                butcheck = true;
            }

        }

        private void butGo_Click(object sender, EventArgs e)
        {
            Ktest = Convert.ToDouble(textBox1.Text);
        }
 


    }
}
