﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;
using MPS;
using System.Diagnostics;


namespace WINDF7CSharp.RealTimeController
{
    public partial class FormDRTKranregler : Form
    {
        TMultimediaTimer MMTimer1;
        FormMain meinMain;
        double Pendymin, Pendymax;
        double t0end=0, t0start=0, t0 = 0, dtend=0,dt=0;
        Stopwatch stopwatch1;

        
        public FormDRTKranregler(FormMain m)
        {
            InitializeComponent();
            Pendymax = 9.9;
            Pendymin = -9.9;
            meinMain = m;
            MMTimer1 = new TMultimediaTimer(null);
            MMTimer1.Interval = 6;
            MMTimer1.OnTimer = onMMTimer1;
            stopwatch1 = new Stopwatch();
            stopwatch1.Start();
        }

        double TrackBarWert;
        double Yout = 0;
        double test = 0;
        double AD0, AD1;
        double WagPosIst, WagPosSoll,alpha, PendPos,deltAlpha;
        double PendSoll, PendPosPT1, PendPosPT1old;
        double PendVIst, xdPendV, xdPendVold, PendVSoll;
        double xdPendPosold, xdPendPos;

        void onMMTimer1(TMultimediaTimer Sender)
        {
            t0end = t0start;
            t0start = stopwatch1.ElapsedTicks;
            t0 = (t0start - t0end);  // Periode
            // Zeitmessung

            PendSoll = TrackBarWert;
            AD0 = inputAD0();
            AD1 = inputAD1();
            WagPosIst = AD0;
            alpha =AD1 - 2.86; // Bei 12 Uhr ist der Wert Null
            PendPos = WagPosIst - 5.55 * alpha;  // P Block  8 + Summierstelle
            PendPosPT1 = 0.94258 * PendPosPT1 + 0.057416 * PendPos;  // PT1 Block 9
            PendVIst = 0.8868 * PendVIst + 5.649 * PendPosPT1 - 5.649 * PendPosPT1old; //DT1 Block 10
            PendPosPT1old = PendPosPT1;


            if ((AD1 > 2.46) && (AD1 < 3.26))  // Nur in einem kleinen Bereich oben aktiv, 12 Uhr = 2.86V
            {
                if (cBPendPosRegler.Checked)
                {  // hier Pendelpositionsregelung
                    xdPendPos = PendSoll - WagPosSoll;
                    PendVSoll = PendVSoll + 0.09588 * xdPendPos - 0.09576 * xdPendPosold; //PI Block 1
                    xdPendPosold = xdPendPos;
                }
                else { PendVSoll = TrackBarWert; xdPendPosold = 0; }

                if (cBPendelgeschwindigkeit.Checked)
                {    // hier Pendelgeschwindigkeit regeln
                    xdPendV = PendVSoll - PendVIst;
                    deltAlpha = 2.0596 * xdPendV - 1.584 * xdPendVold;  // PD Block 2
                    if (deltAlpha > Pendymax) deltAlpha = Pendymax;  // Block 34
                    if (deltAlpha < Pendymin) deltAlpha = Pendymin;
                    xdPendVold = xdPendV;
                }
                else { deltAlpha = TrackBarWert; xdPendVold = 0; }
                if (cBKranUnterPendelOn.Checked)
                {    // hier Wagen unter Pendel stellen, Grün gestrichelt
                    WagPosSoll = PendPos - deltAlpha;
                    if (WagPosSoll > Pendymax) WagPosSoll = Pendymax;  // Block 4
                    if (WagPosSoll < Pendymin) WagPosSoll = Pendymin;
                }
            }
            else WagPosSoll = TrackBarWert;
            if (cBKranPosReglerOn.Checked)
            {   // hier Kranwagenposition regeln mit Block 5
                Yout = 22 * (WagPosSoll - WagPosIst); // P-Regler  
            }

            outputx(Yout);

            // Zeitmessung
            dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - t0start);  // dt Laufzeit der function
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            tSSLabel1.Text = "T0=  " + (t0 / Stopwatch.Frequency * 1000.0).ToString("f3") + "  ms   Dauer=  " +
                (dt / Stopwatch.Frequency * 1000.0).ToString("f3");
            labelAD0.Text = "AD0= " + AD0.ToString("f3");
            labelAD1.Text = "AD1= " + AD1.ToString("f3");
            labelDA0.Text = "DA0= " + Yout.ToString("f3");
            labeltestWert.Text = "Test= " + test.ToString("f3");
        }


        private void buttonReset_Click(object sender, EventArgs e)
        {
            outputx(-4); // Fahre Kran ganz nach rechts in die Lichtschranke 
        }

        //input of angel ,channel 1
        double inputAD1()
        {
            double val = 0;
            meinMain.ADCinput(1, ref val);
            return val;
        }

        //output of position, channel 0
        void outputx(double y)
        {
            if (y >= Pendymax) y = Pendymax;
            if (y <= Pendymin) y = Pendymin;

            meinMain.DACoutput(0, y);
        }
        // input of position ,channel 0
        double inputAD0()
        {
            double val = 0;
            meinMain.ADCinput(0, ref val);
            return val;

        }

        private void FormDRTKranregler_FormClosing(object sender, FormClosingEventArgs e)
        {
            MMTimer1.Disable();
            e.Cancel = true;
            this.Visible = false;

        }

        double Div10 = 1;
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            TrackBarWert = trackBar1.Value / 10.0 / Div10;
            labelTrVal.Text = "Wert= " + TrackBarWert.ToString("f2");
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            MMTimer1.Enable();
            timer1.Enabled = true;
        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            MMTimer1.Disable();
            timer1.Enabled = false;
        }

        private void buttonSetZero_Click(object sender, EventArgs e)
        {
            trackBar1.Value = 0;
            TrackBarWert = 0;
            labelTrVal.Text = "Wert= " + TrackBarWert.ToString("f2");
        }

        bool butcheck = true;
        private void radioButtonDiv10_Click(object sender, EventArgs e)
        {
            if (butcheck)
            {
                Div10 = 10;
                radioButtonDiv10.Checked = true;
                butcheck = false;
            }
            else
            {
                Div10 = 1;
                radioButtonDiv10.Checked = false;
                butcheck = true;
            }

        }



    }
}
