﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;

using MPS;
 

namespace es_Pendel_10
{
    public partial class Form1 : Form
    {
        //private NationalInstruments.DAQmx.Task analogOutTask;
        //private NationalInstruments.DAQmx.AnalogSingleChannelWriter writesinglechannel;
        double ao0Value = 0.0, maxaoValue;

        //private NationalInstruments.DAQmx.Task Task_Wagen;      //w. Auswahl : System.Threading.Tasks;
        //private NationalInstruments.DAQmx.Task Task_Pendel;
        //private CounterSingleChannelReader countsinglechannel_Wagen;
        //private CounterSingleChannelReader countsinglechannel_Pendel;
        //private CICountEdgesActiveEdge AktiveFlanke;
        //private CICountEdgesCountDirection ZaehlRichtung;

        private double WagenPosition, WagenPosition_Old, Wa_DT1_Out, Wa_DT1_Out_Old;
        private double Wa_DT1_p1, Wa_DT1_q0, Kp_x_Wert, Kd_x_Wert,Wa_Kp_x_Out,Wa_Kd_x_Out, Wa_PDT1_Out;
        private double PendelPosition , alpha_Nenner;
        private double inv_alpha, inv_alpha_old, Pe_DT1_Out, Pe_DT1_Out_Old;
        private double Pe_DT1_p1, Pe_DT1_q0, Kp_alpha_Wert, Kd_alpha_Wert,Kp_alpha_Out,Kd_alpha_Out,Pe_PDT1_Out;
        private double Motor_Voltage;

        long dtstart, dtstop;
        double dtsec;

        double[] dbBufferX;
        double[,] dbBufferY;
        int iSample;

        private TMultimediaTimer MMTimerWork;
        private Stopwatch stopwatch_1 = new Stopwatch();
        private double T0;   
        
        
        public Form1()
        {
            InitializeComponent();
            T0 = 0.001;     // Abtastzeit = 1ms
            nUD_xc_dot_ValueChanged(null,null);
            nUD_Kp_x_ValueChanged(null, null);
            nUD_Kd_x_ValueChanged(null, null);
            nUD_Pen_Velo_ValueChanged(null, null);
            nUD_Kp_alpha_ValueChanged(null, null);
            nUD_Kd_alpha_ValueChanged(null, null);

            dbBufferX = new double[5000];
            dbBufferY = new double[4, 5000];

             maxaoValue = 6; // maximale Ausgangsspannung = 6 Volt
            

            MMTimerWork = new TMultimediaTimer(null);
            MMTimerWork.Interval = (uint)(T0 * 1000);
            MMTimerWork.OnTimer = EventMMTimerWork;
            stopwatch_1.Start();
            alpha_Nenner = Math.PI * 2;
            chart1.ChartAreas[0].AxisX.Minimum = 0;
            chart1.ChartAreas[0].AxisX.Maximum = 5000;
            chart1.ChartAreas[0].AxisY.Minimum = -7;
            chart1.ChartAreas[0].AxisY.Maximum = 7;
        }

        void EventMMTimerWork(TMultimediaTimer sender)
        {
            dtstart = stopwatch_1.ElapsedTicks;

            //**** Wagen fährt nach rechts: positive Strecke
            //if (Task_Wagen != null) WagenPosition = (double)(Int16)countsinglechannel_Wagen.ReadSingleSampleInt32();
            //***   Inkremente * 4 (QuadEncoder) , Umfang = 0,0392m (Durchmesser) * pi   ------ FHL-Aufbau
            //***   Inkremente * 4 (QuadEncoder) , Umfang = 0,02963m (Durchmesser) * pi  ------ Quanser-Aufbau
            WagenPosition = WagenPosition / 4 / 1024.0 * 0.0392 * Math.PI;  // Position in Meter
            Wa_Kp_x_Out = Kp_x_Wert * WagenPosition;
            Wa_DT1_Out = Wa_DT1_p1 * Wa_DT1_Out_Old + Wa_DT1_q0 * (WagenPosition - WagenPosition_Old);
            Wa_DT1_Out_Old = Wa_DT1_Out;
            WagenPosition_Old = WagenPosition;
            Wa_Kd_x_Out = Wa_DT1_Out * Kd_x_Wert;
            Wa_PDT1_Out = Wa_Kp_x_Out + Wa_Kd_x_Out;

             
            //****  wenn das Pendel "ccw" dreht, ist ein positiver Werte notwendig. Also: -- negatives Vorzeichen --
            //if (Task_Pendel != null)
            //    if (rBCartSilver.Checked)
            //        PendelPosition = -(double)(Int16)countsinglechannel_Pendel.ReadSingleSampleInt32();
            //    else
            //        PendelPosition = (double)(Int16)countsinglechannel_Pendel.ReadSingleSampleInt32();

            PendelPosition = PendelPosition / 4 / 1024 * 2 * Math.PI;
            inv_alpha = ((PendelPosition % alpha_Nenner + alpha_Nenner) % alpha_Nenner) - Math.PI;
            Kp_alpha_Out = Kp_alpha_Wert * inv_alpha;
            Pe_DT1_Out = Pe_DT1_p1 * Pe_DT1_Out_Old + Pe_DT1_q0 * (inv_alpha - inv_alpha_old);
            Pe_DT1_Out_Old = Pe_DT1_Out;
            inv_alpha_old = inv_alpha;
            Kd_alpha_Out = Pe_DT1_Out * Kd_alpha_Wert;
            Pe_PDT1_Out = Kp_alpha_Out + Kd_alpha_Out;

            Motor_Voltage = Wa_PDT1_Out + Pe_PDT1_Out;
     
            if (Math.Abs(inv_alpha) <= 0.087266) ao0Value = Motor_Voltage;
            else ao0Value = 0;

            if (ao0Value >=  maxaoValue) ao0Value =  maxaoValue;
            if (ao0Value <= -maxaoValue) ao0Value = -maxaoValue;
            //writesinglechannel.WriteSingleSample(true, ao0Value);

            dbBufferX[iSample] = iSample;
            dbBufferY[0, iSample] = -5;
            dbBufferY[1, iSample] = inv_alpha * 360 / Math.PI / 2;
            dbBufferY[2, iSample] = +5;
            dbBufferY[3, iSample] = ao0Value;
            iSample++;
            if (iSample >= 4990) iSample = 0;
             
            dtstop = stopwatch_1.ElapsedTicks;
            dtsec = (dtstop - dtstart) / (double)Stopwatch.Frequency * 1000;

        }

        private void startMessung()
        {
            try
            {
            //    AktiveFlanke = CICountEdgesActiveEdge.Rising;
            //    ZaehlRichtung = CICountEdgesCountDirection.ExternallyControlled;
                
            //    //Wagen
            //    Task_Wagen = new NationalInstruments.DAQmx.Task();
            //    Task_Wagen.CIChannels.CreateCountEdgesChannel("Dev1/ctr0", "", AktiveFlanke, 0, ZaehlRichtung);
            //    Task_Wagen.Start();
            //    countsinglechannel_Wagen = new CounterSingleChannelReader(Task_Wagen.Stream);

            //    //Pendel
            //    Task_Pendel = new NationalInstruments.DAQmx.Task();
            //    Task_Pendel.CIChannels.CreateCountEdgesChannel("Dev1/ctr1", "", AktiveFlanke, 0, ZaehlRichtung);
            //    Task_Pendel.Start();
            //    countsinglechannel_Pendel = new CounterSingleChannelReader(Task_Pendel.Stream);

            }
            catch (Exception exception)
            {
                MessageBox.Show(exception.Message);
            }
        }

        private void btStRe_Click(object sender, EventArgs e)
        {
            //analogOutTask = new NationalInstruments.DAQmx.Task();
            //writesinglechannel = new AnalogSingleChannelWriter(analogOutTask.Stream);
            //analogOutTask.AOChannels.CreateVoltageChannel(
            //    "Dev1/ao0",
            //    "",
            //    -10.0,
            //    10.0,
            //    AOVoltageUnits.Volts
            //    );

            //MMTimerWork.Disable();
            //if (Task_Wagen != null) Task_Wagen.Stop();
            //if (Task_Pendel != null) Task_Pendel.Stop();
            //startMessung();
            //MMTimerWork.Enable();
            //timer1.Enabled = true;

            //writesinglechannel.WriteSingleSample(true, 0.0);

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            label1.Text = "Wagen Position  :  " + WagenPosition.ToString("f3") + "  m";
            label6.Text = "Ausgangsspannung:  " + ao0Value.ToString("f3") + "  V";
            label9.Text = "Pendel Position   :  " + (inv_alpha * 360 / Math.PI / 2).ToString("f3") + "  deg";

            label11.Text = "p1:  " + Wa_DT1_p1.ToString();  
            label12.Text = "q0:  " + Wa_DT1_q0.ToString();
            label10.Text = "p1:  " + Pe_DT1_p1.ToString();
            label13.Text = "q0:  " + Pe_DT1_q0.ToString();
            
            chart1.Series[0].Points.Clear();
            chart1.Series[1].Points.Clear();
            chart1.Series[2].Points.Clear();
            chart1.Series[3].Points.Clear();
            for (int i = 0; i < iSample; i++)
            {
                chart1.Series[0].Points.AddXY(dbBufferX[i], dbBufferY[0, i]);
                chart1.Series[1].Points.AddXY(dbBufferX[i], dbBufferY[1, i]);
                chart1.Series[2].Points.AddXY(dbBufferX[i], dbBufferY[2, i]);
                chart1.Series[3].Points.AddXY(dbBufferX[i], dbBufferY[3, i]);
            }

            toolStripStatusLabel1.Text = " Datum/Uhrzeit:  " + DateTime.Now.ToString() +"   |  ";
            toolStripStatusLabel2.Text =  "Laufzeit:  " +dtsec.ToString("F3") + "  msec";

        }

        
        private void nUD_xc_dot_ValueChanged(object sender, EventArgs e)
        {
            Wa_DT1_p1 = Math.Exp(-T0/(double)nUD_xc_dot.Value);
            Wa_DT1_q0 = Wa_DT1_p1/(double)nUD_xc_dot.Value;
        }

        private void nUD_Kp_x_ValueChanged(object sender, EventArgs e)
        {
            Kp_x_Wert = (double)nUD_Kp_x.Value;
        }

        private void nUD_Kd_x_ValueChanged(object sender, EventArgs e)
        {
            Kd_x_Wert = (double)nUD_Kd_x.Value;
        }

        
        
        private void nUD_Pen_Velo_ValueChanged(object sender, EventArgs e)
        {
            Pe_DT1_p1 = Math.Exp(-T0/(double )nUD_Pen_Velo.Value);
            Pe_DT1_q0 = Pe_DT1_p1/(double)nUD_Pen_Velo.Value;
        }

        private void nUD_Kp_alpha_ValueChanged(object sender, EventArgs e)
        {
            Kp_alpha_Wert = (double)nUD_Kp_alpha.Value;
        }
        

        private void nUD_Kd_alpha_ValueChanged(object sender, EventArgs e)
        {
            Kd_alpha_Wert = (double)nUD_Kd_alpha.Value;
        }

        private void btStopp_Click(object sender, EventArgs e)
        { 
            //writesinglechannel.WriteSingleSample(true, 0.0);
            //MMTimerWork.Disable();
            //if (Task_Wagen != null) Task_Wagen.Stop();
            //if (Task_Pendel != null) Task_Pendel.Stop();
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

      

    }
}
