﻿// since 7.4.38 without error in pictureBox1_SizeChange

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;

namespace RealTimerDevice
{
    public partial class FormRTdevice : Form
    {
        Graphics gPB;
        Pen p,wp;
        Point poi1,wp1; //poi1 stands for a point from the output of motor,wp1 stands for W value
        Point poi2, wp2; //poi2 stands for a point from the output of motor,wp1 stands for W value
        SolidBrush pbrush;
        FormMain meinMain;
        bool xindex = false; int wy;
        bool drawOK=true;
        int y,stepy=10,startP=100; //stepx,stepy stands for a graphic distance according to the current scalling
        public int x = 0;
        //startP stands for a start point according to the current scalling
        int height, width; // size picturebox
        int range = 20;// range scale in V
        double tdisplay=2; // tdisplay horizontal total time in sec 
        double pos0V=0.5;  // Position of 0V- Line. 0:top, 1: Bottom, 0.5 middle
        public double xreal=0;
        double stepx=3;

        public FormRTdevice(FormMain m)
        {
            meinMain = m;
            InitializeComponent();
            pbrush = new SolidBrush(Color.White);
            p = new Pen(Color.Blue, 1);
            wp = new Pen(Color.Green, 1);
            height = 200; width = 600;
            xreal=0;
            gPB = Graphics.FromHwnd(pictureBox1.Handle);
        }

        private void FormRTdevice_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Visible = false;
           
        }

        private void FormRTdevice_Load(object sender, EventArgs e)
        {
            pictureBox1.BackColor = Color.White;

         }

        public void DrawRT(double w, double val, bool drawW,double T0)
        {
            if (drawOK)
            {
                if (val > 20) val = 20;  // Not more than 20 V are possible in realtime curve
                if (val < -20) val = -20;
                stepx = width *T0 / tdisplay;
                wy = (int)(startP - w * stepy);
                if (xindex == false || x < 0)//check whether it is the first loop timer
                {
                    x = 0; xreal = 0;
                    y = (int)(startP - (val) * stepy);
                    poi1 = new Point(x, y);
                    //label3.Text = x.ToString();
                    //label4.Text = y.ToString();
                    xindex = true;
                    wp1 = new Point(x, wy);
                }
                else
                {
                    xreal = xreal + stepx;
                    x = (int)xreal;
                    wp2 = new Point(x, wy);
                    y = (int)(startP - (val) * stepy);
                    if (xreal >= width)
                    {
                        xreal = 0; x = 0;
                        poi2 = new Point(x, y);
                        wp2 = new Point(x, wy);
                    }
                    else
                    {
                        poi2 = new Point(x, y); wp2 = new Point(x, wy);
                        gPB.DrawLine(p, poi1, poi2);
                        if (drawW)
                        {
                            gPB.DrawLine(wp, wp1, wp2);

                        }
                    }

                    wp1 = wp2;

                    poi1 = poi2;
                    //label3.Text = x.ToString();
                    //label4.Text = y.ToString();
                    if (!cBWithoutClear.Checked) gPB.FillRectangle(pbrush, x + 1, 0, 30, pictureBox1.Height);//draw a white rectangle to clear the graphic
                }
            }
        }


          private void comboBoxUrange_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBoxUrange.SelectedItem.ToString()=="-10V bis +10V")
            {
                range = 20; pos0V = 0.5;
             }
            if (comboBoxUrange.SelectedItem.ToString() == "  -5V bis +5V")
            {
                range = 10; pos0V = 0.5;
            }
            if (comboBoxUrange.SelectedItem.ToString() == "  -2V bis +2V")
            {
                range = 4; pos0V = 0.5;
            }
            if (comboBoxUrange.SelectedItem.ToString()=="  -1V bis +1V")
            {
                range = 2; pos0V = 0.5;
            }
            if (comboBoxUrange.SelectedItem.ToString()=="   0V bis +10V")
            {
                range = 10; pos0V = 1;
            }
            if (comboBoxUrange.SelectedItem.ToString()=="   0V bis +5V")
            {
                range = 5; pos0V = 1;
            }
            if (comboBoxUrange.SelectedItem.ToString()=="   0V bis +2V")
            {
                range = 2; pos0V = 1;
            }
            if (comboBoxUrange.SelectedItem.ToString()=="   0V bis +1V")
            {
                range = 1; pos0V = 1;
            }
            if (comboBoxUrange.SelectedItem.ToString()=="   3V bis 6V")
            {
                range = 3; pos0V = 2;
            }
            stepy = height / range;
            startP = (int)Math.Round(height*pos0V);
        }

        private void comboBoxTrange_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBoxTrange.SelectedItem.ToString()=="5 sec")
            {
                tdisplay = 5;
            }
            if (comboBoxTrange.SelectedItem.ToString() == "2 sec")
            {
                tdisplay = 2;
            }
            if (comboBoxTrange.SelectedItem.ToString()=="1 sec")
            {
                tdisplay = 1;
            }
            if (comboBoxTrange.SelectedItem.ToString()=="10 sec")
            {
                tdisplay = 10;
            }
            if (comboBoxTrange.SelectedItem.ToString()=="20 sec")
            {
                tdisplay = 20;
            }
            if (comboBoxTrange.SelectedItem.ToString() == "0.1 sec")
            {
                tdisplay = 0.1;
            }
            if (comboBoxTrange.SelectedItem.ToString() == "0.5 sec")
            {
                tdisplay = 0.5;
            }
        }

        private void pictureBox1_SizeChanged(object sender, EventArgs e)
        {
            drawOK = false;
            if (gPB!=null) gPB.Dispose();  // on some PCs this caused an error
            gPB = Graphics.FromHwnd(pictureBox1.Handle);


            height = pictureBox1.Height;
            width = pictureBox1.Width;
            stepy = height / range;
            startP = (int)Math.Round(height * pos0V);
            //label3.Text = "stepx= " + stepx.ToString("f5");
            drawOK = true;
        }

        private void cBStayOnTop_CheckedChanged(object sender, EventArgs e)
        {
            this.TopMost = cBStayOnTop.Checked;
        }

        public void Clear()
        {
            x = 0; xreal = 0;
            poi1 = new Point(0, 0);
            wp1 = new Point(0, 0);
            SolidBrush br = new SolidBrush(Color.White);
            gPB.FillRectangle(br,0, 0, pictureBox1.Width,pictureBox1.Height);
        }
        
    }
}
