using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using WINDF7CSharp;

namespace DFUFK
{
    public partial class DFUFK1 : Form
    {
        string errorindata = "Data wrong",
            intervallsize = "Intervall-size too often devided by 4 without decreasing the function",
            rootnotfound = "Root not found",
            coeff = "Coeff",
            stable = "stable",
            numdi = "num di",
            denom = "denom ci",
            realpart = "realpart",
            imagpart = "imagpart",
            unstable = "unstable",
            copyfromufk = "Copy from UFK- Module";



        FormMain meinMain;

        List<string> outList =new List<string>(); // for copy into analog filter form /.zk - file

        double max1 = 1.5e38, delta = 1e-5;
        double[] ikoefz = new double[80];
        double[] ikoefn = new double[80];
        double[] rkoefz = new double[80];
        double[] rkoefn = new double[80];
        double tolf = 1.0E-10, tola = 1.0E-10, tzaf;
        int maxnm = 2, itmax = 50;
        string stab;
        double[] rrootz = new double[80];
        double[] irootz = new double[80];
        double[] rrootn = new double[80];
        double[] irootn = new double[80];
        int aktnr, aktnc, aktpr, aktpc, aktmaxi;
        double kaf;
        double[,] wertzk = new double[80, 2];
        int nufk, mufk;
        resultform resultform = new resultform();

        public DFUFK1(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            StringGrid1.addColumn(System.Type.GetType("System.String"), "*.ufk", false);
            StringGrid1.addColumn(System.Type.GetType("System.String"), numdi, false);
            StringGrid1.addColumn(System.Type.GetType("System.String"), denom, false);
            this.BitBtn3Click();

            StringGrid1.activate();

            StringGrid1.Cell(0, 1, "1");
            StringGrid1.Cell(0, 2, "1");
            StringGrid1.Cell(1, 1, "1");
            StringGrid1.Cell(1, 2, "1");


            writewedit();
            InitResultform();
        }

        public void deutsch()
        {
            errorindata = "Daten falsch";
            intervallsize = "Intervallgre zu oft durch vier geteilt nohne Verkleinern der Funktion";
            rootnotfound = "Nullstelle nicht gefunden";
            coeff = "Koeff.";
            stable = "stabil";
            unstable = "instabil";
            label2.Text = "Form der bertragungsfunktion";
            Text="Suche Pole und Nullstellen";
            factor.Text = "Suche Nullstellen und Pole";
            label_degree_m.Text = "Zhlergrad";
            label_degree_n.Text = "Nennergrad";
            label_delay_T0.Text = "Totzeit in s";
            label_max_nb.Text = "Maximalzahl Iterationen";
            label_tolerance.Text = "Toleranz fr Nullstellen";
            label_tolerace_poly.Text = "Toleranz fr F()";
            resultform.button2.Text = "Schlieen";
            resultform.label1.Text = "Zhlernullstellen";
            resultform.label2.Text = "Nennernullstellen";
            resultform.Text = "Pol - und Nullstellensuche";
            TBopen.ToolTipText = "Lade *.ufk- Datei";
            TBsaveufk.ToolTipText = "Speichere daten als *.ufk- Datei";
            TBsavezk.ToolTipText = "Speichere Zeitkonstanten als *.zk- Datei";
            TBOK.ToolTipText = "Schliee Fenster und Kopiere Daten in relavante Anwendungen";
            TBCancel.ToolTipText="Schliee Fenster und verwerfe Ergebnisse";
            numdi = "Zhl di";
            denom = "Nenn ci";
            realpart="Realtel";
            imagpart = "Imagteil";
            copyfromufk = "Kopie vom UFK- Modul";
        }

        
        void writewedit()
        {
            this.tolfunc.Text = Convert.ToString(String.Format("{0:e}", tolf));
            this.tolzero.Text = Convert.ToString(String.Format("{0:e}", tola));
            this.nbiterat.Text = Convert.ToString(itmax);
        }
        //calculates Siljak-coefficients, called from siljak
        void silkoef(int n, double[] xsil, double[] ysil, double[] rkoef, double[] ikoef, out double f, out double u, out double v)
        {
            int k;
            double z, t;

            z = xsil[1] * xsil[1] + ysil[1] * ysil[1];
            t = 2 * xsil[1];

            for (k = 0; k <= n - 2; k++)
            {
                xsil[k + 2] = t * xsil[k + 1] - z * xsil[k];
                ysil[k + 2] = t * ysil[k + 1] - z * ysil[k];
            } //Ende  {for k= ...}
            u = 0.0;
            v = 0.0;
            for (k = 0; k <= n; k++)
            {
                u = u + rkoef[k] * xsil[k] - ikoef[k] * ysil[k];
                v = v + rkoef[k] * ysil[k] + ikoef[k] * xsil[k];
            }  // Ende  {for k= ....}
            f = u * u + v * v;
        }

        int siljak(int n, int itmax, double[] rkoef, double[] ikoef, double[] rroot, double[] iroot, double tola, double tolf, bool error)
        {
            /* calculates all zeroes of polynomial with degree n, coefficients in
      rkoef (real parts) and ikoef (imaginary parts). Results in rroot
      (real parts) and iroot (imaginary parts). itmax is max number of
      iterations, break occures if tolerances tola or tolf are reached. */

            const int dzmax = 40;
            int i, k, itzahl, deltazahl;
            double t, x, y, f, old_f, z, u, v;
            double a, b, c, d, p, q;         //  temporary memory
            double deltax, deltay;
            double[] xsil = new double[80];
            double[] ysil = new double[80];
            bool ok1, ok2, Schleife2 = true, Schleife3 = true;
            double[] rkoef1 = new double[80];
            double[] ikoef1 = new double[80];
            error = false;


            for (i = 0; i < 80; i++)
            {
                rkoef1[i] = rkoef[i];
                ikoef1[i] = ikoef[i];
            }

            //   bad data check
            if ((tola <= 0) || (tolf <= 0) || (itmax <= 0))
            {
                MessageBox.Show(errorindata);
                error = true;
                this.Visible = true;
                return -1;
            } //  bad data check


            // Initialising: start values for roots with max 1.7e38
            for (i = 1; i <= n; i++)
            {
                rroot[i] = max1;
                iroot[i] = max1;
            }


            // Start of search, first with n=1 trivial result


            while (n > 1)     // preparation
            {
                y = 1;
                ysil[1] = 1;
                xsil[0] = 1;
                x = 0.1;
                xsil[1] = 0.1;
                ysil[0] = 0;
                itzahl = 0;
                silkoef(n, xsil, ysil, rkoef1, ikoef1, out f, out u, out v);

                //repeat {....until toleranz ok }       (itzahl>itmax) or (ok1 and ok2);
                while (Schleife2)
                {
                    old_f = f;
                    deltazahl = 0;
                    q = 0.0;
                    p = 0.0;
                    itzahl++;

                    // calculate deltax and deltay
                    for (i = 1; i <= n; i++)
                    {
                        p = p + i * (rkoef1[i] * xsil[i - 1] - ikoef1[i] * ysil[i - 1]);
                        q = q + i * (rkoef1[i] * ysil[i - 1] + ikoef1[i] * xsil[i - 1]);
                    } // ende   for i...
                    z = p * p + q * q;
                    deltax = -(u * p + v * q) / z;    // {u and v from silkoef()}
                    deltay = (u * q - v * p) / z;

                    while (Schleife3)  //  { 2. repeat-loop until f<fmin or deltazahl>dzmax}
                    {
                        deltazahl++;

                        // new approx for root
                        xsil[1] = x + deltax;
                        ysil[1] = y + deltay;
                        silkoef(n, xsil, ysil, rkoef1, ikoef1, out f, out u, out v);  //new Siljak-coeff
                        deltax = deltax / 4;
                        deltay = deltay / 4;
                        if ((f < old_f) || (deltazahl > dzmax))
                            Schleife3 = false;
                    } // Ende Schleife 3
                    Schleife3 = true;
                    ok2 = ((Math.Abs(u) <= tolf) && (Math.Abs(v) <= tolf));
                    //  {ok, if both re,im ok}

                    if ((deltazahl > dzmax) && (!ok2))
                    {  // error message and break
                        MessageBox.Show(intervallsize);
                        error = true;
                        this.Visible = true;
                        return -1;
                    } //ende if delta...
                    x = xsil[1];
                    y = ysil[1];
                    ok1 = (Math.Abs(4 * deltax) < tola) && (Math.Abs(4 * deltay) < tola);
                    //{ok, if both delta ok}
                    if ((itzahl > itmax) || (ok1 && ok2))
                        Schleife2 = false;
                }// Ende Schleife 2
                Schleife2 = true;

                if (itzahl > itmax)
                {  //  {error message and break}
                    MessageBox.Show(rootnotfound);
                    error = true;
                    this.Visible = true;
                    return -1;
                } // ende if ...

                //{ here root is found !! }

                rroot[n] = xsil[1];
                iroot[n] = ysil[1];

                //{ calculate new reduced coefficients by division }

                a = rkoef1[n];
                b = ikoef1[n];
                rkoef1[n] = 0.0;
                ikoef1[n] = 0.0;
                x = xsil[1];
                y = ysil[1];

                for (i = 0; i <= n - 1; i++)
                {
                    k = n - 1 - i;  //{loop parameter from k=n-1 to 0}
                    c = rkoef1[k];
                    d = ikoef1[k];
                    u = rkoef1[k + 1];
                    v = ikoef1[k + 1];
                    rkoef1[k] = a + x * u - y * v;
                    ikoef1[k] = b + x * v + y * u;
                    a = c;
                    b = d;
                } //ende for..

                n = n - 1;  // Reduce nb. of unknown coeff. and look for next root

            }  //   end;  {while n<>1 ....}

            // triviale algebraic result for n=1
            a = rkoef1[0];
            u = rkoef1[1];
            b = ikoef1[0];
            v = ikoef1[1];
            t = (u * u) + (v * v);
            rroot[1] = -(a * u + b * v) / t;
            iroot[1] = (a * v - u * b) / t;

            return 0;
        }
        public void Grid2array()
        {
            // Nach einer Eingabe/Aenderung in StringGrid1 Werte mit Array abgleichen
            int i, maxnm;
            if (nufk <= mufk)
                maxnm = mufk;
            else
                maxnm = nufk;
            for (i = 0; i < 80; i++)     // loeschen des Koeffizientenarry
            {
                rkoefn[i] = 0.0;
                rkoefz[i] = 0.0;
            }

            for (i = 0; i <= maxnm; i++)
            {
                if (i <= nufk)
                    meinMain.ConvertToDouble(StringGrid1.Cell(i, 2).ToString(),ref rkoefn[i] );
                if (i <= mufk)
                    meinMain.ConvertToDouble(StringGrid1.Cell(i, 1).ToString(),ref rkoefz[i] );
            }
        }

        void BitBtn3Click()
        {
            int i;

            mufk = Convert.ToInt32(degreem.Value);
            nufk = Convert.ToInt32(degreen.Value);
            if (nufk <= mufk)
                maxnm = mufk;
            else
                maxnm = nufk;
            while (StringGrid1.RowCount > maxnm + 1)
            {
                StringGrid1.Select(StringGrid1.RowCount - 1);
                StringGrid1.RemoveSelectedRow();
            }
            while (StringGrid1.RowCount <= maxnm)
                StringGrid1.AddRow(StringGrid1.NewRow());

            for (i = 0; i <= maxnm; i++)
            {
                StringGrid1.Cell(i, 0, coeff + i);
            }
            try
            {
                StringGrid1.Cell(i - 1, 1, "0");
                StringGrid1.Cell(i - 1, 2, "0");
            }
            catch (Exception)
            {
            }
        }

        public void Factor()
        {
            double maxz;
            int i, j, maxj, partner;
            double hilf, rei, imi, nere, neim;
            bool errn = false, errz = false;
            double betrag;
            double[] hilftz = new double[80], hilftn = new double[80];         // temp memory
            double[,] hilfdwz = new double[80, 2], hilfdwn = new double[80, 2];


            Grid2array();  // Copy String to Array rkoef

            // calculate effective degrees
            while ((rkoefz[mufk] == 0.0) && (mufk > 0))
                mufk = mufk - 1;
            degreem.Value = mufk;
            while ((rkoefn[nufk] == 0.0) && (nufk > 0))
                nufk = nufk - 1;
            degreen.Value = nufk;
            if (nufk <= mufk)
                maxnm = mufk;
            else
                maxnm = nufk;
            //BitBtn3Click();   // Neuaufbau von StringGrid1

            this.Visible = false;

            if (mufk > 0)
            {
                if (siljak(mufk, itmax, rkoefz, ikoefz, rrootz, irootz, tola, tolf, errz) == -1)
                    return;
            }
            if (nufk > 0)
            {
                if (siljak(nufk, itmax, rkoefn, ikoefn, rrootn, irootn, tola, tolf, errn) == -1)
                    return;
            }
            stab = "";



            // Sorting with primitive method of real parts, first largest real part
            if ((mufk > 1) && (!errz))
                for (i = 1; i <= mufk - 1; i++)
                {
                    maxz = rrootz[i];
                    maxj = i;
                    for (j = i + 1; j <= mufk; j++)
                        if (rrootz[j] > maxz)
                        {
                            maxz = rrootz[j];
                            maxj = j;
                        } //ende for j..
                    if (i != maxj)
                    {           // swap
                        hilf = rrootz[i];
                        rrootz[i] = maxz;
                        rrootz[maxj] = hilf;
                        hilf = irootz[i];
                        irootz[i] = irootz[maxj];
                        irootz[maxj] = hilf;
                    } // end if i!=maxj
                } //  end for i...
            if ((nufk > 1) && (!errn))
                for (i = 1; i <= nufk - 1; i++)
                {
                    maxz = rrootn[i];
                    maxj = i;
                    for (j = i + 1; j <= nufk; j++)
                        if (rrootn[j] > maxz)
                        {
                            maxz = rrootn[j];
                            maxj = j;
                        } // ende if ...
                    if (i != maxj)
                    {  //  { swap }
                        hilf = rrootn[i];
                        rrootn[i] = maxz;
                        rrootn[maxj] = hilf;
                        hilf = irootn[i];
                        irootn[i] = irootn[maxj];
                        irootn[maxj] = hilf;
                    } // ende if...
                }  // end for...

            /* now second sorting, so that with equal real parts the conjugate
              complexe pairs are combined */

            if ((mufk > 2) && (!errz))
                for (i = 1; i <= mufk - 1; i++)
                {
                    rei = rrootz[i];
                    imi = irootz[i];
                    partner = i + 1;
                    if (Math.Abs(rei) < delta)
                        nere = tola / delta;
                    else
                        nere = Math.Abs(rei);
                    if (Math.Abs(imi) < delta)
                        neim = tola / delta;
                    else
                        neim = Math.Abs(imi);
                    for (j = i + 1; j <= mufk; j++)
                        if (Math.Abs(rrootz[j] - rei) / nere < delta)
                        {     // if  real parts equal, look for pairs
                            if (Math.Abs(irootz[j] + imi) / neim < delta)
                                partner = j;
                        } // ende if abs..
                    if ((i + 1) != partner)
                    {   //  { swap }
                        hilf = rrootz[i + 1];
                        rrootz[i + 1] = rrootz[partner];
                        rrootz[partner] = hilf;
                        hilf = irootz[i + 1];
                        irootz[i + 1] = irootz[partner];
                        irootz[partner] = hilf;
                    }  // ende if i+1...
                } //  ende for i..

            //  same for denominator
            if ((nufk > 2) && (!errn))
                for (i = 1; i <= nufk - 1; i++)
                {
                    rei = rrootn[i];
                    imi = irootn[i];
                    partner = i + 1;
                    if (Math.Abs(rei) < delta)
                        nere = tola / delta;
                    else
                        nere = Math.Abs(rei);
                    if (Math.Abs(imi) < delta)
                        neim = tola / delta;
                    else
                        neim = Math.Abs(imi);
                    for (j = i + 1; j <= nufk; j++)
                        if (Math.Abs(rrootn[j] - rei) / nere < delta)
                        {    // if  real parts equal, look for pairs}
                            if (Math.Abs(irootn[j] + imi) / neim < delta)
                                partner = j;
                        }   // endif abs..
                    if ((i + 1) != partner)
                    {  //    { swap }
                        hilf = rrootn[i + 1];
                        rrootn[i + 1] = rrootn[partner];
                        rrootn[partner] = hilf;
                        hilf = irootn[i + 1];
                        irootn[i + 1] = irootn[partner];
                        irootn[partner] = hilf;
                    }  // ende if i+1....
                } //  ende for i...
            while (resultform.resultnum.RowCount > mufk)
            {
                resultform.resultnum.Select(resultform.resultnum.RowCount - 1);
                resultform.resultnum.RemoveSelectedRow();
            }
            while (resultform.resultnum.RowCount < mufk)
                resultform.resultnum.AddRow(resultform.resultnum.NewRow());
            for (i = 0; i < resultform.resultnum.RowCount; i++)
            {
                resultform.resultnum.Cell(i, 0, "Nullst " + i);
            }

            if (!errz)   //  result if no error
                for (i = 1; i <= mufk; i++)
                {
                    resultform.resultnum.Cell(i - 1, 1, String.Format("{0:e}", Convert.ToString(rrootz[i])));
                    resultform.resultnum.Cell(i - 1, 2, String.Format("{0:e}", Convert.ToString(irootz[i])));
                } // ende {for}
            else
                for (i = 1; i <= mufk; i++)
                {   // result if  error
                    resultform.resultnum.Cell(i - 1, 1, "--");
                    resultform.resultnum.Cell(i - 1, 2, "--");
                } //ende {for}

            while (resultform.resultdenom.RowCount > nufk)
            {
                resultform.resultdenom.Select(resultform.resultdenom.RowCount - 1);
                resultform.resultdenom.RemoveSelectedRow();
            }
            while (resultform.resultdenom.RowCount < nufk)
                resultform.resultdenom.AddRow(resultform.resultdenom.NewRow());


            for (i = 0; i < resultform.resultdenom.RowCount; i++)
            {
                resultform.resultdenom.Cell(i, 0, "Pol " + i);
            }
            if (!errn)
            {  // {result if no error }
                stab = stable;
                for (i = 1; i <= nufk; i++)
                {
                    resultform.resultdenom.Cell(i - 1, 1, rrootn[i].ToString("G8"));
                    resultform.resultdenom.Cell(i - 1, 2, irootn[i].ToString("G8"));
                    if ((rrootn[i] > 0) || (Math.Abs(rrootn[i]) < delta))
                        stab = unstable;
                } // ende {for}
            }
            else
            {
                for (i = 1; i <= nufk; i++)
                {  // result if  error
                    resultform.resultdenom.Cell(i - 1, 1, "--");
                    resultform.resultdenom.Cell(i - 1, 2, "--");
                } // ende {for}
            } // ende {else}

            /* Convert into time constants or into PT2- blocks with d,wo */
            kaf = rkoefz[mufk] / rkoefn[nufk];
            aktnr = 0;
            aktnc = 0;
            aktpr = 0;
            aktpc = 0;
            // first numerator
            i = 1;
            while (i <= mufk)
            {
                rei = rrootz[i];
                imi = irootz[i];
                betrag = Math.Sqrt((rei * rei) + (imi * imi));
                if (betrag < delta)
                {   //    p=0
                    aktnr = aktnr + 1;
                    hilftz[aktnr] = 1e10;
                    kaf = kaf / 1e10;
                    resultform.resultnum.Cell(i - 1, 3, "1e10");
                    resultform.resultnum.Cell(i - 1, 4, "");
                }
                else
                    if (Math.Abs(imi / betrag) < delta)
                    {  // real zero
                        aktnr = aktnr + 1;
                        hilftz[aktnr] = -1 / rei;
                        kaf = kaf * (-rei);
                        resultform.resultnum.Cell(i - 1, 3, (-1 / rei).ToString("G8"));
                        resultform.resultnum.Cell(i - 1, 4, "");
                    }
                    else
                    { // conjugate complex pair
                        aktnc = aktnc + 1;
                        hilfdwz[aktnc, 0] = -rei / betrag;
                        hilfdwz[aktnc, 1] = betrag;
                        kaf = kaf * (betrag * betrag);
                        resultform.resultnum.Cell(i - 1, 3, (-rei / betrag).ToString("G8"));
                        resultform.resultnum.Cell(i - 1, 4, betrag.ToString("G8"));
                        i = i + 1;
                    } // Ende else
                i = i + 1;
            }  // ende {while ...}

            // then denomonator
            i = 1;
            while (i <= nufk)
            {
                rei = rrootn[i];
                imi = irootn[i];
                betrag = Math.Sqrt((rei * rei) + (imi * imi));
                if (betrag < delta)
                {  //   p=0
                    aktpr = aktpr + 1;
                    hilftn[aktpr] = 1e10;
                    kaf = kaf * 1e10;
                    resultform.resultdenom.Cell(i - 1, 3, "1e10");
                    resultform.resultdenom.Cell(i - 1, 4, "");
                } //
                else
                    if (Math.Abs(imi / betrag) < delta)
                    {  //   real pole
                        aktpr = aktpr + 1;
                        hilftn[aktpr] = -1 / rei;
                        kaf = kaf * hilftn[aktpr];
                        resultform.resultdenom.Cell(i - 1, 3, (-1 / rei).ToString("G8"));
                        resultform.resultdenom.Cell(i - 1, 4, "");
                    }
                    else
                    { // conjugate complex pole pair
                        aktpc = aktpc + 1;
                        hilfdwn[aktpc, 0] = -rei / betrag;
                        hilfdwn[aktpc, 1] = betrag;
                        kaf = kaf / (betrag * betrag);
                        resultform.resultdenom.Cell(i - 1, 3, (-rei / betrag).ToString("G8"));
                        resultform.resultdenom.Cell(i - 1, 4, betrag.ToString("G8"));
                        i = i + 1;
                    } //ende else
                i = i + 1;
            } //ende {while ...}

            aktmaxi = aktnc + aktnr + aktpc + aktpr;

            //resultform.resultdenom.TopRow:=1;
            //resultform.resultnum.toprow:=1;
            resultform.Label3.Text = stab;
            resultform.Labelk.Text = Convert.ToString(kaf);



            // copy result to ZK-array wertzk[] via List- Array

            outList.Clear();
            outList.Add("!" + copyfromufk);
            outList.Add(aktnr.ToString() + " " + aktnc.ToString() + " " + aktpr.ToString() + " " + aktpc.ToString() + " " + kaf.ToString());

            i = 1;
            j = 1;    // numerator

            while (i <= aktnr)
            {
                wertzk[j, 0] = hilftz[i];
                wertzk[j, 1] = 0;
                outList.Add(hilftz[i].ToString() + " 0");
                //FAnalogfilter.StringGrid1.Cells[1][j]=hilftz[i];
                //FAnalogfilter.StringGrid1.Cells[2][j]=0;
                i = i + 1;
                j = j + 1;
            } // Ende while...
            i = 1;
            while (i <= aktnc)
            {
                wertzk[j, 0] = hilfdwz[i, 0];
                wertzk[j, 1] = hilfdwz[i, 1];
                outList.Add(hilfdwz[i, 0].ToString() + " " + hilfdwz[i, 1].ToString());
                //FAnalogfilter.StringGrid1.Cells[1][j]=hilfdwz[i][1];
                //FAnalogfilter.StringGrid1.Cells[2][j]=hilfdwz[i][2];
                i = i + 1;
                j = j + 1;
            } // Ende while;
            i = 1; // denominator
            while (i <= aktpr)
            {
                wertzk[j, 0] = hilftn[i];
                wertzk[j, 1] = 0;
                outList.Add(hilftn[i].ToString() + " 0");
                //FAnalogfilter.StringGrid1.Cells[1][j]=hilftn[i];
                //FAnalogfilter.StringGrid1.Cells[2][j]=0;
                i = i + 1;
                j = j + 1;
            } // Ende while..
            i = 1;
            while (i <= aktpc)
            {
                wertzk[j, 0] = hilfdwn[i, 0];
                wertzk[j, 1] = hilfdwn[i, 1];
                outList.Add(hilfdwn[i, 0].ToString() + " " + hilfdwn[i, 1].ToString());
                //FAnalogfilter.StringGrid1.Cells[1][j]=hilfdwn[i][1];
                //FAnalogfilter.StringGrid1.Cells[2][j]=hilfdwn[i][2];
                i = i + 1;
                j = j + 1;
            }

            outList.Add(ETz.Text);
            if (resultform.ShowDialog() == DialogResult.OK)
            {
                meinMain.fanalogfilter.copyList2AnalogFilterForm(outList);
            }
            TBsavezk.Enabled = true;

            //  End if modal result
            this.Visible = true;
        }

        private void degreem_ValueChanged(object sender, EventArgs e)
        {
            this.BitBtn3Click();
        }

        private void degreen_ValueChanged(object sender, EventArgs e)
        {
            this.BitBtn3Click();
        }

        private void factor_Click(object sender, EventArgs e)
        {
            Factor();
        }
        private void InitResultform()
        {
            resultform.resultnum.addColumn(System.Type.GetType("System.String"), " ", false);
            resultform.resultnum.addColumn(System.Type.GetType("System.String"), realpart, false);
            resultform.resultnum.addColumn(System.Type.GetType("System.String"), imagpart, false);
            resultform.resultnum.addColumn(System.Type.GetType("System.String"), "T or d", false);
            resultform.resultnum.addColumn(System.Type.GetType("System.String"), "wo", false);
            resultform.resultnum.activate();

            resultform.resultdenom.addColumn(System.Type.GetType("System.String"), " ", false);
            resultform.resultdenom.addColumn(System.Type.GetType("System.String"), realpart, false);
            resultform.resultdenom.addColumn(System.Type.GetType("System.String"), imagpart, false);
            resultform.resultdenom.addColumn(System.Type.GetType("System.String"), "T or d", false);
            resultform.resultdenom.addColumn(System.Type.GetType("System.String"), "wo", false);
            resultform.resultdenom.activate();
        }

        private void TBopen_Click(object sender, EventArgs e)
        {
            List<string> pList = new List<string>();
            StreamReader reader;
            int i, dm, dn, cntcomment = 0;
            int maxnm;
            OpenDialog1.FilterIndex = 1;
            //OpenDialog1->InitialDir="..\UFK";

            if (OpenDialog1.ShowDialog() == DialogResult.OK)
            {
                reader = new StreamReader(OpenDialog1.FileName);
                while (!reader.EndOfStream)
                {
                    pList.Add(reader.ReadLine());
                }
                while (pList[cntcomment].Substring(0, 1) == "!") cntcomment++;

                if (cntcomment != 0)
                {
                    ecomment.Text = pList[0].Substring(1);
                    ecomment.Visible = true;
                }
                degreem.Value = Convert.ToInt32(pList[cntcomment]);
                degreen.Value = Convert.ToInt32(pList[1 + cntcomment]);
                BitBtn3Click();
                dm = Convert.ToInt32(degreem.Value);
                dn = Convert.ToInt32(degreen.Value);
                if (dn <= dm) maxnm = dm;
                else maxnm = dn;

                double help=0;
                for (i = 0; i <= maxnm; i++)
                {
                    StringGrid1.Cell(i, 1, "0"); // clear old values
                    StringGrid1.Cell(i, 2, "0");
                }
                for (i = 0; i <= dm; i++)
                {
                    meinMain.ConvertToDouble(pList[i + 2 + cntcomment],ref help);
                    StringGrid1.Cell(i, 1, String.Format("{0:e}", Convert.ToString(help)));
                }
                for (i = 0; i <= dn; i++)
                {
                    meinMain.ConvertToDouble(pList[i + 3 + cntcomment + dm],ref help);
                    StringGrid1.Cell(i, 2, String.Format("{0:e}", Convert.ToString(help)));
                }
                if (pList.Count > 5 + dn + dm)
                {
                    meinMain.ConvertToDouble(pList[4 + cntcomment + dn + dm], ref help);
                    ETz.Text = String.Format("{0:e}", Convert.ToString(help));
                    meinMain.ConvertToDouble(ETz.Text,ref tzaf );
                }
                Label4.Text = OpenDialog1.FileName;
                reader.Close();
            }  // Ende Execute..

        }

        private void TBsaveufk_Click(object sender, EventArgs e)
        {
            List<string> pList;
            StreamWriter writer = null;
            int i;

            pList = new List<string>();
            SaveDialog1.FilterIndex = 1;
            //SaveDialog1->InitialDir="..\UFK";
            SaveDialog1.FileName = ecomment.Text + ".UFK";
            // SaveDialog1->Options=[ofOverwritePrompt,ofNoValidate];

            if (SaveDialog1.ShowDialog() == DialogResult.OK)
            {
                pList.Add("!" + ecomment.Text);
                pList.Add(Convert.ToString(degreem.Value));
                pList.Add(Convert.ToString(degreen.Value));
                for (i = 0; i <= degreem.Value; i++)
                    pList.Add(String.Format("{0:e}", Convert.ToString(rkoefz[i])));
                for (i = 0; i <= degreen.Value; i++)
                    pList.Add(String.Format("{0:e}", Convert.ToString(rkoefn[i])));
                pList.Add(ETz.Text);
                try
                {
                    writer = new StreamWriter(SaveDialog1.FileName);
                    for (int j = 0; j < pList.Count; j++)
                    {
                        writer.WriteLine(pList[j]);
                    }
                }
                catch (IOException ex)
                {
                    MessageBox.Show(ex.Message);
                }
                finally
                {
                    writer.Close();
                }
            }
        }

        private void TBsavezk_Click(object sender, EventArgs e)
        {
            List<string> pList;
            int i;
            StreamWriter writer = null;

            pList = new List<string>();
            SaveDialog2.FilterIndex = 1;
            //SaveDialog2.InitialDir="..\UFK";
            SaveDialog2.FileName = ecomment.Text + ".UFK";
            // SaveDialog1.Options=[ofOverwritePrompt,ofNoValidate];


            if (SaveDialog2.ShowDialog() == DialogResult.OK)
            {

                pList.Add("!" + ecomment.Text);
                pList.Add(Convert.ToString(aktnr) + " " + Convert.ToString(aktnc) + " " + Convert.ToString(aktpr) + " " + Convert.ToString(aktpc) + " " + String.Format("{0:e}", Convert.ToString(kaf)));
                for (i = 1; i <= aktmaxi; i++)
                    pList.Add(wertzk[i, 0].ToString() + " " + wertzk[i, 1].ToString());
                pList.Add(ETz.Text);
                try
                {
                    writer = new StreamWriter(SaveDialog2.FileName);
                    for (int j = 0; j < pList.Count; j++)
                    {
                        writer.WriteLine(pList[j]);
                    }
                }
                catch (IOException ex)
                {
                    MessageBox.Show(ex.Message);
                }
                finally
                {
                    writer.Close();
                }
            }
        }

        private void TBCancel_Click(object sender, EventArgs e)
        {
            this.Hide();
        }

        private void TBOK_Click(object sender, EventArgs e)
        {
            this.Hide();
            meinMain.DFUFK_OK(); // Copy Data to other windows
        }

        private void factor_MouseHover(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = toolTip1.GetToolTip(factor);
        }

        private void factor_MouseLeave(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = "";
        }

        private void label_tolerace_poly_Click(object sender, EventArgs e)
        {

        }

        private void DFUFK1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Visible = false;

        }
    }
}
