using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;

namespace smallTools
{
    public partial class nichols : Form
    {
        //const double pi = Math.PI;
        FormMain meinMain = null;

        public nichols(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            textBox5.Text = "1";
            textBox1.Text = "0";
            textBox2.Text = "0";
            textBox3.Text = (-6.0206).ToString();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Visible = false;
        }

        private void textBox2_Enter(object sender, EventArgs e)
        {
            double magnitudeF, magnitudeFo=0;
            double ln10, bf, bfo;
            double PhaseF, PhaseFo=0;
            double radiantf, radiantfo;

            ln10 = Math.Log(10);
            meinMain.ConvertToDouble(textBox1.Text,ref magnitudeFo );

            meinMain.ConvertToDouble(textBox2.Text,ref PhaseFo );
            bfo = Math.Exp(ln10 * magnitudeFo / 20);   /* dB -. Faktor */
            radiantfo = PhaseFo * pi / 180;         /* bmfo: phase in rad */

            /* Nichols-Formulae */
            bf = bfo / Math.Sqrt(1 + 2 * bfo * Math.Cos(radiantfo) + bfo * bfo);
            radiantf = arctn(Math.Sin(radiantfo), (Math.Cos(radiantfo) + bfo));

            magnitudeF = 20 * Math.Log(bf) / ln10;      /* Faktor -. dB */
            PhaseF = radiantf * 180 / pi;       /* Phase F: in degrees */
            textBox3.Text = (magnitudeF).ToString("G6");
            textBox4.Text = (PhaseF).ToString("G6");
            textBox5.Text = (Math.Exp(ln10 * magnitudeFo / 20)).ToString("G6");
        }

        private void textBox5_Leave(object sender, EventArgs e)
        {
            double inp=0, ln10, db;
            ln10 = Math.Log(10);
            meinMain.ConvertToDouble(textBox5.Text,ref inp );
            db = Math.Log(inp) * 20 / ln10;
            textBox1.Text = (db).ToString();
            textBox2_Enter(sender, e);

        }

        private double arctn(double im, double re)
        {
            double  x;
            if (re==0)
                if (im>0) x=pi/2;
                else x=-pi/2 ;
            else{
                x=Math.Atan(im/re);
                if (re<0) x=x+pi;
                };
            if (x>0) x=x-2*pi;     // {phase always negative}
            return(x);
        }

        private void btnAttToReport_Click(object sender, EventArgs e)
        {
            string a = "      ", cr = "\x0d\x0a";

            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr + cr);
            meinMain.tBMainReport1.AppendText(a + this.Text + cr);
            meinMain.tBMainReport1.AppendText(a + cr);

            meinMain.tBMainReport1.AppendText(a + "Fo= " + textBox5.Text + " = " + textBox1.Text + " dB /" + textBox2.Text + " ---> Fw = " + textBox3.Text + " dB /" + textBox4.Text + "" + cr);

            meinMain.tBMainReport1.AppendText(a + cr);
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr);

       
        }

        public void deutsch()
        {
            btnClose.Text = "Schlieen";
            btnReport.Text = "Zum Report";
            label2.Text = "Betrag offener Kreis in dB";
            label3.Text = "Phase offener Kreis in Grad";
            label4.Text = "Betrag geschlossener Kreis in dB";
            label5.Text = "Phase geschlossener Kreis in Grad";
            label9.Text = "zur Berechnung eines Punktes des Bodediagrammes des ";
            label10.Text = "geschlossenen Kreises Fw aus dem offenen Kreis Fo";
            label8.Text = "Nichols Formeln";
            this.Text = "Nichols Formeln";
            label1.Text = "Betrag offener Kreis als Faktor";
        }

        private void nichols_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;
        }

        private void textBox5_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox5_Leave(sender, e);
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox2_Enter(sender, e);

        }
    }
}