using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;

namespace smallTools
{
    public partial class pt1id : Form
    {
        FormMain meinMain;

        public pt1id(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            textBox1.Text = (2.5).ToString();
            textBox2.Text = (5).ToString();
            textBox3.Text = (1.4270).ToString();
            textBox4.Text = (1.8360).ToString();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Visible = false;
        }

        private void textBox1_Leave(object sender, EventArgs e)
        {
            double t1 = 0, u1 = 0, u2 = 0;
            meinMain.ConvertToDouble(textBox1.Text, ref t1);
            textBox2.Text = (t1 * 2).ToString("G6");
            meinMain.ConvertToDouble(textBox3.Text, ref u1);
            meinMain.ConvertToDouble(textBox4.Text, ref u2);
            double k = u1 / (2 - u2 / u1);
            textBox5.Text = (k).ToString("G6");
            textBox6.Text = (-2 * t1 / Math.Log(1 - u2 / k)).ToString("G6");
            label10.Text = "";
            label11.Text = "";
            label12.Text = "";
            label13.Text = "";
        }

        private void btnSrnsitivity_Click(object sender, EventArgs e)
        {
            double t1 = 0, u1 = 0, u2 = 0, t2 = 0;
            meinMain.ConvertToDouble(textBox1.Text, ref t1);
            meinMain.ConvertToDouble(textBox2.Text, ref t2);
            meinMain.ConvertToDouble(textBox3.Text, ref u1);
            meinMain.ConvertToDouble(textBox4.Text, ref u2);
            double k = u1 / (2 - u2 / u1);
            double t = -2 * t1 / Math.Log(1 - u2 / k);
            label10.Text = "1%";
            label11.Text = "1%";
            t1 = t1 * 1.01;
            double kn = u1 / (2 - u2 / u1);
            double tn = -2 * t1 / Math.Log(1 - u2 / kn);
            double dkmax = Math.Abs((k - kn) / k * 100);
            double dtmax = Math.Abs((t - tn) / t * 100);
            t1 = t1 / 1.01;
            u1 = u1 * 1.01;
            kn = u1 / (2 - u2 / u1);
            tn = -2 * t1 / Math.Log(1 - u2 / kn);
            double dk = Math.Abs((k - kn) / k * 100);
            double dt = Math.Abs((t - tn) / t * 100);
            u1 = u1 / 1.01;
            if (dk > dkmax) dkmax = dk;
            if (dt > dtmax) dtmax = dt;
            label12.Text = dkmax.ToString("G2") + "%";
            label13.Text = dtmax.ToString("G2") + "%";
        }

        private void textBox2_Leave(object sender, EventArgs e)
        {
            double t2 = 0, u1 = 0, u2 = 0;
            meinMain.ConvertToDouble(textBox2.Text, ref t2);
            textBox1.Text = (t2 / 2).ToString("G6");
            meinMain.ConvertToDouble(textBox3.Text, ref u1);
            meinMain.ConvertToDouble(textBox4.Text, ref u2);
            double k = u1 / (2 - u2 / u1);
            textBox5.Text = (k).ToString("G6");
            textBox6.Text = (-t2 / Math.Log(1 - u2 / k)).ToString("G6");
            label10.Text = "";
            label11.Text = "";
            label12.Text = "";
            label13.Text = "";
        }

        public void deutsch()
        {
            this.Text = "PT1-Identifikation";
            btnSrnsitivity.Text = "Empfindlichkeit";
            btnClose.Text = "Schlieen";
            label1.Text = "Identifikation einer einfachen PT1-Strecke";
            label2.Text = "mit zwei gemessenen Punkten";
            label7.Text = "DC-Verstrkung K";
            label8.Text = "Zeitkonstante T1";
            label9.Text = "Methode setzt t2=2*t1 voraus";
            btnReport.Text = "zum Report";
        }

        private void btnReport_Click(object sender, EventArgs e)
        {
            string a = "      ", cr = "\x0d\x0a";
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr + cr);
            meinMain.tBMainReport1.AppendText(a + this.Text + cr);
            meinMain.tBMainReport1.AppendText(a + cr);

            meinMain.tBMainReport1.AppendText(a + label3.Text + " = " + textBox1.Text + " " + label11.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label4.Text + " = " + textBox2.Text + " " + cr);

            meinMain.tBMainReport1.AppendText(a + cr);
            meinMain.tBMainReport1.AppendText(a + label5.Text + " = " + textBox3.Text + " " + label10.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label6.Text + " = " + textBox4.Text + " " + cr + cr);

            meinMain.tBMainReport1.AppendText(a + label7.Text + " = " + textBox5.Text + " " + label12.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label8.Text + " = " + textBox6.Text + " " + label13.Text + cr);

            meinMain.tBMainReport1.AppendText(a + cr);
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr);


        }

        private void pt1id_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox1_Leave(sender, e);
        }

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox2_Leave(sender, e);

        }


    }
}