using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;

namespace smallTools
{
    public partial class pt2equ : Form
    {

        const double pi = Math.PI; 
        const String __d0d1 = "0<d<1 !!!!";
        const String _phir76345 = "0<phir<76.345 !!!!";
        const String ue1 = "0<ue<1 !!!!";
        double __wo;
        double __d;
        double __tmax;
        double __ue;
        double _phir;
        FormMain meinMain;
    
        private double sqr(double x)
        { 
            return (x * x); 
        }

        double phasenreserve(double d)
        {
            return (90 - 180 / pi * Math.Atan(Math.Sqrt(Math.Sqrt(0.25 + 1 / sqr(sqr(2 * d))) - 0.5)));
        }

        double daempfung(double phi)
        {
            double x = pi / 180 * (90 - phi);
            return (0.5 * Math.Sqrt(Math.Sqrt(1 / (sqr(sqr(Math.Sin(x) / Math.Cos(x)) + 0.5) - 0.25))));
        }

        public pt2equ(FormMain m)
        {
            InitializeComponent();
            this.meinMain = m;
           
            textBox1.Text = "5";
            textBox2.Text = (0.60).ToString();
            textBox1_Leave(null, null);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Visible = false;
        }

        public void deutsch()
        {
            this.Text = "PT2 Gleichungen";
            btnClose.Text = "Schlieen";
            label1.Text = "Beziehung zwischen den Parametern wo und d";
            label2.Text = "und dem Maximum der Sprungantwort mit  und tmax";
            label3.Text = "bertragungsfunktion F(p)";
            label4.Text = "Sprungantwort";
            label6.Text = "Dmpfung d";
            label7.Text = "rel. berschwingen ";
            label9.Text = "entsprechende Phasenreserve";
            btnAddToReport.Text = "Zum Report";
            chart2D1.Germanlanguage = true;
            label26.Text = "Zeitachse in Sekunden";
            labelPoints.Text = "Anzahl Punkte";
        }

        private void textBox1_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(textBox1.Text,ref __wo );
            meinMain.ConvertToDouble(textBox2.Text,ref __d );
            if ((__d <= 0) || (__d >= 1)) 
                MessageBox.Show(__d0d1);
            else
            {
                __tmax = pi / __wo / Math.Sqrt(1 - __d * __d);
                __ue = Math.Exp(-__d * pi / Math.Sqrt(1 - __d * __d));
                _phir = phasenreserve(__d);
                textBox3.Text = _phir.ToString("G6");
                textBox4.Text = __tmax.ToString("G64");
                textBox5.Text = __ue.ToString("G6");
                drawStart();
            }
        }

        private void textBox3_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(textBox1.Text,ref __wo );
            meinMain.ConvertToDouble(textBox3.Text,ref _phir );
            if ((_phir <= 0) || (_phir >= 76.345)) 
                MessageBox.Show(_phir76345);
            else
            {
                __d = daempfung(_phir);
                __tmax = pi / __wo / Math.Sqrt(1 - __d * __d);
                __ue = Math.Exp(-__d * pi / Math.Sqrt(1 - __d * __d));
                textBox2.Text = __d.ToString("G6");
                textBox4.Text = __tmax.ToString("G6");
                textBox5.Text = __ue.ToString("G6");
                drawStart();
            }
        }

        private void textBox4_Leave(object sender, EventArgs e)
        {
           meinMain.ConvertToDouble(textBox4.Text,ref  __tmax );
           meinMain.ConvertToDouble(textBox5.Text,ref  __ue );
            if ((__ue <= 0) || (__ue >= 1)) 
                MessageBox.Show(ue1);
            else
            {
                double lnue = Math.Log(__ue);
                __d = -lnue / Math.Sqrt(pi * pi + lnue * lnue);
                __wo = pi / __tmax / Math.Sqrt(1 - __d * __d);
                _phir = phasenreserve(__d);
                textBox1.Text = __wo.ToString("G6");
                textBox2.Text = __d.ToString("G6");
                textBox3.Text = _phir.ToString("G6");
                drawStart();
            }
        }

        private void btnAddToReport_Click(object sender, EventArgs e)
        {
            string a = "      ", cr = "\x0d\x0a";

            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr + cr);
            meinMain.tBMainReport1.AppendText(a + this.Text + cr);
            meinMain.tBMainReport1.AppendText(a + cr);
            meinMain.tBMainReport1.AppendText(a + label3.Text);
            meinMain.tBMainReport1.AppendText(a + label5.Text + " = " + textBox1.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label6.Text + " = " + textBox2.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label9.Text + " = " + textBox3.Text + cr);

            meinMain.tBMainReport1.AppendText(a + cr);
            meinMain.tBMainReport1.AppendText(a + label4.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label8.Text + " = " + textBox4.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label7.Text + " = " + textBox5.Text + cr);



            meinMain.tBMainReport1.AppendText(a + cr);
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr);

          
        }

        private void pt2equ_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;
        }


        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox1_Leave(sender, e);

        }

        private void textBox3_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox3_Leave(sender, e);

        }

        private void textBox4_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox4_Leave(sender, e);

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown1, 1e-5, 1e5);
            drawStart();
        }

        private void drawStart()
        {
            chart2D1.clearAll();
            int nb = (int)numericUpDown2.Value;
            double kx = 0, y = 0;
            kx = (double)numericUpDown1.Value;
            kx = kx / nb;

            double dneu = __d;
            double wo = __wo;
            double sqrD = 0, phi = 0;
            double T1 = 1, T2 = 2;
            if (dneu < 1)
            {
                sqrD = Math.Sqrt(1 - dneu * dneu);
                phi = Math.Atan(sqrD / dneu);
            }
            else
            {
                sqrD = Math.Sqrt(-1 + dneu * dneu);
                T1 = (dneu + sqrD) / wo;
                T2 = (dneu - sqrD) / wo;
            }

            for (int i = 0; i < nb; i++)
            {

                double x = kx * i;
                if (dneu < 1)
                    y = 1 - Math.Exp(-dneu * wo * x) / sqrD * Math.Sin(wo * sqrD * x + phi);
                else if (dneu > 1)
                    y = 1 - T1 / (T1 - T2) * Math.Exp(-x / T1) - T2 / (T2 - T1) * Math.Exp(-x / T2);
                chart2D1.setPoint(0, x, y);
            }
            chart2D1.startDrawing();
            chart2D1.autoScaling();
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            meinMain.nUD1_2_5(numericUpDown2, 10, 1e4);
            drawStart();

        }

    }
}