using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;


namespace smallTools
{
    public partial class wrc2pt1 : Form
    {
        FormMain meinMain;

        public wrc2pt1(FormMain m)
        {
            InitializeComponent();
            meinMain = m;

            r1.Text = "0";
            c1.Text = "0";
            r2.Text = "0";
            c2.Text = "0";
            r3.Text = "1000";
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Visible = false;

        }

        public void deutsch()
        {
            this.Text = "Zeitkonstanten einer 2 RC-Schaltung";
            btnClose.Text = "Schlieen";
            btnReport.Text = "Zum Report";
        }

        private void btnReport_Click(object sender, EventArgs e)
        {
            string a = "      ",cr="\x0d\x0a";
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr + cr);
            meinMain.tBMainReport1.AppendText(a + this.Text+cr);
            meinMain.tBMainReport1.AppendText(a+cr);

            meinMain.tBMainReport1.AppendText(a + label1.Text + " = " + r1.Text + " " + label6.Text+cr);
            meinMain.tBMainReport1.AppendText(a + label2.Text + " = " + c1.Text + " " + label7.Text+cr);
            meinMain.tBMainReport1.AppendText(a + label3.Text + " = " + r2.Text + " " + label8.Text+cr);
            meinMain.tBMainReport1.AppendText(a + label4.Text + " = " + c2.Text + " " + label9.Text+cr);
            meinMain.tBMainReport1.AppendText(a + label5.Text + " = " + r3.Text + " " + label10.Text+cr);

            meinMain.tBMainReport1.AppendText(cr);
            meinMain.tBMainReport1.AppendText(a + label11.Text + " = " + ek.Text + " " + cr);
            meinMain.tBMainReport1.AppendText(a + label12.Text + " = " + et1.Text + " " + label14.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label13.Text + " = " + et2.Text + " " + label15.Text + cr);

            meinMain.tBMainReport1.AppendText(a + cr);
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr);

          
        }

        private void r1_Leave(object sender, EventArgs e)
        {
            double zr1 = 0, zc1 = 0, zr2 = 0, zc2 = 0,zr3 = 0;
             meinMain.ConvertToDouble(r1.Text,ref zr1);
             meinMain.ConvertToDouble(c1.Text,ref zc1 );
             meinMain.ConvertToDouble(r2.Text,ref zr2 );
             meinMain.ConvertToDouble(c2.Text,ref zc2 );
             meinMain.ConvertToDouble(r3.Text,ref zr3 );
            double rsum = zr1 + zr2 + zr3;
            if (rsum == 0) rsum = 1e-10; else rsum = 1.0 / rsum;
            double k = zr3 * rsum;
            double a = rsum * (zc1 * zr1 * (zr2 + zr3) + zc2 * zr3 * (zr1 + zr2));
            double b = rsum * zc1 * zc2 * zr1 * zr2 * zr3;
            double sq = Math.Sqrt(a * a / 4.0 - b);
            double t1 = a / 2.0 + sq;
            double t2 = a / 2.0 - sq;
            ek.Text = k.ToString("F4");
            et1.Text = t1.ToString("F4");
            et2.Text = t2.ToString("F4");
        }

        private void wrc2pt1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;
        }

        private void r1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) r1_Leave(sender, e);

        }
    }
}