using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WINDF7CSharp;


namespace smallTools
{
    public partial class wrc3pt1 : Form
    {
        FormMain meinMain;

        public wrc3pt1(FormMain m)
        {
            InitializeComponent();
            meinMain = m;

            r1.Text = "10";
            c1.Text = "4";
            r2.Text = "10";
            c2.Text = "4";
            r3.Text = "10";
            r4.Text = "22";
            c3.Text = "4";
            r5.Text = "51";
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
               Visible = false;
        }

        public void deutsch()
        {
            this.Text = "bertragungsfunktion einer 3 RC-Schaltung";
            btnClose.Text = "Schlieen";
            btnReport.Text = "Zum Report";
            butRCMess.Text = "RC gemessen";
            butOK.Text = "Schliee und Kopiere in UFK- Box";
        }

        private void btnReport_Click(object sender, EventArgs e)
        {
            string a = "      ",cr="\x0d\x0a";
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr + cr);
            meinMain.tBMainReport1.AppendText(a + this.Text+cr);
            meinMain.tBMainReport1.AppendText(a+cr);

            meinMain.tBMainReport1.AppendText(a + label1.Text + " = " + r1.Text + " " + label6.Text+cr);
            meinMain.tBMainReport1.AppendText(a + label2.Text + " = " + c1.Text + " " + label7.Text+cr);
            meinMain.tBMainReport1.AppendText(a + label3.Text + " = " + r2.Text + " " + label8.Text+cr);
            meinMain.tBMainReport1.AppendText(a + label4.Text + " = " + c2.Text + " " + label9.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label5.Text + " = " + r3.Text + " " + label10.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label19.Text + " = " + c3.Text + " " + label7.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label18.Text + " = " + r4.Text + " " + label6.Text + cr);
            meinMain.tBMainReport1.AppendText(a + label21.Text + " = " + r5.Text + " " + label6.Text + cr);

            meinMain.tBMainReport1.AppendText(cr);
            meinMain.tBMainReport1.AppendText(a + label11.Text + " = " + ek.Text + " " + cr);
            meinMain.tBMainReport1.AppendText(a + label12.Text + " = " + et1.Text + " " + cr);
            meinMain.tBMainReport1.AppendText(a + label13.Text + " = " + et2.Text + " " + cr);
            meinMain.tBMainReport1.AppendText(a + label14.Text + " = " + et3.Text + " " + cr);

            meinMain.tBMainReport1.AppendText(a + cr);
            meinMain.tBMainReport1.AppendText(a + "_____________________________________________________" + cr);

          
        }

        double k;
        double a1;
        double a2;
        double a3;

        private void r1_Leave(object sender, EventArgs e)
        {
            double zr1 = 0, zc1 = 0, zr2 = 0, zc2 = 0, zr3 = 0, zr4 = 0, zr5 = 0, zc3 = 0;
             meinMain.ConvertToDouble(r1.Text,ref zr1);
             meinMain.ConvertToDouble(c1.Text,ref zc1 );
             meinMain.ConvertToDouble(r2.Text,ref zr2 );
             meinMain.ConvertToDouble(c2.Text, ref zc2);
             meinMain.ConvertToDouble(r3.Text, ref zr3);
             meinMain.ConvertToDouble(c3.Text, ref zc3);
             meinMain.ConvertToDouble(r4.Text, ref zr4);
             meinMain.ConvertToDouble(r5.Text, ref zr5);
             double rsum = zr1 + zr2 + zr3 + zr4;
             zc1 = zc1 * 1e-3; zc2 = zc2 * 1e-3; zc3 = zc3 * 1e-3;  // Time in sec, c in mF and r in kohm
            if (rsum == 0) rsum = 1e-10; else rsum = 1.0 / rsum;
            k = zr5 * rsum;
            a1 = rsum * (zr1 * zr2 * zc1 + (zr1 + zr2) * (zr3 * zc2 + zr4 * zc3 + zr4 * zc2) + (zr3 + zr4) * zc1 * zr1 + zr3 * zr4 * zc3);
            a2 = rsum * (zr1 * zr2 * zc1 * (zr3 * zc2 + zr4 * zc3 + zr4 * zc2) + (zr1 + zr2) * zr3 * zr4 * zc2 * zc3 + zc1 * zr1 * zr3 * zr4 * zc3);
            a3 = rsum * (zr1 * zr2 * zc1 * zr3 * zr4 * zc2 * zc3);
           
            ek.Text = k.ToString("g6");
            et1.Text = a1.ToString("g6");
            et2.Text = a2.ToString("g6");
            et3.Text = a3.ToString("g6");


        }

        private void wrc2pt1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;
        }

        private void r1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) r1_Leave(sender, e);

        }

        private void butOK_Click(object sender, EventArgs e)
        {
            Visible = false;
            meinMain.dfufk.degreem.Value = 0; // Numerator degree
            meinMain.dfufk.degreen.Value = 3; // Denominator
            meinMain.dfufk.StringGrid1.Cell(1, 2, a1.ToString());
            meinMain.dfufk.StringGrid1.Cell(2, 2, a2.ToString());
            meinMain.dfufk.StringGrid1.Cell(3, 2, a3.ToString());
            meinMain.dfufk.StringGrid1.Cell(2, 1, "0");
            meinMain.dfufk.StringGrid1.Cell(0, 1, k.ToString());
        }

        private void butRCMess_Click(object sender, EventArgs e)
        {

            r1.Text = "9.99";
            c1.Text = "4.288";
            r2.Text = "9.82";
            c2.Text = "4.303";
            r3.Text = "9.807";
            r4.Text = "21.47";
            c3.Text = "4.258";
            r5.Text = "50.94";
            r1_Leave(sender, e);

        }
    }
}